//$(function(){
// DEBUG 模式，统计所有请求的耗时
var isDebug = false
var requests = []
var timeoutRequests = []
var hasTimeoutToast = false
// APP审核专用账户，其他情况禁止使用
var REVIEW_USERNAME = '10000000001'

var commonPart = 'http://113.247.231.124:5050/zjtq';
// var commonPart = 'http://192.168.1.107:8080/zjtq/';
// var commonPart = 'http://192.168.1.120:5050/zjtq';
// var commonPart = 'http://192.168.1.115:8080/zjtq';

var HOST = 'http://hntq.zhijietianqi.com:5050/zjtq/v3'
// var HOST = 'https://zjtq.ifzm.cn/zjtq/v3'
// var HOST = 'http://192.168.1.245:8080/zjtq/v3'
// var HOST = 'http://10.111.100.230:8080/zjtq/v3'

// 重试所有网络超时的请求
function retryRequest() {
	for (var i = 0, len = timeoutRequests.length; i < len; i++) {
		ajax.apply(window, timeoutRequests.shift())
	}
}

function networkVerify() {
	var net = plus.networkinfo.getCurrentType();
	switch (net) {
		case plus.networkinfo.CONNECTION_ETHERNET:
		case plus.networkinfo.CONNECTION_WIFI:
			mui.toast("当前处于WiFi网络");
			retryRequest()
			break;
		case plus.networkinfo.CONNECTION_CELL2G:
		case plus.networkinfo.CONNECTION_CELL3G:
		case plus.networkinfo.CONNECTION_CELL4G:
			mui.toast("当前处于2G/3G/4G网络");
			retryRequest()
			break;
		default:
			mui.toast("网络断开连接");
			break;
	}
}

mui.plusReady(function () {
	// 网络监听
	document.addEventListener("netchange", debounce(networkVerify, 500), false)

	// 隐藏滚动条
	plus.webview.currentWebview().setStyle({
		scrollIndicator: 'none'
	})

	// 强制不能横屏
	plus.screen.lockOrientation('portrait-primary')

	// 监听上一个页面的返回事件
	window.addEventListener('back', function () {
		setTimeout(function () {
			plus.nativeUI.closeWaiting()
		}, 300)
	})
})

window.onerror = function (message, source, lineno, colno, e) {
	if (isDebug) {
		mui.toast(message + ', ' + source + ', ' + lineno + ', ' + colno)
		console.log(message + ', ' + source + ', ' + lineno + ', ' + colno)
	} else {
		mui.toast('Unknown Error')
	}
}

var http = {
	get: function (url, params, success, intercept, hasMask) {
		if ($.isFunction(params)) {
			if (success === true || success === false) {
				if (intercept === true || intercept === false) {
					hasMask = intercept
				}
				intercept = success
			}
			if (success === true || success === false) {
				hasMask = success
			}
			success = params
			params = {}
		}

		ajax(url, params, success, 'get', hasMask, intercept)
	},
	post: function (url, params, success, intercept, hasMask) {
		if ($.isFunction(params)) {
			if (success === true || success === false) {
				if (intercept === true || intercept === false) {
					hasMask = intercept
				}
				intercept = success
			}
			if (success === true || success === false) {
				hasMask = success
			}
			success = params
			params = {}
		}

		ajax(url, params, success, 'post', hasMask, intercept)
	},
	count: 0
}

function ajax(url, params, success, type, hasMask, intercept, complete) {
	if (window.plus) {
		var network = plus.networkinfo.getCurrentType()
		if (network === plus.networkinfo.CONNECTION_NONE || network === plus.networkinfo.CONNECTION_UNKNOW) {
			mui.toast("当前没有网络")
			return
		}
	}
	if (isDebug && console && console.time) {
		console.time(url)
	}

	var token = localStorage.Token
	var request = $.ajax({
		type: type || 'post',
		url: url.indexOf('http') === 0 ? url : (HOST + url),
		data: params,
		timeout: 15000,
		cache: false,
		traditional: true,//阻止深度序列化
		headers: {
			'Authorization': token ? 'Bearer ' + token : '',
		},
		beforeSend: function () {
			if (hasMask != false) {
				mui.showLoading()
			}
		},
		success: function (res) {
			if (res.status === 401) {
				// 清除Token
				localStorage.removeItem('Token')

				if (mui.os.plus) {
					mui.plusReady(function () {
						var home = plus.webview.getLaunchWebview()
						home.show()

						var wvs = plus.webview.all()
						for (var i = 0, len = wvs.length; i < len; i++) {
							var view = wvs[i]
							if (view.id != home.id) {
								view.close()
							}
						}

						clearTimeout(window.loadingAsyncTimer)
						plus.nativeUI.closeWaiting()
						plus.navigator.closeSplashscreen()
					})

					mui.toast('身份认证过期，请您重新登录...', {
						duration: 'long'
					})
				} else {
					window.location.href = '/login.html'
				}
				return
			}

			if (intercept != false && res.status != 200) {
				mui.toast(res.message)
				return
			}

			try {
				success && success(res)
			} catch (e) {
				request.abort()

				if (isDebug) {
					mui.toast(e.message)
					console.log(e)
				} else {
					mui.toast('Unknown Error')
				}
			}
		},
		error: function () {
			console.log('cancel request... ' + url)
		},
		complete: function (xhr, status) {
			if (status === 'timeout' || status === 'error') {
				request.abort()
				if (!hasTimeoutToast) {
					mui.toast(status === 'error' ? "网络出现异常" : "请求超时")
					hasTimeoutToast = true
					setTimeout(function () {
						hasTimeoutToast = false
					}, 3000)
				}
				timeoutRequests.push([url, params, success, type, hasMask, intercept])

				// 校验Token避免超时卡住欢迎页
				if (url === '/auth/verify') {
					mui.plusReady(function() {
						plus.navigator.closeSplashscreen()
					})
				}
			}

			if (hasMask != false) {
				mui.hideLoading()
			}

			if (isDebug && console && console.timeEnd) {
				console.timeEnd(url)
			}

			try {
				complete && complete()
			} catch (e) {
				mui.toast(e.message)
				console.log("name: " + e.name + "message: " + e.message + "lineNumber: " + e.lineNumber + "fileName: " + e.fileName + "stack: " + e.stack)
			}
		}
	})

	// requests.push(request)
}

/**
 * img 通用的错误方法
 */
function notFoundImage(img) {
	img.src = 'http://img.ifzm.cn/image.png'
	img.onerror = null
}

var mask = mui.createMask(function () {
	return mask.clickClose;
})

/**
 * Ajax請求
 * 
 * @param url 请求地址
 * @param params 传递参数
 * @param onSucceed 处理成功
 * @param onError 处理失败
 * @param info 传入参数
 */
function ajaxPost(url, params, onSuccess, info, hasMask) {
	alert('[ajaxPost]方法已经废弃，请及时调整。。。')
}

function loginAjaxPost(url, params, onSuccess, info, ontherCase) {
	alert('[loginAjaxPost]方法已经废弃，请及时调整。。。')
}

/**
 * 校验用户输入的权限密码是否正确
 * @param {Object} callback 回调函数
 */
function checkPermissionPassword(callback) {
	mui.prompt('', '', '请输入密码', ['取消', '确认'], function (e) {
		if (e.index === 1) {
			// 校验密码
			ajaxPost('/user/checkPermissionPassword.do', {
				phone: localStorage.username,
				permissionPassword: e.value
			}, function (res) {
				if (res.body.result) {
					callback()
				} else {
					mui.alert('您输入的密码有误，请确认后操作！')
				}
			}, '', false)
		}
	}, 'div')

	setTimeout(function () {
		var input = document.querySelector('.mui-popup-input input')
		input.type = 'password'
		input.focus()
	}, 50)
}

//格式化时间字符串
Date.prototype.Format = function (fmt) {
	var o = {
		"M+": this.getMonth() + 1, //月份 
		"d+": this.getDate(), //日 
		"h+": this.getHours(), //小时 
		"m+": this.getMinutes(), //分 
		"s+": this.getSeconds(), //秒 
		"q+": Math.floor((this.getMonth() + 3) / 3), //季度 
		"S": this.getMilliseconds() //毫秒 
	};
	if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	for (var k in o)
		if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[
			k]).substr(("" + o[k]).length)));
	return fmt;
}
//获取当前时间
//2017-03-24 17:21:18 时间格式
function getNowFormatDate() {
	var date = new Date();
	var seperator1 = "/";
	var seperator2 = ":";
	var month = date.getMonth() + 1;
	var strDate = date.getDate();
	if (month >= 1 && month <= 9) {
		month = "0" + month;
	}
	if (strDate >= 0 && strDate <= 9) {
		strDate = "0" + strDate;
	}
	//			    var currentdate = date.getFullYear() + seperator1 + month + seperator1 + strDate
	//			            + " " + date.getHours() + seperator2 + date.getMinutes()
	//			            + seperator2 + date.getSeconds();
	var currentdate = date.getFullYear() + seperator1 + month + seperator1 + strDate +
		" " + date.getHours() + seperator2 + "00" +
		seperator2 + "00";

	return currentdate;
}

function getNowFormatDateNew() {
	var date = new Date();
	var seperator1 = "-";
	var seperator2 = ":";
	var month = date.getMonth() + 1;
	var strDate = date.getDate();
	var strHour = date.getHours();
	var strMinutes = date.getMinutes();
	if (month >= 1 && month <= 9) {
		month = "0" + month;
	}
	if (strDate >= 0 && strDate <= 9) {
		strDate = "0" + strDate;
	}
	if (strHour >= 0 && strHour <= 9) {
		strHour = "0" + strHour;
	}
	if (strMinutes >= 0 && strMinutes <= 9) {
		strMinutes = "0" + strMinutes;
	}
	var currentdate = date.getFullYear() + seperator1 + month + seperator1 + strDate +
		" " + strHour + seperator2 + strMinutes +
		seperator2 + date.getSeconds();
	return currentdate;
}
//..判断数组是否包含指定元素的方法     x.contains('foo')
Array.prototype.contains = function (needle) {
	for (i in this) {
		if (this[i] == needle) return true;
	}
	return false;
}

//加一个小时  日期格式： 2017-06-15 00:00:00
function addHour(dateTime, addVal) {
	var time = dateTime;
	var dateTimeStr = time.replace(/-/g, ",").replace(/ /g, ",").replace(/:/g, ",");
	var dateTimeArr = dateTimeStr.split(',');
	var year = parseInt(dateTimeArr[0]);
	var month = parseInt(dateTimeArr[1]) - 1;
	var day = parseInt(dateTimeArr[2]);
	var hour = parseInt(dateTimeArr[3]);
	var min = Number(dateTimeArr[4])
	var newDateTime = new Date(year, month, day, hour, min);
	var resHourTimeStamp = newDateTime.getTime() + Number(addVal);
	var resHour = new Date(resHourTimeStamp).Format('yyyy-MM-dd hh:mm:ss');
	return resHour;
}

//获取时间戳
function getTimeStamp(dateTime) {
	var datetime = dateTime;
	var dateTimeStr = datetime.replace(/-/g, ",");
	dateTimeStr = dateTimeStr.replace(/ /g, ",");
	dateTimeStr = dateTimeStr.replace(/:/g, ",");
	var dateTimeArr = dateTimeStr.split(',');
	var year = parseInt(dateTimeArr[0]);
	var month = parseInt(dateTimeArr[1]) - 1;
	var day = parseInt(dateTimeArr[2]);
	var hour = parseInt(dateTimeArr[3]);
	var newDateTime = new Date(year, month, day, hour);
	var resHourTimeStamp = newDateTime.getTime();
	//	var resHour=new Date(resHourTimeStamp).Format('yyyy-MM-dd hh:mm:ss');
	return resHourTimeStamp;
}
//时间戳转日期格式
function formatDateTime(inputTime) {
	var date = new Date(inputTime);
	var y = date.getFullYear();
	var m = date.getMonth() + 1;
	m = m < 10 ? ('0' + m) : m;
	var d = date.getDate();
	d = d < 10 ? ('0' + d) : d;
	var h = date.getHours();
	h = h < 10 ? ('0' + h) : h;
	var minute = date.getMinutes();
	var second = date.getSeconds();
	minute = minute < 10 ? ('0' + minute) : minute;
	second = second < 10 ? ('0' + second) : second;
	return y + '-' + m + '-' + d + ' ' + h + ':' + minute + ':' + second;
};

//当前为周几
function getWeek(dateTime, addVal) {
	var datetime = dateTime;
	var dateTimeStr = datetime.replace(/-/g, ",");
	dateTimeStr = dateTimeStr.replace(/ /g, ",");
	dateTimeStr = dateTimeStr.replace(/:/g, ",");
	var dateTimeArr = dateTimeStr.split(',');
	var year = parseInt(dateTimeArr[0]);
	var month = parseInt(dateTimeArr[1]) - 1;
	var day = parseInt(dateTimeArr[2]);
	var hour = parseInt(dateTimeArr[3]);
	var newDateTime = new Date(year, month, day, hour);
	var resHourTimeStamp = newDateTime.getTime() + addVal;
	var resHour = new Date(resHourTimeStamp).Format('yyyy-MM-dd hh:mm:ss');
	var dt = new Date(resHour.replace(/-/g, '/'));
	var a = ['周天', '周一', '周二', '周三', '周四', '周五', '周六'];
	return a[dt.getDay()];
}
var time = new Date()

function getHour() {
	var hourStr = time.getHours();
	if (hourStr >= 0 && hourStr <= 9) {
		hourStr = "0" + hourStr;
	}
	return hourStr;
}

function getMin() {
	var minStr = time.getMinutes();
	if (minStr >= 0 && minStr <= 9) {
		minStr = "0" + minStr;
	}
	return minStr;
}

function CompareDate(t1, t2) {
	var date = new Date();
	var a = t1.split(":");
	var b = t2.split(":");
	return date.setHours(a[0], a[1]) > date.setHours(b[0], b[1]);
}


//根据数组中某一属性值排序 
//arr.sort(sortNumberLowToHigh('age'))
function sortNumberLowToHigh(property) {
	return function (a, b) {
		var value1 = a[property];
		var value2 = b[property];
		return value1 - value2;
	}
}

function sortNumberHighToLow(property) {
	return function (a, b) {
		var value1 = a[property];
		var value2 = b[property];
		return value2 - value1;
	}
}

//屏幕坐标转换为canvas坐标
function windowTocanvas(hazeCanOne, x, y) {
	var bbox = hazeCanOne.getBoundingClientRect();
	return {
		x: (x - bbox.left) * (hazeCanOne.width / bbox.width),
		y: (y - bbox.top) * (hazeCanOne.height / bbox.height)
	};
}
//鼠标经过显示可点击区域
function onmousemoveCursor(x, y, canvas) {
	var searchObj = geoMap.getElementDataByXY(x, y);
	if (searchObj != null) {
		canvas.style.cursor = "pointer";
	} else {
		canvas.style.cursor = "default";
	}
}

function overlay() {
	var $modal = $("#myModal");
	$modal.css("visibility", ($modal.css("visibility") == "visible" ? "hidden" : "visible"));
}

//删除信息可以实现注销	 
function remove() {
	localStorage.clear();
}

//获取信息
function getItem(key) {
	localStorage.getItem(key)
}

//分享     begin 
var shares = null;
var currentWebview = null;
// H5 plus事件处理
function plusReady() {
	updateSerivces();
	currentWebview = plus.webview.currentWebview();
	// 设置系统状态栏背景为蓝色
	// plus.navigator.setStatusBarBackground('#4f8eff');
}
if (window.plus) {
	plusReady();
} else {
	document.addEventListener('plusready', plusReady, false);
}

// 截屏绘制   TODO
var bitmap = null;
var screenTimes
function captureWebview(cb) {
	mui.showLoading()
	if (mui.os.plus) {
		screenTimes = Date.now()
		bitmap = new plus.nativeObj.Bitmap('test', "_doc/screen_" + screenTimes + ".jpg");
	}

	var map = $('#map')
	if (map.length > 0) {
		var height = map.css('height')
		var mapDom = map[0]

		// html2canvas 不能重复绘制WebGL，需要强制渲染地图（刷新WebGL缓冲区）
		if (window.GIS) {
			GIS.utils.forcedRenderMap()
		}
		html2canvas(mapDom, {
			useCORS: true,
			ignoreElements: function (element) {
				if (element && element.className && element.className.indexOf && element.className.indexOf('mapboxgl-popup') != -1) {
					return true
				}
				return false
			}
		}).then(function (canvas) {
			var img = new Image()
			img.src = canvas.toDataURL()
			img.onload = function () {
				drawWebview(function () {
					cb && cb()
				}, true)
			}

			$('.mui-content').append('<div class="simulation-map mapboxgl-map" style="position: absolute; height: ' + height + '; top: ' + mapDom.offsetTop + 'px;"><img class="background" src="' + img.src + '"></div>')
			$('.mapboxgl-popup').appendTo($('.simulation-map'))
		})
	} else {
		drawWebview(cb)
	}
}

function drawWebview(cb, hide) {
	if ($('body').hasClass('horizontal')) {
		$('.horizontal-display-item').css('display', 'none')
		plus.navigator.setFullscreen(true)
	}

	setTimeout(function () {
		// 将webview内容绘制到Bitmap对象中
		currentWebview.draw(bitmap, function () {
			if (hide === true) {
				$('.mapboxgl-popup').appendTo(map)
				$('.simulation-map').remove()
			}
			saveBitmap(cb)
			mui.hideLoading()
		}, function (e) {
			mui.toast('截屏分享图片失败!')
			console.log('截屏绘制图片失败：' + JSON.stringify(e))
		}, {
			bit: "ARGB",
			check: true
		})
	}, hide === true ? 500 : 100)
}

//裁剪图片
function clipImage() {
	plus.zip.compressImage({
		src: "_doc/screen_" + screenTimes + ".jpg",
		dst: "_doc/screen_" + screenTimes + ".jpg",
		clip: {
			top: "25%",
			left: "25%",
			width: "50%",
			height: "50%"
		} // 裁剪图片中心区域
	}, function () {
		alert("Compress success!");
	}, function (error) {
		alert("Compress error!");
	});
}

// 保存图片
function saveBitmap(cb) {
	bitmap.save("_doc/screen_" + screenTimes + ".jpg", {
		"overwrite": true,
		"quality": 100,
	}, function (i) {
		//			bitmap.recycle();
		//			bitmap.clear();
		// console.log('保存图片成功：'+JSON.stringify(i));
		cb && cb()
	}, function (e) {
		mui.toast('保存分享图片失败!')
		// console.log('保存图片失败：'+JSON.stringify(e));
	});
}

/**
 * 更新分享服务
 */
function updateSerivces() {
	plus.share.getServices(function (s) {
		shares = {};
		for (var i in s) {
			var t = s[i];
			shares[t.id] = t;
		}
	}, function (e) { });
}
// var sharehref={value:'http://img.ifzm.cn/阿里巴巴开发手册（Java）.pdf'};
// var sharehrefTitle={};
// var sharehrefDes={};
// sharehrefTitle.value='气象服务链接'
// sharehrefDes.value='点击查看好友分享的气象服务文件'

/**
 * 分享操作
 * @param {JSON} sb 分享操作对象s.s为分享通道对象(plus.share.ShareService)
 * @param {Boolean} bh 是否分享链接
 */
function shareAction(sb, bh) {
	var shareLink = {};
	var shareLinkStorage = localStorage.shareLink;
	if (shareLinkStorage && shareLinkStorage !== 'undefined') {
		shareLink = JSON.parse(shareLinkStorage);
	}

	if (!sb || !sb.s) {
		mui.toast('无效的分享服务！')
		return;
	}
	//		console.log(JSON.stringify(sb))
	var msg = { /*content:bitmap,*/
		extra: {
			scene: sb.x
		}
	};
	if (bh) {
		if (!shareLink.pdfUrl) {
			mui.toast('当前文件暂不支持分享！')
			return false;
		}
		msg.href = shareLink.pdfUrl;
		msg.title = shareLink.fileName ? shareLink.fileName : '文件分享';
		msg.content = shareLink.description ? shareLink.description : '点击查看分享链接';
		msg.thumbs = [shareLink.logoUrl];
		msg.pictures = [shareLink.logoUrl];
		if (sb.s.authenticated) {
			sharePDFLink(msg, sb.s);
		} else {
			sb.s.authorize(function () {
				sharePDFLink(msg, sb.s);
			}, function (e) {
				mui.toast('分享服务认证失败!')
			});
		}
	} else {
		plus.io.requestFileSystem(plus.io.PRIVATE_DOC, function (fs) {
			var directoryReader = fs.root.createReader();
			directoryReader.readEntries(function (entries) {
				for (i = 0; i < entries.length; i++) {
					if (entries[i].name.indexOf("screen_" + screenTimes) === 0) {
						msg.pictures = ['_doc/' + entries[i].name]
						// 发送分享
						if (sb.s.authenticated) {
							shareMessage(msg, sb.s);
						} else {
							sb.s.authorize(function () {
								shareMessage(msg, sb.s);
							}, function (e) {
								mui.toast('分享服务认证失败!')
							});
						}
						break;
					}
				}
			}, function (e) {
				mui.toast('获取分享图片失败!')
			});
		}, function (e) {
			mui.toast('获取分享图片失败!')
		})
	}
}

/**
 * 发送分享消息
 * @param {JSON} msg
 * @param {plus.share.ShareService} 
 */
function shareMessage(msg, s) {
	//		mui.alert(JSON.stringify(msg))
	s.send(msg, function () {
		bitmap.recycle();
		bitmap.clear();
	}, function (e) {
		//			mui.alert(JSON.stringify(e))
		mui.toast('取消分享')
	});
}


// 使用Logo图片分享
function shareLogoPicture() {
	var url = "_doc/screen.jpg";
	plus.io.resolveLocalFileSystemURL(url, function (entry) {
		pic.src = entry.toLocalURL();
		pic.realUrl = url;
	}, function (e) { });
}

// 打开分享
function MYshareShow() {
	var shareBts = [];
	// 更新分享列表
	var ss = shares['weixin'];
	if (navigator.userAgent.indexOf('qihoo') < 0) { //在360流应用中微信不支持分享图片
		shareBts.push({
			title: '微信好友',
			s: ss,
			x: 'WXSceneSession'
		});
	}
	ss = shares['qq'];
	ss && ss.nativeClient && shareBts.push({
		title: 'QQ',
		s: ss
	});
	// 弹出分享列表
	shareBts.length > 0 ? plus.nativeUI.actionSheet({
		title: '分享',
		cancel: '取消',
		buttons: shareBts
	}, function (e) {
		(e.index > 0) && shareAction(shareBts[e.index - 1], false);
	}) : plus.nativeUI.alert('当前环境无法支持分享操作!');
}

// 打开分享
/**
 * @param {boolean} isLink true分享链接，false分享截图
 */
function shareShow(isLink) {
	if ($('body').hasClass('horizontal')) {
		$('.horizontal-display-item').css('display', 'none')
		plus.navigator.setFullscreen(true)
	}

	var shareBts = [];
	// 更新分享列表
	if (shares['weixin']) {
		var ss = shares['weixin'];
	}
	if (navigator.userAgent.indexOf('qihoo') < 0) { //在360流应用中微信不支持分享图片
		ss && ss.nativeClient && (shareBts.push({
			title: '微信朋友圈',
			s: ss,
			x: 'WXSceneTimeline'
		}),
			shareBts.push({
				title: '微信好友',
				s: ss,
				x: 'WXSceneSession'
			}));
	}
	//		ss=shares['sinaweibo'];
	//		ss&&shareBts.push({title:'新浪微博',s:ss});
	ss = shares['qq'];
	ss && ss.nativeClient && shareBts.push({
		title: 'QQ',
		s: ss
	});
	// 弹出分享列表
	if (shareBts.length > 0) {
		mask.show()
		plus.nativeUI.actionSheet({
			title: '分享',
			cancel: '取消',
			buttons: shareBts
		}, function (e) {
			(e.index > 0) && shareAction(shareBts[e.index - 1], isLink)
			mask.close()
		})
	} else {
		plus.nativeUI.alert('当前环境无法支持分享操作!');
	}
}

mui(".mui-bar").on("click", ".bar-nav-share", function () {
	if ($(this).hasClass('shareLink')) {
		shareShow(true);
	} else {
		captureWebview(function () {
			shareShow(false)
		});
	}
	// clipImage()
	//		shareShow();
});
//分享     end	


function sharePDFLink(msg, s) {
	// alert(JSON.stringify(msg));
	s.send(msg, function () {
		mui.toast("分享到\"" + s.description + "\"成功！ ");
	}, function (e) {
		//				mui.toast( "分享到\""+s.description+"\"失败: "+JSON.stringify(e) );
		mui.toast('取消分享')
	});
}

/**
 * 根据空气质量分数判断污染等级
 * 
 * @param {Object} aqi
 */
function checkAqiLevel(aqi) {
	if (aqi <= 50) {
		return '优';
	} else if (aqi > 50 && aqi <= 100)
		return '良';
	else if (aqi > 100 && aqi <= 150)
		return '轻';
	else if (aqi > 150 && aqi <= 200)
		return '中';
	else if (aqi > 200 && aqi <= 300)
		return '重';
	else
		return '严重';
}

/**
 * 根据风力计算对应的等级名称  
 *
 * @param {Object} windSpeed 风速
 */
function getWindData(windSpeed) {
	if (windSpeed < 0.3)
		return ['0级风', '0'];
	else if (windSpeed >= 0.3 && windSpeed <= 1.5)
		return ['1级风', '1'];
	else if (windSpeed > 1.5 && windSpeed <= 3.3)
		return ['2级风', '2'];
	else if (windSpeed > 3.3 && windSpeed <= 5.4)
		return ['3级风', '3'];
	else if (windSpeed > 5.4 && windSpeed <= 7.9)
		return ['4级风', '4'];
	else if (windSpeed > 7.9 && windSpeed <= 10.7)
		return ['5级风', '5'];
	else if (windSpeed > 10.7 && windSpeed <= 13.8)
		return ['6级风', '6'];
	else if (windSpeed > 13.8 && windSpeed <= 17.1)
		return ['7级风', '7'];
	else if (windSpeed > 17.1 && windSpeed <= 20.7)
		return ['8级风', '8'];
	else if (windSpeed > 20.7 && windSpeed <= 24.4)
		return ['9级风', '9'];
	else if (windSpeed > 24.4 && windSpeed <= 28.4)
		return ['10级风', '10'];
	else if (windSpeed > 28.4 && windSpeed <= 32.6)
		return ['11级风', '11'];
	else if (windSpeed > 32.6)
		return ['12级风', '12'];

	return ['0级风', '0']
}

//数组去重
function unique(arr) {
	for (var i = 0, uarr = []; i < arr.length; i++) {
		for (var k = 0; k < uarr.length; k++) {
			if (arr[i] == uarr[k]) {
				break;
			}
		}
		k == uarr.length && (uarr[k] = arr[i]);
	}
	return uarr;
}
//});

// 重写 back
var originalBack = mui.back
mui.back = function () {
	clearTimeout(window.loadingAsyncTimer)
	if (window.plus) {
		clearWaiting()
	} else {
		mui.plusReady(clearWaiting)
	}

	originalBack.apply(mui, arguments)
}

function clearWaiting() {
	plus.nativeUI.closeWaiting()
	// 通知上一个页面关闭可能由异步请求导致延迟的的waiting窗口
	mui.fire(plus.webview.getWebviewById(localStorage.currentPageId), 'back')
}

// 重写 openwindow 
var originalOpenWindow = mui.openWindow
mui.openWindow = function () {
	if (window.plus) {
		localStorage.currentPageId = plus.webview.currentWebview().id
	}

	originalOpenWindow.apply(mui, arguments)
}

// 扩展mui.showLoading
; (function ($, window) {
	var count = 0

	//显示加载框
	$.showLoading = function (message, type) {
		if (++count > 1) {
			return
		}

		if ($.os.plus && type !== 'div') {
			$.plusReady(function () {
				plus.nativeUI.showWaiting(message)
			})
		} else {
			var html = '';
			html += '<i class="mui-spinner mui-spinner-white"></i>'
			html += '<p class="text">' + (message || "数据加载中") + '</p>'

			//遮罩层
			var mask = document.getElementsByClassName("mui-show-loading-mask")
			if (mask.length == 0) {
				mask = document.createElement('div')
				mask.classList.add("mui-show-loading-mask")
				document.body.appendChild(mask)
				mask.addEventListener("touchmove", function (e) { e.stopPropagation(); e.preventDefault(); })
			} else {
				mask[0].classList.remove("mui-show-loading-mask-hidden")
			}
			//加载框
			var toast = document.getElementsByClassName("mui-show-loading")
			if (toast.length == 0) {
				toast = document.createElement('div')
				toast.classList.add("mui-show-loading")
				toast.classList.add('loading-visible')
				document.body.appendChild(toast)
				toast.innerHTML = html
				toast.addEventListener("touchmove", function (e) { e.stopPropagation(); e.preventDefault(); })
			} else {
				toast[0].innerHTML = html
				toast[0].classList.add("loading-visible")
			}
		}
	}

	//隐藏加载框
	$.hideLoading = function (callback) {
		if (--count > 0) {
			callback && callback()
			return
		}

		if (!window.updatePatching) {
			$.plusReady(function () {
				clearTimeout(window.loadingAsyncTimer)
				window.loadingAsyncTimer = setTimeout(function () {
					plus.nativeUI.closeWaiting()
				}, 200)
			})

			var mask = document.getElementsByClassName("mui-show-loading-mask")
			var toast = document.getElementsByClassName("mui-show-loading")
			if (mask.length > 0) {
				mask[0].classList.add("mui-show-loading-mask-hidden")
			}
			if (toast.length > 0) {
				toast[0].classList.remove("loading-visible")
				callback && callback()
			}
		}
	}
})(mui, window);

function debounce(n, t, r) {
	var T = undefined;function e(t) { var r = c, e = a; return c = a = T, _ = t, s = n.apply(e, r) } function u(n) { var r = n - p; return n -= _, p === T || r >= t || 0 > r || g && n >= l } function i() { var n = Date.now(); if (u(n)) return o(n); var r, e = setTimeout; r = n - _, n = t - (n - p), r = g ? Ci(n, l - r) : n, h = e(i, r) } function o(n) { return h = T, d && c ? e(n) : (c = a = T, s) } function f() {
		var n = Date.now(), r = u(n); if (c = arguments, a = this, p = n, r) { if (h === T) return _ = n = p, h = setTimeout(i, t), v ? e(n) : s; if (g) return h = setTimeout(i, t), e(p) } return h === T && (h = setTimeout(i, t)),s
	} var c, a, l, s, h, p, _ = 0, v = false, g = false, d = true; if (typeof n != "function") throw new ti("Expected a function"); return t = t || 0, $.isPlainObject(r) && (v = !!r.leading, l = (g = "maxWait" in r) ? Li(r.maxWait || 0, t) : l, d = "trailing" in r ? !!r.trailing : d), f.cancel = function () { h !== T && lo(h), _ = 0, c = p = a = h = T }, f.flush = function () { return h === T ? s : o(Date.now()) }, f
}