var checkPhone = {
	phone: true,
	passWord: false,
	verifyCode: false,
	forget: false,
	submit: true,
	submitText: '登录',
	tip: false,
	tipText: ''
}, activate = {
	phone: false,
	passWord: true,
	verifyCode: true,
	forget: false,
	submit: true,
	submitText: '登录',
	placeholderText: '请设置登录密码',
	tip: true,
	tipText: '账号激活'
}, login = {
	phone: false,
	passWord: true,
	verifyCode: false,
	forget: true,
	submit: true,
	submitText: '登录',
	placeholderText: '请输入您的密码',
	tip: false,
	tipText: ''
}, loginWithVerify = {
	phone: false,
	passWord: true,
	verifyCode: true,
	forget: true,
	submit: true,
	submitText: '登录',
	placeholderText: '请输入您的密码',
	tip: false,
	tipText: ''
}, forget = {
	phone: false,
	passWord: true,
	verifyCode: true,
	forget: false,
	submit: true,
	submitText: '提交',
	placeholderText: '请设置登录密码',
	tip: true,
	tipText: '重置密码'
}

// 切换状态
function switchPage(domObj) {
	for (key in domObj) {
		if (domObj[key] === true) {
			if (key === 'tip') {
				$('#tip').text(domObj.tipText)
				$('#tip').addClass('show')
			} else {
				$('#' + key).fadeIn(500)
			}
		} else {
			if (key === 'tip') {
				$('#tip').removeClass('show')
			} else {
				$('#' + key).fadeOut(0)
			}
		}
	}
	$('#passWord')[0].placeholder = domObj.placeholderText
	$('#submit')[0].value = domObj.submitText
	
	$('#return').removeClass('hide')
	if(domObj.phone){
		$('#return').addClass('hide')
	}
}



// 验证码计时器
var timer
function settime($obj, time) {
	if (time == 0) {
		$obj.attr("disabled", false);
		$obj.text("获取验证码");
		return;
	} else {
		$obj.attr("disabled", true);
		$obj.text("重新发送 ( " + time + " ) ");
		time--;
	}
	timer = setTimeout(function () {
		settime($obj, time)
	}, 1000)
}

function initDeviceInfoCache(cb) {
	var NET_TYPES = {}
	NET_TYPES[plus.networkinfo.CONNECTION_UNKNOW] = "Unknown"
	NET_TYPES[plus.networkinfo.CONNECTION_NONE] = "None"
	NET_TYPES[plus.networkinfo.CONNECTION_ETHERNET] = "Ethernet"
	NET_TYPES[plus.networkinfo.CONNECTION_WIFI] = "WiFi"
	NET_TYPES[plus.networkinfo.CONNECTION_CELL2G] = "Cellular 2G"
	NET_TYPES[plus.networkinfo.CONNECTION_CELL3G] = "Cellular 3G"
	NET_TYPES[plus.networkinfo.CONNECTION_CELL4G] = "Cellular 4G"

	plus.runtime.getProperty(plus.runtime.appid, function(info) {
		window.device = {
			deviceId: plus.device.uuid,
			appid: plus.runtime.appid,
			appVersion: info.version,
			imei: plus.device.imei,
			os: mui.os.android ? 'Android' : 'iOS',
			osVersion: mui.os.version,
			deviceModel: plus.device.model,
			plusVersion: plus.runtime.innerVersion,
			net: NET_TYPES[plus.networkinfo.getCurrentType()] || plus.networkinfo.getCurrentType()
		}

		localStorage.device = JSON.stringify(window.device)
		localStorage.statusbarColor = window.statusbarColor
		localStorage.statusbarHeight = plus.navigator.getStatusbarHeight()
		localStorage.localPath = 'file://' + plus.io.convertLocalFileSystemURL('_www')

		typeof cb === 'function' && cb()
	})
}

$(function () {
	$('body').height(screen.height)

	mui.init({
		keyEventBind: {
			backbutton: false
		}
	})
	
	// 默认的状态栏高度/颜色
	window.statusbarColor = '#597ff7'
	localStorage.statusbarHeight = 20
	localStorage.statusbarColor = window.statusbarColor

	window.device = { deviceId: 'uuid_123456' }
	localStorage.device = JSON.stringify(device)
	
	mui.plusReady(function () {
		initDeviceInfoCache(function() {
			window.addEventListener('refreshDeviceInfoCache', initDeviceInfoCache)
			window.addEventListener('indexLoadComplete', function() {
				mui.openWindow({
					url: 'web/index.html',
					styles: {
						popGesture: 'none'
					}
				})
	
				reset()
				plus.webview.getLaunchWebview().hide()
				plus.navigator.closeSplashscreen()
				mui.hideLoading()
			})
			
			var username = localStorage.username
			var token = localStorage.Token
			// 校验token是否有效/过期
			if (token) {
				http.post('/auth/verify', function (res) {
					if (res.status === 200) {
						// token有效跳转到首页,并更新Token
						http.post('/auth/refresh', function (res) {
							localStorage.Token = res.body.token
	
							mui.openWindow({
								url: 'web/index.html',
								styles: {
									popGesture: 'none'
								}
							})
						})
					} else if (res.status === 400) {
						plus.navigator.closeSplashscreen()
						mui.toast('身份认证过期，请您重新登录...', {
							duration: 'long'
						})
					} else {
						plus.navigator.closeSplashscreen()
					}
				}, false)
			} else {
				localStorage.clear()
				localStorage.username = username || ''
				initDeviceInfoCache(function() {
					plus.navigator.closeSplashscreen()
				})
			}
		})
	})

	switchPage(checkPhone)
	$('#phone').val(localStorage.username || '')

	// 登录
	var username, state
	$('.phone_btn').click(function () {
		if (state === -1) {
			// 忘记密码
			var code = $('#code').val()
			if (state != 3 && (!code || !code.trim())) {
				mui.toast('请输入验证码')
				return
			}

			var password = $('#passWord').val()
			if (!password || !password.trim()) {
				mui.toast('请输入您的新密码')
				return
			}

			if (!/^[A-Za-z\d]{6,18}$/.test(password)) {
				mui.toast('密码必须是6-18位，仅支持数字和大小写字母')
				return
			}

			http.post('/auth/reset', $.extend(device, {
				username: username,
				password: password,
				code: code
			}), function (res) {
				mui.toast('重置成功')
				reset()
			})
			return
		}

		if (state === 2 || state === 3 || state === 4) {
			// 输入验证码/密码登录
			var code = $('#code').val()
			if (state != 3 && (!code || !code.trim())) {
				mui.toast('请输入验证码')
				return
			}

			var password = $('#passWord').val()
			if (!password || !password.trim()) {
				mui.toast('请输入您的登录密码')
				return
			}

			if (!/^[A-Za-z\d]{6,18}$/.test(password)) {
				mui.toast('密码必须是6-18位，仅支持数字和大小写字母')
				return
			}

			http.post('/auth/' + (state === 2 ? 'activation' : 'login'), $.extend(device, {
				username: username,
				password: password,
				code: code
			}), function (res) {
				localStorage.Token = res.body.token
				localStorage.username = username
				localStorage.realName = res.body.realName
				localStorage.roles = res.body.roles || ''

				mui.showLoading()
				if (mui.os.plus) {
					// 登录成功跳转到首页
					mui.preload({
						url: 'web/index.html'
					})
				} else {
					mui.openWindow({
						url: 'web/index.html',
						styles: {
							popGesture: 'none'
						}
					})
				}
			})
			return
		}

		var phone = $('.phone').val()

		if (!phone || !phone.trim()) {
			mui.toast('请输入您的手机号码')
			return
		}

		if (!/^1\d{10}$/.test(phone)) {
			mui.toast('请输入有效的手机号码')
			return
		}

		username = phone
		http.post('/auth/checkUsername', $.extend(device, {
			username: phone
		}), function (res) {
			state = res.body
			switch (res.body) {
				case 0:
					mui.alert('您的手机号禁止登录，请联系管理员...')
					break
				case 1:
					mui.alert('您的手机号未注册，请联系管理员...')
					break
				case 2:
					switchPage(activate)
					break
				case 3:
					switchPage(login)
					break
				case 4:
					switchPage(loginWithVerify)
					break
				default:
					mui.alert(res.message)
			}
		})
	})

	// 获取验证码
	var isVerifying = false
	$('#getCode').on('click', function () {
		if (isVerifying) {
			return
		}
		isVerifying = true

		var $el = $(this)
		ajax('/auth/getVerificationCode', {
			username: username
		}, function (res) {
			if (res.status === 200) {
				$('#code')[0].focus()
				settime($el, 60)
			} else {
				mui.toast('获取验证码失败')
			}
		}, 'post', true, false, function() {
			isVerifying = false
		})
	})

	// 忘记密码
	$('#forget').click(function () {
		switchPage(forget)
		state = -1
	})

	function reset() {
		state = 0
		clearTimeout(timer)
		$('#getCode').attr("disabled", false).text("获取验证码")
		$('#code').val('')
		$('#passWord').val('')
		$('#phone').val(localStorage.username || '')
		switchPage(checkPhone)
	}

	//返回按钮
	$('#return').on('click',function(){
		reset()
	})
})