$(function(){
	if(localStorage.storagePhenomenaResData){
		var phenomenaResData=JSON.parse(localStorage.storagePhenomenaResData);
		var phenomenaStartTime=localStorage.phenomenaStartTime;
	}
	if(localStorage.storageWeatherConditionsData){
		var weatherConditionsData=JSON.parse(localStorage.storageWeatherConditionsData);
		var weatherCondStartTime=localStorage.weatherCondStartTime;
	}
	if(localStorage.storageAirqualityData){
		var airqualityData=JSON.parse(localStorage.storageAirqualityData);
		var airqualityStartTime=localStorage.airqualityStartTime;
	}
	
	var activeEleType=localStorage.activeEleType;
	var activeHourType=localStorage.activeHourType;
	var activeEleTxt=localStorage.activeEleTxt;
	
	function getTimeText(time,timeIntelval){
		var str=addHour(time,(timeIntelval-24)*3600*1000).substr(5,2).replace(/^0/,'')+"月"+
		addHour(time,(timeIntelval-24)*3600*1000).substr(8,2).replace(/^0/,'')+"日"+
		addHour(time,(timeIntelval-24)*3600*1000).substr(11,2).replace(/^0/,'')+"时至"+
		addHour(time,timeIntelval*3600*1000).substr(5,2).replace(/^0/,'')+"月"+
		addHour(time,timeIntelval*3600*1000).substr(8,2).replace(/^0/,'')+"日"+
		addHour(time,timeIntelval*3600*1000).substr(11,2).replace(/^0/,'')+"时";
		return str;
	}

	function _switchPhenomenaData(data){
		var resData=data;
		var phenomenaStr='' ,matchData=[];
		var phenomenaCity,phenomenaCnty;
		for(var i=0;i<resData.length;i++){
			var weatherDataItem=resData[i].weatherData;
			var resItem=getStationByCode(resData[i].stationCode);
			var hazeTxt;
		    $(weatherDataItem).each(function(idx){
		    	if(weatherDataItem[idx].dateHour==activeHourType){ //绘制匹配当前预报时效的数据
		    		weatherDataItem[idx].city=resData[i].city;
		    		weatherDataItem[idx].cnty=resData[i].cnty;
		    		weatherDataItem[idx].stationCode=resData[i].stationCode;
		    		matchData.push(weatherDataItem[idx])
		    	}
		    });
		}
	    var activeRank=$("#envirRankBtn").attr("data-rank");
		if(activeRank=='descending'){
			sortData=matchData.sort(sortNumberLowToHigh('haze'));
		}else{
			sortData=matchData.sort(sortNumberHighToLow('haze'));
		}
		var i=1;
		$('#envirTime').text(getTimeText(phenomenaStartTime,activeHourType));
		// $('#envirTime').text(phenomenaStartTime.substr(5,2)+"月"+phenomenaStartTime.substr(8,2)+"日"+phenomenaStartTime.substr(11,2)+"时");
		for(var j=0;j<sortData.length;j++){
			if (!sortData[j].city) {
				continue
			}
			
			switch(parseInt(sortData[j].haze)) {
    			case 0:
    				hazeTxt='无';
    			break;
    			case 1:
    				hazeTxt='轻微霾';
    			break;
    			case 2:
    				hazeTxt='轻度霾';
    			break;
    			case 3:
    				hazeTxt='中度霾';
    			break;
    			case 4:
    				hazeTxt='重度霾';
    			break;
    		}
			phenomenaCity=sortData[j].city;
			phenomenaCnty=sortData[j].cnty === 'null' ? '' : sortData[j].cnty;
    		phenomenaStr+='<li class="mui-table-view-cell statistics-item" data-stationName="'+phenomenaCity+phenomenaCnty+'"  data-stationCode="'+sortData[j].stationCode+'">'+
			        '<a class="mui-navigate-right statistics-item-txt">'+
			        	(i++)+"."+phenomenaCity+' '+phenomenaCnty+
			        	'<span class="statistics-item-number">'+(hazeTxt || '-')+'</span>'+
			        '</a>'+
			    '</li>';
		}
		$("#envirRankUl").html(phenomenaStr);
		$("#totalStations").text("共" + (i - 1) + "站");
	}
	
//	气象条件 begin
	function _switchWeatherCondData(data){
		var resData=data;
		var weatherCondStr='' ,matchWeatherCond=[],sortData=[] , weatherCity,weatherCnty,weatherLevel,weatherCondDataItem;
		for(var i=0;i<resData.length;i++){
		    weatherCondDataItem=resData[i].weatherConditionData;
		    $(weatherCondDataItem).each(function(idx){
		    	if(weatherCondDataItem[idx].dateHour==activeHourType){ //绘制匹配当前预报时效的数据
		    		weatherCondDataItem[idx].stationCode=resData[i].stationCode;
		    		matchWeatherCond.push(weatherCondDataItem[idx]);
		    	}
		    });
		}
		 //升序 降序  TODO
	    var activeRank=$("#envirRankBtn").attr("data-rank");
		if(activeRank=='descending'){
			sortData=matchWeatherCond.sort(sortNumberLowToHigh('meteCondLevel'));
		}else{
			sortData=matchWeatherCond.sort(sortNumberHighToLow('meteCondLevel'));
		}
		var h=1;
		$('#envirTime').text(getTimeText(weatherCondStartTime,activeHourType));
		// $('#envirTime').text(weatherCondStartTime.substr(5,2)+"月"+weatherCondStartTime.substr(8,2)+"日"+weatherCondStartTime.substr(11,2)+"时");
		for(var j=0;j<sortData.length;j++){
			if (!sortData[j].city) {
				continue
			}
			
			weatherCity=sortData[j].city;
			weatherCnty=sortData[j].cnty === 'null' ? '' : sortData[j].cnty;
			weatherLevel=sortData[j].meteCondLevel;
			weatherCondStr+='<li class="mui-table-view-cell statistics-item " data-stationName="'+weatherCity+weatherCnty+'"  data-stationCode="'+sortData[j].stationCode+'">'+
			        '<a class="mui-navigate-right statistics-item-txt">'+
			        	(h++)+"."+weatherCity+' '+weatherCnty+
			        	'<span class="statistics-item-number">'+weatherLevel+'级</span>'+
			        '</a>'+
			    '</li>';
		}
		$("#envirRankUl").html(weatherCondStr);
		$("#totalStations").text("共" + (h - 1) + "站");
		
	}
	// 气象条件    end
	
	//空气质量     begin 
	function _switchAirqualityData(data,type){
		var airqualityStr='';
		var resData=data;
		var sortData=[] ,matchAirqualityData=[] ,airqualityCity, airqualityCnty ,activeVal,airqualityEleTxt;
		for(var i=0;i<resData.length;i++){
			var airqualityItem=resData[i].airData;
		    $(airqualityItem).each(function(idx){
		    	if(airqualityItem[idx].dateHour==activeHourType){ //绘制匹配当前预报时效的数据
		    		airqualityItem[idx].stationCode= resData[i].stationCode;
		    		matchAirqualityData.push(airqualityItem[idx]);
		    	}
		    });
		}
		 //升序 降序  
	    var activeRank=$("#envirRankBtn").attr("data-rank");
		if(activeRank=='descending'){
			sortData=matchAirqualityData.sort(sortNumberLowToHigh(type));
		}else{
			sortData=matchAirqualityData.sort(sortNumberHighToLow(type));
		}
		var k=1;
		$('#envirTime').text(getTimeText(airqualityStartTime,activeHourType));
		// $('#envirTime').text(airqualityStartTime.substr(5,2)+"月"+airqualityStartTime.substr(8,2)+"日"+airqualityStartTime.substr(11,2)+"时");
		for(var j=0;j<sortData.length;j++){
			if (!sortData[j].city || sortData[j][type] >= 9999) {
				continue
			}
			
			airqualityCity=sortData[j].city;
			airqualityCnty=sortData[j].cnty === 'null' ? '' : sortData[j].cnty;
			activeVal=sortData[j][type];
			airqualityStr+='<li class="mui-table-view-cell statistics-item" data-stationName="'+airqualityCity+airqualityCnty+'"  data-stationCode="'+sortData[j].stationCode+'">'+
					        '<a class="mui-navigate-right statistics-item-txt">'+
					        	(k++)+"."+airqualityCity+' '+airqualityCnty+
					        	'<span class="statistics-item-number">'+(activeVal || '-')+'</span>'+
					        '</a>'+
					    '</li>';
		}
		
		$("#envirRankUl").html(airqualityStr);
		$("#totalStations").text("共" + (k - 1) + "站");
	}
	
	//空气质量    end 
	/**
	 * 
	 * @param {Object} activeClassify 
	 * @param {Object} activeType
	 */
	function switchRequest(activeClassify,activeType){
		//0为空气质量，1为天气现象，2为气象条件
		switch (activeClassify){
			case 0:
				if(airqualityData){
					_switchAirqualityData(airqualityData,activeType);
				}
			break;
			case 1:
				if(phenomenaResData){
					_switchPhenomenaData(phenomenaResData);
				}
			break;
			case 2:
				if(weatherConditionsData){
					_switchWeatherCondData(weatherConditionsData);
				}
			break;
			
		}
	}
	
	
	
	//init begin 
	switch(parseInt(activeEleType)){
		case 0:
			$(".airquality-datehour-option").each(function(){
				if($(this).attr("data-type")==activeEleTxt){
					$(this).addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
				}
			});
			if(airqualityData){
				_switchAirqualityData(airqualityData,activeEleTxt);
			}
		break;
		
		case 1:
			$("#hazeOption").addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
			if(phenomenaResData){
				_switchPhenomenaData(phenomenaResData);
			}
		break;
		
		case 2:
			$("#weatherCondOption").addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
			if(weatherConditionsData){
				_switchWeatherCondData(weatherConditionsData);
			}
		break;
	}
//	switchRequest(activeEleType,activeEleTxt);
//	_switchAirqualityData(airqualityData,'aqi');
	
	//要素
	$("#rain-datehour-ul").on("click",".ele-datehour-option",function(){
		var activeClassify=parseInt($(this).attr("data-classify"));
		var activeType=$(this).attr("data-type");
		switchRequest(activeClassify,activeType);
	});
	
	mui("#searchShowTimeBox").on("tap","#envirRankBtn",function(){
		var activeClassify,activeType;
		var activeOrder=$(this).attr("data-rank");
		if(activeOrder=="descending"){
			$(this).attr("data-rank","ascending");
			$(this).text("升序");
		}else{
			$(this).attr("data-rank","descending");
			$(this).text("降序");
		}
		
		activeClassify=parseInt($(".ele-datehour-option.datehour-option-active").attr("data-classify"));
		activeType=$(".ele-datehour-option.datehour-option-active").attr("data-type");
		switchRequest(activeClassify,activeType);
	});
	
	$("#search-ip").on("input", debounce(function(){
		var searchTxt=$(this).val();
		var matchResultArr=[];
		if(searchTxt){
			$(".statistics-item").each(function(){
				var stationName=$(this).find(".statistics-item-txt").text();
				var stationCode=$(this).attr("data-stationCode");
				var matchName=stationName.match(searchTxt);
				var matchStationcode=stationCode.match(searchTxt);
				
				if(matchName){
					matchResultArr.push($(this));
				}
				if(matchStationcode){
					matchResultArr.push($(this));
				}
			});
			if(matchResultArr.length>0){
				$("#envirRankUl").children().hide();
				var matchStationArr=[],matchStation;
				$(".statistics-item").hide();
				for(var i=0;i<matchResultArr.length;i++){
					matchStation=matchResultArr[i].attr("data-stationCode");
					matchStationArr.push(matchStation);
					$(".statistics-item").each(function(idx){
						var stationName=$(this).attr("data-stationName");
						var stationCode=$(this).attr("data-stationCode");
						if(matchStationArr[i]==stationCode){
							$(this).show();
						}
					});
				}
			}else{
				$(".statistics-item").hide();
			}
		}else{
			$(".statistics-item").show();
		}
	}, 200))
	
	
	$(".envir-rank-cancle-btn").on("click",function(){
		$("#search-ip").val('');
		$(".statistics-item").show();
	});
	
});
	
	
	
