//$(function(){
	var map_lat_start, //底图左上角对应的经度
		map_lon_start, //底图左上角对应的纬度
		map_lat_end, //底图右下角对应的经度
		map_lon_end, //底图右小角对应的纬度
		map_w, //底图宽度
		map_h; //底图高度
	var scr_w=$(window).width();
	var scr_h=$(window).height();
	$("#mapWrapper").width(scr_w).height(scr_h-88 - localStorage.statusbarHeight);

	var fogIcon=document.getElementById("fogIcon");
	var hazeIcon=document.getElementById("hazeIcon");
	var envirBgWp=document.getElementById("envirBgWp");
	var rankIcon=document.getElementById("rankIcon");
	
	var cityCan=document.getElementById("cityCan");//城市名画布
	var cityCtx=cityCan.getContext('2d');
	var fullCan=document.getElementById("fullCan"); //可视区域画布
	var fullCtx=fullCan.getContext('2d');
	
	var geoMap ,fullGeoMap ,
		dip=window.devicePixelRatio,
	    lv = 2,
	    tScale  = dip * lv;//设备像素比
	var fontSetting=10*tScale+'px sans-seri';
	var phenomenaResData ,weatherConditionsData ,airqualityData;
	
	// 天气现象  begin    页面上对应数据为霾 
	/**
	 * 
	 * @param {Object} info 0为初始化
	 */
	function phenomena(info){
		fullGeoMap.clear();
		fullCtx.clearRect(0,0,fullCan.width,fullCan.height);
		var url='/environment/phenomena.do';
		var startTime;
		if(info==0){
			startTime='';
		}else{
			startTime=info;
		}
		var params={startTime:startTime};
		ajaxPost(url,params,_phenomenaSuccess,info);
		
	}
	
	function _phenomenaSuccess(data,info){
		localStorage.storagePhenomenaResData=null;
		if(data.body.recordNum==0){
			mui.alert("暂无数据！","提示","确定",function(){})
			return false;
		}
		var envirTime=data.body.startTime;
		phenomenaResData=data.body.data;
		var storagePhenomenaResData=JSON.stringify(phenomenaResData);
		localStorage.storagePhenomenaResData=storagePhenomenaResData;
		if(info==0){
			localStorage.phenomenaInitTime=envirTime;
			localStorage.phenomenaEndTime=addHour(envirTime,3*24*3600*1000);
		}
		localStorage.phenomenaStartTime=envirTime;
		// localStorage.phenomenaTimeTxt=envirTime.substr(5,2)+"月"+envirTime.substr(8,2)+"日"+envirTime.substr(11,2)+"时";
		$('#envirRealTime').text(getTimeText(localStorage.phenomenaStartTime,dataHourIntelval));
		$('#envirRealTime').attr("data-val",envirTime);
		asyncMapVisualization(phenomenaResData, 'phenomenaMv');
		_switchPhenomenaData(phenomenaResData,activeScale,fullCtx);
	}
	
	function _switchPhenomenaData(data,activeScale,ctx){
		fullGeoMap.clear();
		fullCtx.clearRect(0,0,fullCan.width,fullCan.height);
		
		if(activeScale > 1.5 && activeScale < 7){
			drawTwoLvData(result.data, 'cnty');//绘制地理数据
		}
		if(activeScale > 7){
			drawTwoLvData(result.data, 'station');//绘制地理数据
		}
		var size = Math.ceil(10 * dip * lv * 1.4),
			fontSetting= size +'px sans-seri';
		ctx.font=fontSetting;
		
		var resData=data ,conItem;
		var activeDatehour=parseInt($(".envir-datehour-item.datehour-option-active").attr('data-val')); //当前预报时效
		for(var i=0;i<resData.length;i++){
			var weatherDataItem=resData[i].weatherData;
		    conItem= fullGeoMap.registerElement(resData[i],resData[i].lon,resData[i].lat,30);
		    resData[i].containerPos=[conItem[0],conItem[1]];//(x,y)
		    $(weatherDataItem).each(function(idx){
		    	if(weatherDataItem[idx].dateHour==activeDatehour){ //绘制匹配当前预报时效的数据
		    		 switch(weatherDataItem[idx].haze){
						case 1:
							ctx.drawImage(hazeIcon,0,0,74,48,conItem[0]*tScale,conItem[1]*tScale,20*tScale,13*tScale);
						break;
						
						case 2:
							ctx.drawImage(hazeIcon,0,34*tScale,74,48,conItem[0]*tScale,conItem[1]*tScale,20*tScale,13*tScale);
						break;
						
						case 3:
							ctx.drawImage(hazeIcon,0,70*tScale,74,48,conItem[0]*tScale,conItem[1]*tScale,20*tScale,13*tScale);
						break;
					}
		    	}
		    });
		}
		//霾图标
	}
	// 天气现象 end 
	
	// 气象条件     begin  
	function weatherConditions(info){
		fullGeoMap.clear();
		fullCtx.clearRect(0,0,fullCan.width,fullCan.height);
		var url='/environment/weatherConditions.do';
		var startTime;
		if(info==0){
			startTime='';
		}else{
			startTime=info;
		}
		var params={dateHour:startTime};
		ajaxPost(url,params,_weatherConditionsSuccess,info);
	}
	function _weatherConditionsSuccess(data,info){
		localStorage.storageWeatherConditionsData=null;
		if(data.body.recordNum==0){
			mui.alert("暂无数据！","提示","确定",function(){})
			return false;
		}
		var envirTime=data.body.startTime;
		weatherConditionsData=data.body.data;
		var storageWeatherConditionsData=JSON.stringify(weatherConditionsData);
		localStorage.storageWeatherConditionsData=storageWeatherConditionsData;
		if(info==0){
			localStorage.weatherCondInitTime=envirTime;
			localStorage.weatherCondEndTime=addHour(envirTime,3*24*3600*1000);
		}
		localStorage.weatherCondStartTime=envirTime;
		// localStorage.weatherCondTimeTxt=envirTime.substr(5,2)+"月"+envirTime.substr(8,2)+"日"+envirTime.substr(11,2)+"时";
		$('#envirRealTime').text(getTimeText(localStorage.weatherCondStartTime,dataHourIntelval));
		$('#envirRealTime').attr("data-val",envirTime);
		asyncMapVisualization(weatherConditionsData, 'weatherConditionsMv');
		_switchWeatherCondData(weatherConditionsData,activeScale,fullCtx);
	}
	function _switchWeatherCondData(data,activeScale,ctx){
		fullGeoMap.clear();
		fullCtx.clearRect(0,0,fullCan.width,fullCan.height);
		if(activeScale > 1.5 && activeScale < 7){
			drawTwoLvData(result.data, 'cnty');//绘制地理数据
		}
		if(activeScale > 7){
			drawTwoLvData(result.data, 'station');//绘制地理数据
		}
		var size = Math.ceil(10 * dip * lv * 1.4),
			fontSetting= size +'px sans-seri';
		ctx.font=fontSetting;
		
		var weatherCondColorsArr=["#2af744","#e4f439","#df9441","#f20d08","#a01856","#7b0225"];
		var resData=data  ,weatherCondDataItem ,conItem;
		var activeDatehour=parseInt($(".envir-datehour-item.datehour-option-active").attr('data-val')); //当前预报时效
		for(var i=0;i<resData.length;i++){
		    
		    weatherCondDataItem=resData[i].weatherConditionData;
		    $(weatherCondDataItem).each(function(idx){
		    	if(weatherCondDataItem[idx].dateHour==activeDatehour&&weatherCondDataItem[idx].meteCondLevel){ //绘制匹配当前预报时效的数据
		    		conItem= fullGeoMap.registerElement(resData[i],weatherCondDataItem[idx].lon,weatherCondDataItem[idx].lat,30);
		    		ctx.fillStyle="#fff";
					ctx.beginPath();
					ctx.arc((conItem[0]+7.5)*tScale,(conItem[1]-3)*tScale,15.8*tScale,0,360);
					ctx.closePath();
					ctx.fill();
					
					ctx.fillStyle=weatherCondColorsArr[weatherCondDataItem[idx].meteCondLevel-1];
					ctx.beginPath();
					ctx.arc((conItem[0]+7.5)*tScale,(conItem[1]-3)*tScale,15*tScale,0,360);
					ctx.closePath();
					ctx.fill();
					ctx.fillStyle='#000';
					var fontSetting=10*tScale+'px 黑体';
					ctx.font=fontSetting;
					ctx.fillText(weatherCondDataItem[idx].meteCondLevel+'级', conItem[0]*tScale, conItem[1]*tScale);
		    	}
		    });
		}
	}
	// 气象条件    end
	
	//空气质量  begin  
	function airquality(info){
		fullGeoMap.clear();
		fullCtx.clearRect(0,0,fullCan.width,fullCan.height);
		var url='/environment/airquality.do';
		var startTime;
		if(info==0){
			startTime='';
		}else{
			startTime=info;
		}
		var params={startTime:startTime};
		ajaxPost(url,params,_airqualitySuccess,info);
		
	}
	function _airqualitySuccess(data,info){
		localStorage.storageAirqualityData=null;
		if(data.body.recordNum==0){
			mui.alert("暂无数据！","提示","确定",function(){})
			return false;
		}
		var envirTime=data.body.startTime;
		airqualityData=data.body.data;
		var storageAirqualityData=JSON.stringify(airqualityData);
		localStorage.storageAirqualityData=storageAirqualityData;
		if(info==0){
			localStorage.airqualityInitTime=envirTime;
			localStorage.airqualityEndTime=addHour(envirTime,3*24*3600*1000);
		}
		localStorage.airqualityStartTime=envirTime;
		// localStorage.airqualityTimeTxt=envirTime.substr(5,2)+"月"+envirTime.substr(8,2)+"日"+envirTime.substr(11,2)+"时";
		$('#envirRealTime').text(getTimeText(localStorage.airqualityStartTime,dataHourIntelval));
		$('#envirRealTime').attr("data-val",envirTime);
		asyncMapVisualization(airqualityData, 'airqualityMv');
		_switchAirqualityData(airqualityData,activeScale,fullCtx);
	}
	function _switchAirqualityData(data,activeScale,ctx){
		fullGeoMap.clear();
		fullCtx.clearRect(0,0,fullCan.width,fullCan.height);
		
		if(activeScale > 1.5 && activeScale < 7){
			drawTwoLvData(result.data, 'cnty');//绘制地理数据
		}
		if(activeScale > 7){
			drawTwoLvData(result.data, 'station');//绘制地理数据
		}
		var size = Math.ceil(10 * dip * lv * 1.4),
			fontSetting= size +'px sans-seri';
		ctx.font=fontSetting;
		
		var activeDatehour=parseInt($(".envir-datehour-item.datehour-option-active").attr('data-val')); //当前预报时效
		var resData=data ,airqualityItem,conItem ,aqi,activeColor,fontSetting;
		var airqualityColorArr=['#2af744','#e4f439','#df9441','#f20d08','#a01856','#7b0225'];//优良轻中重严重
		var activeType=$(".airquality-datehour-option.datehour-option-active").data('type');//当前选中元素
		for(var i=0;i<resData.length;i++){
			airqualityItem=resData[i].airData;
		    $(airqualityItem).each(function(idx){
		    	if(airqualityItem[idx].dateHour==activeDatehour){ //绘制匹配当前预报时效的数据
		    		if(airqualityItem[idx][activeType]==null){
		    			return true;
		    		}
		    		conItem= fullGeoMap.registerElement(resData[i],airqualityItem[idx].lon,airqualityItem[idx].lat,30);
		    		resData[i].containerPos=[conItem[0],conItem[1]];//(x,y)
		    		aqi=airqualityItem[idx].aqi;
		    		switch(true){
				    	case aqi<51:
				    		activeColor=airqualityColorArr[0];
				    	break;
				    	case aqi>=51 && aqi <=100:
				    		activeColor=airqualityColorArr[1];
				    	break;
				    	case aqi>=101 && aqi <150:
				    		activeColor=airqualityColorArr[2];
				    	break;
				    	case aqi>=151 && aqi <=200:
				    		activeColor=airqualityColorArr[3];
				    	break;
				    	case aqi>=201 && aqi <=300:
				    		activeColor=airqualityColorArr[4];
				    	break;
				    	case aqi>300 :
				    		activeColor=airqualityColorArr[5];
				    	break;
				    }
		    		ctx.fillStyle="#fff";
					ctx.beginPath();
					ctx.arc((conItem[0]+7.5)*tScale,(conItem[1]-3)*tScale,15.8*tScale,0,360);
					ctx.closePath();
					ctx.fill();
					
					ctx.fillStyle=activeColor;
					ctx.beginPath();
					ctx.arc((conItem[0]+7.5)*tScale,(conItem[1]-3)*tScale,15*tScale,0,360);
					ctx.closePath();
					ctx.fill();
					ctx.fillStyle='#000';
					fontSetting=10*tScale+'px 黑体';
					ctx.font=fontSetting;
					ctx.fillText(airqualityItem[idx][activeType], conItem[0]*tScale, conItem[1]*tScale);
		    	}
		    });
		}
	}
	
	//空气质量    end 
	
	function init() {
		map_w=$("#rainMap").width();
		map_h=$("#rainMap").height();
		$("#handleLayer").width(map_w).height(map_h)
		map_lat_start =24.5;
		map_lon_start =108.6; 
		map_lat_end = 30.3; 
		map_lon_end =114.4;
		
		cityCan.width=map_w * dip * lv;
		cityCan.height=map_h * dip * lv;
		cityCan.style.width=map_w+'px';
		cityCan.style.height=map_h+'px';
		
		var wrapperHeight = $('#mapWrapper').outerHeight()
		window.FULL_CAN_TOP = -(wrapperHeight - map_h) / 2
		fullCan.style.top = FULL_CAN_TOP + 'px'
		fullCan.width = map_w * dip * lv
		fullCan.height = wrapperHeight * dip * lv
		fullCan.style.width = map_w + 'px'
		fullCan.style.height = wrapperHeight + 'px'
		geoMap = new GeoMapUtil();
		geoMap.init(map_lon_start,map_lon_end,map_lat_start,map_lat_end, 2, map_w, map_h);
		
		var perLat=Decimal.div(5.8, map_h).toNumber();
		var diffTopLat=Decimal.sub(wrapperHeight, map_h).div(2).mul(perLat).toNumber()
		var initLatMin= Decimal.sub(24.5,diffTopLat);
		var initLatMax=Decimal.add(30.3,diffTopLat);
		
		fullGeoMap = new GeoMapUtil();
		fullGeoMap.init(map_lon_start,map_lon_end,initLatMin,initLatMax, 2, map_w, wrapperHeight);
		drawCityName(cityData,1);
	}
	function drawCityName(data,activeScale){
		var registerElement;
		var size = Math.ceil(10 * dip / activeScale * lv)
		var fontSetting= size +'px sans-seri';
		cityCtx.font=fontSetting;
		cityCtx.clearRect(0,0,cityCan.width,cityCan.height);//	清空画布
		data.forEach(function(item) {
			registerElement = geoMap.registerElement(item, item.lon, item.lat, 30);
			item.containerPos=[registerElement[0],registerElement[1]];
			cityCtx.fillText(item.city, item.containerPos[0]*dip * lv, item.containerPos[1]*dip * lv);
		})
	}
	function drawTwoLvData(data,keyName) {
//		if(data.length==0){return}
		var size = Math.ceil(10 * dip * lv)
		var fontSetting= size +'px sans-seri';
		fullCtx.fillStyle = "#3b3b3c"; 
		fullCtx.font=fontSetting;
//		fullGeoMap.clear();
		fullCtx.clearRect(0,0,fullCan.width,fullCan.height);//	清空画布
		data.forEach(function(item) {
			var registerElement = fullGeoMap.registerElement(item, item.lon, item.lat, 30);
			item.containerPos=[registerElement[0],registerElement[1]];
			size = Math.ceil(10 * dip * lv*2)
			fontSetting= size +'px sans-seri';
			fullCtx.font=fontSetting;
			fullCtx.fillText('.', item.containerPos[0] * dip * lv + item[keyName].length*size/4.8 , item.containerPos[1]*dip * lv + size/4);
			size = Math.ceil(10 * dip * lv)
			fontSetting= size +'px sans-seri';
			fullCtx.font=fontSetting;
			fullCtx.fillText(item[keyName], item.containerPos[0] * dip * lv, item.containerPos[1]*dip * lv);
		})
	}
	/**
	 * 
	 * @param {Object} info  0为初始化，其他为传入时间
	 */
	function switchRequest(info){
		//0为空气质量airquality，1为天气现象phenomena，2为气象条件weatherCond
		var activeType=parseInt($(".ele-datehour-option.datehour-option-active").attr("data-classify"));
		switch (activeType){
			case 0:
				if(airqualityData&&info==0){
					_switchAirqualityData(airqualityData,activeScale,fullCtx);
					$('#envirRealTime').text(getTimeText(localStorage.airqualityStartTime,dataHourIntelval));
				}else{
					airquality(info);
				}
			break;
			case 1:
				if(phenomenaResData&&info==0){
					_switchPhenomenaData(phenomenaResData,activeScale,fullCtx);
					$('#envirRealTime').text(getTimeText(localStorage.phenomenaStartTime,dataHourIntelval));
				}else{
					phenomena(info);
				}
			break;
			case 2:
				if(weatherConditionsData&&info==0){
					_switchWeatherCondData(weatherConditionsData,activeScale,fullCtx);
					$('#envirRealTime').text(getTimeText(localStorage.weatherCondStartTime,dataHourIntelval));
				}else{
					weatherConditions(info);
				}
			break;
			
		}
	}
	function getTimeText(time,timeIntelval){
		var str=addHour(time,(timeIntelval-24)*3600*1000).substr(5,2).replace(/^0/,'')+"月"+
		addHour(time,(timeIntelval-24)*3600*1000).substr(8,2).replace(/^0/,'')+"日"+
		addHour(time,(timeIntelval-24)*3600*1000).substr(11,2).replace(/^0/,'')+"时至"+
		addHour(time,timeIntelval*3600*1000).substr(5,2).replace(/^0/,'')+"月"+
		addHour(time,timeIntelval*3600*1000).substr(8,2).replace(/^0/,'')+"日"+
		addHour(time,timeIntelval*3600*1000).substr(11,2).replace(/^0/,'')+"时";
		console.log(time, timeIntelval, str)
		return str;
	}
	
//	weatherConditions(0);
//	phenomena(0);
	//init   begin TODO    新建一个操作层 把数据层放在地图上
	var activeScale= 1 ,resAirqualityData=[], resPhenomenaData=[], resWeatherCondData=[],dataHourIntelval=24;
	var self = $("#handleLayer")
	$("#rainMap").load(function() {
		init();
		airquality(0);
		
		asyncMapVisualization(cityData, 'cityMv')
		asyncMapVisualization(cntyData, 'cntyMv')
		asyncMapVisualization(townsStationData, 'townsMv')
		
		$("#mapBox").height($(window).width() / $("#rainMap")[0].naturalWidth * $("#rainMap")[0].naturalHeight)
		var isMoved = false
		self.zoom({
			syncDoms: ['#cityCan',"#rainMap"],
			onUpdate: function(x, y, s) {
				if (isMoved) {
					isMoved = false
					return
				}
				fullCan.style.left = (fullCan.offsetLeft - x) + 'px'
				fullCan.style.top = (fullCan.offsetTop - y) + 'px' 
			},
			moved: function(x, y, scale) {
				isMoved = true
				fullCan.style.left = '0px'
				fullCan.style.top = window.FULL_CAN_TOP + 'px'
				activeScale=scale;
				
				if (scale < 1.5) {
					drawCityName(cityData, scale)
					fullCtx.clearRect(0,0,fullCan.width,fullCan.height);
					result = CONSTANT.cityMv.query(Math.abs(x), Math.abs(y), scale) //查询出当前屏幕范围内的数据
				}
				if(scale > 1.5 && scale <7){
					result = CONSTANT.cntyMv.query(Math.abs(x), Math.abs(y), scale) 
					cityCtx.clearRect(0,0,cityCan.width,cityCan.height)
				}
				if(scale > 7){
					if(CONSTANT.townsMv){
						result = CONSTANT.townsMv.query(Math.abs(x), Math.abs(y), scale) 
						cityCtx.clearRect(0,0,cityCan.width,cityCan.height)
					}
				}
				
				fullGeoMap = new GeoMapUtil()
				fullGeoMap.init(result.startLon,result.endLon,result.startLat,result.endLat, Decimal.sub(result.endLon, result.startLon).div(10).toNumber(), Number(fullCan.style.width.replace('px', '')), Number(fullCan.style.height.replace('px', '')));
				
				//0为空气质量，1为天气现象，2为气象条件
				var activeType=Number($(".ele-datehour-option.datehour-option-active").attr("data-classify"));
				switch (activeType){
					case 0: 
						if(airqualityData){
							resAirqualityData= CONSTANT.airqualityMv.query(Math.abs(x), Math.abs(y), scale).data;
							
							if(resAirqualityData.length != 0){
								_switchAirqualityData(resAirqualityData,activeScale,fullCtx);
							}else{
								_switchAirqualityData(airqualityData,activeScale,fullCtx);
							}
							
						}else{
							if(activeScale > 1.5 && activeScale < 7){
								drawTwoLvData(result.data, 'cnty');
							}
							if(activeScale > 7){
								drawTwoLvData(result.data, 'station');
							}
						}
					break;
					case 1:
						if(phenomenaResData){
							resPhenomenaData= CONSTANT.phenomenaMv.query(Math.abs(x), Math.abs(y), scale).data;
							
							if(resAirqualityData.length != 0){
								_switchPhenomenaData(resPhenomenaData,activeScale,fullCtx);
							}else{
								_switchPhenomenaData(phenomenaResData,activeScale,fullCtx);
							}
							
						}else{
							if(activeScale > 1.5 && activeScale < 7){
								drawTwoLvData(result.data, 'cnty');
							}
							if(activeScale > 7){
								drawTwoLvData(result.data, 'station');
							}
						}
					break;
					case 2:
						if(weatherConditionsData){
							resWeatherCondData= CONSTANT.weatherConditionsMv.query(Math.abs(x), Math.abs(y), scale).data;
							
							if(resAirqualityData.length != 0){
								_switchWeatherCondData(resWeatherCondData,activeScale,fullCtx);
							}else{
								_switchWeatherCondData(weatherConditionsData,activeScale,fullCtx);
							}
							
							
						}else{
							if(activeScale > 1.5 && activeScale < 7){
								drawTwoLvData(result.data, 'cnty');
							}
							if(activeScale > 7){
								drawTwoLvData(result.data, 'station');
							}
						}
					break;
					
				}


			}
		})
	})
	 .attr('src', '../../images/map/a.min.svg')
	
	//时效
	$(".envir-datehour-item").on("click",function(){
		var activeType=parseInt($(".ele-datehour-option.datehour-option-active").attr("data-classify"));
		$(this).addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
		dataHourIntelval=parseInt($(this).attr('data-val'));
		switchRequest(0);
	});
	
	//要素
	$("#rain-datehour-ul").on("click",".ele-datehour-option",function(e){
		var activeType=parseInt($(this).attr("data-classify"));
		$(this).addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
		switchRequest(0);
	});
	
	//点击前后一天
	$("#envir-conent").on("click","#prevTimeBtn",function(){
		var activeType ,activeTime ,activeInitTime ,activeEndTime;
		activeType=parseInt($(".ele-datehour-option.datehour-option-active").attr("data-classify"));
		switch(activeType){
			case 0:
				activeTime=addHour(localStorage.airqualityStartTime,-12*3600*1000);
				activeInitTime=localStorage.airqualityInitTime;
				activeEndTime=localStorage.airqualityEndTime;
			break;
			case 1:
				activeTime=addHour(localStorage.phenomenaStartTime,-12*3600*1000);
				activeInitTime=localStorage.phenomenaInitTime;
				activeEndTime=localStorage.phenomenaEndTime;
			break;
			case 2:
				activeTime=addHour(localStorage.weatherCondStartTime,-12*3600*1000);
				activeInitTime=localStorage.weatherCondInitTime;
				activeEndTime=localStorage.weatherCondEndTime;
			break;
		}
		if(activeTime>activeEndTime){
			mui.alert("已经是最后数据！","提示","确定",function(){})
			return false;
		}
		console.log(localStorage.weatherCondStartTime)
		console.log(activeTime)
		switchRequest(activeTime);
	});
	$("#envir-conent").on("click","#nextTimeBtn",function(){
		var activeType ,activeTime ,activeInitTime ,activeEndTime;
		activeType=parseInt($(".ele-datehour-option.datehour-option-active").attr("data-classify"));
		switch(activeType){
			case 0:
				activeTime=addHour(localStorage.airqualityStartTime,12*3600*1000);
				activeInitTime=localStorage.airqualityInitTime;
				activeEndTime=localStorage.airqualityEndTime;
			break;
			case 1:
				activeTime=addHour(localStorage.phenomenaStartTime,12*3600*1000);
				activeInitTime=localStorage.phenomenaInitTime;
				activeEndTime=localStorage.phenomenaEndTime;
			break;
			case 2:
				activeTime=addHour(localStorage.weatherCondStartTime,12*3600*1000);
				activeInitTime=localStorage.weatherCondInitTime;
				activeEndTime=localStorage.weatherCondEndTime;
			break;
		}
		if(activeTime>activeInitTime){
			mui.alert("已经是最新数据！","提示","确定",function(){})
			return false;
		}
		switchRequest(activeTime);
	});
	
	mui(".show-info-btn-box").on("click","#environmental-rank-link",function(){
		var activeEleType, activeHourType ,activeEleTxt;
		activeEleType=parseInt($(".ele-datehour-option.datehour-option-active").attr("data-classify"));
		activeEleTxt=$(".ele-datehour-option.datehour-option-active").attr("data-type");
		activeHourType=$(".envir-datehour-item.datehour-option-active").attr("data-val");
		localStorage.activeEleType=activeEleType;
		localStorage.activeHourType=activeHourType;
		localStorage.activeEleTxt=activeEleTxt;
		
		if(!localStorage.storagePhenomenaResData){
			phenomena(0);
		}
		if(!localStorage.storageWeatherConditionsData){
			weatherConditions(0);
		}
		mui.openWindow({
		    url:'../forecastInfo/envirForecastRank.html',
			styles: {
				statusbar: {
					background: localStorage.statusbarColor
				}
			}
		});
	});
	
	
//});
