$(function () {
	// 初始化容器宽高
	$(".mui-content").height($(window).height() - $('header').css('height').replace('px', ''))

	mui.init({
		swipeBack: false, //启用右滑关闭功能
		gestureConfig: {
			tap: true, //默认为true
			doubletap: true, //默认为false
			longtap: true, //默认为false
			swipe: true, //默认为true
			drag: false, //默认为true
			hold: false, //默认为false，不监听
			release: false //默认为false，不监听
		}
	})
	
	// 初始化地图
	var map = GIS.init()
	map.on('load', function() {
		GIS.utils.addBlankImageSource('spotImage')
		
		map.addLayer({
			id: 'spotImage',
			source: 'spotImage',
			type: "raster"
		}, 'city-boundary')
		
		loadData()
	})

	// 加载数据
	var swiper
	function loadData(cb) {
		http.post('/severeWeather/severeWeatherImg.do', {
			isMode: 0,
			startTime: '',
			type: $(".rain-datehour-option.datehour-option-active").attr("data-val")
		}, function (data) {
			var result = data.body.data
			if (data.body.recordNum === 0) {
				return mui.alert("暂无数据！", "提示")
			}
			
			var path = result[0].path
			var image = (path === null || path === undefined || path === '' || path.indexOf('.png') === -1) ? GIS.defaults.blankImageURI : path
			map.getSource('spotImage').updateImage({ url: image })

			// 显示起报时间
			$("#rainfallStartTime").text(dayjs(data.body.startTime).format('MM月DD日HH时'))

			// 处理时间轴条目
			var items = [].concat(result).reverse().slice(1).reduce(function (arr, item) {
				return ['<div class="swiper-slide">' + dayjs(item.datetime).format('YYYY-MM-DD<br>HH:mm') + '</div>'].concat(arr)
			}, Array(3).fill('<div class="swiper-slide none"></div>'))
			$('.swiper-wrapper').html(items)

			// 生成时间轴控件
			swiper && swiper.destroy()
			swiper = new Swiper('.swiper-container', {
				autoplay: {
					delay: 1000,
					stopOnLastSlide: true
				},
				slidesPerView: 'auto',
				slideToClickedSlide: true,
				on: {
					slideChange: function () {
						var path = result[this.activeIndex + 1].path
						var image = (path === null || path === undefined || path === '' || path.indexOf('.png') === -1) ? GIS.defaults.blankImageURI : path
						map.getSource('spotImage').updateImage({ url: image })
					},
					autoplayStop: function () {
						$('#play').data("val", 0)
						$('#play').css("background-image", "url(../../images/play.png)")
					}
				}
			})
			swiper.autoplay.stop()
		})
	}

	// 播放按钮
	$('#play').click(function () {
		if ($(this).data("val") == 0) {
			$(this).data("val", 1)
			$(this).css("background-image", "url(../../images/pause.png)")
			swiper && swiper.autoplay.start()
		} else {
			$(this).data("val", 0)
			$(this).css("background-image", "url(../../images/play.png)")
			swiper && swiper.autoplay.stop()
		}
	})

	// 色标切换
	$(".mui-content").on("tap","#swLegendBox",function(){
		var activeType = $(".rain-datehour-option.datehour-option-active").data('val')
		$("#severeWeatherlegend").attr("src", "../../images/severeWeatherFiLegend/" + activeType + ".png")
    $("#severeWeatherlegend").toggle()
	});

	// 切换类型
	$("#rain-datehour-ul").on("click", ".rain-datehour-option", function () {
		$(this).addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
		$("#severeWeatherlegend").attr("src", "../../images/severeWeatherFiLegend/" + $(this).data("val") + ".png")
		loadData()
	})
})
