$(function(){
	$(".mui-content").height($(window).height() - 44 - Number(localStorage.statusbarHeight))

	var swiper, activeData
	function renderSwiper(htmls) {
		swiper && swiper.destroy()
		$('.swiper-wrapper').html(htmls.join(''))
		swiper = new Swiper('.swiper-container', {
			passiveListeners: false,
			initialSlide: 0,
			preloadImages: false,
			lazy: {
			    loadPrevNext: true
			},
			zoom: {
			    toggle: false
			}, 
			autoplay: {
				delay: 1000,
				stopOnLastSlide: true
			},
			on: {
				init: function() {
					$("#radarControl").val(0)
					$("#playImg").attr("data-val", 0)
					$("#playImg").attr("src", "../../images/monitoringOfLive/radar-play.png")
				},
				slideChange: function() {
					$("#radarControl").val(this.activeIndex)
					var activeDay = activeData[this.activeIndex].day;
					var activeStartTime = addHour(startTime,(activeDay-1)*24*3600*1000);
					var activeStartTimeTxt = activeStartTime.substr(5,2)+"月"+activeStartTime.substr(8,2)+"日"+activeStartTime.substr(11,2)+"时";
					var activeEndTime = addHour(startTime,activeDay*24*3600*1000);
					var activeEndTimeTxt = activeEndTime.substr(5,2)+"月"+activeEndTime.substr(8,2)+"日"+activeEndTime.substr(11,2)+"时";
					$("#realTime").text(activeStartTimeTxt + "-" + activeEndTimeTxt);
				},
				autoplayStop: function() {
					$("#playImg").attr("data-val", 0)
					$("#playImg").attr("src", "../../images/monitoringOfLive/radar-play.png")
				}
			}
		})
		swiper.autoplay.stop()
	}
	
	//气温预报图片信息获取   begin 
	function temForecastImg(){
		var url="/preTemForecast/preTemForecast.do";
		var type=parseInt($("#distinguishType").val());		//预报版块中气温和降水为同一接口，用该隐藏域来判断，降水为1，气温为2
		var params={type:type};
		http.post(url,params,_temForecastImgSuccess,'');
	}
	var resData;
	function _temForecastImgSuccess(data,info){
		if(data.body.recordNum==0){
			mui.confirm("暂无数据！","提示",function(){
				return false;
			});
		}
		resData=data.body.data;
		_switchData(resData,0);
	}
	/**
	 * 
	 * @param {Object} data      渲染数据
	 * @param {Object} order     图片次序
	 */
	var matchItem = [];
	var startTime;
	function _switchData(data,order){
		var activeType ,recordNum;
		var type=parseInt($("#distinguishType").val());
		if(type==1){
			activeType=1;
		}else{
			activeType=parseInt($(".tem-datehour-option.datehour-option-active").attr("data-sort"));
		}
		var match = activeType == 1 ? 'rain' :(activeType == 2 ? 'TMAX' : 'TMIN');
		var days = [];
		var imgs = data[0].imgs;
		matchItem = [];
		$(imgs).each(function(idx){
			var item = imgs[idx];
			var day = item.day;
			var fileName = item.fileName;
			var isDealed = false;
			$(days).each(function(i){
				if(days[i] == day)
					isDealed = true;
			});
			if(!isDealed && fileName.indexOf(match) >= 0){
				startTime=item.startTime;
				matchItem.push(item);
				days.push(day);
			}
		});
		
		var htmls = []
		
		var imgStr='';
			activeClass='';
		for(var i=0;i<matchItem.length;i++){
			if(i==0){
				activeClass='img-active'
			}else{
				activeClass='';
			}
			var activeDay=matchItem[i].day;
			var activeStartTime=addHour(startTime,(activeDay-1)*24*3600*1000);
			var activeStartTimeTxt=activeStartTime.substr(5,2)+"月"+activeStartTime.substr(8,2)+"日"+activeStartTime.substr(11,2)+"时";
			var activeEndTime=addHour(startTime,activeDay*24*3600*1000);
			var activeEndTimeTxt=activeEndTime.substr(5,2)+"月"+activeEndTime.substr(8,2)+"日"+activeEndTime.substr(11,2)+"时";
			
			imgStr+='<img class="img radar-img '+activeClass+'" src="'+matchItem[i].path+'" data-order='+(i)+' data-time='+activeStartTimeTxt+"-"+activeEndTimeTxt+' data-preview-src="" data-preview-group="1" />'
			
			htmls.push('<div class="swiper-slide"><div class="swiper-zoom-container"><img data-src="' + matchItem[i].path + '" class="swiper-lazy"></div><div class="swiper-lazy-preloader"></div></div>')
		}
		
		activeData = matchItem
		renderSwiper(htmls)
		
//		$("#imgBox").html(imgStr);
		recordNum = matchItem.length;
		$("#radarControl").attr("max",htmls.length - 1);
//		$("#radarImg").attr("src",matchItem[order].path);
		
		_switchActiveImg(0);
		
		
	}
	//气温预报图片信息获取  end
	function _switchActiveImg(order){
		$(".img").each(function(){
			if($(this).attr("data-order")==order){
				$(this).addClass("img-active").siblings().removeClass("img-active");
			}
		});
		$("#radarControl").val(order);
		if(order==matchItem.length){
			return
		}
		var activeDay=matchItem[order].day;
		var activeStartTime=addHour(startTime,(activeDay-1)*24*3600*1000);
		var activeStartTimeTxt=activeStartTime.substr(5,2)+"月"+activeStartTime.substr(8,2)+"日"+activeStartTime.substr(11,2)+"时";
		var activeEndTime=addHour(startTime,activeDay*24*3600*1000);
		var activeEndTimeTxt=activeEndTime.substr(5,2)+"月"+activeEndTime.substr(8,2)+"日"+activeEndTime.substr(11,2)+"时";
		$("#realTime").text(activeStartTimeTxt+"-"+activeEndTimeTxt);
	}
	
	
	
	//开始 暂停
	function progressTimeControl(img,rangeDom) {
	    if ($(img).attr("data-val") == 0) {
	    	$(img).attr("data-val",1);
	        $(img).attr("src", "../../images/monitoringOfLive/radar-unplay.png");
//	       　		autoPlay(img,rangeIp);　
			swiper && swiper.autoplay.start()
	    }else {
	       	$(img).attr("data-val",0);
	        $(img).attr("src", "../../images/monitoringOfLive/radar-play.png");
//	       	clearInterval(time),function(){
//			　　  autoPlay(img,rangeIp);　
//			}　
			swiper && swiper.autoplay.stop()
	    }
	}

	function autoPlay(img,rangeDom){
		$('.radar-img').css({
			"transform":"translate3d(0,0,0) scale(1) rotate3d(0,0,0,0)"
		});
	　　	time = setInterval(function(){
			var orderVal=parseInt(rangeDom.val());
	    	var orderMax=parseInt(rangeDom.attr("max"));
	    	var orderMin=parseInt(rangeDom.attr("min"));
	    	var orderStep=parseInt(rangeDom.attr("step"));
	    	if(orderVal<orderMax){
	    		orderVal+=1;
	    		rangeDom.val(orderVal)
//				_switchData(resData,orderVal);
				_switchActiveImg(orderVal)
	    	}else if(orderVal>=orderMax){
	    		$(img).attr("data-val",0);
	        	$(img).attr("src", "../../images/monitoringOfLive/radar-play.png");
				clearInterval(time),function(){
				　　  autoPlay(img,rangeIp);　
				}　
	    	}
	　　	},1000)
	}
	

	//交互   begin  
	
	temForecastImg();
	
	var img=$("#playImg");
	var rangeIp=$("#radarControl");
	$("#playControlBtn").on("click",function(){
		var maxOrder=parseInt($("#radarControl").attr("max"));
		var activeOrder=parseInt($("#radarControl").val());
		if(activeOrder==maxOrder){
			$("#radarControl").val(0);
			swiper && swiper.slideTo(0, 0)
		}
		progressTimeControl(img,rangeIp);
	});
	
	//TODO range移动时提示框隐藏
	$("#radarControl").siblings('span').remove();
	$("#radarControl").change(function(){
		var order=$(this).val();
		$(this).siblings('span').remove();
//		_switchData(resData,order);
		_switchActiveImg(order)
		
		swiper && swiper.slideTo(order, 0)
	});

	mui("#tem-datehour-box").on("click",".tem-datehour-option",function(){
		var order=parseInt($("#radarControl").val());
		_switchData(resData,order);
//		_switchActiveImg(order)
	});
	
	$('.time-btn').on('click', function() {
		$('.radar-img').css({
			"transform":"translate3d(0,0,0) scale(1) rotate3d(0,0,0,0)"
		});
		var activeOrder = parseInt($("#radarControl").val());
		var id = $(this).attr('id');
		var option = id == 'prevTimeBtn' ? -1 : 1;
		var orderVal = parseInt(activeOrder + option);
		var maxVal=parseInt($("#radarControl").attr('max'));
		if(orderVal > maxVal || orderVal < 0) {
			return false;
		}
		$("#radarControl").val(orderVal);
		_switchData(resData,orderVal);
	});
});
