$(function() {
	window.map = new AMap.Map('map-content', {
		center: [111.81, 26.5],
		resizeEnable: true,
		layers: [new AMap.TileLayer()], //卫星图层AMap.TileLayer.RoadNet(roadnetOpt:RoadNetOptions)
		zoom: 6
	});
	//初始化
	stainMap();

	function stainMap() {
		var url = "/forecastMonitor/gridForecast/gridForecastStainMap.do";
		var param, timeInterval;
		$(".gird-list-item-link").each(function() {
			if ($(this).hasClass("gird-list-item-link-active")) {
				var dataType = $(this).attr("data-type");
				switch (dataType) {
					case 'cloud':
						param = 11;
						timeInterval = 3;
						break;
					case 'wind':
						param = 10;
						timeInterval = 3;
						break;
					case 'rain':
						param = 0;
						timeInterval = 3;
						break;
					default:
						param = $(this).siblings(".gird-list-item-option-box").find("input[type='radio']:checked").attr("data-params");
						timeInterval = $(this).siblings(".gird-list-item-option-box").find("input[type='radio']:checked").attr(
							"data-aging");
						break;
				}
			}
		});
		var params = {
			param: param
		};
		ajaxPost(url, params, _stainMapSuccess, timeInterval);

	}
	var showData = [],
		markerData = [];

	function _stainMapSuccess(data, timeInterval) {
		var resData = data.body.data;
		var resStartTime = addHour(data.body.startTime, 1000 * 3600 * 8);
		var timeInterval = parseInt(timeInterval);
		//生成时间轴
		timeShaft(timeInterval, resStartTime);
		$("#show-real-time").text(resStartTime);
		if (data.body.recordNum == 0) {
			mui.alert('暂无数据！')
			return false;
		}
		showData = []; //清空数组
		for (var i = 0; i < resData.length; i++) {
			var showItem = {};
			if (i == 0) {
				showItem.showTime = resStartTime;
			} else {
				showItem.showTime = addHour(resStartTime, i * timeInterval * 60 * 60 * 1000);
			}
			showItem.imageLayerUrl = resData[i];
			showData.push(showItem);
		}
		setImgLayer(showData, resStartTime);
	}

	//根据所选择的时间来设置要展示的图片图层

	var imgLayerArr = [],
		firstImgLayerFlag = 0;

	function setImgLayer(data, datetime) {
		var showData = data;
		var resShowItem, imageLayerURL;
		$(showData).each(function(idx) {
			var showItem = data[idx];
			if (datetime == showItem.showTime) {
				resShowItem = showItem;
				if (resShowItem.imageLayerUrl == '') {
					return;
				}
				imageLayerURL = resShowItem.imageLayerUrl;
				return false;
			} else {
				imageLayerURL = '';
			}
		});
		//如果地图上已存在img图层   移除
		if (firstImgLayerFlag == 1) {
			for (var i = 0; i < imgLayerArr.length; i++) {
				imgLayerArr[i].setMap(null);
			}
		}
		var imageLayer = new AMap.ImageLayer({
			url: imageLayerURL,
			bounds: new AMap.Bounds(
				[108.65, 24.5],
				[114.4, 30.25]
			),
			zooms: [6, 18]
		});
		if (imageLayerURL) {
			imageLayer.setMap(map);
			imgLayerArr.push(imageLayer);
			firstImgLayerFlag = 1;
		} else {
			imageLayer.setMap(null);
		}
	}


	//为地图注册click事件获取鼠标点击出的经纬度坐标 TODO
	var clickEventListener = map.on('click', function(e) {
		var lonLat = {};
		var lnglatXY = [];
		lonLat.lon = e.lnglat.getLng();
		lonLat.lat = e.lnglat.getLat();
		lnglatXY.push(e.lnglat.getLng());
		lnglatXY.push(e.lnglat.getLat());
		regeocoder(lnglatXY);
		singleGridChart(lonLat);
	});


	//逆地理编码
	var searchFocusFlag = 0;

	function regeocoder(lnglatXY) {
		var geocoder = new AMap.Geocoder({
			radius: 1000,
			extensions: "all"
		});
		geocoder.getAddress(lnglatXY, function(status, result) {
			if (status === 'complete' && result.info === 'OK') {
				var resProvince = result.regeocode.addressComponent.province; //返回地址描述
				var resCity = result.regeocode.addressComponent.city;
				var resDistrict = result.regeocode.addressComponent.district;
				$(".location-province").text(resProvince);
				$(".location-city").text(resCity);
				$(".location-district").text(resDistrict);
				$("#gridIP").addClass("mui-active");
				$("#girdding-search").val(resDistrict);
			} else {}
		});
	}
	//正向地理编码
	function geocoder(placeName) {
		var geocoder = new AMap.Geocoder({
			city: "全国", //城市，默认：“全国”
			radius: 1000 //范围，默认：500
		});
		//地理编码,返回地理编码结果
		geocoder.getLocation(placeName, function(status, result) {
			if (status === 'complete' && result.info === 'OK') {
				var geocode = result.geocodes;
				$(".location-province").text(geocode[0].addressComponent.province);
				$(".location-city").text(geocode[0].addressComponent.city);
				$(".location-district").text(geocode[0].addressComponent.district);
				var lonLat = {};
				var lon = geocode[0].location.getLng();
				var lat = geocode[0].location.getLat();
				lonLat.lon = lon;
				lonLat.lat = lat;
				singleGridChart(lonLat);

			}
		});
	}

	//验证字符串是数字还是中文
	function checkNumOrZn(theObj) {
		var regNum = /^[0-9]+.?[0-9]*$/;
		var regZN = /^[\u4e00-\u9fa5]+$/;
		if (regNum.test(theObj)) {
			return 0;
		} else if (regZN.test(theObj)) {
			return 1;
		} else {
			return 2;
		}
	}

	//搜索地名
	$("#girdding-search").keyup(function() {
		var placeVal = $(this).val();
		var valArr = [],
			lon, lat, lonLat = {};
		var valFlag = checkNumOrZn(placeVal);
		if (valFlag == 0) {
			valArr = placeVal.split(",");
			if (valArr.length == 2) {
				lon = valArr[0];
				lat = valArr[1];
				lonLat.lon = valArr[0];
				lonLat.lat = valArr[1];
				regeocoder(lonLat);
				singleGridChart(lonLat);
			}
		} else if (valFlag == 1) {
			geocoder(placeVal);

		} else {
			return false;
		}
	});




	//单格点折线图数据获取 
	function singleGridChart(lonLat) {
		var url = "/forecastMonitor/gridForecast/singleGridChart.do";
		var lat = lonLat.lat;
		var lon = lonLat.lon;
		var params = {
			lat: lat,
			lon: lon
		};
		ajaxPost(url, params, _singleGridChartSuccess, lonLat);
	}

	function _singleGridChartSuccess(data, lonLat) {
		if (data.body.recordNum == 0) {
			$("#chart-box").hide();
			return false;
		}
		$("#chart-box").show();
		var resData = data.body;
		var cloudArr = [],
			preArr = [],
			rhuArr = [],
			temArr = [],
			windDirectionArr = [],
			windSpeedArr = [],
			xAixsTime = [],
			cloudNumArr = [],
			preNumArr = [],
			rhuNumArr = [],
			temNumArr = [],
			windDirectionNumArr = [],
			windSpeedNumArr = [],
			resStartTime, xAixsTimeItemDetails;

		resStartTime = data.body.startTime;
		cloudArr = resData.cloud;
		preArr = resData.pre;
		rhuArr = resData.rhu;
		temArr = resData.tem;
		windDirectionArr = resData.windDirection;
		windSpeedArr = resData.windSpeed;

		for (var i = 0; i < preArr.length; i++) {
			cloudNumArr.push(Number(cloudArr[i]));
			preNumArr.push(Number(preArr[i]));
			rhuNumArr.push(Number(rhuArr[i]));
			temNumArr.push(Number(temArr[i]));
			windDirectionNumArr.push(Number(windDirectionArr[i]));
			windSpeedNumArr.push(Number(windSpeedArr[i]));
		}

		var dataLength = preArr.length;
		var screenWeight = $(window).width();
		//		$('#chart-container').width(screenWeight*Math.round(dataLength/6));
		$(".release-time").text(resStartTime.substr(0, 16));
		markerData = []; //清空数组
		for (var i = 0; i < dataLength; i++) {
			var xAixsTimeItem = '',
				markerDetails = {};
			xAixsTimeItem = addHour(resStartTime, i * 3 * 60 * 60 * 1000);
			markerDetails.rain = preArr[i];
			markerDetails.cloud = cloudArr[i];
			markerDetails.humidity = rhuArr[i];
			markerDetails.tem = temArr[i];
			markerDetails.wind = windSpeedArr[i];
			markerDetails.windDirection = windDirectionArr[i];
			markerDetails.datetime = xAixsTimeItem;
			markerData.push(markerDetails);

			xAixsTimeItemDetails = xAixsTimeItem.substr(8, 2) + '日/' + xAixsTimeItem.substr(11, 2);
			xAixsTime.push(xAixsTimeItemDetails);
		}

		accordingToTime(lonLat, markerData, ($("#show-time-tip").text() + ':00'));
		//图表
		$('#temChartBox').highcharts({
			chart: {
				//				margin: [30, 40, auto, 40],
				//				backgroundColor:'rgba(195,201,214,.9)',
				//				spacing: [0,0,0,0],
				//				zoomType: 'x',
				//				panning: true,
				//	            panKey: 'shift'
			},
			title: {
				text: ' '
			},
			xAxis: {
				categories: xAixsTime
			},
			yAxis: [{
				title: {
					text: ' '
				},
				lineWidth: 1,
			}, {
				title: {
					text: ' '
				},
				lineWidth: 1,
				opposite: true
			}],
			legend: {
				padding: 0,
				margin: 6,
				//		        layout: 'horizontal',
				align: 'left',
				verticalAlign: 'top',
				//	        y: 0,
				//	            floating: true,
				itemDistance: 4,
				itemHiddenStyle: {
					color: '#ccc'
				}
			},
			scrollbar: {
				enabled: false
			},
			plotOptions: {
				series: {
					dataLabels: {
						enabled: false,
						color: 'red'
					}
				}
			},
			series: [{
				type: 'line',
				name: '温度',
				data: temNumArr,
				color: '#e44050'
			}, {
				type: 'column',
				name: '降水',
				data: preNumArr,
				yAxis: 0,
				color: '#92eb92'
			}, {
				type: 'line',
				name: '风速',
				data: windSpeedNumArr,
				color: '#252627'
			}],
			tooltip: {
				shared: true
			},
			exporting: {
				enabled: false
			},
			credits: {
				enabled: false
			}
		});
		$('#humidityChartBox').highcharts({
			chart: {
				//				margin: [30, 40, 24, 40],
				//				backgroundColor:'rgba(195,201,214,.9)',
				//				spacing: [0,0,0,0],
				//				zoomType: 'x',
				//				panning: true,
				//	            panKey: 'shift'
			},
			title: {
				text: ' '
			},
			xAxis: {
				categories: xAixsTime
			},
			yAxis: [{
				tickPositions: [0, 50, 100],
				title: {
					text: ''
				}
			}, {
				tickPositions: [0, 50, 100],
				title: {
					text: ''
				},
				opposite: true
			}],
			legend: {
				padding: 0,
				margin: 6,
				//		        layout: 'horizontal',
				align: 'left',
				verticalAlign: 'top',
				//	        y: 0,
				//	            floating: true,
				itemDistance: 4,
				itemHiddenStyle: {
					color: '#ccc'
				}
			},
			scrollbar: {
				enabled: false
			},
			plotOptions: {
				series: {
					dataLabels: {
						enabled: false,
						color: 'red'
					}
				}
			},
			series: [{
				type: 'line',
				name: '湿度',
				data: rhuNumArr,
				color: '#1ca7ef'
			}, {
				type: 'column',
				name: '云量',
				data: cloudNumArr,
				yAxis: 1,
				color: '#fca04f'
			}],
			tooltip: {
				shared: true
			},
			exporting: {
				enabled: false
			},
			credits: {
				enabled: false
			}
		});
		var lonLatArr = [];
		lonLatArr.push(Number(lonLat.lon));
		lonLatArr.push(Number(lonLat.lat));
		map.setZoomAndCenter(8, lonLatArr);

	}

	//温度、云量折线图切换
	mui("#chart-box").on("tap", "#switchChartBtn", function() {
		var switchChartBtn = $("#switchChartBtn"),
			temChartBox = $("#temChartBox"),
			humidityChartBox = $("#humidityChartBox");
		if (temChartBox.hasClass('active-box')) {
			temChartBox.removeClass('active-box').siblings().addClass('active-box')
			switchChartBtn.text('温度降水风速')
		} else {
			humidityChartBox.removeClass('active-box').siblings().addClass('active-box')
			switchChartBtn.text('相对湿度、云量')
		}
	})

	//	TODO  1、拖动时间轴的时候  地图上当前选中点数据切换
	var markersArr = [],
		firstMarkerFlag = 0;

	function accordingToTime(lonLat, data, datetime) {
		var realTime = datetime,
			showData = data,
			toShowDataItem, toShowMarkerCont, dataType, toShowTime;
		//获取当前选择展示类别  和 对应时效  
		$(".gird-list-item-link").each(function() {
			if ($(this).hasClass("gird-list-item-link-active")) {
				dataType = $(this).attr("data-type");
			}

		});
		if (!dataType) {
			return false;
		}
		switch (dataType) {
			case 'rain':
				//TODO 1、当前选择时间加降水当前选择时效=要展示的时间，根据要展示时间去寻找对应数据    2、切换时效选择时， 要展示时间=当前选择时间加选择时效   通过时间去匹配对应数据
				var rainDateHour = $("input[name='rain-options']:checked").attr('data-aging');
				toShowTime = addHour(realTime, rainDateHour * (1000 * 3600));

				break;

			case 'tem':
				var temDateHour = $("input[name='tem-options']:checked").attr('data-aging');
				toShowTime = addHour(realTime, temDateHour * (1000 * 3600));
				break;

			case 'wind':
				toShowTime = realTime;
				break;

			case 'humidity':
				var humidityAging = $("input[name='humidity-options']:checked").attr('data-aging');
				toShowTime = addHour(realTime, humidityAging * (1000 * 3600));
				break;

			case 'cloud':
				toShowTime = realTime;
				break;
		}
		$(showData).each(function(idx) {
			var showDataItem = showData[idx];
			if (toShowTime == showDataItem.datetime) {
				toShowDataItem = showDataItem;
				return false;
			}

		});

		//在地图上标注当前选项该点数据

		if (toShowDataItem) {
			if (dataType == 'rain' || dataType == 'tem') {
				if (Number(toShowDataItem[dataType]) > 1000) {
					toShowDataItem[dataType] = '';
				}
			}
			toShowMarkerCont = toShowDataItem[dataType];
		} else {
			toShowMarkerCont = '';
		}
		//如果当前地图上已存在marker 将其清除
		if (firstMarkerFlag == 1) {
			map.remove(markersArr);
		}
		lonMarker = new AMap.Marker({
			position: [lonLat.lon, lonLat.lat],
			content: toShowMarkerCont
		});
		markersArr.push(lonMarker);
		firstMarkerFlag = 1;

		lonMarker.setMap(map);
	}

	//生成时间轴
	//	TODO  根据屏幕宽度设置时间轴宽度  确保可以拖动选择到最后一个时刻
	//	aging 时效
	function timeShaft(aging, startTime) {
		var arr = []

		var forecastAging = aging; // 每个表格间隔几个小时
		var realTime = startTime.substr(0, 16); // tip 显示的日期
		$("#show-time-tip").html(addHour(realTime, forecastAging * 60 * 60 * 1000));
		$("#startTime").val(addHour(startTime, forecastAging * 60 * 60 * 1000));
		if (forecastAging == 24) {
			$("#endTime").val(addHour(startTime, 10 * 24 * 60 * 60 * 1000));
		} else {
			$("#endTime").val(addHour(startTime, 9 * 24 * 60 * 60 * 1000));
		}

		var dateNum = 10; //天数
		var str = '', //表格
			hourSrt = '',
			hourTimeScale = '',
			dayOptTxt,
			hourOptTxt;
		var startHour = startTime.substr(11, 2); // 开始的小时时间
		var aging_eight = ['02', '05', '08', '11', '14', '17', '20', '23'];
		var aging_six = ['02', '08', '14', '20'];
		var aging_twelve = ['08', '20'];
		for (var i = 0; i < dateNum; i++) { // 循环生成10天的小时数据表格
			var hourTimeScale = '',
				nowHourTimeScaleWidth;
			switch (forecastAging) { //表格跨度相差3小时
				case 3:
					dayOptTxt = addHour(startTime, i * 24 * 60 * 60 * 1000); // 天的日期txt
					str += '<li class="day-option border-box">' + dayOptTxt.substr(0, 10) + '</li>'; // 上面填写天数的div
					switch (startHour) {
						case '08': // 初始小时是08 时
							if (i == 0) {
								for (var j = 3; j < 8; j++) {
									$(".hour-time-scale").css({
										"width": "calc(" + 100 / 5 + "% - 0px)"
									});
									nowHourTimeScaleWidth = $(".hour-time-scale").width(); // 小时宽度
									hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' + aging_eight[
										j] + '</div>'; // 小时div
									arr.push(nowHourTimeScaleWidth)
								}
							} else if (i == 9) {
								for (var j = 0; j < 3; j++) {
									$(".hour-time-scale").css({
										"width": "calc(" + 100 / 3 + "% - 0px)"
									});
									nowHourTimeScaleWidth = $(".hour-time-scale").width();
									hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' + aging_eight[
										j] + '</div>';
									arr.push(nowHourTimeScaleWidth)
								}
							} else {
								for (var j = 0; j < 8; j++) {
									$(".hour-time-scale").css({
										"width": "calc(" + 100 / 8 + "% - 0px)"
									});
									nowHourTimeScaleWidth = $(".hour-time-scale").width();
									hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' + aging_eight[
										j] + '</div>';
									arr.push(nowHourTimeScaleWidth)
								}
							}
							break;
						case '20':
							if (i == 0) {
								$(".hour-time-scale").css({
									"width": "calc(" + 100 + "% - 0px)"
								});
								nowHourTimeScaleWidth = $(".hour-time-scale").width();
								hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' + aging_eight[
									7] + '</div>';
								arr.push(nowHourTimeScaleWidth)
							} else if (i == 9) {
								for (var j = 0; j < 7; j++) {
									$(".hour-time-scale").css({
										"width": "calc(" + 100 / 7 + "% - 0.4px)"
									});
									nowHourTimeScaleWidth = $(".hour-time-scale").width();
									hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' + aging_eight[
										j] + '</div>';
									arr.push(nowHourTimeScaleWidth)
								}
							} else {
								for (var j = 0; j < 8; j++) {
									$(".hour-time-scale").css({
										"width": "calc(" + 100 / 8 + "% - 0px)"
									});
									nowHourTimeScaleWidth = $(".hour-time-scale").width();
									hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' + aging_eight[
										j] + '</div>';
									arr.push(nowHourTimeScaleWidth)
								}
							}
							break;
					}

					break;

				case 6: // 表格跨度相差6小时
					switch (startHour) {
						case '08':
							dayOptTxt = addHour(startTime, i * 24 * 60 * 60 * 1000);
							str += '<li class="day-option border-box">' + dayOptTxt.substr(0, 10) + '</li>';
							if (i == 0) {
								$(".hour-time-scale").css({
									"width": "calc(" + 100 / 1 + "% - 0px)"
								});
								nowHourTimeScaleWidth = $(".hour-time-scale").width();
								hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' + aging_six[2] +
									'</div>';
								arr.push(nowHourTimeScaleWidth)
							} else if (i == 9) {
								$(".hour-time-scale").css({
									"width": "calc(" + 100 / 2 + "% - 0px)"
								});
								nowHourTimeScaleWidth = $(".hour-time-scale").width();
								for (var j = 0; j < 2; j++) {
									hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' + aging_six[j] +
										'</div>';
									arr.push(nowHourTimeScaleWidth)
								}
							} else {
								$(".hour-time-scale").css({
									"width": "calc(" + 100 / 4 + "% - 0px)"
								});
								nowHourTimeScaleWidth = $(".hour-time-scale").width();
								for (var j = 0; j < 4; j++) {
									hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' + aging_six[j] +
										'</div>';
									arr.push(nowHourTimeScaleWidth)
								}
							}
							break;

						case '20':
							dayOptTxt = addHour(startTime, (i + 1) * 24 * 60 * 60 * 1000);
							str += '<li class="day-option border-box">' + dayOptTxt.substr(0, 10) + '</li>';
							$(".hour-time-scale").css({
								"width": "calc(" + 100 / 4 + "% - 0px)"
							});
							nowHourTimeScaleWidth = $(".hour-time-scale").width();
							for (var j = 0; j < 4; j++) {
								hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' + aging_six[j] +
									'</div>';
								arr.push(nowHourTimeScaleWidth)
							}
							break;

					}

					break;

				case 12: // 表格跨度相差 12小时

					switch (startHour) {
						case '08':
							dayOptTxt = addHour(startTime, i * 24 * 60 * 60 * 1000);
							str += '<li class="day-option border-box">' + dayOptTxt.substr(0, 10) + '</li>';
							if (i == 0) {
								$(".hour-time-scale").css({
									"width": "calc(" + 100 / 1 + "% - 0px)"
								});
								nowHourTimeScaleWidth = $(".hour-time-scale").width();
								hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' + aging_twelve[
									1] + '</div>';
								arr.push(nowHourTimeScaleWidth)
							} else if (i == 9) {
								$(".hour-time-scale").css({
									"width": "calc(" + 100 / 1 + "% - 0px)"
								});
								nowHourTimeScaleWidth = $(".hour-time-scale").width();
								hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' + aging_twelve[
									0] + '</div>';
								arr.push(nowHourTimeScaleWidth)
							} else {
								$(".hour-time-scale").css({
									"width": "calc(" + 100 / 2 + "% - 0px)"
								});
								nowHourTimeScaleWidth = $(".hour-time-scale").width();
								for (var j = 0; j < 2; j++) {
									hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' +
										aging_twelve[j] + '</div>';
									arr.push(nowHourTimeScaleWidth)
								}
							}
							break;
						case '20':
							dayOptTxt = addHour(startTime, (i + 1) * 24 * 60 * 60 * 1000);
							str += '<li class="day-option border-box">' + dayOptTxt.substr(0, 10) + '</li>';
							$(".hour-time-scale").css({
								"width": "calc(" + 100 / 2 + "% - 0px)"
							});
							nowHourTimeScaleWidth = $(".hour-time-scale").width();
							for (var j = 0; j < 2; j++) {
								hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">' + aging_twelve[
									j] + '</div>';
								arr.push(nowHourTimeScaleWidth)
							}
							break;
					}

					break;

				case 24: // 表格跨度相差 12小时

					switch (startHour) {
						case '08':
							dayOptTxt = addHour(startTime, (i + 1) * 24 * 60 * 60 * 1000);
							str += '<li class="day-option border-box">' + dayOptTxt.substr(0, 10) + '</li>';
							$(".hour-time-scale").css({
								"width": "calc(" + 100 / 1 + "% - 0px)"
							});
							nowHourTimeScaleWidth = $(".hour-time-scale").width();
							hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">08</div>';
							arr.push(nowHourTimeScaleWidth)
							break;
						case '20':
							dayOptTxt = addHour(startTime, (i + 1) * 24 * 60 * 60 * 1000);
							str += '<li class="day-option border-box">' + dayOptTxt.substr(0, 10) + '</li>';
							$(".hour-time-scale").css({
								"width": "calc(" + 100 / 1 + "% - 0px)"
							});
							nowHourTimeScaleWidth = $(".hour-time-scale").width();
							hourTimeScale += '<div class="hour-time-scale" style="width:' + nowHourTimeScaleWidth + 'px">20</div>';
							arr.push(nowHourTimeScaleWidth)
							break;
					}

					break;

			}

			hourSrt += '<li class="hour-option  border-box clearfix"  data-time="' + dayOptTxt.substr(0, 10) + '" >' +
				hourTimeScale + '</li>';
		}
		$(".day-option-box").html(str);
		$(".hour-option-box").html(hourSrt);

		// init
		if (window.TIMELINE && window.TIMELINE.timer) {
			clearTimeout(TIMELINE.timer)
			$('#progressTime_control').attr("data-val", 0);
			$('#progressTime_control').css("background-image", "url(../images/play.png)");
		}
		window.TIMELINE = {
			minPosition: 45 - $('.hour-option-box .hour-time-scale:eq(0)').width() / 2 - 1,
			items: arr,
			index: 0,
			timer: null
		}
		locate()
	}
	timeShaft(12, '2017-12-07 08:00:00');

	//计算拖动后当前指向时间
	function getRealTime(dom, event, aging, dragArrow) {
		//		console.log(event.type)
		//		console.log(event.detail.direction);
		//console.log(event.detail.changedTouches[0].pageX);
		$this = dom;
		// console.log($this.offsetLeft)

		var count = -minPosition,
			left = minPosition - $this.offsetLeft,
			_i = 0
		for (var i = 0; i < arr.length; i++) {
			count += arr[i]
			if (left <= minPosition) {
				_i = 0
				break
			}
			if (left >= count - arr[i] / 2 && left < count + arr[i + 1]) {
				_i = i + 1
				break
			}
		}
		// console.log(left, _i)
		var index = _i,
			active = $('.hour-time-scale').eq(index),
			border = active.parent().index()
		$('.hour-time-scale').removeClass('active')
		active.addClass('active')
		$(dom).stop().animate({
			'left': 44 - border - arr[index] / 2 - calcSum(arr.slice(0, index))
		})
		$("#show-time-tip").text($('.day-option').eq(border).html() + ' ' + active.html() + ":00:00");




		// //		TODO  1、如何设置只能拖动/滑动到有刻度的位置？  2、外层宽度如何根据屏幕宽度设置，超出时间范围正好拖动到最后一个时刻？
		// 		var realTime,
		// 		    realDayHoutMetres,////当前日期有多少个时间间隔
		// 		    perDayScale, // 每个小格时间间隔 有几个小时 
		// 		    nowDayHourRange,
		// 		    realTime,
		// 		    dateHour,
		// 		    realHourDistance, //每个格子所占宽度
		// 		    zoreWhith, //当前日期0点到拖动位置的距离
		// 		    currentHours, // 当前是第几小时
		// 		    recentHour, // 左拖拽离最近刻度的小时
		// 		    recentHourRight, //右拖拽最近时刻
		// 		    hoursWidth; // 每个小时所占宽度
		// 		var lastStartTime=$("#startTime").val();
		// 		var endTimeShow=$("#endTime").val();//最后预报时间
		// 		var $thisLeft = $this.offsetLeft // dom当前的left值

		// 		var offsetLeft=Math.abs($thisLeft-10);//当前偏移量取绝对值

		// 		var hors = Math.abs(parseInt(offsetLeft/161))*24*(1000*3600)

		// 		var realDay=(addHour(lastStartTime, hors)).substr(0,10);//当前日期
		// 		realDay=realDay+" 00:00:00"; // 当前日趋0点

		// 		$(".hour-option").each(function(idx){
		// 			if($(this).attr('data-time')==realDay.substr(0,10)){
		// 				realDayHoutMetres=$(this).find('.hour-time-scale').length;//当前日期有多少个时间间隔
		// 				return;
		// 			}
		// 		}); // 获得 当前日期 小时 有几个格子 realDayHoutMetres

		// 		// realDay 当前日期


		// 		//时效为24时
		// 		if(aging==24){ // 时间段是24小时时 怎么赋值
		// 			dateHour=lastStartTime.substr(11,2);
		// 			$("#show-time-tip").text(realDay.substr(0,11)+dateHour+":00");
		// 			return false;
		// 		}

		// 		realHourDistance=161/realDayHoutMetres;//拖动完成后当前日期每个时间间隔的距离 就是小时所占宽度


		// 		if(endTimeShow.substr(0,10)==realDay.substr(0,10)){//如果当前日期为最后一天
		// 			if(realDayHoutMetres==1){
		// 				$("#show-time-tip").text(endTimeShow.substr(0,16));
		// 				return false;
		// 			}

		// 			perDayScale=parseInt(endTimeShow.substr(11,2))/realDayHoutMetres;//每一个时间间隔有多小时
		// 			hoursWidth = realHourDistance/perDayScale // 每小时所占宽度
		// 			zoreWhith = $thisLeft % 161 // 当前日期0点到拖动位置的距离
		// 			currentHours = Math.abs(zoreWhith / hoursWidth) // 当前是第几小时
		// 			recentHour = (aging-1 - (currentHours % aging)) * hoursWidth // 左拖拽离最近刻度的小时
		// 			recentHourRight = (currentHours % aging) *hoursWidth // 右拖拽最近时刻
		// 			if(dragArrow === 'left') { // 左拖拽赋值left
		// 				$thisLeft = $thisLeft -recentHour
		// 				var tatol = document.getElementById("li_ul").children.length
		// 				if($thisLeft<=-(tatol*161-10)) { // 如果
		// 					$thisLeft = -(tatol*161)+10
		// 					$this.style.left = $thisLeft + 'px'
		// 				    $("#show-time-tip").text(endTimeShow.substr(0,16));
		// 				    return false
		// 				}


		// 			} else { // 右拖拽 赋值left 

		// 				$thisLeft = $thisLeft + recentHourRight + hoursWidth
		// 				offsetLeft=Math.abs($thisLeft-10)
		// 				nowDayHourRange=Math.round(((offsetLeft/161)-parseInt(offsetLeft/161))*24);

		// 				realTime=addHour(realDay,nowDayHourRange*(1000*3600));
		// 			    $("#show-time-tip").text(realTime.substr(0,16));

		// 		        $this.style.left = $thisLeft+'px'
		// 				debugger
		// 			}



		// 			offsetLeft=Math.abs($thisLeft-10)

		// 			nowDayHourRange=Math.round(((offsetLeft/161)-parseInt(offsetLeft/161))*parseInt(endTimeShow.substr(11,2)));
		// 			realTime=addHour(realDay,nowDayHourRange*(1000*3600));
		// 		    $("#show-time-tip").text(realTime.substr(0,16));
		// 		    $this.style.left = $thisLeft+'px'

		// 		}else if(lastStartTime.substr(0,10)==realDay.substr(0,10)){ // 如果拖动天数等于第一一天执行

		// 			if(realDayHoutMetres==1){ // 如果今天就一个小时格子就执行
		// 				$("#show-time-tip").text(lastStartTime.substr(0,16));
		// 				return false;
		// 			}



		// 			perDayScale=(24-parseInt(lastStartTime.substr(11,2)))/realDayHoutMetres;//每一个时间间隔有多小时
		// 			hoursWidth = realHourDistance/perDayScale // 每小时所占宽度
		// 			zoreWhith = $thisLeft % 161 // 当前日期0点到拖动位置的距离
		// 			currentHours = Math.abs(zoreWhith / hoursWidth) // 当前是第几小时
		// 			recentHour = (aging-1 - (currentHours % aging)) * hoursWidth // 左拖拽离最近刻度的小时
		// 			recentHourRight = (currentHours % aging) *hoursWidth // 右拖拽最近时刻
		// 			if(dragArrow === 'left') { // 左拖拽赋值left
		// 				$thisLeft = $thisLeft -recentHour


		// 				offsetLeft=Math.abs($thisLeft-10)

		// 				nowDayHourRange=Math.round(((offsetLeft/161)-parseInt(offsetLeft/161))*(24-parseInt(lastStartTime.substr(11,2)))); //当天拖动到的小时
		// 				realTime=addHour(lastStartTime,nowDayHourRange*(1000*3600)); // tip 显示的时间
		// 				$("#show-time-tip").text(realTime.substr(0,16)); // tip 显示时间

		// 		        $this.style.left = $thisLeft-(hoursWidth/2)+'px' // 设置left位置

		// 			} else { // 右拖拽 赋值left 

		// 				$thisLeft = $thisLeft + recentHourRight + hoursWidth
		// 				if($thisLeft>=0) { // 当往右拖动到最左边的时候赋值为时间起始值
		// 					$thisLeft = 0+hoursWidth
		// 				}

		// 				offsetLeft=Math.abs($thisLeft-10)

		// 				nowDayHourRange=Math.round(((offsetLeft/161)-parseInt(offsetLeft/161))*(24-parseInt(lastStartTime.substr(11,2)))); //当天拖动到的小时
		// 				realTime=addHour(lastStartTime,nowDayHourRange*(1000*3600)); // tip 显示的时间
		// 				$("#show-time-tip").text(realTime.substr(0,16)); // tip 显示时间

		// 		        $this.style.left = $thisLeft-(hoursWidth/2)-3+'px' // 设置left位置
		// 			}





		// 			return false;
		// 		}else{

		// 			perDayScale=24/realDayHoutMetres;//每一个时间间隔有多小时
		// 			hoursWidth = realHourDistance/perDayScale // 每小时所占宽度
		// 			zoreWhith = $thisLeft % 161 // 当前日期0点到拖动位置的距离
		// 			currentHours = Math.abs(zoreWhith / hoursWidth) // 当前是第几小时
		// 			recentHour = (aging - (currentHours % aging)) * hoursWidth // 左拖拽离最近刻度的小时
		// 			recentHourRight = (currentHours % aging) *hoursWidth // 右拖拽最近时刻
		// 			if(dragArrow === 'left') { // 左拖拽赋值left
		// 				$thisLeft = $thisLeft -recentHour-hoursWidth
		// 				//$this.style.left = $thisLeft+'px'
		// 				offsetLeft=Math.abs($thisLeft-10)
		// 				hors = Math.abs(parseInt(offsetLeft/161))*24*(1000*3600)

		// 				realDay=(addHour(lastStartTime, hors)).substr(0,10);//当前日期
		// 				realDay=realDay+" 00:00:00"; // 当前日趋0点


		// 				nowDayHourRange=Math.round(((offsetLeft/161)-parseInt(offsetLeft/161))*24);

		// 				realTime=addHour(realDay,nowDayHourRange*(1000*3600));
		// 			    $("#show-time-tip").text(realTime.substr(0,16));
		// 				$this.style.left = $thisLeft+10+'px'


		// 			} else { // 右拖拽 赋值left 

		// 				$thisLeft = $thisLeft + recentHourRight - hoursWidth 
		// 				if($thisLeft>=0) { // 当往右拖动到最左边的时候赋值为时间起始值
		// 					$thisLeft = 0+hoursWidth
		// 				}

		// 				offsetLeft=Math.abs($thisLeft-10)

		// 				hors = Math.abs(parseInt(offsetLeft/161))*24*(1000*3600)

		// 				realDay=(addHour(lastStartTime, hors)).substr(0,10);//当前日期
		// 				realDay=realDay+" 00:00:00"; // 当前日趋0点



		// 				nowDayHourRange=Math.round(((offsetLeft/161)-parseInt(offsetLeft/161))*24);

		// 				realTime=addHour(realDay,nowDayHourRange*(1000*3600));
		// 			    $("#show-time-tip").text(realTime.substr(0,16));
		// 				$this.style.left = $thisLeft+8+'px'

		// 			}

		// 		}

	}







	var screenWidth = $(window).width();
	$("#timer-wrapper").width(screenWidth);

	function task() {
		if (TIMELINE.index >= TIMELINE.items.length - 1) {
			TIMELINE.index = 0
		} else {
			TIMELINE.index += 1
		}
		locate()

		if (TIMELINE.index >= TIMELINE.items.length - 1) {
			clearTimeout(TIMELINE.timer)
			TIMELINE.index = -1
			$('#progressTime_control').attr("data-val", 0);
			$('#progressTime_control').css("background-image", "url(../images/play.png)");
		}
	}
	//TODO  播放暂停
	$("#progressTime_control").on("click", function() {
		var activeStatus = $(this).attr("data-val");
		if (parseInt(activeStatus) == 0) {
			$(this).attr("data-val", 1);
			$(this).css("background-image", "url(../images/pause.png)");
			task()
			TIMELINE.timer = setInterval(task, 2000)
		} else {
			$(this).attr("data-val", 0);
			$(this).css("background-image", "url(../images/play.png)");
			clearTimeout(TIMELINE.timer)
		}

	});

	//   色斑图数据获取
	$(".gird-list-item-cloud").on("click", function() {
		//		stainMap();
	});
	//	$(".gird-list-item-wind").on("click",function(){
	//		stainMap();
	//		
	//	});
	//	$(".gird-radion-box").on("click",function(){
	//		stainMap();
	//	});
	mui(".girdding-ul").on("click", ".gird-list-item", function() {
		$("#chart-box").hide();
		var dataType = $(this).attr('data-type');
		var legendImgUrl, param;
		switch (dataType) {
			case 'rain':
				//				var rainDataType=$("input[name='rain-options']:checked").attr('data-params');
				var rainDateHour = $("input[name='rain-options']:checked").attr('data-aging');
				//				var legendImgUrl;
				//				if(parseInt(rainDataType)==0||parseInt(rainDataType)==1){
				legendImgUrl = '../images/legend/rain_1h.png';
				//				}else{
				//					legendImgUrl='../images/legend/rain_12h.png';
				//				}
				$("#show-info-detail").text(rainDateHour + 'H降水格点预报（5km）');
				$(".legend-img").attr("src", legendImgUrl);
				break;

			case 'tem':
				legendImgUrl = '../images/legend/tem.png';
				var temDateHour = $("input[name='tem-options']:checked").attr('data-aging');
				var temDataType = $("input[name='tem-options']:checked").attr('data-params');
				if (temDataType == 6) {
					$("#show-info-detail").text('24H低温格点预报（5km）');
				} else if (temDataType == 5) {
					$("#show-info-detail").text('24H高温格点预报（5km）');
				} else {
					$("#show-info-detail").text('温度格点预报（5km）');
				}

				break;

			case 'wind':
				legendImgUrl = '../images/legend/wind.png';
				$("#show-info-detail").text('风场格点预报（5km）');
				break;

			case 'humidity':
				legendImgUrl = '../images/legend/humidity.png';
				var humidityDataType = $("input[name='humidity-options']:checked").attr('data-params');
				if (humidityDataType == 7) {
					$("#show-info-detail").text('3H相对湿度格点预报（5km）');
				} else if (humidityDataType == 8) {
					$("#show-info-detail").text('24H最高相对湿度格点预报（5km）');
				} else if (humidityDataType == 9) {
					$("#show-info-detail").text('24H最低相对湿度格点预报（5km）');
				}

				break;

			case 'cloud':
				legendImgUrl = '../images/legend/cloud.png';
				$("#show-info-detail").text('云量格点预报（5km）');
				break;
		}
		$(".legend-img").attr("src", legendImgUrl);
		stainMap();
	});

	mui(".gird-list-item").on("click", ".gird-list-item-link", function() {
		if ($(this).hasClass("gird-list-item-link-active")) {
			var dataType = $(this).attr("data-type");
			// $(this).removeClass("gird-list-item-link-active").siblings(".gird-list-item-option-box").hide();
		} else {
			$(this).addClass("gird-list-item-link-active").parent().siblings(".gird-list-item").find(".gird-list-item-link")
				.removeClass("gird-list-item-link-active");
			$(".gird-list-item-link").each(function() {
				var dataType = $(this).attr("data-type");
				$(this).siblings(".gird-list-item-option-box").hide();
			});
			var dataTypeActive = $(this).attr("data-type");
			$(this).siblings(".gird-list-item-option-box").show();
		}
	});

	//操作时间轴
	/*mui("#timer-wrapper").on("dragstart",".datetime-option-box",function(event){
		//getRealTime($(this),event,3);
		setImgLayer(showData,($("#show-time-tip").text()+':00'));
		accordingToTime(markerData,($("#show-time-tip").text()+':00'));
	});
	mui("#timer-wrapper").on("drag",".datetime-option-box",function(event){
		//getRealTime($(this),event,3);
		setImgLayer(showData,($("#show-time-tip").text()+':00'));
		accordingToTime(markerData,($("#show-time-tip").text()+':00'));
	});
	mui("#timer-wrapper").on("dragend",".datetime-option-box",function(event){
		getRealTime($(this),event,3);
		//$this.css('left',$(this).offset().left)
		setImgLayer(showData,($("#show-time-tip").text()+':00'));
		accordingToTime(markerData,($("#show-time-tip").text()+':00'));
		
	});*/

	/*mui("#timer-wrapper").on("swipeleft",".datetime-option-box",function(event){
		getRealTime($(this),event,3);
		setImgLayer(showData,($("#show-time-tip").text()+':00'));
		accordingToTime(markerData,($("#show-time-tip").text()+':00'));
	});
	mui("#timer-wrapper").on("swiperight",".datetime-option-box",function(event){
		getRealTime($(this),event,3);
		setImgLayer(showData,($("#show-time-tip").text()+':00'));
		accordingToTime(markerData,($("#show-time-tip").text()+':00'));
	});
	*/
	//	$("#show-time-tip").click(function(){
	//		$("#timer-wrapper").scrollLeft(100);
	//	})

	//获取元素
	var dragDom = document.getElementById("datetime-option-box");
	//添加触屏开始事件
	dragDom.addEventListener("touchstart", function(e) {
		var p, f1, f2, dragArrow, startx;
		//由于触屏的坐标是个数组，所以取出这个数组的第一个元素
		startx = e.touches[0].pageX;
		e = e.touches[0];

		// console.log($(this)[0].offsetLeft, dragDom.offsetLeft)

		//保存dragDom和开始触屏时的坐标差
		p = {
			x: dragDom.offsetLeft - e.clientX,
			//y:picture.offsetTop-e.clientY
		};

		//添加触屏移动事件
		document.addEventListener("touchmove", f2 = function(e) {
			//获取保触屏坐标的对象

			var t = t = e.touches[0];
			var tatol = document.getElementById("li_ul").children.length
			var widthDom = -(tatol * 161 - 11) // 获取dom 宽度 设置限制拖动最大值 ,40是tip下箭头位置就是不能拖动超过箭头位置
			var leftDom = p.x + t.clientX // dom的left值

			// 判断是不是超出拖拽的dom宽度了
			if (leftDom <= widthDom) {
				leftDom = widthDom
			} else if (leftDom >= TIMELINE.minPosition) {
				leftDom = TIMELINE.minPosition
				return
			}

			//把picture移动到初始计算的位置加上当前触屏位置
			dragDom.style.left = leftDom + "px";
			// picture.style.top=p.y+t.clientY+"px";
			//阻止默认事件
			// console.log(':', leftDom)

			e.preventDefault();
		}, {
			passive: false
		});
		//添加触屏结束事件
		document.addEventListener("touchend", f1 = function(e) {
			var endx;
			endx = e.changedTouches[0].pageX;
			var arrowNumber = endx - startx;
			if (arrowNumber === 0) return
			if (arrowNumber > 0) {
				dragArrow = 'right'
			} else {
				dragArrow = 'left'
			}

			var count = -TIMELINE.minPosition,
				left = TIMELINE.minPosition - dragDom.offsetLeft,
				currentIndex = 0
			for (var i = 0, len = TIMELINE.items.length; i < len; i++) {
				count += TIMELINE.items[i]
				// if (left <= minPosition) {
				// 	currentIndex = 0
				// 	break
				// }
				if (left >= count - TIMELINE.items[i] / 2 && left < count + TIMELINE.items[i + 1]) {
					currentIndex = i
					break
				}
				if (i === len - 1 && left >= count - TIMELINE.items[i]) {
					currentIndex = i
					break
				}
			}
			// console.log(left, _i) TODO 把i 存为全局变量 传入下面代码  定时调用  最后一张为arr.length
			TIMELINE.index = currentIndex
			locate()

			//移除在document上添加的两个事件
			document.removeEventListener("touchend", f1);
			document.removeEventListener("touchmove", f2);
		}, false);
	}, false);

	function calcSum(arr) {
		var sum = 0
		for (var i = 0; i < arr.length; i++) sum += arr[i]
		return sum
	}

	// 根据下标定位时间轴
	function locate() {
		var active = $('.hour-time-scale').eq(TIMELINE.index),
			border = active.parent().index(),
			text = $('.day-option').eq(border).html() + ' ' + active.html() + ":00:00"
		$('.hour-time-scale').removeClass('active')
		active.addClass('active')
		$('#datetime-option-box').stop().animate({
			'left': 44 - border - TIMELINE.items[TIMELINE.index] / 2 - calcSum(TIMELINE.items.slice(0, TIMELINE.index))
		})
		$("#show-time-tip").text(text)
		$("#show-time-tip").attr('data-time', text)
		//切换色斑图
		setImgLayer(showData, text);
	}
});
