$(function(){
//	空气质量参数折线图数据获取   begin
	function airQualityChart(){
	 	var url="/air/airQualityChart.do";
	 	var datetime=localStorage.airAualityTime;
	 	var stationCode=localStorage.envirRankStationCode;
	 	var params={datetime:datetime,stationCode:stationCode};
	 	http.post(url,params, _airQualityChartSuccess,params);
		$("#stationDetails").text(localStorage.envirRankStationName);
	}
	function _airQualityChartSuccess(data,info){
		if(data.body.recordNum==0){
			return false;
		}
		var airQualityData=data.body.data;
		var airQualityDataLength=airQualityData.length;
		var aqiArr=[],o3Arr=[],pm10Arr=[],pm25Arr=[],datetimeArr=[],datetimeItem;
		for(var i=0;i<airQualityDataLength;i++){
//			TODO  X轴时间显示跨日处理
			if(i>0){
				var currentDay=(airQualityData[i].dateTime).substr(8,2);
				var prevDay=(airQualityData[(i-1)].dateTime).substr(8,2);
				if(Number(currentDay)-Number(prevDay)==1){
					datetimeItem=currentDay+"日"
				}else{
					datetimeItem=(airQualityData[i].dateTime).substr(11,5);
				}
				datetimeArr.push(datetimeItem);
			}else{
				datetimeArr.push((airQualityData[i].dateTime).substr(11,5));
			}
			
			aqiArr.push(Number(airQualityData[i].aqi));
			o3Arr.push(Number(airQualityData[i].o3));
			pm10Arr.push(Number(airQualityData[i].pm10));
			pm25Arr.push(Number(airQualityData[i].pm25));
		}

		$('#aqiContainer').highcharts({
			chart: {
	            type: 'column'
	        },
	        title: {
	            text: '近24小时AQI统计'
	        },
	        legend: {
	            enabled: false
	        },
	        exporting: {
	            enabled: false
	        },
	        credits: {
	            enabled: false
	        },
	        xAxis: {
	            categories: datetimeArr,
	            crosshair: true
	        },
	        yAxis: {
	            min: 0,
	            title: {
	                text: 'AQI'
	            }
	        },
	        series: [{
	            name: ' ',
	            data: aqiArr,
	            color:"#97ca00"
	        }]
		});
		$('#o3Container').highcharts({
			chart: {
	            type: 'column'
	        },
	        title: {
	            text: '近24小时O3统计'
	        },
	        legend: {
	            enabled: false
	        },
	        exporting: {
	            enabled: false
	        },
	        credits: {
	            enabled: false
	        },
	        xAxis: {
	            categories: datetimeArr,
	            crosshair: true
	        },
	        yAxis: {
	            min: 0,
	            title: {
	                text: 'O3'
	            }
	        },
	        series: [{
	            name: ' ',
	            data: o3Arr,
	            color:"#97ca00"
	        }]
		});
		$('#pm10Container').highcharts({
			chart: {
	            type: 'column'
	        },
	        title: {
	            text: '近24小时PM10统计'
	        },
	        legend: {
	            enabled: false
	        },
	        exporting: {
	            enabled: false
	        },
	        credits: {
	            enabled: false
	        },
	        xAxis: {
	            categories: datetimeArr,
	            crosshair: true
	        },
	        yAxis: {
	            min: 0,
	            title: {
	                text: 'PM10'
	            }
	        },
	        series: [{
	            name: ' ',
	            data: pm10Arr,
	            color:"#97ca00"
	        }]
		});
		$('#pm25Container').highcharts({
			chart: {
	            type: 'column'
	        },
	        title: {
	            text: '近24小时PM2.5统计'
	        },
	        legend: {
	            enabled: false
	        },
	        exporting: {
	            enabled: false
	        },
	        credits: {
	            enabled: false
	        },
	        xAxis: {
	            categories: datetimeArr,
	            crosshair: true
	        },
	        yAxis: {
	            min: 0,
	            title: {
	                text: 'PM2.5'
	            }
	        },
	        series: [{
	            name: ' ',
	            data: pm25Arr,
	            color:"#97ca00"
	        }]
		});
	}

// 空气质量参数折线图数据获取      end


//气象参数折线图数据获取     begin 
	function weatherParamChart(){
		var url="/environment/weather/weatherParamChart.do";
		var endTime=localStorage.weatherStartTime;
	 	var stationCode=localStorage.envirRankStationCode;
	 	var params={endTime:endTime,stationCode:stationCode};
	 	http.post(url,params, _weatherParamChartSuccess,params);
		$("#stationDetails").text(localStorage.envirRankStationName);
	}
	function _weatherParamChartSuccess(data){
		if(data.body.recordNum==0){
			return false;
		}
		var weatherData=data.body.data;
		var weatherDataLength=weatherData.length;
		var rhuArr=[],visArr=[],winSAvg10miArr=[],datetimeArr=[],datetimeItem;
		for(var i=0;i<weatherDataLength;i++){
//			TODO  X轴时间显示跨日处理
			if(i>0){
				var currentDay=(weatherData[i].datetime).substr(8,2);
				var prevDay=(weatherData[(i-1)].datetime).substr(8,2);
				if(Number(currentDay)-Number(prevDay)==1){
					datetimeItem=currentDay+"日"
				}else{
					datetimeItem=(weatherData[i].datetime).substr(11,5);
				}
				datetimeArr.push(datetimeItem);
			}else{
				datetimeArr.push((weatherData[i].datetime).substr(11,5));
			}
			rhuArr.push(weatherData[i].rhu);
			visArr.push(weatherData[i].vis);
			winSAvg10miArr.push(weatherData[i].winSAvg10mi);
			
		}
		$('#rhuContainer').highcharts({
			chart: {
	            type: 'column'
	        },
	        title: {
	            text: '近24小时RHU统计'
	        },
	        legend: {
	            enabled: false
	        },
	        exporting: {
	            enabled: false
	        },
	        credits: {
	            enabled: false
	        },
	        xAxis: {
	            categories: datetimeArr,
	            crosshair: true
	        },
	        yAxis: {
	            min: 0,
	            title: {
	                text: 'RHU'
	            }
	        },
	        series: [{
	            name: ' ',
	            data: rhuArr,
	            color:"#97ca00"
	        }]
		});
		$('#visContainer').highcharts({
			chart: {
	            type: 'column'
	        },
	        title: {
	            text: '近24小时VIS统计'
	        },
	        legend: {
	            enabled: false
	        },
	        exporting: {
	            enabled: false
	        },
	        credits: {
	            enabled: false
	        },
	        xAxis: {
	            categories: datetimeArr,
	            crosshair: true
	        },
	        yAxis: {
	            min: 0,
	            title: {
	                text: 'VIS'
	            }
	        },
	        series: [{
	            name: ' ',
	            data: visArr,
	            color:"#97ca00"
	        }]
		});
		$('#windContainer').highcharts({
			chart: {
	            type: 'column'
	        },
	        title: {
	            text: '近24小时winSAvg10mi统计'
	        },
	        legend: {
	            enabled: false
	        },
	        exporting: {
	            enabled: false
	        },
	        credits: {
	            enabled: false
	        },
	        xAxis: {
	            categories: datetimeArr,
	            crosshair: true
	        },
	        yAxis: {
	            min: 0,
	            title: {
	                text: 'winSAvg10mi'
	            }
	        },
	        series: [{
	            name: ' ',
	            data: winSAvg10miArr,
	            color:"#97ca00"
	        }]
		});
		
	}

//气象参数折线图数据获取    end

	var activeSort=localStorage.envirActiveSort;
	if(activeSort==0){
		$("#airQualityBox").show();
		$("#weatherBox").hide();
		airQualityChart();
	}else{
		$("#airQualityBox").hide();
		$("#weatherBox").show();
		weatherParamChart();
	}


});
