$(function () {
  // 初始化容器宽高
  var headerHeightCss = $('header').css('height')
  $(".mui-content").height($(window).height() - headerHeightCss.replace('px', ''))



  mui.init({
    swipeBack: false, //启用右滑关闭功能
    gestureConfig: {
      tap: true, //默认为true
      doubletap: true, //默认为false
      longtap: true, //默认为false
      swipe: true, //默认为true
      drag: false, //默认为true
      hold: false, //默认为false，不监听
      release: false //默认为false，不监听
    }
  })
  //响应获取地图初始化比例
  function getMapboxScale() {
    var _screenWidth = window.innerWidth;
    var _widthArr = [320, 375, 414]
    var _scaleArr = [5.3, 5.5, 5.7]

    function find(array, val) {
      if (val < Math.min.apply(null, array)) {
        return 0;
      };
      if (val > Math.max.apply(null, array)) {
        return array.length - 1;
      };
      var idx = 0,
        i = 0,
        j = array.length;
      for (; i < j; i++) {
        if (array[i] >= val) {
          idx = i;
          break;
        };
      };
      return idx;
    };
    return _scaleArr[find(_widthArr, _screenWidth)]
  }
  var badgeData = {
    rain: {
      visibility: true,
      arr: []
    },
    wind: {
      visibility: true,
      arr: []
    },
    hail: {
      visibility: true,
      arr: []
    },
    electric: {
      visibility: true,
      arr: []
    }
  }
  Object.defineProperty(badgeData, "showArr", {
    value: ["in", "displayClass", "rain", "wind", "hail", "electric"],
    enumerable: false,
    writable: true
  });

  var impBadgeData = {
    snowCover: {
      visibility: true,
      arr: []
    },
    wireIcing: {
      visibility: true,
      arr: []
    },
    impWind: {
      visibility: true,
      arr: []
    },
    hoarFrost: {
      visibility: true,
      arr: []
    },
    sleet: {
      visibility: true,
      arr: []
    },
    snow: {
      visibility: true,
      arr: []
    },
    coldWave: {
      visibility: true,
      arr: []
    },
    tornado: {
      visibility: true,
      arr: []
    }
  }
  Object.defineProperty(impBadgeData, "showArr", {
    value: ["in", "displayClass", 'snowCover', 'wireIcing', 'impWind', 'hoarFrost', 'sleet', 'snow', 'coldWave', 'tornado'],
    enumerable: false,
    writable: true
  });
  var severeOption = {
    interval: 48,
    endTime:'',
    cacheTime:'',
    curType:'important'
  }

  // var changeTimeCounter = new Counter;
  // var detailCounter = new Counter;
  // var isSevereWeather = new Counter;
  // isSevereWeather.changeFlag()
  // detailCounter.changeFlag()
  var map = GIS.init()
  map.on('load', function () {
    GIS.utils.addBlankImageSource('spotImage')
    GIS.utils.addBlankGeoJSONSource('sevWeather')
    GIS.utils.addBlankGeoJSONSource('impWeather')

    map.addLayer({
      id: 'spotImage',
      source: 'spotImage',
      type: "raster"
    }, 'city-boundary')
    map.addLayer({
      "id": "severeWeather",
      "type": "symbol",
      "source": "sevWeather",
      // "filter": ["==", "attrName", "electricStrength"],
      "layout": {
        "icon-image": {
          "property": "iconID",
          "stops": [[1, "v3rain1"], [2, "v3rain2"], [3, "v3rain3"], [4, "v3rain4"]
            , [5, "v3wind1"], [6, "v3wind2"], [7, "v3wind3"]
            , [8, "v3hail1"], [9, "v3hail2"], [10, "v3hail3"], [11, "v3hail4"]
            , [12, "v3electricP"], [13, "v3electricN"]
          ]
        },

        "icon-rotate": ['get', 'rotate'],
        "icon-size": 0.4,
        "icon-allow-overlap": true
      }
    })
    map.addLayer({
      "id": "importantWeather",
      "type": "symbol",
      "source": "impWeather",
      // "filter": ["==", "attrName", "electricStrength"]
      "layout": {
        "icon-image": {
          "property": "iconID",
          "stops": [[1, "snowCover"], [2, "wireIcing"], [3, "wind"], [4, "hoarFrost"]
            , [5, "sleet"], [6, "snow"], [7, "coldWave"]
            , [8, "tornado"]
          ]
        },
        "icon-rotate": ['get', 'rotate'],
        "icon-size": 0.5,
        "icon-allow-overlap": true
      }
    })

    // 默认进场效果优化 根据首页月份 强天气/冰雪天气
    var isImportantWeather = localStorage.isImportantWeather === '1'
    if (isImportantWeather) {
      $(".girdding-title").html('冰雪天气监测')
      severeOption.curType = 'important'
      loadImportantData(true)
      $('.warning-datehour-option[data-val="important"]').addClass("datehour-option-active").siblings().removeClass("datehour-option-active")
    } else {
      $(".girdding-title").html('强天气监测')
      severeOption.curType = 'severe'
      loadSevereData(true)
      $('.warning-datehour-option[data-val="severe"]').addClass("datehour-option-active").siblings().removeClass("datehour-option-active")
    }
    checkLegend()
  })

  function loadSevereData(notButton) {
    var url = '/strongWeather/getSevereWeather'
    var _nowTime = dayjs().format('YYYY-MM-DD HH:00:00')
    var params = {
      datetime: (severeOption.endTime||_nowTime),
      interval: severeOption.interval,
    }
    var dataStr = dayjs(params.datetime).format('YYYY-MM-DD HH:00');
    $('#realTime').html(dataStr);
    if(notButton){
      severeOption.endTime = severeOption.cacheTime = _nowTime
    }
    ajax(url, params, loadSevereDataSuccess, "get")
  }

  function loadSevereDataSuccess(data) {
    window.popup && (window.popup.remove(), window.popup = undefined)
    $(".girdding-title").html('强天气监测')
    map.setLayoutProperty('severeWeather', 'visibility', 'visible');
    map.setLayoutProperty('importantWeather', 'visibility', 'none');
    badgeData.showArr = ["in", "displayClass", "rain", "wind", "hail", "electric"]
    map.setFilter("severeWeather", badgeData.showArr)
    resetBadgeData(badgeData)
    var markers = [];
    markers = data.body.data.map(function (val) {
      return severeDataFormat(val)
    })
    getBottomStr()
    $('#queryText').text(severeOption.interval + "小时")
    map.getSource('sevWeather').setData({
      "type": "FeatureCollection",
      "features": markers
    })
  }

  function loadImportantData(notButton) {
    var url = '/currentMonitor/getImportantWeather.do'
    var _nowTime = dayjs().format('YYYY-MM-DD HH:00:00')
    var params = {
      dateTime: (severeOption.endTime||_nowTime),
      interval: severeOption.interval,
    }
    var dataStr = dayjs(params.dateTime).format('YYYY-MM-DD HH:00');
    $('#realTime').html(dataStr);
    if(notButton){
      severeOption.endTime = severeOption.cacheTime = _nowTime
    }
    ajax(url, params, _loadImportantDataSuccess, "post")
  }

  function _loadImportantDataSuccess(data) {
    window.popup && (window.popup.remove(), window.popup = undefined)

    sortFilter(data)
    $(".girdding-title").html('冰雪天气监测')
    map.setLayoutProperty('severeWeather', 'visibility', 'none');
    map.setLayoutProperty('importantWeather', 'visibility', 'visible');
    impBadgeData.showArr = ["in", "displayClass", 'snowCover', 'wireIcing', 'impWind', 'hoarFrost', 'sleet', 'snow', 'coldWave', 'tornado']
    map.setFilter("importantWeather", impBadgeData.showArr)
    resetBadgeData(impBadgeData)
    var markers = [];
    markers = data.body.filter(function(val,idx){
      return val.type !== "3" && val.type !== "7" && val.type !== "8"
    }).map(function (val) {
      return importantDataFormat(val)
    })
    getBottomStr()
    $('#queryText').text(severeOption.interval + "小时")
    map.getSource('impWeather').setData({
      "type": "FeatureCollection",
      "features": markers
    })
    map.setLayoutProperty('importantWeather', 'visibility', 'visible');
  }

  // 排序过滤冰雪天气重复数据
  function sortFilter(data) {
    var alls = []

    var types = {}
    data.body.forEach(function(item) {
      if (!types[item.type]) {
        types[item.type] = []
      }

      types[item.type].push(item)
    })

    for (var type in types) {
      var stations = {}

      types[type].forEach(function(item) {
        if (!stations[item.stationCode]) {
          stations[item.stationCode] = []
        }
  
        stations[item.stationCode].push(item)
      })

      var keys = {
        '1': 'snowDepth',
        '2': 'wireIceDiameter',
        '3': 'windSpeed',
      }

      for (var code in stations) {
        if (keys[type]) {
          var sorts = stations[code].sort(function(a, b) {
            if (b[keys[type]] === a[keys[type]]) {
              return dayjs(b.datetime) - dayjs(a.datetime)
            }

            return b[keys[type]] - a[keys[type]]
          })

          alls.push(sorts[0])
        } else {
          alls.push(stations[code][0])
        }
      }
    }

    data.body = alls
  }


  //获取拼接字符串
  function getBottomStr() {
    var str = '';
    var data;
    if (severeOption.curType == 'severe') {
      data = badgeData
    } else {
      data = impBadgeData
    }
    for (key in data) {
      var badgeNum;
      if (data[key].arr.length != 0) {
        str += '<li data-val="' + key + '">' +
          '<img src="../../images/monitoringOfLive/severe-weather-icon/v3' + key + '.png" alt="">' +
          '<span class="mui-badge mui-badge-danger">' + data[key].arr.length + '</span></li>'
      }
    }
    if (str) {
      $(".mapBottom-icon").html(str)
    } else {
      if (severeOption.curType == 'severe') {
        $(".mapBottom-icon").html("<p>当前暂无强天气</p>")
      } else {
        $(".mapBottom-icon").html("<p>当前暂无冰雪天气</p>")
      }
    }
  }

  //重置图标状态
  function resetBadgeData(BadgeData) {
    for (key in BadgeData) {
      BadgeData[key].visibility = true;
      BadgeData[key].arr = [];
    }
  }

  //数据格式化geo Point  
  function severeDataFormat(data) {
    var activeTypeTxt, unit, attrName, fillText, iconID, typeText, timeText, displayClass;
    var activeType = data.weatherType;
    switch (parseInt(activeType)) {
      case 1:
        badgeData.rain.arr.push(data)
        activeTypeTxt = '降水量';
        unit = 'mm';
        attrName = 'pre';
        displayClass = 'rain';
        if (data.pre >= 20 && data.pre < 30) {
          iconID = 1;
        } else if (data.pre >= 30 && data.pre < 50) {
          iconID = 2;
        } else if (data.pre >= 50 && data.pre < 80) {
          iconID = 3;
        } else if (data.pre >= 80) {
          iconID = 4;
        }
        break;
      case 2:
        badgeData.wind.arr.push(data)
        activeTypeTxt = '风速';
        unit = 'm/s';
        attrName = 'maxWindSpeed';
        displayClass = 'wind';
        if (data.maxWindSpeed >= 17 && data.maxWindSpeed < 25) {
          iconID = 5;
        } else if (data.maxWindSpeed >= 25 && data.maxWindSpeed < 30) {
          iconID = 6;
        } else if (data.maxWindSpeed >= 30) {
          iconID = 7;
        }
        break;
      case 3:
        badgeData.hail.arr.push(data)
        activeTypeTxt = '直径';
        unit = 'mm';
        attrName = 'hail';
        displayClass = 'hail';
        if (data.hail > 0 && data.hail < 5) {
          iconID = 8;
        } else if (data.hail >= 5 && data.hail < 10) {
          iconID = 9;
        } else if (data.hail >= 10 && data.hail < 20) {
          iconID = 10;
        } else if (data.hail >= 20) {
          iconID = 11;
        }
        break;
      case 4:
        activeTypeTxt = '龙卷类型';
        unit = '';
        attrName = 'tornadoType';
        iconID = "";
        break;
      case 5:
        badgeData.electric.arr.push(data)
        activeTypeTxt = '电流强度';
        unit = 'A';
        attrName = 'electricStrength';
        displayClass = 'electric';
        if (data.electricStrength > 0) {
          iconID = 12;
        } else {
          iconID = 13;
        }
        break;

    }
    if (parseInt(activeType) != 5) {
      //TODO 位置与大小不对
      stationText = "站名：" + (data.city || '') + ' ' + (data.cnty === 'null' ? '' : data.cnty);
      timeText = "时间：" + data.datetime;
      typeText = activeTypeTxt + " : " + data[attrName] + unit
    } else {
      stationText = "经纬度：" + '(' + data.lon + ', ' + data.lat + ')';
      timeText = "时间：" + data.datetime;
      typeText = activeTypeTxt + " : " + data[attrName] + unit
    }
    return {
      "type": "Feature",
      "geometry": {
        "type": "Point",
        "coordinates": [Number(data.lon), Number(data.lat)]
      },
      "properties": {
        "title": stationText + "<br/>" + timeText + "<br/>" + typeText,
        "attrName": attrName,
        "attrVal": data[attrName],
        "iconID": iconID,
        "displayClass": displayClass,
        'rotate': data.maxWindDirection || 0
      }
    };
  }



  //冰雪天气数据格式化
  function importantDataFormat(data) {

    var activeTypeTxt, unit, attrName, fillText, iconID, typeText, timeText, displayClass;
    var activeType = data.type;
    var _city = getStationByCode(data.stationCode)
    switch (parseInt(activeType)) {
      case 1:
        impBadgeData.snowCover.arr.push(data)
        activeTypeTxt = '积雪深度';
        unit = 'cm';
        attrName = 'snowDepth';
        displayClass = 'snowCover';
        iconID = 1;
        break;
      case 2:
        impBadgeData.wireIcing.arr.push(data)
        activeTypeTxt = '电线积冰厚度';
        unit = 'mm';
        attrName = 'wireIceDiameter';
        displayClass = 'wireIcing';
        iconID = 2;
        break;
      case 3:
        impBadgeData.impWind.arr.push(data)
        activeTypeTxt = '大风';
        unit = 'm/s';
        attrName = 'windSpeed';
        displayClass = 'impWind';
        iconID = 3;
        break;
      case 4:
        impBadgeData.hoarFrost.arr.push(data)
        activeTypeTxt = '雨凇';
        unit = '';
        attrName = '';
        displayClass = 'hoarFrost';
        iconID = 4;
        break;
      case 5:
        impBadgeData.sleet.arr.push(data)
        activeTypeTxt = '雨夹雪';
        unit = '';
        attrName = '';
        displayClass = 'sleet';
        iconID = 5;
        break;
      case 6:
        impBadgeData.snow.arr.push(data)
        activeTypeTxt = '雪';
        unit = '';
        attrName = '';
        displayClass = 'snow';
        iconID = 6;
        break;
      case 7:
        impBadgeData.coldWave.arr.push(data)
        activeTypeTxt = '寒潮';
        unit = '';
        attrName = '';
        displayClass = 'coldWave';
        iconID = 7;
        break;
      case 8:
        impBadgeData.tornado.arr.push(data)
        activeTypeTxt = '龙卷风';
        unit = '';
        attrName = '';
        displayClass = 'tornado';
        iconID = 8;
        break;

    }
    // if(parseInt(activeType)!=5){
    //TODO 位置与大小不对
    var weather = (data[attrName] || '') + (unit || '')
    stationText = "站名：" + (_city.city||'') + ' ' + (_city.name || '');
    timeText = "时间：" + data.datetime;
    typeText = "现象：" + activeTypeTxt + (weather ? '（' + weather + '）' : '')
    // }else{
    //   stationText = "经纬度："+'('+data.lon+','+data.lat+')';
    //   timeText = "时间："+data.datetime;
    //   typeText = activeTypeTxt+" : "+data[attrName]+unit
    // }
    return {
      "type": "Feature",
      "geometry": {
        "type": "Point",
        "coordinates": [Number(_city.lon), Number(_city.lat)]
      },
      "properties": {
        "title": stationText + "<br/>" + timeText + "<br/>" + typeText,
        "attrName": attrName,
        "attrVal": data[attrName],
        "iconID": iconID,
        "displayClass": displayClass,
        'rotate': Number(data.windDirection) || 0
      }
    };
  }


  //点击显示隐藏数据
  $(".mapBottom-icon").on("click", "li", function (e) {
    window.popup && (window.popup.remove(), window.popup = undefined)
    var curKey = e.currentTarget.dataset.val;
    if (severeOption.curType == 'severe') {
      if (badgeData[curKey].visibility) {
        badgeData.showArr.splice(badgeData.showArr.indexOf(curKey), 1)
        badgeData[curKey].visibility = !badgeData[curKey].visibility
      } else {
        badgeData.showArr.push(curKey)
        badgeData[curKey].visibility = !badgeData[curKey].visibility
      }
      map.setFilter("severeWeather", badgeData.showArr)
    } else {
      if (impBadgeData[curKey].visibility) {
        impBadgeData.showArr.splice(impBadgeData.showArr.indexOf(curKey), 1)
        impBadgeData[curKey].visibility = !impBadgeData[curKey].visibility
      } else {
        impBadgeData.showArr.push(curKey)
        impBadgeData[curKey].visibility = !impBadgeData[curKey].visibility
      }
      map.setFilter("importantWeather", impBadgeData.showArr)
    }
    $(this).toggleClass('invalid').children('.mui-badge').toggleClass('mui-badge-danger')
  })


  map.on('click', 'severeWeather', function (e) {
    var feature = e.features[0]
    var popup = new mapboxgl.Popup()
      .setLngLat(feature.geometry.coordinates)
      .setHTML(feature.properties.title)
      .addTo(map);
    window.popup = popup;
  })

  map.on('click', 'importantWeather', function (e) {
    var feature = e.features[0]
    var popup = new mapboxgl.Popup()
      .setLngLat(feature.geometry.coordinates)
      .setHTML(feature.properties.title)
      .addTo(map);
    window.popup = popup;
  })

  //选择时间按钮
  $('.mapBottom-title').on('tap', '#queryButtom', function () {
    //对齐定位
    var topShift = $('#hourQuery').outerHeight();
    $('#hourQuery').css('top', -topShift)
    toggleLeftMenu()
  })


  function checkLegend(){
    var _src = '../../images/monitoringOfLive/severe-weather-icon/'
    if (severeOption.curType == 'severe') {
      $('#rain-legend').attr('src', _src + 'v3severe-legend.png').css('width', '4.8rem')
      //对齐定位
    } else {
      $('#rain-legend').attr('src', _src + 'v3important-legend.png').css('width', '2.6rem')
    }
  }

  function changeWeather() {
    if (severeOption.curType == 'severe') {
      console.log("切换为强天气")
      loadSevereData()
    } else {
      console.log("切换为冰雪天气")
      loadImportantData()
    }
    checkLegend()
    window.popup && (window.popup.remove(), window.popup = undefined)
  }

  $(".updateTime").click(function () {
    var cacheEndTime = dayjs(severeOption.cacheTime).toDate()
    var hourPicker = new mui.DtPicker({ type: 'hour' ,
    "beginDate":new Date(2018,10,01),
    "endDate":cacheEndTime}); //年月日时
    var _curDate = $('#realTime').text()
    hourPicker.setSelectedValue(_curDate)
    hourPicker.show(function (items) {
      if (severeOption.curType == 'severe') {
        var datetime = items.text + ':00:00';
        severeOption.endTime = datetime
        loadSevereData()
        // resetBadgeData(badgeData)
      } else {
        var datetime = items.text + ':00:00';
        severeOption.endTime = datetime
        loadImportantData()
        // resetBadgeData(impBadgeData)
      }
    })
  })

  $("#prevTimeBtn").on("tap", function () {
    severeOption.endTime = dayjs(severeOption.endTime).subtract(severeOption.interval, 'hour').format('YYYY-MM-DD HH:mm:ss')
    if (severeOption.curType == 'severe') {
      loadSevereData()
    } else {
      loadImportantData()
    }
  });
  $("#nextTimeBtn").on("tap", function () {
    var _endTime = dayjs(severeOption.endTime).add(severeOption.interval, 'hour')
    var _firstTime = dayjs(severeOption.cacheTime)
    if(_endTime>_firstTime){
      mui.alert("已是最新数据！")
      severeOption.endTime = dayjs().format('YYYY-MM-DD HH:mm:ss')
    }else{
      severeOption.endTime = _endTime.format('YYYY-MM-DD HH:mm:ss')
    }
    if (severeOption.curType == 'severe') {
      loadSevereData()
    } else {
      loadImportantData()
    }
  });

  // 色标图切换
  $("#warnningContent").on("tap","#rain-legend-box",function(e){
    $("#rain-legend").toggle()
    //防止点击到翻页按钮
		e.stopPropagation()
	});

  $("#rain-datehour-ul").unbind('click')
  $("#rain-datehour-ul").on("click", ".rain-datehour-option", function () {
    $(this).addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
    var curQueryHour = $(this).attr("data-val")
    severeOption.interval = Number(curQueryHour)
    if (severeOption.curType == 'severe') {
      console.log(badgeData)
      // resetBadgeData(badgeData)
      loadSevereData()
    } else {
      // resetBadgeData(impBadgeData)
      loadImportantData()
    }
    $(this).addClass('active').siblings().removeClass('active')
    // $('#queryText').text(curQueryHour + '小时')
  })

  //切换按钮
  $("#rain-rank-datehour-box").on("click",".datehour-option",function(e){
    var _curType = $(this).attr("data-val")
    severeOption.curType = _curType;
    changeWeather()
    console.log(severeOption.curType)
  })
})