var cacheStationMarkers = {};//缓存之前拖动的数据
var cacheTemStationMarkers = {};//缓存之前拖动的数据
var drawData;
var layers = {}//城市名图层
var CacheData = function(){
	this.temAnd24hChange = {nationData:[],backboneData:[],areaData:[]}
	this.maxAndMin = {nationData:[],backboneData:[],areaData:[]}
}
//缓存数据结构和添加清空方法
Object.defineProperty(CacheData.prototype, "init", {
	value: function(key){
		for(val in this[key]){
			this[key][val] = [];
		}
		return this;
	},
	enumerable: false
});
var cacheData=new CacheData;
var temOption = {
	dataSort:'temAnd24hChange',//用来切换请求URL  temAnd24hChange和maxAndMin
	dataType:'tem',//主数据字段名
	activeKeyData:'nationData',//三级  国家 骨干 区域站 
	reRenderSelect:true,//是否需要渲染选项 默认true
	maxDisplayTime:'',//存储的当前数据显示时间
	changeDisplayTime:'',//存储的当前数据显示时间
	maxMinEndTime:'',//存储的最新返回时间
	change24hEndTime:'',//存储的最新返回时间
}

var map = L.map('mapWrapper', {
	maxBoundsViscosity: 1.0,
	attributionControl:false,
	zoomControl:false,
	zoomDelta:0.5,
	zoomSnap:0.5
}).setView([27.3, 111.5], 6.5);

//三级图层初始化
layers.tem = L.layerGroup();
layers.temStation = L.layerGroup();
['city','cnty','station'].forEach(function(val,idx){
	layers[val] = L.layerGroup()
})
// 14个地市边界图层
var cityLayer = L.layerGroup()
;[57687, 57662, 57558, 57674, 57749, 57763, 57766, 57773, 57872, 57972, 57780, 57584, 57866, 57649].forEach(function(code) {
	L.geoJson.ajax('../../libs/geojson/' + code + '.json', {
		local: true,
			style: function (feature) {
					return feature.properties && feature.properties.style
			}
	}).addTo(map)
})

// 湖南省边界图层
var provinceLayer = L.geoJson.ajax('../../libs/geojson/hunan.json', {
local: true,
	style: function (feature) {
			return feature.properties && feature.properties.style
	}
})
provinceLayer.addTo(map)

//画城市名
cityData.forEach(function(val,idx){drawCityNames(val,'city')})
cntyData.forEach(function(val,idx){drawCityNames(val,'cnty')})
townsStationData.forEach(function(val,idx){drawCityNames(val,'station')})
map.addLayer(layers.city)

//画城市名函数
function drawCityNames(val,layerName){
	var icon = L.divIcon({ html: val[layerName], className: 'city-marker',iconSize:40 })
  L.marker([val.lat,val.lon], { icon: icon }).addTo(layers[layerName])
}

//站点stationLayey优化
function initStationLayer() {
  layers.station.clearLayers()
  if (map.getZoom() >= 10) {
      console.time('contains')
      var bounds = map.getBounds()
      townsStationData.forEach(function(marker) {
          var latlng = [marker.lat * 1, marker.lon * 1]
          var contains = bounds.contains(latlng)
          if (contains) {
              var stationMarker = cacheStationMarkers[latlng]
              if (!stationMarker) {
                  var icon = L.divIcon({ html: marker.station, className: 'city-marker' ,iconSize:60 })
                  cacheStationMarkers[latlng] = stationMarker = L.marker(latlng, { icon: icon })
              }
              // var icon = L.divIcon({ html: marker.station, className: 'city-marker' ,iconSize:60 })
              // var stationMarker = L.marker(latlng, { icon: icon })
              stationMarker.addTo(layers.station)
          }
      })
      console.timeEnd('contains')
  }
}
//数值temstationLayey优化
function initTemStationLayer() {
  layers.temStation.clearLayers()
  if (map.getZoom() >= 10) {
      // console.time('contains')
			var bounds = map.getBounds()
			drawData.forEach(function(val,idx){
				val.items.forEach(function(marker) {
						var latlng = [marker.lat * 1, marker.lon * 1]
						var contains = bounds.contains(latlng)
						if (contains) {
								var stationMarker = cacheTemStationMarkers[latlng]
								if (!stationMarker) {
										var icon = L.divIcon({ html: marker[temOption.dataType], className: 'text-marker' ,iconSize:60 ,iconAnchor:[0,0]})
										cacheTemStationMarkers[latlng] = stationMarker = L.marker(latlng, { icon: icon })
								}
								// var icon = L.divIcon({ html: marker.station, className: 'city-marker' ,iconSize:60 })
								// var stationMarker = L.marker(latlng, { icon: icon })
								stationMarker.addTo(layers.temStation)
						}
				})
			})
      // console.timeEnd('contains')
  }
}
initStationLayer()
map.on('zoomend moveend', initStationLayer)
map.on('zoomend moveend', initTemStationLayer)
//缩放层级显示
map.on('zoom',function(e){
  if(e.target._zoom>=8&&e.target._zoom<10){
    map.removeLayer(layers.city)
    map.removeLayer(layers.station)
		map.addLayer(layers.cnty)
  }else if(e.target._zoom>=10){
    map.removeLayer(layers.cnty)
		map.addLayer(layers.station)

		map.addLayer(layers.temStation)
		map.removeLayer(layers.tem)
  }else{
    map.removeLayer(layers.cnty)
    map.removeLayer(layers.station)
		map.addLayer(layers.city)

		map.removeLayer(layers.temStation)
		map.addLayer(layers.tem)
  }
})

//请求
function getTemChange(dateTime,isButton){
	var url = "";
	if(temOption.dataSort === 'temAnd24hChange'){
		url = "/currentMonitor/tem/temAndTemChange24h.do"
	}else{
		url = "/currentMonitor/tem/temMaxAndMin.do"
	}
	var params={datetime:dateTime||''};
	ajaxPost(url,params,function(data){
		getTemChangeSuc(data,isButton)
	});
}

function getTemChangeSuc(data,isButton){
	var res = data.body;
	//根据接口不同，初始化缓存，存储对应返回最新时间
	if(temOption.dataSort === 'temAnd24hChange'){
		temOption.changeDisplayTime = data.body.datetime
		cacheData.init('temAnd24hChange');
		if(!isButton){
			temOption.change24hEndTime = data.body.datetime
			console.log('储存change24h时间')
		}
	}else{
		temOption.maxDisplayTime = data.body.datetime
		cacheData.init('maxAndMin');
		if(!isButton){
			temOption.maxMinEndTime = data.body.datetime
			console.log('储存maxMin时间')
		}
	}
	dayjsToDom(data.body.datetime)

	//缓存数据 三级处理
	res.data.forEach(function(val,idx){
		switch(val.level){
			case '1':
				cacheData[temOption.dataSort].nationData.push(val)
        break;
      case '2':
				cacheData[temOption.dataSort].backboneData.push(val)
				cacheData[temOption.dataSort].areaData.push(val)
        break;
      case '3':
				cacheData[temOption.dataSort].areaData.push(val)
        break;
      default :	
        // console.log('未分类：',val)
        return null;		
    }
	})
	switchMapData(cacheData[temOption.dataSort][temOption.activeKeyData])
}


getTemChange()

//时间字符串填充 存储返回时间
function dayjsToDom(timeString){
	var rainfallStartTimeTxt,endTime,startTime;
	//空：使用缓存  传参：使用参数
	if(!timeString){
		if(temOption.dataSort === 'temAnd24hChange'){
			endTime = dayjs(temOption.changeDisplayTime)
			rainfallStartTimeTxt = endTime.format('M月D日H时')
		}else{
			endTime = dayjs(temOption.maxDisplayTime)
			startTime = endTime.subtract(1,'day')
			rainfallStartTimeTxt = startTime.format('M月D日H时')+'-'+ endTime.format('D日H时')
		}
	}else{
		endTime = dayjs(timeString)
		startTime = endTime.subtract(1,'day')
		if(temOption.dataSort === 'temAnd24hChange'){
			rainfallStartTimeTxt = endTime.format('M月D日H时')
		}else{
			rainfallStartTimeTxt = startTime.format('M月D日H时')+'-'+ endTime.format('D日H时')
		}
	}
	$("#temShowRealtime").text(rainfallStartTimeTxt);
}
//切换降水数据
function switchMapData(data){
	//根据查询时间间隔-选择range；把当前站点级别的数据处理到range里
	var pickedRanges = pickRanges(ranges,temOption.dataType);
	drawData = dataFilter(pickedRanges,cacheData[temOption.dataSort][temOption.activeKeyData],temOption.dataType);
	renderRainfallTable(drawData)
	//进一步根据所选选项筛选
	var index = document.getElementById("rainfallSel").selectedIndex;
	if (index || index == 0) {
		drawData = Array(drawData.temCanvasData[index]);
	}
	//区域站 数据太多 默认缩放比例下显示2%
	if(temOption.activeKeyData == 'areaData'&& map.getZoom() < 10){
		sliceData(drawData,2,true)
	}else{
		rainPreToMap(drawData)//画点
	}
  dayjsToDom()//时间
}

/**
 * 数组排序 取百分比数据  绘制到图层
 * @param {Object} data 数据源。格式和drawData相同
 * @param {Number} percent 百分比 
 * @param {Boolean} lowToHigh 排列顺序
 */
function sliceData(data,percent,lowToHigh){
	layers.tem.clearLayers()
	if(!data||typeof percent !== 'number'){
		return false;
	}
	var tmpArr = [];
	data.forEach(function(val,idx){
		val.items.forEach(function(val,idx){
			tmpArr.push(val)
		})
	})
	if(!!lowToHigh){
		tmpArr.sort(sortNumberLowToHigh(temOption.dataType))
	}else{
		tmpArr.sort(sortNumberHighToLow(temOption.dataType))
	}
	var len = tmpArr.length;
	len = Math.floor(percent/100*len)
	tmpArr.splice(-len).forEach(function(val,idx){
		var icon = L.divIcon({ html: Number(val[temOption.dataType]), className: 'text-marker' })
		L.marker([val.lat,val.lon], { icon: icon }).addTo(layers.tem)
	})
	map.addLayer(layers.tem)
}

//画降水数据
function rainPreToMap(dataArr){
	console.log('清除')
  layers.tem.clearLayers()
  dataArr.forEach(function(val,idx){
    val.items.forEach(function(val,idx){
      var icon = L.divIcon({ html: Number(val[temOption.dataType]), className: 'text-marker' })
      L.marker([val.lat,val.lon], { icon: icon }).addTo(layers.tem)
    })
  })
	map.addLayer(layers.tem)
}

//画色斑图
function rainColorToMap(){
}

var ranges=[{
	dataType:'temChange24h',
	content:{
		temCanvasData:[
		{				text:'全显示',		min:-99,			max:99			},
		{				text:'≤-12°C',		min:-99,			max:-12			},
		{				text:'≤-8°C',			min:-99,			max:-8			},
		{				text:'≤-4°C',			min:-99,			max:-4			},
		{				text:'≥4°C',			min:4,				max:99			},
		{				text:'≥8°C',			min:8,				max:99			},
		{				text:'≥12°C',			min:12,				max:99			},
		{				text:'全不显示',		min:500,			max:501			},
		],
		temRank:'最大值',
		temCountData:[
			{				text:'-10~-5.1°C',		min:-10,			max:-5.1			},
			{				text:'-5~-0.1°C',			min:-5,				max:-0.1			},
			{				text:'0~4.9°C',				min:0,				max:4.9			},
			{				text:'5~10°C',			min:5,				max:10			}
		]
	}},{
	dataType:'',
	content:[{
		activeMouth:['11','12','01','02','03'],
		temCanvasData:[
			{				text:'全显示',		min:-99,			max:99			},
			{				text:'≤-4°C',			min:-99,			max:-4			},
			{				text:'≤-2°C',			min:-99,			max:-2			},
			{				text:'≤0°C',			min:-99,			max:0			},
			{				text:'≤2°C',			min:-99,			max:2			},
			{				text:'全不显示',		min:500,			max:501			}
		],
		temRank:'最小值',
		temCountData:[
			{				text:'-4.1°C以下',	min:-99,			max:-4.1			},
			{				text:'-4~-2.1°C',		min:-4,				max:-2.1			},
			{				text:'-2~-0.1°C',		min:-2,				max:-0.1			},
			{				text:'0~1.9°C',			min:0,				max:1.9			},
			{				text:'2°C以上',		min:2,				max:99			}
		]},{
		activeMouth:['05','06','07','08','09'],
		temCanvasData:[
			{				text:'全显示',		min:-99,			max:99			},
			{				text:'≥30°C',			min:30,			max:99			},
			{				text:'≥35°C',			min:35,				max:99			},
			{				text:'≥37°C',			min:37,				max:99			},
			{				text:'≥40°C',			min:40,				max:99			},
			{				text:'全不显示',		min:500,			max:501			}
		],
		temRank:'最大值',
		temCountData:[
			{				text:'29.9°C以下',	min:-99,			max:29.9			},
			{				text:'30~34.9°C',		min:30,			max:34.9			},
			{				text:'35~36.9°C',		min:35,				max:36.9			},
			{				text:'37~39.9°C',		min:37,				max:39.9			},
			{				text:'40°C以上',	min:40,				max:99			}
		]},{
		activeMouth:['04','10'],
		temCanvasData:[
			{				text:'全显示',		min:-99,			max:99			},
			{				text:'≤10°C',			min:-99,			max:10			},
			{				text:'≥20°C',			min:20,				max:99			},
			{				text:'≥30°C',			min:30,				max:99			},
			{				text:'≥35°C',			min:35,				max:99			},
			{				text:'全不显示',		min:500,			max:501			}
		],
		temRank:'最大值',
		temCountData:[
			{				text:'9.9°C以下',	min:-99,			max:9.9			},
			{				text:'10~19.9°C',		min:10,				max:19.9			},
			{				text:'20~29.9°C',		min:20,				max:29.9			},
			{				text:'30~34.9°C',		min:30,				max:34.9			},
			{				text:'35°C以上',	min:35,				max:99			}
		]
	}]		
}]

	/**
 * 选择筛选数据源,返回相应的数组  与降水不同。数据源格式有差别
 * @param {Object} data 筛选数据源
 * @param {Number} type temChange24h等
 */
function pickRanges(data,type){
	var pickedRanges=[];
	var currentMouth=temOption.change24hEndTime.substr(5,2)
	if(data.some(function(value,index){return value.dataType===type})){
		return pickedRanges=data[0].content;
	}else{
		pickedRanges=data[1].content;
		return pickedRanges.find(function(value){
			return value.activeMouth.some(function(v){return v==currentMouth});
		});
	}
}

/**
 * 数据区间过滤方法
 * @param {object} ranges 过滤条件数组 第一组返回结果存储在ranges[0].item中
 * @param {object} data	待过滤数据源 
 * @param {string} key 过滤数据键名
 */
function dataFilter(ranges, data, key) {
	var result = ranges;
	// var result =JSON.parse(JSON.stringify(ranges));
	// var result = [];
	// $.extend(result, ranges);
	result.temCountData.forEach(function(el) { el.items = []})
	result.temCanvasData.forEach(function(el) { el.items = []})
	data.forEach(function(item){
			result.temCountData.some(function(el) {
					var number = Number(item[key] === null ? NaN : item[key])
					if (number >= el.min && number <= el.max) {
							el.items.push(item)
							// return true
					}
			})
			result.temCanvasData.some(function(el) {
				var number = Number(item[key] === null ? NaN : item[key])
				if (number >= el.min && number <= el.max) {
						el.items.push(item)
						// return true
				}
		})
	})
	return result
}
//拼接降水筛选表html
function renderRainfallTable(ranges){
	var rainfallTableStr='',rainfallSelBoxStr='',maxStr='';
	for(var i=0;i<ranges.temCountData.length;i++){
		rainfallTableStr +='<li class="rainfalltable">'+
		'<div class="rainfalltable-title">'+ranges.temCountData[i].text+'</div>'+
		'<div class="rainfalltable-data">'+ranges.temCountData[i].items.length+'站</div></li>';
	};
	for(var i=0;i<ranges.temCanvasData.length;i++){
		rainfallSelBoxStr += '<option value='+i+'>'+ranges.temCanvasData[i].text+'</option>';
	};
	maxStr=ranges.temRank;
	if(temOption.reRenderSelect){
		$("#rainfallSel").html(rainfallSelBoxStr);
	}
	temOption.reRenderSelect = true;
	// $("#rainfallSel").val('')
	$("#rainfallSelTxt").text('气温过滤');
	$("#rainfalltable-box").html(rainfallTableStr);
	$("#maxRainfallTitle").html(maxStr);

	_countMax()
	function _countMax(){
		var calcResult=_dataCalc(cacheData[temOption.dataSort][temOption.activeKeyData],temOption.dataType);
		$("#avgRainfallData").text(calcResult.avg);
		if(ranges.temRank==="最大值"){
			$("#maxRainfallData").text(calcResult.max);
		}else{
			$("#maxRainfallData").text(calcResult.min);
		}

		/**
		 * 最大值 最小值 计算方法
		 * @param {object} data 计算的数据集合
		 * @param {string} key  数据中的字段名
		 * @param {object} res 存放结果的空对象 key:max,min,sum,avg
		*/
		function _dataCalc(data,key){
			var curdata=[],res={sum:0};
			if(data.length===0){
				res.max = "无数据";
				res.mim = "无数据";
				res.avg = 0;
			}else{
				data.forEach(function(el){
					curdata.push(el[key])
					res.sum+=el[key];
				})
				res.max = Math.max.apply(null,curdata);
				res.min = Math.min.apply(null,curdata);
				res.sum = parseFloat(res.sum.toFixed(1));
				res.avg = parseFloat((res.sum/data.length).toFixed(1));
			}
			return res;
		}
	}
}

//筛选气温过滤条件
$("#rainfallSel").on("change",function(){
	var activeTxt=$(this).find("option:checked").text();
	$("#rainfallSelTxt").text(activeTxt);
	temOption.reRenderSelect = false;
	switchMapData(cacheData[temOption.dataSort][temOption.activeKeyData])
});

//筛选站点 
$("#rainSelTxt").text($("#rainSel").find("option:checked").text());
$("#rainSel").on("change",function(){
	temOption.activeKeyData=$("#rainSel").find('option:checked').attr('data-keyData');
	var activeTxt=$(this).find("option:checked").text();
	$("#rainSelTxt").text(activeTxt);
	switchMapData(cacheData[temOption.dataSort][temOption.activeKeyData])

	//生成拼接html
  renderRainfallTable(pickRanges(ranges));
});

//点击切换 逐小时/最高/最低/24小时变温
$("#tem-datehour-box").on("click",".tem-datehour-option",function(event){
	// event.stopPropagation();
	temOption.dataSort = event.currentTarget.dataset.sort;
	temOption.dataType = event.currentTarget.dataset.type;
	if(cacheData[temOption.dataSort].nationData.length !==0){
		switchMapData(cacheData[temOption.dataSort][temOption.activeKeyData])//todo 24小时变温只有国家站有数据
		console.log('有缓存')
	}else{
		getTemChange()
		console.log('无缓存，新请求')
	}
});


//点击弹出时间选择器 todo：需要释放资源吗？
$(".show-info-realtime-box").click(function(){
	console.log('当前maxMinEndTime',temOption.maxMinEndTime)
	console.log('当前change24hEndTime',temOption.change24hEndTime)
	var maxMinEndDate= dayjs(temOption.maxMinEndTime).toDate();//原生的 Date 对象
	var dPicker = new mui.DtPicker({type:'date',"endDate":maxMinEndDate}); //年月日
	var change24hEndDate= dayjs(temOption.change24hEndTime).toDate();//原生的 Date 对象
	var dhourPicker = new mui.DtPicker({type:'hour',"endDate":change24hEndDate}); //年月日时
	if(temOption.dataSort=='temAnd24hChange'){
		console.log('当前changeDisplayTime',temOption.changeDisplayTime)
		dhourPicker.setSelectedValue(temOption.changeDisplayTime)
		dhourPicker.show(function(items){
			var firstTime = dayjs(temOption.change24hEndTime).format('YYYY-MM-DD HH:mm:ss')
			var datetime=items.text+':00:00';
			if(datetime>firstTime){
				mui.alert("已是最新数据！")
				// $(this).hide();
				return false;
			}
			getTemChange(datetime,true)
		});
	}else{
		console.log('当前maxDisplayTime',temOption.maxDisplayTime)
		dPicker.setSelectedValue(temOption.maxDisplayTime.substr(0,10))
		dPicker.show(function(items){
			var firstTime = dayjs(temOption.maxMinEndTime).format('YYYY-MM-DD HH:mm:ss')
			var datetime=items.text+' 08:00:00';
			if(datetime>firstTime){
				mui.alert("已是最新数据！")
				// $(this).hide();
				return false;
			}
			getTemChange(datetime,true)
		});
	}
});


$("#temPrevBtn").on("click",function(){
	if(temOption.dataSort=='temAnd24hChange'){
		console.log('按钮 24h ')
		var datetime = dayjs(temOption.changeDisplayTime).subtract(1,'hour').format('YYYY-MM-DD HH:mm:ss');
		getTemChange(datetime,true)
	}else{
		console.log('按钮 max ')
		var datetime = dayjs(temOption.maxDisplayTime).subtract(1,'day').format('YYYY-MM-DD HH:mm:ss');
		getTemChange(datetime,true)
	}
});

$("#temNextBtn").on("click",function(){
	if(temOption.dataSort=='temAnd24hChange'){
		endTime = dayjs(temOption.changeDisplayTime).add(1,'hour')
		var firstTime = dayjs(temOption.change24hEndTime)
		if(endTime>firstTime){
			mui.alert("已是最新数据！")
			return false;
		}
		var datetime = endTime.format('YYYY-MM-DD HH:mm:ss');
		getTemChange(datetime,true)
	}else{
		endTime = dayjs(temOption.maxDisplayTime).add(1,'day')
		var firstTime = dayjs(temOption.maxMinEndTime)
		if(endTime>firstTime){
			mui.alert("已是最新数据！")
			return false;
		}
		var datetime = endTime.format('YYYY-MM-DD HH:mm:ss');
		getTemChange(datetime,true)
	}
});