$(function () {
	// 初始化容器宽高
	var headerHeightCss = $('header').css('height')
	$(".mui-content").height($(window).height() - headerHeightCss.replace('px', ''))
	$('.rain-select').css('top', 'calc(1.4rem + ' + headerHeightCss + ')').show()

	mui.init({
		swipeBack: false, //启用右滑关闭功能
		gestureConfig: {
			tap: true, //默认为true
			doubletap: true, //默认为false
			longtap: true, //默认为false
			swipe: true, //默认为true
			drag: false, //默认为true
			hold: false, //默认为false，不监听
			release: false //默认为false，不监听
		}
	})

	var temOption = {
		dataSort: 'temAnd24hChange',//用来切换请求URL  temAnd24hChange和maxAndMin
		dataType: 'tem',//主数据字段名  tem maxTem minTem changeTem
		displayTime: '',//存储的当前数据显示时间
		cacheTime:'',//存储的最新返回时间
		curStation: [1],//当前站点筛选条件
		valBegin:'',
		valEnd:'',
		spotOrText:'all',
		range:'',
	}
	var rangeCondition = {
		changeTem:{
			temRank: '最大值',
			temCountData: [
				{ text: '-10~-5.1°C', min: -10, max: -5.1 },
				{ text: '-5~-0.1°C', min: -5, max: -0.1 },
				{ text: '0~4.9°C', min: 0, max: 4.9 },
				{ text: '5~10°C', min: 5, max: 10 }
			]
		},
		default:[{
				activeMouth: ['11', '12', '01', '02', '03'],
				temRank: '最小值',
				temCountData: [
					{ text: '-4.0及以下', min: -99, max: -4.0 },
					{ text: '-3.9~-2.0°C', min: -3.9, max: -2.0 },
					{ text: '-1.9~0°C', min: -1.9, max: 0 },
					{ text: '0.1~2.0°C', min: 0.1, max: 2.0 },
					{ text: '2.1°C及以上', min: 2.1, max: 99 }
				]
			}, {
				activeMouth: ['05', '06', '07', '08', '09'],
				temRank: '最大值',
				temCountData: [
					{ text: '29.9°C以下', min: -99, max: 29.9 },
					{ text: '30~34.9°C', min: 30, max: 34.9 },
					{ text: '35~36.9°C', min: 35, max: 36.9 },
					{ text: '37~39.9°C', min: 37, max: 39.9 },
					{ text: '40°C以上', min: 40, max: 99 }
				]
			}, {
				activeMouth: ['04', '10'],
				temRank: '最大值',
				temCountData: [
					{ text: '9.9°C以下', min: -99, max: 9.9 },
					{ text: '10~19.9°C', min: 10, max: 19.9 },
					{ text: '20~29.9°C', min: 20, max: 29.9 },
					{ text: '30~34.9°C', min: 30, max: 34.9 },
					{ text: '35°C以上', min: 35, max: 99 }
				]
			}],
	}
	
	//获取当前选项设置
	function getSetting(option){
		if($('#curStation').val().length == 1){
      option.curStation = [$('#curStation').val()];
    }else{
      option.curStation = $('#curStation').val().split(',');
    }
		option.dataSort = $(".tem-datehour-option.datehour-option-active").attr("data-sort");
		option.dataType = $(".tem-datehour-option.datehour-option-active").attr("data-type");
		option.valBegin = $("#range").find("option:checked").attr("data-begin");
		option.valEnd = $("#range").find("option:checked").attr("data-end");
		option.spotOrText = $('#spotOrText').val();
		option.range = _pickRangeByTypeAndMounth(rangeCondition,option.dataType)
	}

	//根据选项类型更新select
  function upDomByType(){
    var rainfalltableStr = [],rangeSelectStr = ['<option value="1" data-begin="-999" data-end="99999">全显示</option>'];
    temOption.range.temCountData.forEach(function(val,idx){
			rangeSelectStr.push('<option value="'+(idx+2)+'" data-begin="'+val.min+'" data-end="'+val.max+'">'+val.text+'</option>')
    })
		rangeSelectStr.push('<option value="'+(temOption.range.temCountData.length+2)+'" data-begin="hidden" data-end="hidden">全不显示</option>')
		$('#range').html(rangeSelectStr.join(''))
		temOption.valBegin = $("#range").find("option:checked").attr("data-begin");
		temOption.valEnd = $("#range").find("option:checked").attr("data-end");
	}
	
	/**
	 * //根据type currentMouth返回range
	 * @param {Object} data 筛选range源
	 * @param {Number} type temChange24h等
	 */
	function _pickRangeByTypeAndMounth(range, type) {
		if(range[type]){
			return range[type]
		}else{
			return range.default.find(function(val,idx){
				var currentMouth = dayjs().format('YYYY-MM-DD HH:mm:ss').substr(5, 2)
				return val.activeMouth.some(function(v){return v == currentMouth})
			})
		}
	}

	/**
	 * 
	 * @param {String} queryTime YYYY-MM-DD HH:mm:ss   为空时将存储resTime到
	 */
	function getMapData(queryTime){
    popup && popup.remove()
    if(temOption.valBegin === 'hidden'){
      map.getSource('temSpot').setData({
        "type": "FeatureCollection",
        "features": []
      })
      map.getSource('temText').setData({
        "type": "FeatureCollection",
        "features": []
			})
			return
    }
		var spotUrlData = {
			tem:'/currentMonitor/tem/temStainMap.do',
			maxTem:"/currentMonitor/tem/temMaxStainMap.do",
			minTem:"/currentMonitor/tem/temMinStainMap.do",
			changeTem:"/currentMonitor/tem/temChange24hStainMap.do",
		} 
		var spotUrl,textUrl,isButton = false;
		spotUrl = spotUrlData[temOption.dataType]
		if (temOption.dataSort === 'temAnd24hChange') {
			textUrl = "/currentMonitor/tem/temAndTemChange24hData.do"
		} else {
			textUrl = "/currentMonitor/tem/temMaxAndMinData.do"
		}
		if(!!queryTime){
			isButton = true
		}
		var params = {
			type:temOption.dataType,
			dateTime: queryTime || '',
			stationTypes: temOption.curStation,
			numericalBegin:temOption.valBegin,
			numericalEnd:temOption.valEnd,
		}
		switch (temOption.spotOrText){
			case 'spot':
				map.getSource('temText').setData({
					"type": "FeatureCollection",
					"features": []
				})
				ajax(spotUrl, params, _preSpotSuccess, "get")
				break
			case 'text':
				map.getSource('temSpot').setData({
					"type": "FeatureCollection",
					"features": []
				})
				break
			case 'all':
				ajax(spotUrl, params, _preSpotSuccess, "get")
				break
			default:
				break;
		}
		ajax(textUrl, params, function(data){
			if (params.type === 'changeTem' && params.stationTypes.join(',') != '1') {
				data.body.data = []
				data.body.total = 0
			}

			_preTextSuccess(data,isButton)
		}, "get")
		function _preSpotSuccess(data) {
			map.getSource('temSpot').setData({
				"type": "FeatureCollection",
				"features": []
			})
			map.getSource('temSpot').setData({
				"type": "FeatureCollection",
				"features": data.body.data.features
			})
		}

		function _preTextSuccess(data,isButton){
			//根据接口不同，存储对应返回最新时间
			temOption.displayTime = data.body.datetime
			dayjsToDom(temOption.displayTime)
			if (!isButton) {
				temOption.cacheTime = data.body.datetime
			}

			if(temOption.spotOrText !== "spot"){
				//显示所选数据
				var markers = data.body.data.map(function (val) {
					return temDataFormat(val)
				})
				map.setLayoutProperty("temText", "text-field", "{" + temOption.dataType + "}")
				map.getSource('temText').setData({
					"type": "FeatureCollection",
					"features": markers
				})
			}
			renderTemTable(data.body.data)
		}
  }

	var map = GIS.init({ spot: true })
	map.on('load', function () {
		GIS.utils.addBlankGeoJSONSource('temText')
		GIS.utils.addBlankGeoJSONSource('temSpot')
		map.addLayer({
			"id": "temSpot",
			'type': 'fill',
			'source': "temSpot",
			type: "fill",
			paint: {
				"fill-color": {
					"type": "identity",
					"property": "color"
				},
				"fill-opacity": 1
			}
		}, 'city-boundary')
		map.addLayer({
			"id": "temText",
			"type": "symbol",
			"source": 'temText',
			"layout": {
				"text-field": "{tem}",
				"text-size": 14,
				"text-offset": [0, 1.2],
				"text-font": ["Microsoft YaHei"],
				"icon-image": 'point.normal',
				"icon-anchor": 'top',
				"icon-size": 0.4,
			},
			"paint": {
			  "text-color": "#3766fd",
			  "text-halo-color": '#fff',
			  "text-halo-width": 1
			}
		})
		$("#spotOrText").val(temOption.spotOrText);
		getSetting(temOption)
		getMapData()
		upDomByType()
	})
  
	// 点击事件
	var popup
	map.on('click', 'temText', function (e) {
		var feature = e.features[0]
		popup = new mapboxgl.Popup()
			.setLngLat(feature.geometry.coordinates)
			.setHTML(feature.properties.popup.replace('{key}', getSelectTypeToPopupKeyText(temOption.dataType)).replace('{value}', feature.properties[temOption.dataType]))
			.addTo(map)
	})

	function getSelectTypeToPopupKeyText(type) {
		if (type === 'maxTem') {
			return '最高气温'
		}
		if (type === 'minTem') {
			return '最低气温'
		}
		if (type === 'changeTem') {
			return '24小时变温'
		}
		return '气温'
	}

	function temSpot(dataTime) {
		popup && popup.remove()
		var url = "";
		if (temOption.dataSort === 'temAnd24hChange') {
			url = "/currentMonitor/tem/temAndTemChange24h.do"
		} else {
			url = "/currentMonitor/tem/temMaxAndMin.do"
		}
		var params = {
			dateTime: (dataTime || ''),
			type: temOption.dataType,
			stationLevel: temOption.curStation
		}
		ajax(url, params, _temSpotSuccess, "get")
	}
	function _temSpotSuccess(data) {
		map.getSource('temSpot').setData({
			"type": "FeatureCollection",
			"features": []
		})
		map.getSource('temSpot').setData({
			"type": "FeatureCollection",
			"features": data.body.features
		})
	}

	//数据格式化geo Point  
	function temDataFormat(data) {
		var types = {
			tem: 'TEMSCENE_1H',
			changeTem: 'TEMSCENE_24H',
			maxTem: 'TEMSCENE_MINORMAX',
			minTem: 'TEMSCENE_MINORMAX'
		}
		
		var _tmpStation = getStationByCode(data.code)
		return {
			"type": "Feature",
			"geometry": {
				"type": "Point",
				"coordinates": [Number(_tmpStation.lon), Number(_tmpStation.lat)]
			},
			"properties": {
				"tem": Number(data.tem),
				"changeTem": Number(data.changeTem),
				"maxTem": Number(data.maxTem),
				"minTem": Number(data.minTem),
				"level": Number(data.level),
				"color": Colors.getColor(types[temOption.dataType], Number(data[temOption.dataType])),
				"popup": GIS.utils.createDefaultStylePopupHtml({
					'{key}': '{value}°C'
				}, _tmpStation)
			}
		};
	}

	//时间字符串填充 存储返回时间
	function dayjsToDom(timeString) {
		var rainfallStartTimeTxt, endTime, startTime;
		endTime = dayjs(timeString)
		if (temOption.dataSort === 'temAnd24hChange') {
			rainfallStartTimeTxt = endTime.format('M月D日H时')
		} else {
			startTime = endTime.subtract(1, 'day')
			rainfallStartTimeTxt = startTime.format('M月D日H时') + '-' + endTime.format('D日H时')
		}
		$("#temShowRealtime").text(rainfallStartTimeTxt);
	}

	/**
	 * //拼接气温筛选表html  依赖: cacheData、 temOption
	 * @param {*} type "temChange24h"...  即temOption.dataType
	 */
	function renderTemTable(data) {
		var rainfallTableStr = [], range = temOption.range;
		_dataFilter(temOption.range,data,temOption.dataType)
    range.temCountData.forEach(function(val,idx){
      rainfallTableStr.push('<li class="rainfalltable"><div class="rainfalltable-title">' + val.text + '</div>' +
      '<div class="rainfalltable-data">' + val.itemNum + '站</div></li>')
    })
		$("#rainfalltable-box").html(rainfallTableStr.join(''));
		$("#maxRainfallTitle").html(range.temRank);
		$("#avgRainfallData").text(range.avg);
		if (range.temRank === "最大值") {
			$("#maxRainfallData").text(range.max);
		} else {
			$("#maxRainfallData").text(range.min);
		}

		/**
		 * 数据区间过滤方法
		 * @param {object} range 过滤条件数组 第一组返回结果存储在range[0].item中
		 * @param {object} data	待过滤数据源 
		 * @param {string} key 过滤数据键名
		 */
		function _dataFilter(range, data, key) {
			var mathData = [],mathSum = 0;;
			range.temCountData.forEach(function (el) { el.itemNum = 0 })
			if(data.length === 0){
				range.max = "0";
				range.mim = "0";
				range.itemNum = "0";
			}else{
				data.forEach(function (item) {
					mathData.push(item[key])
					mathSum += Number(item[key]);
					range.temCountData.some(function (el) {
						var number = Number(item[key] === null ? NaN : item[key])
						if (number >= el.min && number <= el.max) {
							el.itemNum++
							// return true
						}
					})
				})
				range.max = Math.max.apply(null, mathData);
				range.min = Math.min.apply(null, mathData);
				mathSum = parseFloat(mathSum.toFixed(1));
				range.avg = parseFloat((mathSum / mathData.length).toFixed(1));
			}
			return range
		}
	}

	//点击切换 逐小时/最高/最低/24小时变温
	$("#tem-datehour-box").on("click", ".tem-datehour-option", function (event) {
		getSetting(temOption)
		upDomByType()
		getMapData(temOption.displayTime)
	});
  //站点选项 事件
  $("#curStation,#range,#spotOrText").on("change", function () {
		getSetting(temOption)
    getMapData(temOption.displayTime)
  })
	
	$("#temPrevBtn").on("tap", function () {
		var queryTime;
		queryTime = dayjs(temOption.displayTime).subtract(1, 'hour').format('YYYY-MM-DD HH:mm:ss');
		getMapData(queryTime)
	});

	$("#temNextBtn").on("tap", function () {
		var firstTime = dayjs(temOption.cacheTime),queryTime;
		queryTime = dayjs(temOption.displayTime).add(1, 'hour')
		if (queryTime > firstTime) {
			mui.alert("已是最新数据！")
			queryTime = firstTime
		}
		queryTime = queryTime.format('YYYY-MM-DD HH:mm:ss');
		getMapData(queryTime)
	});

	//点击弹出时间选择器
	$(".show-info-realtime-box").click(function () {
		var firstTime = dayjs(temOption.cacheTime),queryTime;
		var dhourPicker = new mui.DtPicker({ type: 'hour', beginDate: new Date(2018,10,01), "endDate": firstTime.toDate() }); //年月日时
		dhourPicker.setSelectedValue(temOption.displayTime)
		dhourPicker.show(function (items) {
			var datetime = dayjs(items.text + ':00:00');
			if (datetime > firstTime) {
				mui.alert("已是最新数据！")
				queryTime = firstTime
			}else{
				queryTime = datetime
			}
			queryTime = queryTime.format('YYYY-MM-DD HH:mm:ss');
			getMapData(queryTime)
		});
	});

	mui(".show-info-btn-box").on('tap', '#tem-rank-link', function () {
		localStorage.temOption = JSON.stringify(temOption)
		mui.openWindow({
			url: '../../web/monitoringOfLive/tem-ranking.html',
			styles: {
				statusbar: {
					background: localStorage.statusbarColor
				}
			}
		});
	});
})