$(function () {
	var height = $(window).height(), 
		width = $(window).width(),
		containerHeight = height - Number($('header').css('height').replace("px", ''))
	$(".mui-content").height(containerHeight)

	mui.init({
		swipeBack: false, //启用右滑关闭功能
		gestureConfig: {
			tap: true, //默认为true
			doubletap: true, //默认为false
			longtap: true, //默认为false
			swipe: true, //默认为true
			drag: true, //默认为true
			hold: false,//默认为false，不监听
			release: false//默认为false，不监听
		},
		beforeback: function () {
			if (mui.os.plus) {
				if ($('body').hasClass('horizontal')) {
					plus.screen.lockOrientation('portrait-primary')
					setTimeout(function() {
						plus.screen.unlockOrientation()
					}, 2000)
					return false
				}

				plus.screen.lockOrientation('portrait-primary')
			}

			return true
		}
	})

	// 监听屏幕旋转事件
	window.addEventListener("orientationchange", function() {
		switch (window.orientation) {
			case 90:
			case -90:
				plus.navigator.setFullscreen(true)
				$('body').addClass('horizontal')
				$('.time-btn').removeClass('hide')
				$('.horizontal-display-item').css('display', 'none')
				$('.mui-content,.swiper-container').height(width)
				$('.mui-title').text('数据更新时间：' + $('.show-realtime').text())
				Screen.horizontal()
				break
			default:
				plus.navigator.setFullscreen(false)
				$('body').removeClass('horizontal')
				$('.time-btn').addClass('hide')
				$('.horizontal-display-item').css('display', 'flex')
				$('.mui-content').height(containerHeight)
				$('.swiper-container').height('')
				$('.mui-title').text($('title').text())
				Screen.vertical()
				break
		}

		swiper.update(true)
	}, false)

	$(document).click(function(e) {
		if ($('body').hasClass('horizontal') && $('.horizontal-display-item').find($(e.target)).length === 0) {
			if ($('.mui-bar').css('display') === 'flex') {
				plus.navigator.setFullscreen(true)
			} else {
				plus.navigator.setFullscreen(false)
			}
			$('.horizontal-display-item').stop().slideToggle(100).css('display', 'flex')
		}
	})

	var swiper, activeData
	function renderSwiper(htmls) {
		swiper && swiper.destroy()
		$('#swiper-container .swiper-wrapper').html(htmls.join(''))

		var options = {
			effect: 'fade',
			passiveListeners: false,
			initialSlide: htmls.length - 1,
			preloadImages: false,
			lazy: {
				loadPrevNext: true
			},
			watchSlidesVisibility: true,
			zoom: {
				toggle: false
			},
			autoplay: {
				delay: 1000,
				stopOnLastSlide: true
			},
			on: {
				init: function () {
					$("#radarControl").val(htmls.length - 1)
					$("#realTime").text(activeData[0].imgTime);
					$("#playImg").attr("data-val", 0)
					$("#playImg").attr("src", "../../images/monitoringOfLive/radar-play.png")
				},
				slideChange: function () {
					$("#radarControl").val(this.activeIndex)
					$("#realTime").text(activeData[htmls.length - 1 - this.activeIndex].imgTime)
				},
				autoplayStop: function () {
					$("#playImg").attr("data-val", 0)
					$("#playImg").attr("src", "../../images/monitoringOfLive/radar-play.png")
				}
			},
			// navigation: {
			// 	nextEl: '#nextTimeBtn',
			// 	prevEl: '#prevTimeBtn',
			// },
		}
		swiper = new Swiper('#swiper-container', options)
		swiper.autoplay.stop()
	}

	//	雷达拼图   begin
	function radar(order) {
		var url = "/radar/radar.do";
		var area = $("#radarAreaSel").val();
		var params = {
			city: area
		};
		http.get(url, params, _radarSuccess);
		$("#radarImg").attr("src", "");
	}
	var resData;

	function _radarSuccess(data) {
		resData = data.body.data;
		if (resData && resData.length === 0) {
			mui.alert('未采集到对应数据', "提示", "确定", function () { });
			return false;
		}

		var htmls = []
		var imgStr = '';
		activeClass = '';
		for (var i = resData.length - 1; i >= 0; i--) {
			if (i == resData.length - 1) {
				activeClass = 'img-active'
			} else {
				activeClass = '';
			}
			imgStr += '<img class="img radar-img ' + activeClass + '" src="' + resData[i].saveUrl + '" data-order=' + i + ' data-preview-src="" data-preview-group="1" />'

			htmls.push('<div class="swiper-slide"><div class="swiper-zoom-container"><img data-src="' + resData[i].saveUrl + '" class="swiper-lazy"></div><div class="swiper-lazy-preloader"></div></div>')
		}

		activeData = resData
		renderSwiper(htmls)

		$(".radar-img").remove();
		//		$("#imgBox").append(imgStr);
		$("#radarControl").attr('max', htmls.length - 1);
		$('.radar-img').load(function () {
			var self = $(this), el = self[0]
			$(".img-box").height($(window).width() / el.naturalWidth * el.naturalHeight)
			//					self.zoom()
		})

		// _switchData(resData, order);

		mui.plusReady(function () {
			// 解除方向锁定
			plus.screen.unlockOrientation()
		})
	}

	function _switchData(data, order) {
		var switchData = data;

		$(".radar-img").each(function () {
			if ($(this).attr("data-order") == order) {
				$(this).addClass("img-active").siblings().removeClass("img-active");
			}
		});

		//		$("#radarImg").attr("src", switchData[order].saveUrl);
		$("#realTime").text(switchData[order].imgTime);
	}

	//	雷达拼图  end

	//  单站雷达        begin
	function QNX(order) {
		var url = "/radar/QNX.do";
		var city = $("#radarCitySel").val();
		var params = {
			city: city
		};
		http.get(url, params, _QNXSuccess, order);
		$("#radarImg").attr("src", "");
	}
	var resQnxData;

	function _QNXSuccess(data, order) {
		resQnxData = data.body.data

		if (resQnxData && resQnxData.length === 0) {
			mui.alert('未采集到对应数据', "提示", "确定", function () { });
			return false;
		}

		var htmls = []
		var QNXimgStr = '';
		activeClass = '';
		for (var i = resQnxData.length - 1; i >= 0; i--) {
			if (i == 9) {
				activeClass = 'img-active'
			} else {
				activeClass = '';
			}
			QNXimgStr += '<img class="img QNX-img ' + activeClass + '" src="' + resQnxData[i].saveUrl + '" data-order=' + i + ' data-preview-src="" data-preview-group="2" />'

			htmls.push('<div class="swiper-slide"><div class="swiper-zoom-container"><img data-src="' + resQnxData[i].saveUrl + '" class="swiper-lazy"></div><div class="swiper-lazy-preloader"></div></div>')
		}

		activeData = resQnxData
		renderSwiper(htmls)

		$(".QNX-img").remove();
		//		$("#imgBox").append(QNXimgStr);
		$("#radarControl").attr('max', resQnxData.length - 1);
		// _switchQnxData(resQnxData, order);
	}

	function _switchQnxData(data, order) {
		var switchData = data;

		$(".QNX-img").each(function () {
			if ($(this).attr("data-order") == order) {
				$(this).addClass("img-active").siblings().removeClass("img-active");
			}
		});

		//		$("#radarImg").attr("src", switchData[order].saveUrl);
		$("#realTime").text(switchData[order].imgTime);

	}

	//  单站雷达     end

	//开始 暂停
	function progressTimeControl(img, rangeDom) {
		$('.radar-img').css({
			"transform": "translate3d(0,0,0) scale(1) rotate3d(0,0,0,0)"
		});
		if ($(img).attr("data-val") == 0) {
			$(img).attr("data-val", 1);
			$(img).attr("src", "../../images/monitoringOfLive/radar-unplay.png");
			// autoPlay(img, rangeIp);　
			swiper && swiper.autoplay.start()
		} else {
			$(img).attr("data-val", 0);
			$(img).attr("src", "../../images/monitoringOfLive/radar-play.png");
			//			clearInterval(time),
			//				function() {　　
			//					autoPlay(img, rangeIp);　
			//				}　
			swiper && swiper.autoplay.stop()
		}
	}

	function autoPlay(img, rangeDom) {
		time = setInterval(function () {
			var orderVal = parseInt(rangeDom.val());
			var orderMax = parseInt(rangeDom.attr("max"));
			var orderMin = parseInt(rangeDom.attr("min"));
			var orderStep = rangeDom.attr("step");
			if (orderVal < orderMax) {
				orderVal += 1;
				rangeDom.val(orderVal);
				if ($('#radarCitySelTxt').text() == "单站") {
					if (resData) {
						_switchData(resData, orderMax - orderVal);
					}
				}
				if ($('#radarAreaSelTxt').text() == "范围") {
					if (resQnxData) {
						_switchQnxData(resQnxData, orderMax - orderVal);
					}
				}

			} else if (orderVal >= orderMax) {
				$(img).attr("data-val", 0);
				$(img).attr("src", "../../images/monitoringOfLive/radar-play.png");
				clearInterval(time),
					function () {
						autoPlay(img, rangeIp);
					}
			}


		}, 1000)
	}

	radar(0);
	//	交互       begin
	var img = $("#playImg");
	var rangeIp = $("#radarControl");
	$("#playControlBtn").on("click", function () {
		var activeOrder = parseInt($("#radarControl").val());
		var maxVal = Number($("#radarControl").attr('max'));
		if (activeOrder == maxVal) {
			$("#radarControl").val(0);
			swiper && swiper.slideTo(0, 0)
		}
		progressTimeControl(img, rangeIp);
	});
	// $("#radarCitySel").val('none');

	$("#radarAreaSel").on("click", function () {
		if ($('#radarAreaSelTxt').text() == "范围") {
			$("#radarAreaSel").val('central');
			$('#radarAreaSelTxt').text("华中");
			// $("#radarCitySel").val("none");
			$('#radarCitySelTxt').text("单站");
			var areaOrder = $("#radarControl").val();
			radar(areaOrder);
		}
	});
	$("#radarCitySel").on("click", function () {
		if ($('#radarCitySelTxt').text() == "单站") {
			$("#radarCitySel").val("CS");
			$('#radarCitySelTxt').text("长沙");
			// $("#radarAreaSel").val('none');
			$('#radarAreaSelTxt').text("范围");
			var cityOrder = $("#radarControl").val();
			QNX(cityOrder);
		}
	});

	//swiper 横屏时翻页事件
	$("#prevImgBtn").on("click",function(e){
		swiper.slidePrev(0)
		e.stopPropagation()
	})
	$("#nextImgBtn").on("click",function(e){
		swiper.slideNext(0)
		e.stopPropagation()
	})

	$("#radarAreaSel").on("change", function () {
		$('#radarCitySelTxt').text("单站");
		// $("#radarCitySel").val('none');
		var areaOrder = $("#radarControl").val();
		radar(areaOrder);
	});
	$("#radarCitySel").on("change", function () {
		$('#radarAreaSelTxt').text("范围");
		// $("#radarAreaSel").val('none');
		var cityOrder = $("#radarControl").val();
		QNX(cityOrder);
	});
	//TODO range移动时提示框隐藏
	$("#radarControl").siblings('span').remove();
	$("#radarControl").change(function () {
		var order = Number($(this).val());
		var maxVal = Number($(this).attr('max'));
		$(this).siblings('span').remove();

		if ($('#radarCitySelTxt').text() == "单站") {
			if (resData) {
				_switchData(resData, maxVal - order);
			}
		}
		if ($('#radarAreaSelTxt').text() == "范围") {
			if (resQnxData) {
				_switchQnxData(resQnxData, maxVal - order);
			}
		}

		swiper && swiper.slideTo(order, 0)
	});

	mui("#imgBox").on("swiperight", ".img", function () {
		var activeOrder = Number($(".img.img-active").attr("data-order"));
		var orderVal = parseInt(activeOrder + 1);
		var maxVal = Number($("#radarControl").attr('max'));
		if (orderVal > maxVal || orderVal < 0) {
			return false;
		}
		$("#radarControl").val(maxVal - orderVal);
		if ($('#radarCitySelTxt').text() == "单站") {
			if (resData) {
				_switchData(resData, orderVal);
			}
		}
		if ($('#radarAreaSelTxt').text() == "范围") {
			if (resQnxData) {
				_switchQnxData(resQnxData, orderVal);
			}
		}

	});
	mui("#imgBox").on("swipeleft", ".img", function () {
		var activeOrder = Number($(".img.img-active").attr("data-order"));
		var orderVal = parseInt(activeOrder - 1);
		var maxVal = Number($("#radarControl").attr('max'));
		if (orderVal > maxVal || orderVal < 0) {
			return false;
		}
		$("#radarControl").val(maxVal - orderVal);
		if ($('#radarCitySelTxt').text() == "单站") {
			if (resData) {
				_switchData(resData, orderVal);
			}
		}
		if ($('#radarAreaSelTxt').text() == "范围") {
			if (resQnxData) {
				_switchQnxData(resQnxData, orderVal);
			}
		}
	});





	//TODO
	mui("#imgBox").on("swipeleft", "#radarImg", function () {

	})


	$('.time-btn').on('click', function () {
		$('.radar-img').css({
			"transform": "translate3d(0,0,0) scale(1) rotate3d(0,0,0,0)"
		});
		var activeOrder = parseInt($("#radarControl").val());
		var id = $(this).attr('id');
		var option = id == 'prevTimeBtn' ? -1 : 1;
		var orderVal = parseInt(activeOrder + option);
		if (orderVal > 9 || orderVal < 0) {
			return false;
		}
		$("#radarControl").val(orderVal);
		if ($('#radarCitySelTxt').text() == "单站") {
			if (resData) {
				_switchData(resData, 9 - orderVal);
			}
		}
		if ($('#radarAreaSelTxt').text() == "范围") {
			if (resQnxData) {
				_switchQnxData(resQnxData, 9 - orderVal);
			}
		}
	});

});