$(function(){
	var rainOption = JSON.parse(localStorage.rainOption);
	console.log(rainOption)
	preStation(rainOption.endTime);
	//	站点降水量折线图数据获取    begin
	function preStation(time){
		var url="/currentMonitor/pre/preStation.do";
		var url1Hour="/currentMonitor/pre/preStation1Hour.do";
		var stationCode=localStorage.rainfallRankStationCode;
		var params={startTime:'',endTime:time,stationCode:stationCode};
		if(rainOption.interval==1){
			params.startTime=dayjs(time).subtract(1, 'hour').format('YYYY-MM-DD HH:mm:ss')
			http.get(url1Hour,params,_preStationSuccess,params)
		} else {
			params.startTime=dayjs(time).subtract(24, 'hour').format('YYYY-MM-DD HH:mm:ss')
			http.get(url,params, _preStationSuccess,params);
		}
		
		$("#rankChartStartTime").text(dayjs(params.startTime).format('MM月DD日HH时'));
		$("#rankChartEndTime").text(dayjs(params.endTime).format('MM月DD日HH时'));
		$("#rankStationDetails").text(localStorage.rainfallRankStationName);
	}
	
	function _preStationSuccess(data,info){
		var resData=data.body.data;
		resData = resData.map(function(item) {
			if (item.dateTime) {
				item.datetime = item.dateTime
			}
			return item
		})
		var resDataLength=resData.length;
		var datetimeArr=[],preArr=[],datetimeItem,hourtext;
		if(rainOption.interval==1){
			hourtext='1';
		}else{
			hourtext='24';
		}
		for(var i=0;i<resDataLength;i++){
//			TODO  X轴时间显示跨日处理
			if(i>0){
				var currentDay=(resData[i].datetime).substr(8,2);
				var prevDay=(resData[(i-1)].datetime).substr(8,2);
				if(Number(currentDay)-Number(prevDay)==1){
					datetimeItem=currentDay+"日"
				}else{
					datetimeItem=(resData[i].datetime).substr(11,5);
				}
				datetimeArr.push(datetimeItem);
			}else{
				datetimeArr.push((resData[i].datetime).substr(11,5));
			}
			preArr.push(Number(resData[i].pre));
		}

		console.log(preArr)
		
		$('#station-chart-container').highcharts({
			chart: {
				type: 'column',
	        },
	        title: {
	            text: '近'+hourtext+'小时降水统计',
	        },
	        legend: {
	            enabled: false
	        },
	        exporting: {
	            enabled: false
	        },
	        credits: {
	            enabled: false
	        },
	        xAxis: {
	            categories: datetimeArr,
				crosshair: true
	        },
	        yAxis: {
	            min: 0,
	            title: {
	                text: '降雨量 (mm)'
	            },
				plotLines:[{//基准线  
					// color:'#8c8c8c',  
					color:'#d26262',
					dashStyle:'Dash',  
					width:1.5,//基准线宽度  
					value:4.8,//基准线的参考值  
					zIndex:5,
					label:{
						align:'right',
						text:'降水量4.8mm',
						x:-15,
						style:{
							color:'#8c8c8c'
						}
					}
				}]
	        },
	        series: [{
	            name: ' ',
	            data: preArr,
	            color:"#97ca00"
	        }]
		});
		
	}
//	站点降水量折线图数据获取   end
	
});
