$(function(){
	function getMapData(queryTime){
		var textUrl = "/currentMonitor/pre/data.do";
		var params = {
			interval: rainOption.interval,
			dateTime: queryTime || '',
			stationTypes: rainOption.curStation,
			numericalBegin:rainOption.valBegin,
			numericalEnd:rainOption.valEnd,
		}
		ajax(textUrl, params, _preTextSuccess, "get")
		function _preTextSuccess(data){
			var res = data.body.data.filter(function(val){
				return val.pre !== 0
			})
			//时间字符串填充 存储返回时间
			var rainfallStartTimeTxt,cityName,cntyName,statisticsItemStr='';
			var endTime=dayjs(data.body.datetime);
			var startTime= endTime.subtract(rainOption.interval,'hour');
			var rainfallStartTimeTxt = startTime.format('M月D日H时')+'-'+ endTime.format('D日H时')
			$("#rainfallRankTime").text(rainfallStartTimeTxt);
			if(data.body.total==0||data.body.data.length==0){
				$("#rainfallRankStatisticsUl").html('<li class="mui-table-view-cell statistics-item rain-statistics-item">暂无数据！</li>');
				return false;
			}
			sortAndShowData(res)
			//排序和显示数据
			function sortAndShowData(data){
				// var resData=data.body.data;
				var temChangeStr=[],sortData,count = 1;
				activeDataType=$(".max-and-min-datehour-option.datehour-option-active").attr("data-type");
				var activeOrder=$("#tem-rank-btn").attr("data-rank");
				if(activeOrder=="descending"){
					sortData=data.sort(sortNumberHighToLow("pre"));
				}else{
					sortData=data.sort(sortNumberLowToHigh("pre"));
				}
				sortData.forEach(function(val,idx){
					if(val[rainOption.dataType]!==null){
						var _tmpStation = getStationByCode(val.code)
						var name = _tmpStation.city + ' ' + (_tmpStation.level == '1' ? '' : _tmpStation.cnty) + ' ' + _tmpStation.name
						temChangeStr.push('<li class="mui-table-view-cell statistics-item rain-statistics-item" data-stationName="'+name+'"  data-stationCode="'+val.code+'">'+
						'<a class="mui-navigate-right statistics-item-txt"><span class="rank-name">'+(count++)+"."+name+
						'</span><span class="statistics-item-number">'+val.pre+'</span></a></li>')
					}
				})
				$("#rainfallRankStatisticsUl").html(temChangeStr.join(''));
				$("#rainfallRankTotalStations").text(count-1);
			}

		}
	}	
	//交互    begin 
	var rainOption = JSON.parse(localStorage.rainOption);
	getMapData(rainOption.endTime)

	$(".datehour-option").each(function(){
		if($(this).attr("data-val")==rainOption.interval){
			$(this).addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
		}
	});
	mui(".search-show-time-box").on('tap','.rank-search-btn',function(){
		$("#rank-search-box").show().siblings('.search-show-time-box').hide();
		$("#search-ip").focus();
	});
	$("#rank-search-box").on('click','#rank-canle-btn',function(){
		$("#rank-search-box").hide().siblings('.search-show-time-box').show();
	});

	$("#search-ip").on("input", debounce(function(){
		var searchTxt=$(this).val();
		var matchResultArr=[];
		if(searchTxt){
			$(".rain-statistics-item").each(function(){
				$(this).removeClass("mathName");
				$(this).removeClass("mathStationcode");
				var stationName=$(this).find(".statistics-item-txt").text();
				var stationCode=$(this).attr("data-stationCode");
				var matchName=stationName.match(searchTxt);
				var matchStationcode=stationCode.match(searchTxt);
				
				if(matchName){
					$(this).addClass("mathName");
					matchResultArr.push($(this));
				}
				if(matchStationcode){
					$(this).addClass('mathStationcode');
					matchResultArr.push($(this));
				}
			});
			if(matchResultArr.length>0){
				var matchStationArr=[],matchStation;
				$(".rain-statistics-item").hide();
				$(".mathName").show();
				$(".mathStationcode").show();
			}else{
				$(".rain-statistics-item").hide();
			}
		}else{
			$(".rain-statistics-item").show();
		}
	}, 200));

	// 点击取消  应展示完整的数据
	mui(".search-box").on("click",".search-cancle-btn",function(){
	 	$("#search-ip").val('');
	 	$(".rain-statistics-item").show();
	});
	
	mui("#rain-rank-datehour-box").on("tap",".datehour-option",function(){
		$(this).addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
		rainOption.interval=$(".datehour-option.datehour-option-active").attr("data-val");
		localStorage.rainOption = JSON.stringify(rainOption)
		getMapData(rainOption.endTime)
	});
	
	//升序降序
	mui(".search-show-time-box").on("tap","#tem-rank-btn", function(){
		var activeSort;
		var activeOrder=$(this).attr("data-rank");
		if(activeOrder=="descending"){
			$(this).attr("data-rank","ascending");
			$(this).text("降序");
		}else{
			$(this).attr("data-rank","descending");
			$(this).text("升序");
		}
		getMapData(rainOption.endTime)
	});

	mui("#rainfallRankStatisticsUl").on('tap','.rain-statistics-item',function(){
		var activeStationCode=$(this).attr("data-stationCode");
		var activeStationName=$(this).attr("data-stationName");
		localStorage.rainfallRankStationCode=activeStationCode;
		localStorage.rainfallRankStationName=activeStationName;
		mui.openWindow({
		    url:'../../web/monitoringOfLive/rainfall-rank-chart.html',
		    // id: activeStationCode,
		    waiting: {
	            autoShow: false
	        },
	        extras:{
	            name:activeStationCode
	        },
			styles: {
				statusbar: {
					background: localStorage.statusbarColor
				}
			}
		});
	});
	//交互    end
});
