$(function(){
	var height = $(window).height(), 
		width = $(window).width(),
		containerHeight = height - Number($('header').css('height').replace("px", ''))
	$(".mui-content").height(containerHeight)

	mui.init({
		swipeBack: false, //启用右滑关闭功能
		gestureConfig: {
			tap: true, //默认为true
			doubletap: true, //默认为false
			longtap: true, //默认为false
			swipe: true, //默认为true
			drag: true, //默认为true
			hold: false,//默认为false，不监听
			release: false//默认为false，不监听
		},
		beforeback: function () {
			if (mui.os.plus) {
				if ($('body').hasClass('horizontal')) {
					plus.screen.lockOrientation('portrait-primary')
					setTimeout(function() {
						plus.screen.unlockOrientation()
					}, 2000)
					return false
				}

				plus.screen.lockOrientation('portrait-primary')
			}

			return true
		}
	})

	// 监听屏幕旋转事件
	window.addEventListener("orientationchange", function() {
		switch (window.orientation) {
			case 90:
			case -90:
				plus.navigator.setFullscreen(true)
				$('body').addClass('horizontal')
				$('.time-btn').removeClass('hide')
				$('.horizontal-display-item').css('display', 'none')
				$('.mui-content,.swiper-container').height(width)
				$('.mui-title').text('数据更新时间：' + $('.show-realtime').text())
				Screen.horizontal()
				break
			default:
				plus.navigator.setFullscreen(false)
				$('body').removeClass('horizontal')
				$('.time-btn').addClass('hide')
				$('.horizontal-display-item').css('display', 'flex')
				$('.mui-content').height(containerHeight)
				$('.swiper-container').height('')
				$('.mui-title').text($('title').text())
				Screen.vertical()
				break
		}

		swiper.update(true)
	}, false)

	$(document).click(function(e) {
		if ($('body').hasClass('horizontal') && $('.horizontal-display-item').find($(e.target)).length === 0) {
			if ($('.mui-bar').css('display') === 'flex') {
				plus.navigator.setFullscreen(true)
			} else {
				plus.navigator.setFullscreen(false)
			}
			$('.horizontal-display-item').stop().slideToggle(100).toggleClass('opacity').css('display', 'flex')
		}
	})

	var swiper, activeData
	function renderSwiper(htmls) {
		swiper && swiper.destroy()
		$('.swiper-wrapper').html(htmls.join(''))
		swiper = new Swiper('.swiper-container', {
			effect: 'fade',
			passiveListeners: false,
			initialSlide: htmls.length - 1,
			preloadImages: false,
			lazy: {
			    loadPrevNext: true
			},
			watchSlidesVisibility: true,
			zoom: {
			    toggle: false
			}, 
			autoplay: {
				delay: 1000,
				stopOnLastSlide: true
			},
			on: {
				init: function() {
					$("#satelliteControl").val(htmls.length - 1)
					$("#realTime").text(activeData.length > 0 && activeData[0].datetime);
					$("#playImg").attr("data-val", 0)
					$("#playImg").attr("src", "../../images/monitoringOfLive/radar-play.png")
				},
				slideChange: function() {
					$("#satelliteControl").val(this.activeIndex)
					$("#realTime").text(activeData[htmls.length - 1 - this.activeIndex].datetime);
				},
				autoplayStop: function() {
					$("#playImg").attr("data-val", 0)
					$("#playImg").attr("src", "../../images/monitoringOfLive/radar-play.png")
				}
			},
				// navigation: {
				// 	nextEl: '#nextImgBtn',
				// 	prevEl: '#prevImgBtn',
				// },
		})
		swiper.autoplay.stop()
	}
	
//	 卫星云图
	satellite();
	function satellite(){
		var url="/satellite.do";
		var channel=parseInt($("#radarAreaSel").val());
		var params={channel:channel};
		http.post(url,params,_satelliteSuccess,'');
	}
	var resData;
	function _satelliteSuccess(data,info){
		if(data.body.recordNum==0){
			mui.confirm("暂无数据！","提示",function(){
				return false;
			});
		}
		resData=data.body.data;
		var activeType=parseInt($("#radarCitySel").val());
		_switchData(resData,activeType,0);
		
		mui.plusReady(function () {
			// 解除方向锁定
			plus.screen.unlockOrientation()
		})
	}
	/**
	 * 
	 * @param {Object} data  	渲染数据
	 * @param {Object} type	  	当前选择类型
	 * @param {Object} order 	当前播放顺序
	 */
	function _switchData(data,type,order){
		if(!data){
			return false;
		}
		var activeItemData='';
		for(var i=0;i<data.length;i++){
			if(Number(data[i].param) === type){
				activeItemData=data[i];
			}
		}
		
		var htmls = []
		var imgStr='';
			activeClass='';
		for(var i = activeItemData.imgs.length - 1;i >= 0;i--){
			if(i==order){
				activeClass='img-active'
			}else{
				activeClass='';
			}
			activeItemData.imgs[i].datetime = addHour(activeItemData.imgs[i].datetime, 8*60*60*1000)
			imgStr+='<img class="img radar-img '+activeClass+'" src="'+activeItemData.imgs[i].path+'" data-order='+(i)+' data-time="'+activeItemData.imgs[i].datetime+'" data-preview-src="" data-preview-group="1" />'
			
			htmls.push('<div class="swiper-slide"><div class="swiper-zoom-container"><img data-src="' + activeItemData.imgs[i].path + '" class="swiper-lazy"></div><div class="swiper-lazy-preloader"></div></div>')
		}
		
		activeData = activeItemData.imgs
		renderSwiper(htmls)
//		$("#imgBox").html(imgStr);
		$("#satelliteControl").attr('max',htmls.length - 1)
//		$("#satelliteControl").attr({
//			"max": parseInt(activeItemData.recordNum),
//			"value": parseInt(activeItemData.recordNum - order)
//		});
		// $("#satelliteControl").val(activeItemData.recordNum - order);
		$('.radar-img').load(function() {
			var self = $(this), el = self[0]
			$(".img-box").height($(window).width() / el.naturalWidth * el.naturalHeight)
//					self.zoom()
		})
		var activeImgTime = activeItemData.imgs[order].datetime;
		$("#realTime").text(activeImgTime);
	}
	
	function _switchActiveTypeImg(order){
		$(".img").each(function(){
			if($(this).attr("data-order")==Number(order)){
				$(this).addClass("img-active").siblings().removeClass("img-active");
				// $("#realTime").text($(this).attr("data-time"));
			}
		});
		
	}
	
	//开始 暂停
	
	function progressTimeControl(img,rangeDom) {
		$('.radar-img').css({
			"transform":"translate3d(0,0,0) scale(1) rotate3d(0,0,0,0)"
		});
	    if ($(img).attr("data-val") == 0) {
	    	$(img).attr("data-val",1);
	        $(img).attr("src", "../../images/monitoringOfLive/radar-unplay.png");
//	       　	autoPlay(img,rangeIp);　
			swiper && swiper.autoplay.start()
	    }else {
	       	$(img).attr("data-val",0);
	        $(img).attr("src", "../../images/monitoringOfLive/radar-play.png");
			swiper && swiper.autoplay.stop()
//	       	clearInterval(time),function(){
//			　　  autoPlay(img,rangeIp);　
//			}　
	    }
	}
	
	function autoPlay(img,rangeDom){
　　	time = setInterval(function(){
			var orderVal=parseInt(rangeDom.val());
	    	var orderMax=parseInt(rangeDom.attr("max"));
	    	var orderMin=parseInt(rangeDom.attr("min"));
	    	var orderStep=rangeDom.attr("step");
	    	if(orderVal<orderMax){
	    		orderVal+=1;
	    		rangeDom.val(orderVal);
	    		var activeType=parseInt($("#radarCitySel").val());
//	    		_switchData(resData,activeType,orderMax-orderVal);
				_switchActiveTypeImg(orderMax-orderVal);
	    	}else if(orderVal>=orderMax){
	    		$(img).attr("data-val",0);
	        	$(img).attr("src", "../../images/monitoringOfLive/radar-play.png");
					clearInterval(time),function(){
					　　  autoPlay(img,rangeIp);　
					}　
	    	}
	    	
　　	},1000)
	}


	
//	交互       begin
	var activeType=parseInt($("#radarCitySel").val());
//	_switchData(fakeData.body.data,activeType,0)

	$("#radarAreaSel").on("change",function(){
		satellite();
	});
	$("#radarCitySel").on("change",function(){
		if(resData){
			var activeType=parseInt($("#radarCitySel").val());
			_switchData(resData,activeType,0)
		}else{
			satellite();
		}
	});
	
	var img=$("#playImg");
	var rangeIp=$("#satelliteControl");
	$("#playControlBtn").on("click",function(){
		var activeOrder=parseInt($("#satelliteControl").val());
		if(activeOrder==parseInt($("#satelliteControl").attr("max"))){
			$("#satelliteControl").val(0)
			swiper && swiper.slideTo(0, 0)
		}
		progressTimeControl($("#playImg"),$("#satelliteControl"));
	});
	
	//swiper 横屏时翻页事件
	$("#prevImgBtn").on("click",function(e){
		swiper.slidePrev(0)
		e.stopPropagation()
	})
	$("#nextImgBtn").on("click",function(e){
		swiper.slideNext(0)
		e.stopPropagation()
	})
	
   // range移动时提示框隐藏
	$("#satelliteControl").siblings('span').remove();
	$("#satelliteControl").change(function(){
		var order=$(this).val();
		var activeMax=parseInt($(this).attr("max"));
		$(this).siblings('span').remove();
		
		if(resData){
//			var activeType=parseInt($("#radarCitySel").val());
//			_switchData(resData,activeType,activeMax-order);
			_switchActiveTypeImg(activeMax-order);
		}
		
		swiper && swiper.slideTo(order, 0)
	});

	// mui("#imgBox").on("swiperight",".img",function(){
	// 	var activeOrder=Number($(".img.img-active").attr("data-order"));
	// 	var orderVal = parseInt(activeOrder +1);
	// 	var maxVal= Number($("#satelliteControl").attr('max'));
	// 	if(orderVal > maxVal || orderVal < 0) {
	// 		return false;
	// 	}
	// 	$("#satelliteControl").val(maxVal-orderVal);
	// 	_switchActiveTypeImg(orderVal);
		
	// });
	// mui("#imgBox").on("swipeleft",".img",function(){
	// 	var activeOrder=Number($(".img.img-active").attr("data-order"));
	// 	var orderVal = parseInt(activeOrder -1);
	// 	var maxVal= Number($("#satelliteControl").attr('max'));
	// 	if(orderVal > maxVal || orderVal < 0) {
	// 		return false;
	// 	}
	// 	$("#satelliteControl").val(maxVal-orderVal);
	// 	_switchActiveTypeImg(orderVal);
	// });









/* 	$('.time-btn').on('click', function() {
		$('.radar-img').css({
			"transform":"translate3d(0,0,0) scale(1) rotate3d(0,0,0,0)"
		});
		var activeOrder = parseInt($("#satelliteControl").val());
		var id = $(this).attr('id');
		var option = id == 'prevTimeBtn' ? -1 : 1;
		var orderVal = parseInt(activeOrder + option);
		var maxVal=parseInt($("#satelliteControl").attr('max'));
		if(orderVal > maxVal || orderVal < 0) {
			return false;
		}
		$("#satelliteControl").val(orderVal);
		var activeType=parseInt($("#radarCitySel").val());
		_switchData(resData,activeType,(maxVal-orderVal));
	}); */
	
	

	//交互    end
});
