$(function(){
	//默认按降序返回，降序排行时按数组下标从小到大排列即可，升序反之。

	function ascendOrDecendByMonth(time){
		var monthArr=['04','05','06','07','08','09','10'];
		var month=time.substr(5,2);
		var res={};
		if(monthArr.indexOf(month)==-1){
			res.sortStr='asscending';
			res.text='降序';
		}else{
			res.sortStr='descending';
			res.text='升序';
		}
		$("#tem-rank-btn").attr("data-rank",res.sortStr).text(res.text);
		return res;
	}


	function getMapData(queryTime){
    if(temOption.begin === 'hidden'){
      return
    }
		var textUrl;
		if (temOption.dataSort === 'temAnd24hChange') {
			textUrl = "/currentMonitor/tem/temAndTemChange24hData.do"
		} else {
			textUrl = "/currentMonitor/tem/temMaxAndMinData.do"
		}
    var params = {
			type:temOption.dataType,
      dateTime: queryTime || '',
      stationTypes: temOption.curStation,
      numericalBegin:temOption.valBegin,
      numericalEnd:temOption.valEnd,
    }
		ajax(textUrl, params, _preTextSuccess, "get")

    function _preTextSuccess(data){
			if(data.body.recordNum==0){
				$("#temRankUl").html('')
				return false;
			}
      dayjsToDom(data.body.datetime)
			sortAndShowData(data)
			//时间字符串填充 存储返回时间
			function dayjsToDom(timeString) {
				var rainfallStartTimeTxt, endTime, startTime;
				endTime = dayjs(timeString)
				if (temOption.dataSort === 'temAnd24hChange') {
					rainfallStartTimeTxt = endTime.format('M月D日H时')
				} else {
					startTime = endTime.subtract(1, 'day')
					rainfallStartTimeTxt = startTime.format('M月D日H时') + '-' + endTime.format('D日H时')
				}
				$("#temRankTime").text(rainfallStartTimeTxt);
			}
			//排序和显示数据
			function sortAndShowData(data){
				var resData=data.body.data;
				var temChangeStr=[],sortData,count = 1;
				activeDataType=$(".max-and-min-datehour-option.datehour-option-active").attr("data-type");
				var activeOrder=$("#tem-rank-btn").attr("data-rank");
				if(activeOrder=="descending"){
					sortData=resData.sort(sortNumberHighToLow(temOption.dataType));
				}else{
					sortData=resData.sort(sortNumberLowToHigh(temOption.dataType));
				}
				sortData.forEach(function(val,idx){
					if(val[temOption.dataType]!==null){
						var _tmpStation = getStationByCode(val.code)
						var name = _tmpStation.city + ' ' + (_tmpStation.level == '1' ? '' : _tmpStation.cnty) + ' ' + _tmpStation.name
						temChangeStr.push('<li class="mui-table-view-cell statistics-item tem-statistics-item"  data-stationName="'+name+'"  data-stationCode="'+val.code+'">'+
						'<a class="mui-navigate-right statistics-item-txt">'+(count++)+"."+name+
						'<span class="statistics-item-number">'+val[temOption.dataType]+'</span></a></li>')
					}
				})
				$("#temRankUl").html(temChangeStr.join(''));
				$("#totalStations").text('共'+(count-1)+'站点');
			}
    }
	}

//	init
	var temOption = JSON.parse(localStorage.temOption);
	ascendOrDecendByMonth(temOption.displayTime);
	getMapData(temOption.displayTime)
	
	$(".datehour-option").each(function(){
		if($(this).attr("data-type")==temOption.dataType){
			$(this).addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
		}
	});
	$("#tem-rank-datehour-box").on("click",".tem-datehour-option",function(){
		$(this).addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
		temOption.dataType = $(".tem-datehour-option.datehour-option-active").attr("data-type");
		getMapData(temOption.displayTime)
	});

	mui(".search-show-time-box").on("tap","#tem-rank-btn", function(){
		var activeSort;
		var activeOrder=$(this).attr("data-rank");
		if(activeOrder=="descending"){
			$(this).attr("data-rank","ascending");
			$(this).text("降序");
		}else{
			$(this).attr("data-rank","descending");
			$(this).text("升序");
		}
		getMapData(temOption.displayTime)
	});

	$("#search-ip").on("input", debounce(function(){
		var searchTxt=$(this).val();
		var matchResultArr=[];
		if(searchTxt){
			$(".tem-statistics-item").each(function(){
				$(this).removeClass("mathName");
				$(this).removeClass("matchStationcode");
				var stationName=$(this).find(".statistics-item-txt").text();
				var stationCode=$(this).attr("data-stationCode");
				var matchName=stationName.match(searchTxt);
				var matchStationcode=stationCode.match(searchTxt);
				if(matchName){
					$(this).addClass("mathName");
					matchResultArr.push($(this));
				}
				if(matchStationcode){
					$(this).addClass("matchStationcode");
					matchResultArr.push($(this));
				}
			});
			if(matchResultArr.length>0){
				var matchStationArr=[],matchStation;
				$(".tem-statistics-item").hide();
				$(".mathName").show();
				$(".matchStationcode").show();
			}else{
				$(".tem-statistics-item").hide();
			}
		}else{
			$(".tem-statistics-item").show();
		}
	}, 200));

	// 点击取消  应展示完整的数据
	mui(".search-box").on("tap",".search-cancle-btn",function(){
	 	$("#search-ip").val('');
	 	$(".tem-statistics-item").show();
	});
	
	mui("#temRankUl").on('tap','.tem-statistics-item',function(){
		var activeStationCode=$(this).attr("data-stationCode");
		var activeStationName=$(this).attr("data-stationName");
		var activeTemType= $(".tem-datehour-option.datehour-option-active").attr('data-sort');
		localStorage.temRankStationCode=activeStationCode;
		localStorage.temRankStationName=activeStationName;
		localStorage.activeTemType=activeTemType;
		mui.openWindow({
			url:'../../web/monitoringOfLive/tem-chart.html',
			id: activeStationCode,
			styles: {
				statusbar: {
					background: localStorage.statusbarColor
				}
			}
		});
	}); 

});
