//$(function(){
	var map_lat_start, //底图左上角对应的经度
		map_lon_start, //底图左上角对应的纬度
		map_lat_end, //底图右下角对应的经度
		map_lon_end, //底图右小角对应的纬度
		map_w, //底图宽度
		map_h; //底图高度
	var scr_w=$(window).width();
	var scr_h=$(window).height();
	$("#mapWrapper").width(scr_w).height(scr_h-88 - localStorage.statusbarHeight);
	var swBg=document.getElementById("swBgWp");
	
	var cityCan=document.getElementById("cityCan");//城市名画布
	var cityCtx=cityCan.getContext('2d');
	var fullCan=document.getElementById("fullCan"); //可视区域画布
	var fullCtx=fullCan.getContext('2d');
	var geoMap ,fullGeoMap ,
		dip=window.devicePixelRatio,
	    lv = 2,
	    activeScale=1,
	    tScale= dip * lv;
	    
	function severeWeatherEarly(){
		var url="/home/severeWeatherEarly.do";
		ajaxPost(url,'',_severeWeatherEarlySuccess,'');
	}
	var resData;
	function _severeWeatherEarlySuccess(data,info){
		if(data.body.recordNum == 0) {
			$("#warningTxt").text('当前无预警或预警信号。');
			return false;
		}
		resData=data.body.data;
		var earlyWarningIconUrl,lat,lon,conItem;
		var provinceNumArr=[],cityNumArr=[],cntyNumArr=[];
		var unitType=$(".warning-datehour-option.datehour-option-active").attr("data-val");
		_switchData(resData,unitType,'');
		
		for(var i=0;i<resData.length;i++){
			switch(Number(resData[i].unitType)){
				case 1:
					provinceNumArr.push(1);
				break;
				case 3:
					cntyNumArr.push(3);
				break;
			}
		}
		$("#warningTxt").text("生效中省级预警"+provinceNumArr.length+"条,"+"生效中市县(区)预警信号"+cntyNumArr.length+"条。");
	}


	function _switchData(resData, dataUnitType, finish){
		console.log('_switchData()')
		fullCtx.clearRect(0,0,fullCan.width,fullCan.height);
		if(activeScale > 1.5 && activeScale < 7){
			drawTwoLvData(geoResult.data, 'cnty');//绘制地理数据
		}
		if(activeScale > 7){
			drawTwoLvData(geoResult.data, 'station');//绘制地理数据
		}
		fullGeoMap.clear()
		
		var promises = [] 
		for(var i=0;i<resData.length;i++){
			if(resData[i].unitType == dataUnitType){
				var earlyWarningIconUrl = "../images/earlyWarningIcon/" + resData[i].earlyType + "-" + resData[i].earlyLevel + ".jpg";
				var areaArr=resData[i].relevantArea;
				for(var j=0;j<areaArr.length;j++){
					var area = areaArr[j] , areaDataObj={};
					if(area == '湘西州')
						area = '湘西苗族土家族自治州';
					if(!area){
						continue
					}
					var result = getStationByCode(area);
					if(null == result) continue;
					if(result.lat && result.lon){
						resData[i].lon=result.lon;
						resData[i].lat=result.lat;
						areaDataObj.areaName = area 
						areaDataObj.lon=result.lon
						areaDataObj.lat=result.lat
						areaDataObj.sendContent= resData[i].sendContent
			    		conItem= fullGeoMap.registerElement(areaDataObj, result.lon, result.lat, 25*tScale);
			    		promises.push(new Promise(function(resolve, reject) {
			    			(function(url, item) {
					    		var img = new Image();
					    		img.src = url;
					    		img.onload = function() {
					    			fullCtx.drawImage($('<img src='+ url +'>')[0],item[0]*tScale-25*tScale,item[1]*tScale-20*tScale,50*tScale,40*tScale);
					    			resolve()
					    		}
					    		img.onerror = reject
				    		})(earlyWarningIconUrl, conItem)
			    		}))
					}
				}
			}
		}
		Promise.all(promises).then(function() {
			if(finish){
				finish()
			}
			
		})
		
		
	}

	function drawWindow(data,ctx){
		console.log('drawWindow()')
		var searchData=data;
		var dataTxt=searchData[3].sendContent;
		var dataLine=Math.ceil(dataTxt.length/16);//向上取整
		var fontSetting = tScale*10+'px '+'Arial';
		ctx.font=fontSetting;
		ctx.drawImage(swBg,searchData[0]*tScale-80*tScale,searchData[1]*tScale-100*tScale,180*tScale,dataLine*20*tScale);
		writeTextOnCanvas(ctx, 16*tScale, 32, dataTxt ,searchData[0]*tScale-70*tScale, searchData[1]*tScale-84*tScale);
	}
	
    //ctx_2d        getContext("2d") 对象  
    //lineheight    段落文本行高  
    //bytelength    设置单字节文字一行内的数量  
    //text          写入画面的段落文本  
    //startleft     开始绘制文本的 x 坐标位置（相对于画布）  
    //starttop      开始绘制文本的 y 坐标位置（相对于画布）  
    function writeTextOnCanvas(ctx_2d, lineheight, bytelength, text ,startleft, starttop){  
        function getTrueLength(str){//获取字符串的真实长度（字节长度）  
            var len = str.length, truelen = 0;  
            for(var x = 0; x < len; x++){  
                if(str.charCodeAt(x) > 128){  
                    truelen += 2;  
                }else{  
                    truelen += 1;  
                }  
            }  
            return truelen;  
        }  
        function cutString(str, leng){//按字节长度截取字符串，返回substr截取位置  
            var len = str.length, tlen = len, nlen = 0;  
            for(var x = 0; x < len; x++){  
                if(str.charCodeAt(x) > 128){  
                    if(nlen + 2 < leng){  
                        nlen += 2;  
                    }else{  
                        tlen = x;  
                        break;  
                    }  
                }else{  
                    if(nlen + 1 < leng){  
                        nlen += 1;  
                    }else{  
                        tlen = x;  
                        break;  
                    }  
                }  
            }  
            return tlen;  
        }  
        for(var i = 1; getTrueLength(text) > 0; i++){  
            var tl = cutString(text, bytelength);  
            ctx_2d.fillText(text.substr(0, tl).replace(/^\s+|\s+$/, ""), startleft, (i-1) * lineheight + starttop);  
            text = text.substr(tl);  
        }  
    }  
	
	
	
	
	function init() {
		map_w=$("#rainMap").width();
		map_h=$("#rainMap").height();
		$("#handleLayer").width(map_w).height(map_h)
		map_lat_start =24.5;
		map_lon_start =108.6; 
		map_lat_end = 30.3; 
		map_lon_end =114.4;
		
		cityCan.width=map_w * dip * lv;
		cityCan.height=map_h * dip * lv;
		cityCan.style.width=map_w+'px';
		cityCan.style.height=map_h+'px';
		
		var wrapperHeight = $('#mapWrapper').outerHeight()
		window.FULL_CAN_TOP = -(wrapperHeight - map_h) / 2
		fullCan.style.top = FULL_CAN_TOP + 'px'
		fullCan.width = map_w * dip * lv
		fullCan.height = wrapperHeight * dip * lv
		fullCan.style.width = map_w + 'px'
		fullCan.style.height = wrapperHeight + 'px'
		geoMap = new GeoMapUtil();
		geoMap.init(map_lon_start,map_lon_end,map_lat_start,map_lat_end, 2, map_w, map_h);
		
		var perLat=Decimal.div(5.8, map_h).toNumber();
		var diffTopLat=Decimal.sub(wrapperHeight, map_h).div(2).mul(perLat).toNumber()
		var initLatMin= Decimal.sub(24.5,diffTopLat);
		var initLatMax=Decimal.add(30.3,diffTopLat);
		
		fullGeoMap = new GeoMapUtil();
		fullGeoMap.init(map_lon_start,map_lon_end,initLatMin,initLatMax, 2, map_w, wrapperHeight);
		drawCityName(cityData,1);
	}
	function drawCityName(data,activeScale){
		var registerElement;
		var size = Math.ceil(10 * dip / activeScale * lv)
		var fontSetting= size +'px sans-seri';
		cityCtx.font=fontSetting;
		cityCtx.clearRect(0,0,cityCan.width,cityCan.height);
		data.forEach(function(item) {
			registerElement = geoMap.registerElement(item, item.lon, item.lat, 30);
			item.containerPos=[registerElement[0],registerElement[1]];
			cityCtx.fillText(item.city, item.containerPos[0]*dip * lv, item.containerPos[1]*dip * lv);
		})
		geoMap.clear()
	}
	function drawTwoLvData(data,keyName) {
//		if(data.length==0){return}
		var size = Math.ceil(10 * dip * lv)
		var fontSetting= size +'px sans-seri';
		fullCtx.fillStyle = "#3b3b3c"; 
		fullCtx.font=fontSetting;
		fullCtx.clearRect(0,0,fullCan.width,fullCan.height);
		data.forEach(function(item) {
			var registerElement = fullGeoMap.registerElement(item, item.lon, item.lat, 30);
			item.containerPos=[registerElement[0],registerElement[1]];
			size = Math.ceil(10 * dip * lv*2)
			fontSetting= size +'px sans-seri';
			fullCtx.font=fontSetting;
			fullCtx.fillText('.', item.containerPos[0] * dip * lv + item[keyName].length*size/4.8 , item.containerPos[1]*dip * lv + size/4);
			size = Math.ceil(10 * dip * lv)
			fontSetting= size +'px sans-seri';
			fullCtx.font=fontSetting;
			fullCtx.fillText(item[keyName], item.containerPos[0] * dip * lv, item.containerPos[1]*dip * lv);
		})
		fullGeoMap.clear()
	}
	var test= function(searchObj){
		var resSearchObj=searchObj
  		if(resSearchObj != null){
			drawWindow(resSearchObj,fullCtx);
		}
  	}
	
	
//	query(0, 0, 1)
	//发起请求  
//	init
	var self = $("#handleLayer") ,geoResult;
	$("#rainMap").load(function() {
		init();
		severeWeatherEarly();
		asyncMapVisualization(cityData, 'cityMv')
		asyncMapVisualization(cntyData, 'cntyMv')
		asyncMapVisualization(townsStationData, 'townsMv')
		
		$("#mapBox").height($(window).width() / $("#rainMap")[0].naturalWidth * $("#rainMap")[0].naturalHeight)
		
		var isMoved = false , unitType;
		self.zoom({
			syncDoms: [ '#cityCan','#rainMap'],
			onUpdate: function(x, y, s) {
				if (isMoved) {
					isMoved = false
					return
				}
				fullCan.style.left = (fullCan.offsetLeft - x) + 'px'
				fullCan.style.top = (fullCan.offsetTop - y) + 'px' 
			},
			moved: function(x, y, scale) {
				isMoved = true
				fullCan.style.left = '0px'
				fullCan.style.top = window.FULL_CAN_TOP + 'px'
				activeScale=scale;
				if (scale < 1.5) {
					drawCityName(cityData, scale)
					fullCtx.clearRect(0,0,fullCan.width,fullCan.height);
					geoResult = CONSTANT.cityMv.query(Math.abs(x), Math.abs(y), scale) //查询出当前屏幕范围内的数据
				}
				if(scale > 1.5 && scale <7){
					geoResult = CONSTANT.cntyMv.query(Math.abs(x), Math.abs(y), scale) 
					cityCtx.clearRect(0,0,cityCan.width,cityCan.height)
				}
				if(scale > 7){
					if(CONSTANT.townsMv){
						geoResult = CONSTANT.townsMv.query(Math.abs(x), Math.abs(y), scale) 
						cityCtx.clearRect(0,0,cityCan.width,cityCan.height)
					}
				}
				
				fullGeoMap = new GeoMapUtil()
				fullGeoMap.init(geoResult.startLon,geoResult.endLon,geoResult.startLat,geoResult.endLat, Decimal.sub(geoResult.endLon, geoResult.startLon).div(10).toNumber(), Number(fullCan.style.width.replace('px', '')), Number(fullCan.style.height.replace('px', '')));
			  	
			  	unitType=$(".warning-datehour-option.datehour-option-active").attr("data-val");
				
				if(searchObj != null) {
					lastSearchObj= fullGeoMap.registerElement(searchObj[3],searchObj[3].lon,searchObj[3].lat,25*tScale)
					_switchData(resData,unitType,function() {
						test(lastSearchObj)
					})
				}else{
					_switchData(resData,unitType,'')
				}
			}
		})
	})
	.attr('src', '../images/map/a.min.svg')
	
	
	 
	
//	交互  begin 
	$("#rain-rank-datehour-box").on("tap",".warning-datehour-option",function(){
		$(this).addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
		fullCtx.clearRect(0,0,fullCan.width,fullCan.height);
		if(resData){
			var unitType=$(".warning-datehour-option.datehour-option-active").attr("data-val");
			_switchData(resData,unitType);
		}else{
			severeWeatherEarly();
		}
	});
	
	//TODO
	var searchObj, lastSearchObj;
	var mapWrapper=document.getElementById("mapWrapper");
	mapWrapper.addEventListener('tap',function(e){
		searchObj=null , lastSearchObj=null;
		var event=window.event||e;
		var locX, locY;
		if(event.pageX){
			locX=event.pageX;
		}else{
			locX=event.detail.changedTouches[0].pageX;
		}
		if(event.pageY){
			locY=event.pageY;
		}else{
			locY=event.detail.changedTouches[0].pageY;
		}
		var loc = windowTocanvas(fullCan, locX, locY);
		var x = Decimal.div(loc.x, tScale).toNumber();
		var y = Decimal.div(loc.y, tScale).toNumber();
		searchObj = fullGeoMap.getElementDataByXY(x, y);
		unitType=$(".warning-datehour-option.datehour-option-active").attr("data-val");
		if(searchObj != null) {
			_switchData(resData,unitType,function() {
				test(searchObj)
			})
		}else{
			_switchData(resData,unitType,'')
		}
	},true);
	
	
	
//});
