var map = L.map('mapWrapper', {
    maxBoundsViscosity: 1.0,
    attributionControl:false,
    zoomControl:false,
    zoomDelta:0.5,
    zoomSnap:0.5
}).setView([27.3, 111.5], 6.5);

  
// 14个地市边界图层
var cityLayer = L.layerGroup()
;[57687, 57662, 57558, 57674, 57749, 57763, 57766, 57773, 57872, 57972, 57780, 57584, 57866, 57649].forEach(function(code) {
    L.geoJson.ajax('../../libs/geojson/' + code + '.json', {
      local: true,
        style: function (feature) {
            return feature.properties && feature.properties.style
        }
    }).addTo(map)
})

// 湖南省边界图层
var provinceLayer = L.geoJson.ajax('../../libs/geojson/hunan.json', {
  local: true,
    style: function (feature) {
        return feature.properties && feature.properties.style
    }
})
provinceLayer.addTo(map)

var cacheData = [],rainfallTableStr='',cacheTime,startTime,endTime;
//存放当前筛选数据的变量  curFilter：-1 全不选;99 全选;0-9 列表第几项 curStation：1国家站  2骨干站 3区域站
var mapOptions = {
  curStation:'nationData',
  baseLineValue:0
};
$("#rainSelTxt").text('国家站(97)');
$("#rainfallSelTxt").text('全显示');

//三级图层初始化
var layers = {},res={};
layers.pre = L.layerGroup();
['city','cnty','station'].forEach(function(val,idx){
  layers[val] = L.layerGroup()
})
res.nationData=new Array(),res.backboneData=new Array(),res.areaData=new Array();


//三级站点 过滤数据源
function getActiveData(){
  var activeDataKeyName;
  var stationVal=$("#rainSel").val()
  switch(Number(stationVal)){
    case 1:
      activeDataKeyName = 'nationData'  
    break;
    case 2:
      activeDataKeyName = 'backboneData'
    break;
    case 3:
      activeDataKeyName = 'areaData'
    break;
  } 
  return res[activeDataKeyName];
}


//请求数据
function preStainMap(interval,dateTime,isButton){
  var url="/currentMonitor/pre/stainMap.do";
  var params={interval:interval,datetime:dateTime||''};
  
  ajaxPost(url,params, function(data,info){
    _preStainMapSuccess(data,isButton)
  });
}

function _preStainMapSuccess(data,isButton){
  if(!isButton){
    cacheTime = data.body.datetime
    console.log('储存时间')
  }
  cacheData = data.body.data
  //时间字符串填充 存储返回时间
  endTime = dayjs(data.body.datetime)
  startTime = endTime.subtract(interval,'hour')
  var rainfallStartTimeTxt = startTime.format('M月D日H时')+'-'+ endTime.format('D日H时')
  $("#rainfallStartTime").text(rainfallStartTimeTxt);
  //分类三级数据  区域站包含了骨干站的数据
  res = {};
  res.nationData=new Array(),res.backboneData=new Array(),res.areaData=new Array();
  console.log(cacheData)
  cacheData.forEach(function(val,idx){
    switch(val.level){
      case '1':
      case '11':
        res.nationData.push(val)
        break;
      case '2':
      case '12':
        res.backboneData.push(val)
        res.areaData.push(val)
        break;
      case '3':
      case '13':
      case '14':
        res.areaData.push(val)
        break;
      default :	
        console.log('未分类：',val)
        return null;		
    }
  })
  console.log(res)
  switchMapData(cacheData)
  //降水过滤字符串填充
  $("#rainfallSel").html(renderRainfallSelBox(rainfallSelArr,1));
  //得到满足当前的ranges 
  dataFilter(pickRanges(ranges,interval),getActiveData(),'pre');
  //生成拼接html
  renderRainfallTable(pickRanges(ranges,interval));
  // 填充降水站点 
  $("#rainfalltable-box").html(rainfallTableStr);
  rainfallTableStr = '';
  // 按所选站点动态计算最大值
  // 更新最大降水数据 
  $("#maxRainfallData").text(dataCalc(getActiveData(),'pre').max);
}
var interval=$(".rain-datehour-option.datehour-option-active").attr("data-val");
preStainMap(interval)

var ranges=[{
    interval:1,
    data:[
      {				text:'0.1-9.9mm',				min:0.1,				max:9.99			},
      {				text:'10-19.9mm',				min:10,				max:19.99			},
      {				text:'20-29.9mm',			min:20,				max:29.99			},
      {				text:'30mm以上',			min:30,				max:99999			}
    ]		
  },{
    interval:3,
    data:[
      {				text:'0.1-9.9mm',				min:0.1,				max:9.99			},
      {				text:'10-24.9mm',				min:10,				max:24.99			},
      {				text:'25-49.9mm',			min:25,				max:49.99			},
      {				text:'50mm以上',			min:50,				max:99999			}
    ]
  },{
    interval:6,
    data:[
      {				text:'0.1-9.9mm',				min:0.1,				max:9.99			},
      {				text:'10-24.9mm',				min:10,				max:24.99			},
      {				text:'25-49.9mm',			min:25,				max:49.99			},
      {				text:'50mm以上',			min:50,				max:99999			}
    ]
  },{
    interval:12,
    data:[
      {				text:'0.1-9.9mm',				min:0.1,				max:9.99			},
      {				text:'10-24.9mm',			min:10,				max:24.99			},
      {				text:'25-49.9mm',			min:25,				max:49.99			},
      {				text:'50-99.9mm',			min:50,				max:99.99			},
      {				text:'100mm以上',			min:100,				max:99999			}
    ]	
  },{
    interval:24,
    data:[
      {				text:'0.1-9.9mm',				min:0.1,				max:9.99			},
      {				text:'10-24.9mm',			min:10,				max:24.99			},
      {				text:'25-49.9mm',			min:25,				max:49.99			},
      {				text:'50-99.9mm',			min:50,				max:99.99			},
      {				text:'100mm以上',			min:100,				max:99999			}
    ]
  },{
    interval:48,
    data:[
      {				text:'0.1-24.9mm',				min:0.1,				max:24.99			},
      {				text:'25-49.9mm',				min:25,				max:49.99			},
      {				text:'50-99.9mm',			min:50,				max:99.99			},
      {				text:'100-199.9mm',			min:100,				max:199.99			},
      {				text:'200mm以上',			min:200,				max:99999			}
    ]
  },{
    interval:72,
    data:[
      {				text:'0.1-24.9mm',				min:0.1,				max:24.99			},
      {				text:'25-49.9mm',				min:25,				max:49.99			},
      {				text:'50-99.9mm',			min:50,				max:99.99			},
      {				text:'100-199.9mm',			min:100,				max:199.99			},
      {				text:'200mm以上',			min:200,				max:99999			}
    ]
  }]
  

  //根据查询时间间隔，返回筛选阶级
  function pickRanges(data,interval){
    var pickedRanges=[];
    data.forEach(function(value,index){
      if(value.interval==interval){
        pickedRanges=value.data;
      }
    })
    return pickedRanges;
  }
/* *
* 数据区间过滤方法
* @param {object} ranges 过滤条件数组 第一组返回结果存储在ranges[0].item中
* @param {object} data	待过滤数据源
* @param {string} key 过滤数据键名
*/
function dataFilter(ranges, data, key) {
  var result = ranges
  result.forEach(function(el) { el.items = []})
  data.forEach(function(item){
      result.some(function(el) {
          var number = Number(item[key])
          if (number >= el.min && number <= el.max) {
              el.items.push(item)
              // return true
          }
      })
  })
  return result
}

//得到满足当前的ranges 
// dataFilter(pickRanges(ranges,interval),getActiveData(),'pre');


//画城市名
cityData.forEach(function(val,idx){
  var icon = L.divIcon({ html: val.city, className: 'city-marker',iconSize:40 })
  L.marker([val.lat,val.lon], { icon: icon }).addTo(layers.city)
  map.addLayer(layers.city)
})
cntyData.forEach(function(val,idx){
  var icon = L.divIcon({ html: val.cnty, className: 'city-marker',iconSize:40 })
  L.marker([val.lat,val.lon], { icon: icon }).addTo(layers.cnty)
})
townsStationData.forEach(function(val,idx){
  var icon = L.divIcon({ html: val.station, className: 'city-marker',iconSize:40 })
  L.marker([val.lat,val.lon], { icon: icon }).addTo(layers.station)
})

//缓存之前拖动的数据
var cacheStationMarkers = {};
//stationLayey优化
function initStationLayer() {
  layers.station.clearLayers()
  if (map.getZoom() >= 10) {
      console.time('contains')
      var bounds = map.getBounds()
      townsStationData.forEach(function(marker) {
          var latlng = [marker.lat * 1, marker.lon * 1]
          var contains = bounds.contains(latlng)
          if (contains) {
              var stationMarker = cacheStationMarkers[latlng]
              if (!stationMarker) {
                  var icon = L.divIcon({ html: marker.station, className: 'city-marker' ,iconSize:60 })
                  cacheStationMarkers[latlng] = stationMarker = L.marker(latlng, { icon: icon })
              }
              // var icon = L.divIcon({ html: marker.station, className: 'city-marker' ,iconSize:60 })
              // var stationMarker = L.marker(latlng, { icon: icon })
              stationMarker.addTo(layers.station)
          }
      })
      console.timeEnd('contains')
  }
}

initStationLayer()
map.on('zoomend moveend', initStationLayer)

//缩放层级显示
map.on('zoom',function(e){
  if(e.target._zoom>=8&&e.target._zoom<10){
    map.removeLayer(layers.city)
    map.removeLayer(layers.station)
    map.addLayer(layers.cnty)
  }else if(e.target._zoom>=10){
    map.removeLayer(layers.cnty)
    map.addLayer(layers.station)
  }else{
    map.removeLayer(layers.cnty)
    map.removeLayer(layers.station)
    map.addLayer(layers.city)
  }
})


//切换降水数据
function switchMapData(data){
  //根据查询时间间隔-选择range；把当前站点级别的数据处理到range里
  var drawData = dataFilter(pickRanges(ranges,interval),res[mapOptions.curStation],'pre');
  //处理完的数据 根据所选降水量大小筛选显示
  drawData = mapDataFilter(drawData,mapOptions.baseLineValue)
  rainPreToMap(drawData)
}

//画降水数据
function rainPreToMap(dataArr){
  layers.pre.clearLayers()
  dataArr.forEach(function(val,idx){
    // val.forEach(function(val,idx){
      var icon = L.divIcon({ html: Number(val.pre), className: 'text-marker' })
      L.marker([val.lat,val.lon], { icon: icon }).addTo(layers.pre)
      map.addLayer(layers.pre)
    // })
  })
}

//画色斑图
function rainColorToMap(){

}

/**
 * 生成降水过滤筛选选项拼接字符串
 * @param {Object} arr 降水过滤条件数组
 * @param {Number} interval 降水间隔小时数 1,6,24,48,72
 */
function renderRainfallSelBox(arr,interval){
  var rainfallSelBoxStr='';
  var currentOpt=[];
  arr.forEach(function(value,index){
    if(value.interval==interval){
      currentOpt=arr[index].opt;
    }
  })
  for(var i=0;i<currentOpt.length;i++){
    var content=''
    switch(currentOpt[i]){
      case 0.01:
      content = '全显示'
      break
      case 99999:
      content = '全不显示'
      break
      default:
      content = '&ge;' + currentOpt[i] + 'mm';
    }
    rainfallSelBoxStr += '<option value="'+currentOpt[i]+'">'+content+'</option>'
  }
  return rainfallSelBoxStr;
}

/**
 * 
 * @param {Array} data 待筛选数据
 * @param {Number} baseLine 返回数据将大于等于该值
 */
function mapDataFilter(data,baseLine){
  var result=[];
  var curdata={};
  curdata = data;
  if(Object.prototype.toString.call(data)==='[object Object]'){
    curdata=data.data
  }
  curdata.forEach(function(item){
    item.items.forEach(function(val,idx){
      if(Number(val['pre']>=baseLine)){
        result.push(val)
      }
    })
  })
  return result;
}

  /**
 * 最大值 最小值 计算方法
 * @param {object} data 计算的数据集合
 * @param {string} key  数据中的字段名
 * @param {object} res 存放结果的空对象 key:max,min
 */
function dataCalc(data,key){
  var curdata=[],res={};
  if(data.length===0){
    res.max = "0";
    res.mim = "0";
  }else{
    data.forEach(function(el){
      curdata.push(el[key])
    })
    res.max = Math.max.apply(null,curdata);
    res.min = Math.min.apply(null,curdata);
  }
  return res;
}

// 降水过滤条件数组
var rainfallSelArr=[
  {
    interval:1,
    opt:[0.01,1,5,10,20,50,99999]
  },{
    interval:3,
    opt:[0.01,1,5,10,25,50,99999]
  },{
    interval:6,
    opt:[0.01,1,5,10,25,50,99999]
  },{
    interval:12,
    opt:[0.01,10,25,50,100,99999]
  },{
    interval:24,
    opt:[0.01,10,25,50,100,99999]
  },{
    interval:48,
    opt:[0.01,10,25,50,100,99999]
  },{
    interval:72,
    opt:[0.01,25,50,100,200,99999]
  }
]

//筛选过滤降水  
$("#rainfallSel").on("change",function(){
  var activeTxt=$(this).find("option:checked").text();
  $("#rainfallSelTxt").text(activeTxt);
  mapOptions.baseLineValue=Number($(this).find("option:checked").attr('value'));
  switchMapData(cacheData)
});

//筛选过滤站点
$("#rainSel").on("change",function(){
  var activeTxt=$(this).find("option:checked").text();
  $("#rainSelTxt").text(activeTxt);
  // 得到满足当前的ranges 
  dataFilter(pickRanges(ranges,interval),getActiveData(),'pre');
  $("#maxRainfallData").text(dataCalc(getActiveData(),'pre').max);
  switch(Number($('#rainSel').val())){
    case 1:
      mapOptions.curStation = 'nationData'  
    break;
    case 2:
      mapOptions.curStation = 'backboneData'
    break;
    case 3:
      mapOptions.curStation = 'areaData'
    break;
  }
  switchMapData(cacheData)
  //生成拼接html
  renderRainfallTable(pickRanges(ranges,interval));
  // 填充降水站点 
  $("#rainfalltable-box").html(rainfallTableStr);
  rainfallTableStr = '';
})

//拼接降水筛选统计表
function renderRainfallTable(ranges){
  for(var i=0;i<ranges.length;i++){
    rainfallTableStr +='<li class="rainfalltable">'+
    '<div class="rainfalltable-title">'+ranges[i].text+'</div>'+
    '<div class="rainfalltable-data">'+ranges[i].items.length+'站</div></li>';
  }
  return rainfallTableStr;
}
//降水数据时间选择框
mui("#rain-datehour-ul").on("click",".rain-datehour-option",function(){
  $(this).addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
  interval=$(".rain-datehour-option.datehour-option-active").attr("data-val");
  var datehour=$(this).attr("data-legend");
  preStainMap(datehour);
  var legendUrl='../../images/monitoringOfLive/rain-legend-'+datehour+'h.jpg';
  $("#rain-legend").attr("src",legendUrl);
});

//startTime 全局dayjs对象； endTime 全局dayjs对象；  cacheTime全局字符串时间
$("#prevTimeBtn").on("click",function(){
  interval=$(".rain-datehour-option.datehour-option-active").attr("data-val");
  var datetime = startTime.format('YYYY-MM-DD HH:mm:ss');
  preStainMap(interval,datetime,true);
});

$("#nextTimeBtn").on("click",function(){
  interval=$(".rain-datehour-option.datehour-option-active").attr("data-val");
  endTime = endTime.add(interval,'hour')
  var firstTime = dayjs(cacheTime)
  // var datetime = preTime.add(1,'hour')
  // console.log(datetime.format('YYYY-MM-DD HH:mm:ss'),firstTime.format('YYYY-MM-DD HH:mm:ss'))
  if(endTime>firstTime){
    mui.alert("已是最新数据！")
    return false;
  }
  var datetime = endTime.format('YYYY-MM-DD HH:mm:ss')
  preStainMap(interval,datetime,true);
});

//点击弹出时间选择器
var dtPicker = new mui.DtPicker({type:'hour'}); //年月日时
$(".show-info-realtime-box").click(function(){
  dtPicker.show(function(items){
    // var intervalOpt=$(".rain-datehour-option.datehour-option-active").attr("data-val");
    var firstTime = dayjs(cacheTime).format('YYYY-MM-DD HH:mm:ss')
    var datetime=items.text+':00:00';
    if(datetime>firstTime){
      mui.alert("已是最新数据！")
      // $(this).hide();
      return false;
    }
    preStainMap(interval,datetime,true);
  });
});