$(function () {
  // 初始化容器宽高
  var headerHeightCss = $('header').css('height')
  $(".mui-content").height($(window).height() - headerHeightCss.replace('px', ''))
  $('.rain-select').css('top', 'calc(1.4rem + ' + headerHeightCss + ')').show()

  mui.init({
    swipeBack: false, //启用右滑关闭功能
    gestureConfig: {
      tap: true, //默认为true
      doubletap: true, //默认为false
      longtap: true, //默认为false
      swipe: true, //默认为true
      drag: false, //默认为true
      hold: false, //默认为false，不监听
      release: false //默认为false，不监听
    }
  })
  //响应获取地图初始化比例
  function getMapboxScale() {
    var _screenWidth = window.innerWidth;
    var _widthArr = [320, 375, 414]
    var _scaleArr = [5.3, 5.5, 5.7]

    function find(array, val) {
      if (val < Math.min.apply(null, array)) {
        return 0;
      };
      if (val > Math.max.apply(null, array)) {
        return array.length - 1;
      };
      var idx = 0,
        i = 0,
        j = array.length;
      for (; i < j; i++) {
        if (array[i] >= val) {
          idx = i;
          break;
        };
      };
      return idx;
    };
    return _scaleArr[find(_widthArr, _screenWidth)]
  }

  var rainOption = {
    curStation: [1],//新接口改为[3]
    interval: 24,
    valBegin:'',
    valEnd:'',
    cacheTime: '',
    startTime: '',
    endTime: '',
    spotOrText: 'spot',
    range:[
      { text: '0.1-9.9mm', min: 0.1, max: 9.99 },
      { text: '10-24.9mm', min: 10, max: 24.99 },
      { text: '25-49.9mm', min: 25, max: 49.99 },
      { text: '50-99.9mm', min: 50, max: 99.99 },
      { text: '100mm以上', min: 100, max: 99999 }
    ]
  };
  var ranges = [{
    interval: 1,
    data: [
      { text: '0.1-9.9mm', min: 0.1, max: 9.99 },
      { text: '10-19.9mm', min: 10, max: 19.99 },
      { text: '20-29.9mm', min: 20, max: 29.99 },
      { text: '30mm以上', min: 30, max: 99999 }
    ]
  }, {
    interval: 3,
    data: [
      { text: '0.1-9.9mm', min: 0.1, max: 9.99 },
      { text: '10-24.9mm', min: 10, max: 24.99 },
      { text: '25-49.9mm', min: 25, max: 49.99 },
      { text: '50mm以上', min: 50, max: 99999 }
    ]
  }, {
    interval: 6,
    data: [
      { text: '0.1-9.9mm', min: 0.1, max: 9.99 },
      { text: '10-24.9mm', min: 10, max: 24.99 },
      { text: '25-49.9mm', min: 25, max: 49.99 },
      { text: '50mm以上', min: 50, max: 99999 }
    ]
  }, {
    interval: 12,
    data: [
      { text: '0.1-9.9mm', min: 0.1, max: 9.99 },
      { text: '10-24.9mm', min: 10, max: 24.99 },
      { text: '25-49.9mm', min: 25, max: 49.99 },
      { text: '50-99.9mm', min: 50, max: 99.99 },
      { text: '100mm以上', min: 100, max: 99999 }
    ]
  }, {
    interval: 24,
    data: [
      { text: '0.1-9.9mm', min: 0.1, max: 9.99 },
      { text: '10-24.9mm', min: 10, max: 24.99 },
      { text: '25-49.9mm', min: 25, max: 49.99 },
      { text: '50-99.9mm', min: 50, max: 99.99 },
      { text: '100mm以上', min: 100, max: 99999 }
    ]
  }, {
    interval: 48,
    data: [
      { text: '0.1-24.9mm', min: 0.1, max: 24.99 },
      { text: '25-49.9mm', min: 25, max: 49.99 },
      { text: '50-99.9mm', min: 50, max: 99.99 },
      { text: '100-199.9mm', min: 100, max: 199.99 },
      { text: '200mm以上', min: 200, max: 99999 }
    ]
  }, {
    interval: 72,
    data: [
      { text: '0.1-24.9mm', min: 0.1, max: 24.99 },
      { text: '25-49.9mm', min: 25, max: 49.99 },
      { text: '50-99.9mm', min: 50, max: 99.99 },
      { text: '100-199.9mm', min: 100, max: 199.99 },
      { text: '200mm以上', min: 200, max: 99999 }
    ]
  }]

  var map = GIS.init({ spot: true })
  map.on('load', function () {
    GIS.utils.addBlankGeoJSONSource('rainText')
    GIS.utils.addBlankGeoJSONSource('rainSpot')

    map.addLayer({
      "id": "preSpot",
      'type': 'fill',
      'source': "rainSpot",
      type: "fill",
      paint: {
        "fill-color": {
          "type": "identity",
          "property": "color"
        },
        "fill-opacity": 1
      }
    }, 'city-boundary')

    map.addLayer({
      "id": "preText",
      "type": "symbol",
      "source": 'rainText',
      "layout": {
        "text-field": "{attrVal}",
        "text-size": 14,
        "text-offset": [0, 1.2],
        "text-font": ["Microsoft YaHei"],
        "icon-image": 'point.normal',
        "icon-anchor": 'top',
        "icon-size": 0.4,
      },
      "paint": {
        "text-color": {
          "type": "identity", 
          "property": "color" 
        },
        "text-halo-color": '#fff',
        "text-halo-width": 2
      }
    })
    $("#spotOrText").val("all")
    // $("#curStation").val("2,3")
    getSetting(rainOption)
    getMapData()
  })
  
	// 点击事件
	var popup
	map.on('click', 'preText', function (e) {
		var feature = e.features[0]
		popup = new mapboxgl.Popup()
			.setLngLat(feature.geometry.coordinates)
			.setHTML(feature.properties.popup)
			.addTo(map)
	})

  //获取当前选项设置
  function getSetting(option){
    if($('#curStation').val().length == 1){
      option.curStation = [$('#curStation').val()];
    }else{
      option.curStation = $('#curStation').val().split(',');
    }
    option.interval = $(".rain-datehour-option.datehour-option-active").attr("data-val");
    option.valBegin = $("#range").find("option:checked").attr("data-begin");
    option.valEnd = $("#range").find("option:checked").attr("data-end");
    option.spotOrText = $('#spotOrText').val();
    //根据查询时间间隔，返回筛选数组
    ranges.forEach(function(val,idx){
      if(val.interval == option.interval){
        option.range = val.data;
        return;
      }
    })
    console.log(option)
  }
  //根据时间间隔更新option
  function upDomByInterval(){
    var rainfalltableStr = [],rangeSelectStr = ['<option value="1" data-begin="0" data-end="99999">全显示</option>'];
    rainOption.range.forEach(function(val,idx){
			rangeSelectStr.push('<option value="'+(idx+2)+'" data-begin="'+val.min+'" data-end="'+val.max+'">'+val.text+'</option>')
    })
		rangeSelectStr.push('<option value="'+(rainOption.range.length+2)+'" data-begin="hidden" data-end="hidden">全不显示</option>')
    $('#range').html(rangeSelectStr.join('')).val('1')
  }

  function getMapData(queryTime){
    popup && popup.remove()
    if(rainOption.valBegin === 'hidden'){
      map.getSource('rainSpot').setData({
        "type": "FeatureCollection",
        "features": []
      })
      map.getSource('rainText').setData({
        "type": "FeatureCollection",
        "features": []
      })
      return
    }
    var spotUrl = '/currentMonitor/pre/stainMap.do',textUrl = "/currentMonitor/pre/data.do",isButton = false;
    if(!!queryTime){
			isButton = true
		}
    var params = {
      interval: rainOption.interval,
      dateTime: queryTime || '',
      stationTypes: rainOption.curStation,
      numericalBegin:rainOption.valBegin,
      numericalEnd:rainOption.valEnd,
    }
    switch (rainOption.spotOrText){
      case 'spot':
        map.getSource('rainText').setData({
          "type": "FeatureCollection",
          "features": []
        })
        ajax(spotUrl, params, _preSpotSuccess, "get")
        break
      case 'text':
        map.getSource('rainSpot').setData({
          "type": "FeatureCollection",
          "features": []
        })
        break
      case 'all':
        ajax(spotUrl, params, _preSpotSuccess, "get")
        break
      default:
        break;
    }
    ajax(textUrl, params, function(data){
      _preTextSuccess(data,isButton)
    }, "get")

    function _preSpotSuccess(data) {
      map.getSource('rainSpot').setData({
        "type": "FeatureCollection",
        "features": []
      })
      map.getSource('rainSpot').setData({
        "type": "FeatureCollection",
        "features": data.body.data.features
      })
    }

    function _preTextSuccess(data,isButton){
      if (!isButton) {
        rainOption.cacheTime = data.body.datetime
      }

      data.body.data = data.body.data.filter(function (val) {
        return Number(val.pre) > 0;
      })

      if(rainOption.spotOrText !== "spot"){
        var markers;
        if(rainOption.valBegin !== 0){
          markers = data.body.data.filter(function(val){
            return val.pre >= rainOption.valBegin && val.pre <= rainOption.valEnd
          })
        }
        markers = markers.map(function (val) {
          return rainDataFormat(val)
        })
        map.getSource('rainText').setData({
          "type": "FeatureCollection",
          "features": markers
        })
      }
      rainDataAnalyze(data.body.data)

      //时间字符串填充 存储返回时间
      rainOption.endTime = data.body.datetime
      rainOption.startTime = dayjs(data.body.datetime).subtract(rainOption.interval, 'hour').format('YYYY-MM-DD HH:mm:ss')
      var rainfallStartTimeTxt = dayjs(rainOption.startTime).format('M月D日H时') + '-' + dayjs(rainOption.endTime).format('D日H时')
      $("#rainfallStartTime").text(rainfallStartTimeTxt);
      //格式化时间并本地存储--供累加/排位页面调用
      localStorage.rainSummationStartTime = rainOption.startTime;
      localStorage.rainSummationEndTime = rainOption.endTime;
    }
  }

  //数据格式化geo Point  
  function rainDataFormat(data, type) {
    var pre = Number(data.pre)
    var _tmpStation = getStationByCode(data.code)
    return {
      "type": "Feature",
      "geometry": {
        "type": "Point",
        "coordinates": [Number(_tmpStation.lon), Number(_tmpStation.lat)]
      },
      "properties": {
        "attrVal": pre,
        "color": Colors.getColor('RAINSCENE_' + rainOption.interval + 'H', pre),
        // "level": Number(data.level),
        "popup": GIS.utils.createDefaultStylePopupHtml({
          '降水量': pre + 'mm'
        }, _tmpStation)
      }
    };
  }
  //更新降水统计信息
  function rainDataAnalyze(data) {
    // 数据区间过滤
    var result = rainOption.range
    result.forEach(function (el) { el.itemNum = 0 })
    data.forEach(function (item) {
      result.some(function (el) {
        var number = Number(item.pre)
        if (number >= el.min && number <= el.max) {
          el.itemNum ++
        }
      })
    })
    //拼接降水筛选统计表
    var rainfallTableStr = []
    rainOption.range.forEach(function(val,idx){
      rainfallTableStr.push('<li class="rainfalltable"><div class="rainfalltable-title">' + val.text + '</div>' +
      '<div class="rainfalltable-data">' + val.itemNum + '站</div></li>')
    })
    $("#rainfalltable-box").html(rainfallTableStr.join(''));
    /**
     * 最大值 最小值 计算并填充dom
     * @param {object} data 计算的数据集合
     */
    (function _dataCalc(data) {
      var curdata = [], res = {};
      if (data.length === 0) {
        res.max = "0";
        res.mim = "0";
      } else {
        data.forEach(function (el) {
          curdata.push(el.pre)
        })
        res.max = Math.max.apply(null, curdata);
        res.min = Math.min.apply(null, curdata);
      }
      $("#maxRainfallData").text(res.max);
    })(data)
  }

  //降水时间间隔 事件
  mui("#rain-datehour-ul").on("click", ".rain-datehour-option", function () {
    getSetting(rainOption)
    upDomByInterval()
    getMapData(rainOption.endTime)
  })
  //站点选项 事件
  $("#curStation,#range,#spotOrText").on("change", function () {
    getSetting(rainOption)
    getMapData(rainOption.endTime)
  })
  //翻页按钮 事件
  $("#prevTimeBtn").on("tap", function () {
    getMapData(rainOption.startTime)
  });
  $("#nextTimeBtn").on("tap", function () {
    var queryTime = dayjs(rainOption.endTime).add(rainOption.interval, 'hour')
    var firstTime = dayjs(rainOption.cacheTime)
    checkAndQuery(queryTime,firstTime)
  });
  //点击弹出时间选择器
  
  $(".show-info-realtime-box").click(function () {
    var firstTime = dayjs(rainOption.cacheTime),queryTime;
    var dtPicker = new mui.DtPicker({ type: 'hour', beginDate: new Date(2018,11,01) , "endDate": firstTime.toDate() }); //年月日时
    dtPicker.setSelectedValue(rainOption.endTime)
    dtPicker.show(function (items) {
      firstTime = dayjs(rainOption.cacheTime)
      queryTime = dayjs(items.text + ':00:00');
      checkAndQuery(queryTime,firstTime)
    });
  });

  //比较查询时间是否超出缓存时间
  function checkAndQuery(queryTime,firstTime){
    if (queryTime > firstTime) {
      mui.alert("已是最新数据！")
      queryTime = rainOption.cacheTime
    }else{
      queryTime = queryTime.format('YYYY-MM-DD HH:mm:ss')
    }
    getMapData(queryTime)
  }

  //累加
  mui(".show-info-btn-box").on('click','#rain-summation-link',function(){
    localStorage.rainOption = JSON.stringify(rainOption)
		mui.openWindow({
		    url:'../../web/monitoringOfLive/rainfall-summation.html',
			styles: {
				statusbar: {
					background: localStorage.statusbarColor
				}
			}
		});
	}); 

  //排行
  mui(".show-info-btn-box").on('tap', '#rain-rank-link', function () {
    localStorage.rainOption = JSON.stringify(rainOption)
    mui.openWindow({
      url: '../../web/monitoringOfLive/rainfall-ranking.html',
      styles: {
        statusbar: {
          background: localStorage.statusbarColor
        }
      },
      // extras:{
      // 	targetId:targetId
      // }
    });
  });

})