$(function () {
    var height = $(window).height(),
        width = $(window).width(),
        headerHeightCss = $('.mui-bar').css('height'),
		containerHeight = height - Number($('header').css('height').replace("px", ''))
    $(".mui-content").height(containerHeight)
    $("#wrapper").css('top', headerHeightCss)

    mui.init({
        swipeBack: false, //启用右滑关闭功能
        gestureConfig: {
            tap: true, //默认为true
            doubletap: true, //默认为false
            longtap: true, //默认为false
            swipe: true, //默认为true
            drag: true, //默认为true
            hold: false,//默认为false，不监听
            release: false//默认为false，不监听
        },
        beforeback: function () {
            if (mui.os.plus) {
                if ($('body').hasClass('horizontal')) {
                    plus.screen.lockOrientation('portrait-primary')
                    setTimeout(function () {
                        plus.screen.unlockOrientation()
                    }, 2000)
                    return false
                }

                plus.screen.lockOrientation('portrait-primary')
            }

            localStorage.removeItem('shareLink')
            return true
        }
    })

    var scroll
    var SVG_WIDTH = 720, SVG_HEIGHT = 540
    mui.plusReady(function () {
        // 解除方向锁定
        plus.screen.unlockOrientation()

        var info = plus.webview.currentWebview().info
        SVG_WIDTH = info.width || 720
        SVG_HEIGHT = info.height || 540
        var width = $(window).innerWidth() - 20
        var height = SVG_HEIGHT * (width / SVG_WIDTH)
        var html = []
        info.imgs.forEach(function (item) {
            html.push('<div class="item" data-height="' + height + '" style="height: ' + height + 'px;"><img class="lazyload" data-src="' + item + '" alt="" srcset=""></div>')
        })
        
        $('#scroller').html(html.join(''))
        initIScroll()

        $('#upTimeBtn').click(function() {
            scroll.prev()
        })

        $('#downTimeBtn').click(function() {
            scroll.next()
        })

        localStorage.setItem('shareLink', JSON.stringify(info))
    })

    /**
     * 初始化组件
     * @param {是否需要对齐} snap 
     */
    function initIScroll(snap) {
        scroll && (scroll.destroy(), scroll = null)
        scroll = new IScroll('#wrapper', {
            snap: snap ? 'img' : false,
            zoom: true,
            scrollX: true,
            scrollY: true,
            mouseWheel: true,
            wheelAction: 'zoom',
            disablePointer: true
        })
        scroll.refresh()
    }

    document.addEventListener('touchmove', function (e) { e.preventDefault() }, {
        passive: false
    })

    // 监听屏幕旋转事件
    window.addEventListener("orientationchange", function () {
        switch (window.orientation) {
            case 90:
            case -90:
                initIScroll(true)
                plus.navigator.setFullscreen(true)
                $('body').addClass('horizontal')
                $('.time-btn').removeClass('hide')
                $('.horizontal-display-item').css('display', 'none')
                $('.mui-content').height(width)
                $("#wrapper").css('top', '0')
                $('#wrapper .item').height(SVG_HEIGHT * (height / SVG_WIDTH))
                Screen.horizontal()
                break
            default:
                initIScroll()
                plus.navigator.setFullscreen(false)
                $('body').removeClass('horizontal')
                $('.time-btn').addClass('hide')
                $('.horizontal-display-item').css('display', 'flex')
                $('.mui-content').height(containerHeight)
                $("#wrapper").css('top', headerHeightCss)
                $('#wrapper .item').each(function(i, el) {
                    var $el = $(el)
                    $el.height($el.data('height'))
                })
                Screen.vertical()
                break
        }
    }, false)

    $('#wrapper').on('tap', function (e) {
        if ($('body').hasClass('horizontal') && $('.horizontal-display-item').find($(e.target)).length === 0) {
            if ($('.mui-bar').css('display') === 'flex') {
                plus.navigator.setFullscreen(true)
            } else {
                plus.navigator.setFullscreen(false)
            }
            $('.horizontal-display-item').stop().slideToggle(100).css('display', 'flex')
        }
    })

})