//$(function(){
	var map_lat_start, //底图左上角对应的经度
		map_lon_start, //底图左上角对应的纬度
		map_lat_end, //底图右下角对应的经度
		map_lon_end, //底图右小角对应的纬度
		map_w, //底图宽度
		map_h; //底图高度
	var scr_w=$(window).width();
	var scr_h=$(window).height();
	
	var bottomH=Number($("#highTemBox").css('bottom').slice(0,-2));
	var swDatehourH=$("#highTemBox").height();
	$("#mapWrapper").width(scr_w).height(scr_h-88-bottomH-swDatehourH - localStorage.statusbarHeight);
	
	var decadWindowBg=document.getElementById("decadBgWp");
	var cityCan=document.getElementById("cityCan");//城市名画布
	var cityCtx=cityCan.getContext('2d');
	var fullCan=document.getElementById("fullCan"); //可视区域画布
	var fullCtx=fullCan.getContext('2d');
	var geoMap ,fullGeoMap ,
		dip=window.devicePixelRatio,
	    lv = 2,
	    activeScale=1,
	    tScale= dip * lv,
	    hasWindowFlag= false;
	    
	function getData(month,decad){
		fullGeoMap.clear()
		fullCtx.clearRect(0,0,fullCan.width,fullCan.height);//	清空画布
		
		if(activeScale > 1.5 && activeScale < 7){
			drawTwoLvData(result.data, 'cnty');//绘制地理数据
		}
		if(activeScale > 7){
			drawTwoLvData(result.data, 'station');//绘制地理数据
		}
		var size = Math.ceil(10 * dip * lv * 1.4)
		var fontSetting= size +'px sans-seri';
		fullCtx.fillStyle='blue'
		fullCtx.font=fontSetting;
		
		var activeOpt , activeSort ,conItem;
		$(".day-datehour-option").each(function(){
			if($(this).hasClass("datehour-option-active")){
				activeOpt=$(this).attr("data-val");
				activeSort=parseInt($(this).attr("data-sort"));
			}
		});
		if(activeSort==0){
			resData=getDecadData(month,decad).data;
		}else{
			resData=getExtTimeData();
		}
		
		var resItem;
		for(var i=0;i<resData.length ;i++){
			resItem= getStationByCode(resData[i].stationCode);
		    resData[i].lat=resItem.lat;
		    resData[i].lon=resItem.lon;
		    resData[i].cityName=resItem.city;
		    resData[i].cntyName=resItem.cnty;
		    conItem= fullGeoMap.registerElement(resData[i],resItem.lon,resItem.lat,50);
		    resData[i].containerPos=[conItem[0],conItem[1]];//(x,y)
		    fullCtx.fillText(resData[i][activeOpt], conItem[0]*tScale, conItem[1]*tScale+size);
		}
	}
	
	
	//弹出窗口   
	function drawWindow(data,ctx){
		var activeOpt,activeSort,searchData=data;
		$(".day-datehour-option").each(function(){
			if($(this).hasClass("datehour-option-active")){
				activeOpt=$(this).attr("data-val");
				activeTypeTxt=$(this).attr("data-txt");
			}
		});
		var size = Math.ceil(10 * dip * lv * 1.2)
		var fontSetting= size +'px sans-seri';
		ctx.fillStyle='#fff';
		ctx.font=fontSetting;
		ctx.drawImage(decadWindowBg,searchData[0]*tScale-94*tScale,searchData[1]*tScale-82*tScale,210*tScale,72*tScale);
		ctx.fillText("站名："+searchData[3].cityName+searchData[3].cntyName, searchData[0]*tScale-80*tScale, searchData[1]*tScale-64*tScale);
		ctx.fillText(activeTypeTxt+" : "+searchData[3][activeOpt], searchData[0]*tScale-80*tScale, searchData[1]*tScale-44*tScale);
		ctx.fillText(" 经度: "+searchData[3].lon, searchData[0]*tScale-80*tScale, searchData[1]*tScale-24*tScale);
		ctx.fillText("纬度："+searchData[3].lat, searchData[0]*tScale+40*tScale, searchData[1]*tScale-24*tScale);
		hasWindowFlag=true
	}
	
	
	function init() {
		map_w=$("#rainMap").width();
		map_h=$("#rainMap").height();
		$("#handleLayer").width(map_h).height(map_h)
		map_lat_start =24.5;
		map_lon_start =108.6; 
		map_lat_end = 30.3; 
		map_lon_end =114.4;
		
		cityCan.width=map_w * dip * lv;
		cityCan.height=map_h * dip * lv;
		cityCan.style.width=map_w+'px';
		cityCan.style.height=map_h+'px';
		
		var wrapperHeight = $('#mapWrapper').outerHeight()
		window.FULL_CAN_TOP = -(wrapperHeight - map_h) / 2
		fullCan.style.top = FULL_CAN_TOP + 'px'
		fullCan.width = map_w * dip * lv
		fullCan.height = wrapperHeight * dip * lv
		fullCan.style.width = map_w + 'px'
		fullCan.style.height = wrapperHeight + 'px'
		geoMap = new GeoMapUtil();
		geoMap.init(map_lon_start,map_lon_end,map_lat_start,map_lat_end, 2, map_w, map_h);
		
		var perLat= Decimal.div(5.8, map_h).toNumber();
		var diffTopLat=Decimal.sub(wrapperHeight, map_h).div(2).mul(perLat).toNumber()
		var initLatMin= Decimal.sub(24.5,diffTopLat);
		var initLatMax=Decimal.add(30.3,diffTopLat);
		
		fullGeoMap = new GeoMapUtil();
		fullGeoMap.init(map_lon_start,map_lon_end,initLatMin,initLatMax, 2, map_w, wrapperHeight);
		drawCityName(cityData,1);
	}
	function drawCityName(data,activeScale){
		var registerElement;
		var size = Math.ceil(10 * dip / activeScale * lv)
		var fontSetting= size +'px sans-seri';
		cityCtx.font=fontSetting;
		cityCtx.clearRect(0,0,cityCan.width,cityCan.height);//	清空画布
		data.forEach(function(item) {
			registerElement = geoMap.registerElement(item, item.lon, item.lat, 30);
			item.containerPos=[registerElement[0],registerElement[1]];
			cityCtx.fillText(item.city, item.containerPos[0]*dip * lv, item.containerPos[1]*dip * lv);
		})
		
	}
	function drawTwoLvData(data,keyName) {
//		if(data.length==0){return}
		var size = Math.ceil(10 * dip * lv)
		var fontSetting= size +'px sans-seri';
		fullCtx.fillStyle = "#3b3b3c"; 
		fullCtx.font=fontSetting;
		fullCtx.clearRect(0,0,fullCan.width,fullCan.height);//	清空画布
		data.forEach(function(item) {
			var registerElement = fullGeoMap.registerElement(item, item.lon, item.lat, 30);
			item.containerPos=[registerElement[0],registerElement[1]];
			size = Math.ceil(10 * dip * lv*2)
			fontSetting= size +'px sans-seri';
			fullCtx.font=fontSetting;
			fullCtx.fillText('.', item.containerPos[0] * dip * lv + item[keyName].length*size/4.8 , item.containerPos[1]*dip * lv + size/4);
			size = Math.ceil(10 * dip * lv)
			fontSetting= size +'px sans-seri';
			fullCtx.font=fontSetting;
			fullCtx.fillText(item[keyName], item.containerPos[0] * dip * lv, item.containerPos[1]*dip * lv);
		})
		fullGeoMap.clear()
	}
	
	var self = $("#handleLayer")//TODO
	$("#rainMap").load(function() {
		init();
		var now = new Date(); 
		var nowMonth = now.getMonth() + 1;     //月  
	    var day = now.getDate(); 
	    var nowDecad;
	    if(day<=10){
	    	nowDecad=1;
	    }else if(day>10 &&day<=20){
	    	nowDecad=2;
	    }else{
	    	nowDecad=3;
	    }
	    
	    $("#monthSel").val(nowMonth);
	    $("#decadSel").val(nowDecad);
	    $("#monthSelTxt").text($("#monthSel").find("option:checked").text());
	    $("#decadSelTxt").text($("#decadSel").find("option:checked").text());
		getData(nowMonth,nowDecad);
		
		asyncMapVisualization(cityData, 'cityMv')
		asyncMapVisualization(cntyData, 'cntyMv')
		asyncMapVisualization(townsStationData, 'townsMv')
		
		$("#mapBox").height($(window).width() / $("#rainMap")[0].naturalWidth * $("#rainMap")[0].naturalHeight)
		
		var isMoved = false ,month ,decad ,lastSearchObj=null;
		self.zoom({
			syncDoms: ['#cityCan','#rainMap'],
			onUpdate: function(x, y, s) {
				if (isMoved) {
					isMoved = false
					return
				}
				fullCan.style.left = (fullCan.offsetLeft - x) + 'px'
				fullCan.style.top = (fullCan.offsetTop - y) + 'px' 
			},
			moved: function(x, y, scale) {
				isMoved = true
				fullCan.style.left = '0px'
				fullCan.style.top = window.FULL_CAN_TOP + 'px'
				activeScale=scale;
				
				if (scale < 1.5) {
					drawCityName(cityData, scale)
					fullCtx.clearRect(0,0,fullCan.width,fullCan.height);
					result = CONSTANT.cityMv.query(Math.abs(x), Math.abs(y), scale) //查询出当前屏幕范围内的数据
				}
				if(scale > 1.5 && scale <7){
					result = CONSTANT.cntyMv.query(Math.abs(x), Math.abs(y), scale) 
					cityCtx.clearRect(0,0,cityCan.width,cityCan.height)
				}
				if(scale > 7){
					if(CONSTANT.townsMv){
						result = CONSTANT.townsMv.query(Math.abs(x), Math.abs(y), scale) 
						cityCtx.clearRect(0,0,cityCan.width,cityCan.height)
					}
				}
				
				fullGeoMap = new GeoMapUtil()
				fullGeoMap.init(result.startLon,result.endLon,result.startLat,result.endLat, Decimal.sub(result.endLon, result.startLon).div(10).toNumber(), Number(fullCan.style.width.replace('px', '')), Number(fullCan.style.height.replace('px', '')));
				
				month=$("#monthSel").find("option:checked").val();
				decad=$("#decadSel").find("option:checked").val();
				getData(month,decad);
				lastSearchObj=null;
				//TODO 存在两个弹窗
				if(searchObj!=null && searchObj!=undefined){
					lastSearchObj=fullGeoMap.registerElement(searchObj[3],searchObj[3].lon,searchObj[3].lat,50);
					drawWindow(lastSearchObj,fullCtx);
				}
			}
		})
	})
	.attr('src', '../../images/map/a.min.svg')
	
	
	
	var searchObj;
	mui("#decadConent").on("tap","#mapWrapper",function(e){
		searchObj = null;
		var event=window.event||e;
		var locX, locY;
		if(event.pageX){
			locX=event.pageX;
		}else{
			locX=event.detail.changedTouches[0].pageX;
		}
		if(event.pageY){
			locY=event.pageY;
		}else{
			
			locY=event.detail.changedTouches[0].pageY;
		}
		var loc = windowTocanvas(fullCan, locX, locY);
		
		var x = Decimal.div( loc.x, tScale).toNumber();
		var y = Decimal.div( loc.y, tScale).toNumber();
		var month=$("#monthSel").find("option:checked").val();
		var decad=$("#decadSel").find("option:checked").val();
		searchObj = fullGeoMap.getElementDataByXY(x, y);
		//TODO 优化
		if(hasWindowFlag== false && searchObj != null){
			drawWindow(searchObj,fullCtx);
		}else if(hasWindowFlag== true && searchObj != null){
			getData(month,decad);
			drawWindow(searchObj,fullCtx);
		}else if(hasWindowFlag== true && searchObj == null){
			getData(month,decad);
			hasWindowFlag = false
		}
		
	});
	
	mui(".decad-show-info-btn-box").on('click','#decadRankLink',function(){
		var month=$("#monthSel").find("option:checked").val();
		var decad=$("#decadSel").find("option:checked").val();
		var decadTxt=$("#decadSel").find("option:checked").attr("data-txt");
		
		var activeDecadType=$(".day-datehour-option.datehour-option-active").attr("data-val");
		var activeDecadTypeTxt=$(".day-datehour-option.datehour-option-active").attr("data-txt");
		var activeDecadSort=$(".day-datehour-option.datehour-option-active").attr("data-sort");
		
		localStorage.monthVal=month;
		localStorage.decadVal=decad;
		localStorage.decadTxt=decadTxt;
		localStorage.activeDecadType=activeDecadType;
		localStorage.activeDecadTypeTxt=activeDecadTypeTxt;
		localStorage.activeDecadSort=activeDecadSort;
		mui.openWindow({
		    url:'../technicalProducts/decad-ranking.html',
			styles: {
				statusbar: {
					background: localStorage.statusbarColor
				}
			}
		});
		
	});
	
	$(".datehour-box").on("click",".day-datehour-option",function(){
		$(".day-datehour-option").removeClass("datehour-option-active");
		$(this).addClass("datehour-option-active");
		var month=$("#monthSel").find("option:checked").val();
		var decad=$("#decadSel").find("option:checked").val();
		
		getData(month,decad);
	});
	
	
	$("#monthSel").on("change",function(){
		var activeOptTxt=$(this).find("option:checked").text();
		$("#monthSelTxt").text(activeOptTxt);
		var month=$("#monthSel").find("option:checked").val();
		var decad=$("#decadSel").find("option:checked").val();
		getData(month,decad);
	});
	
	$("#decadSel").on("change",function(){
		var activeOptTxt=$(this).find("option:checked").text();
		$("#decadSelTxt").text(activeOptTxt);
		var month=$("#monthSel").find("option:checked").val();
		var decad=$("#decadSel").find("option:checked").val();
		getData(month,decad);
	});

	
	
//	init
	
	
//});
