$(function () {
	// 初始化容器宽高
	$(".mui-content").height($(window).height() - $('header').css('height').replace('px', ''))

	mui.init({
		swipeBack: false, //启用右滑关闭功能
		gestureConfig: {
			tap: true, //默认为true
			doubletap: true, //默认为false
			longtap: true, //默认为false
			swipe: true, //默认为true
			drag: false, //默认为true
			hold: false, //默认为false，不监听
			release: false //默认为false，不监听
		}
	})

	// 设置当前时间选择
	var now = new Date()
	var day = now.getDate()
	$("#monthSel").val(now.getMonth() + 1)
	$("#decadSel").val(day <= 10 ? 1 : day > 10 && day <= 20 ? 2 : 3)
	$("#monthSelTxt").text($("#monthSel").find("option:checked").text())
	$("#decadSelTxt").text($("#decadSel").find("option:checked").text())

	// 初始化地图
	var map = GIS.init()
	map.on('load', function () {
		GIS.utils.addBlankGeoJSONSource('geojson-point')

		map.addLayer({
			id: 'geojson-text',
			source: 'geojson-point',
			type: "symbol",
			layout: {
				"text-field": "{text}",
				"text-size": 14,
				"text-offset": [0, 1.2],
				"text-font": ["Microsoft YaHei"],
				"icon-image": 'point.normal',
				"icon-anchor": 'top',
				"icon-size": 0.4,
			},
			paint: {
				"text-halo-width": 1,
				"text-halo-color": "#fff",
				"text-color": "#1414ff"
			}
		})

		loadData()
	})

	// 点击事件
	var popup
	map.on('click', 'geojson-text', function (e) {
		var feature = e.features[0]
		popup = new mapboxgl.Popup()
			.setLngLat(feature.geometry.coordinates)
			.setHTML(feature.properties.popup)
			.addTo(map)
	})

	// 加载数据
	var geojsons = {}
	function loadData() {
		var month = $("#monthSel").val()
		var decad = $("#decadSel").val()
		var type = $('.datehour-option.datehour-option-active').data('val')

		if (!geojsons[month + '-' + decad]) {
			// 根据月份与旬期查询数据
			var data = {}
			$('.datehour-option').each(function () {
				data[$(this).data('val')] = {
					type: "FeatureCollection",
					features: []
				}
			})

			getDecadData(month, decad).data.forEach(function (item) {
				var station = getStationByCode(item.stationCode)
				for (var key in data) {
					var text = key === 'dayRainExtremum' ? dayRainExtTimeDataValueByCode(item.stationCode) : item[key]
					var popup = GIS.utils.createDefaultStylePopupHtml({
						[$('.datehour-option[data-val=' + key + ']').html().replace('<br>', '')]: text
					}, station)

					data[key].features.push({
						"type": "Feature",
						"geometry": {
							"type": "Point",
							"coordinates": [Number(station.lon), Number(station.lat)]
						},
						"properties": {
							text: text,
							popup: popup
						}
					})
				}
			})

			geojsons[month + '-' + decad] = data
		}

		popup && popup.remove()
		map.getSource('geojson-point').setData(geojsons[month + '-' + decad][type])
	}

	// 要素切换
	$('#decadConent .datehour-option').click(function () {
		$('#decadConent .datehour-option').removeClass("datehour-option-active")
		$(this).addClass("datehour-option-active")

		loadData()
	})

	// 切换月份
	$("#monthSel").on("change", function () {
		var activeOptTxt = $(this).find("option:checked").text()
		$("#monthSelTxt").text(activeOptTxt)

		loadData()
	})

	// 切换旬期
	$("#decadSel").on("change", function () {
		var activeOptTxt = $(this).find("option:checked").text()
		$("#decadSelTxt").text(activeOptTxt)

		loadData()
	})

	// 排位查看
	$('#decadRankLink').click(function () {
		// 缓存一部分数据用于排位页面数据查询
		localStorage.monthVal = $("#monthSel").find("option:checked").val()
		localStorage.decadVal = $("#decadSel").find("option:checked").val()
		localStorage.decadTxt = $("#decadSel").find("option:checked").data("txt")
		localStorage.activeDecadType = $(".day-datehour-option.datehour-option-active").data("val")
		localStorage.activeDecadTypeTxt = $(".day-datehour-option.datehour-option-active").data("txt")
		localStorage.activeDecadSort = $(".day-datehour-option.datehour-option-active").data("sort")

		mui.openWindow({
			url: '../technicalProducts/decad-ranking.html',
			styles: {
				statusbar: {
					background: localStorage.statusbarColor
				}
			}
		});
	})
})