$(function () {
	var height = $(window).height(),
		width = $(window).width(),
		containerHeight = height - Number($('header').css('height').replace("px", ''))
	$(".mui-content").height(containerHeight)
	$('.option-container').removeClass('hide')

	mui.init({
		swipeBack: false, //启用右滑关闭功能
		gestureConfig: {
			tap: true, //默认为true
			doubletap: true, //默认为false
			longtap: true, //默认为false
			swipe: true, //默认为true
			drag: true, //默认为true
			hold: false,//默认为false，不监听
			release: false//默认为false，不监听
		},
		beforeback: function () {
			if (mui.os.plus) {
				if ($('body').hasClass('horizontal')) {
					plus.screen.lockOrientation('portrait-primary')
					setTimeout(function () {
						plus.screen.unlockOrientation()
					}, 2000)
					return false
				}

				plus.screen.lockOrientation('portrait-primary')
			}

			return true
		}
	})

	// 监听屏幕旋转事件
	window.addEventListener("orientationchange", function () {
		switch (window.orientation) {
			case 90:
			case -90:
				plus.navigator.setFullscreen(true)
				$('body').addClass('horizontal')
				$('.time-btn').removeClass('hide')
				$('.option-container').addClass('hide')
				$('.horizontal-display-item').css('display', 'none')
				$('.mui-content,.swiper-container').height(width)
				$('.mui-title').text('数据更新时间：' + $('.show-realtime').text())
				Screen.horizontal()
				break
			default:
				plus.navigator.setFullscreen(false)
				$('body').removeClass('horizontal')
				$('.time-btn').addClass('hide')
				$('.option-container').removeClass('hide')
				$('.horizontal-display-item').css('display', 'flex')
				$('.mui-content').height(containerHeight)
				$('.swiper-container').height('')
				$('.mui-title').text($('title').text())
				Screen.vertical()
				break
		}

		swiper.update(true)
	}, false)

	$(document).click(function (e) {
		if ($('body').hasClass('horizontal') && $('.horizontal-display-item').find($(e.target)).length === 0) {
			if ($('.mui-bar').css('display') === 'flex') {
				plus.navigator.setFullscreen(true)
			} else {
				plus.navigator.setFullscreen(false)
			}
			$('.horizontal-display-item').stop().slideToggle(100).css('display', 'flex')
		}
	})

	var swiper
	function renderSwiper(htmls) {
		swiper && swiper.destroy()
		$('.swiper-wrapper').html(htmls.join(''))
		swiper = new Swiper('.swiper-container', {
			effect: 'fade',
			passiveListeners: false,
			preloadImages: false,
			zoom: {
			    toggle: false
			},
			lazy: {
			    loadPrevNext: true
			}
		})
	}
	
	//模式图片信息获取(新)  begin
	function mode(info, type){
		var url="/technicalProduct/mode/mode.do";
		var startTime;
		if(info == 0){
			startTime = '' 
		}else{
			startTime = info
		}
		var params={param: type || $(".option.active").data('val'),startTime:startTime};
		http.post(url,params, function(data) {
			_modeSuccess(data, info)

			mui.plusReady(function () {
				// 解除方向锁定
				plus.screen.unlockOrientation()
			})
		});
	}
	var resData;
	function _modeSuccess(data,info){
		if(data.body.recordNum==0){
			resData = []
			mui.alert("暂无数据！")
			var imgStr='<img class="img img-active" src="../../images/monitoringOfLive/noData.png" data-order="1" data-total="1" data-preview-src="" data-preview-group="1" />'
			$("#imgBox").html(imgStr);
			$('.img').load(function() {
				var self = $(this), el = self[0]
				$(".pattern-img-box").height($(window).width() / el.naturalWidth * el.naturalHeight)
			})
			
			renderSwiper(['<div class="swiper-slide"><div class="swiper-zoom-container"><img data-src="../../images/monitoringOfLive/noData.png" class="swiper-lazy"></div><div class="swiper-lazy-preloader"></div></div>'])
			return false;
		}
		var $el = $('.option.active'),
			activeDataNum = $el.data('num'),
			activeType = $el.data('val')

		resData = data.body.data;
		$("#rainfallStartTime").text(data.body.startTime.substr(0,13)+"时");
		
		var type = $("#patternSel").val() * 1
		if(info==0){//初始化
			_switchData(resData,type,0);
		}else{
			if(activeDataNum!=1 && activeType != 18){
				if(activeType==1||activeType==6||activeType==11||activeType==12){//当前种类下分类默认选中为第二项的
					_switchData(resData,2,0);
				} else {
					_switchData(resData,1,0);
				}
			}else{
				_switchData(resData,type,0);
			}
		}
	}
	/**
	 * 
	 * @param {Object} data 切换数据
	 * @param {Object} type 当前分类下所选子类名
	 * @param {Object} order 当前种类图片序号
	 */
	function _switchData(data,type,order){
		var activeSubType=type;
		var activeOrder=order;
		var itemData, activeImgArr = [];
		data.some(function(item, i) {
			if (activeSubType === Number(item.type)){
				itemData=item;
				activeImgArr=itemData.imgs;
				return true;
			}
		})
		var imgStr='',
			activeClass='';
		
		if(JSON.stringify(activeImgArr)=='[]'){
			var imgStr='<img class="img img-active" src="../../images/monitoringOfLive/noData.png" data-order="1" data-total="1" data-preview-src="" data-preview-group="1" />'
			$("#imgBox").html(imgStr);
			$('.img').load(function() {
				var self = $(this), el = self[0]
				$(".pattern-img-box").height($(window).width() / el.naturalWidth * el.naturalHeight)
			})
			
			renderSwiper(['<div class="swiper-slide"><div class="swiper-zoom-container"><img data-src="../../images/monitoringOfLive/noData.png" class="swiper-lazy"></div><div class="swiper-lazy-preloader"></div></div>'])
			return false;
		}
		
		var htmls = []
		var totalImgLength=activeImgArr.length;
		for(var i=0;i<activeImgArr.length;i++){
			if(i==0){
				activeClass='img-active'
			}else{
				activeClass='';
			}
			imgStr+='<img class="img '+activeClass+'" src="'+activeImgArr[i].path+'" data-order='+(i+1)+' data-total="' +totalImgLength+ '" data-preview-src="" data-preview-group="1" />'
			
			htmls.push('<div class="swiper-slide"><div class="swiper-zoom-container"><img data-src="' + activeImgArr[i].path + '" class="swiper-lazy"></div><div class="swiper-lazy-preloader"></div></div>')
		}
		// $("#imgBox").html(imgStr);
		
		renderSwiper(htmls)
		
//		$("#patternImg").attr({
//			"data-order":activeOrder,
//			"src":itemData.imgs[parseInt(activeOrder)].path,
//			"data-total":itemData.imgs.length
//		});
		$('.img').load(function() {
			var self = $(this), el = self[0]
			$(".pattern-img-box").height($(window).width() / el.naturalWidth * el.naturalHeight)
//					self.zoom()
		})
		
	}
	
	//切换当前模式当前种类下的图片
	function _switchActiveImg(order){
		$(".img").each(function(){
			if($(this).attr("data-order")==Number(order)){
				$(this).addClass("img-active").siblings().removeClass("img-active");
			}
		});
	}
	//模式图片信息获取(新) end
	
	
	//init begin
	mode(0);
	
	//日期选择器 TODO
	var dtPicker = new mui.DtPicker({type:'hour',pattern:8}); //年月日时
	$("#patternTimeBox").click(function(){
		dtPicker.show(function(items){
			$("#rainfallStartTime").text(items.text + ' 时');
			if ($(".option.active").attr("data-val") === '999') {
				mode(items.text+':00:00', $("#patternSel").find("option:checked").data('type'))
			} else {
				mode(items.text+':00:00')
			}
		});
	});

	// 根据所选模式渲染选项
	$(".option-container").on("click", ".option", function(){
		var self = $(this),
			activeType = self.data('val')

		self.addClass('active').siblings().removeClass('active')
		$(optionData).each(function(index) {
			var item = optionData[index]
			if (activeType == item.type) {

				var htmls = []
				item.options.forEach(function(option) {
					htmls.push('<option value="' + option.subType + '" data-txt="' + option.text + '" data-type="' + option.type + '">' + option.text + '</option>')
				})
				$("#patternSel").html(htmls.join(''))
				$("#patternSelTxt").text($("#patternSel option").first().text())

				return false
			}
		})
		
		if (activeType == 999) {
			mode(0, $("#patternSel option").first().data('type'))
		} else {
			mode(0)
		}
	})
	
	$("#patternSel").on("change",function(){
		var activeOptTxt=$(this).find("option:checked").text();
		$("#patternSelTxt").text(activeOptTxt);
		var activeType=parseInt($("#patternSel").find("option:checked").val());
		if ($(".option.active").attr("data-val") === '999') {
			mode(0, $("#patternSel").find("option:checked").data('type'))
		} else {
			_switchData(resData,activeType,0)
		}
	});
	
	//上下滑切换当前模式
	mui("#imgWrapper").on("swipeup",".img",function(){
		var activeDataNum;
		var activeTypeIdx=parseInt($("#patternSel").find("option:checked").index());//当前被选中opt的下标
		$(".ground-option").each(function(){
			if($(this).hasClass('datehour-option-active')){
				activeDataNum=parseInt($(this).attr("data-num"));//当前种类的总分类值
			}
		});
		var nextActiveTypeIdx = activeTypeIdx+1;
		if(nextActiveTypeIdx>activeDataNum-1){
			return false;
		}
		$('#patternSel option:eq('+nextActiveTypeIdx+')').prop("selected","selected");
		var nextActiveType=$('#patternSel option:eq('+nextActiveTypeIdx+')').val();
		_switchData(resData,nextActiveType,0);
		$("#patternSelTxt").text($('#patternSel option:eq('+nextActiveTypeIdx+')').text());
	});
	mui("#imgWrapper").on("swipedown",".img",function(){
		var activeDataNum;
		var activeTypeIdx=parseInt($("#patternSel").find("option:checked").index());//当前被选中opt的下标
		var prevAactiveTypeIdx=activeTypeIdx-1;
		if(prevAactiveTypeIdx<0){
			return false;
		}
		$('#patternSel option:eq('+prevAactiveTypeIdx+')').prop("selected","selected");
		var prevActiveType=$('#patternSel option:eq('+prevAactiveTypeIdx+')').val();
		_switchData(resData,prevActiveType,0);
		$("#patternSelTxt").text($('#patternSel option:eq('+prevAactiveTypeIdx+')').text());
	});
	//swiper 横屏时翻页事件
	$("#prevImgBtn").on("click",function(e){
		swiper.slidePrev(0)
		e.stopPropagation()
	})
	$("#nextImgBtn").on("click",function(e){
		swiper.slideNext(0)
		e.stopPropagation()
	})
	//左右滑切换前后图片  
	mui("#imgBox").on("swiperight",".img",function(){
		var activeOrder=Number($(".img.img-active").attr("data-order"));
		if(activeOrder==1){
			return
		}
		$("#activeNum").text(activeOrder-1);
		_switchActiveImg(activeOrder-1);
	});
	mui("#imgBox").on("swipeleft",".img",function(){
		var activeOrder = Number($(".img.img-active").attr("data-order"));
		var maxIMGlength = Number($(".img.img-active").attr("data-total"));
		if(activeOrder == maxIMGlength){
			return
		}
		$("#activeNum").text(activeOrder+1);
		_switchActiveImg(activeOrder + 1);
		
	});
	
//	mui("#imgWrapper").on("tap","#prevTimeBtn",function(){
//		$('#patternImg').css({
//			"transform":"translate3d(0,0,0) scale(1) rotate3d(0,0,0,0)"
//		});
//		var activeType=parseInt($("#patternSel").find("option:checked").val());
//		var activeOrder=parseInt($("#patternImg").attr("data-order"));
//		var totalImgNum=parseInt($("#patternImg").attr("data-total"));
//		if(activeOrder!=totalImgNum){
//			$("#nextTimeBtn").show();
//		}else{
//			return false;
//		}
//		if(activeOrder-1<0){
//			$(this).hide();
//			return false;
//		}
//		_switchData(resData,activeType,activeOrder-1);
//		
//	});
//	mui("#imgWrapper").on("tap","#nextTimeBtn",function(){
//		$('#patternImg').css({
//			"transform":"translate3d(0,0,0) scale(1) rotate3d(0,0,0,0)"
//		});
//		var activeType=parseInt($("#patternSel").find("option:checked").val());
//		var activeOrder=parseInt($("#patternImg").attr("data-order"));
//		var totalImgNum=parseInt($("#patternImg").attr("data-total"));
//		if(activeOrder!=0){
//			$("#prevTimeBtn").show();
//		}
//		if(activeOrder+1>=totalImgNum){
//			$(this).hide();
//			return false;
//		}
//		_switchData(resData,activeType,activeOrder+1);
//		
//	});
	
	var optionData=[
	    {
	        "type": 1,
	        "options": [
	        	{
	                "text": "H500W850",
	                "subType": 2,
	            },
	            {
	                "text": "H500W925",
	                "subType": 1,
	            },{
	                "text": "H500W700",
	                "subType": 3,
	            },{
	                "text": "H500W500",
	                "subType": 4,
	            },{
	                "text": "H200W200",
	                "subType": 5,
	            }
	        ]
	    },{
	        "type": 2,
	        "options": [
	            {
	                "text": "无定义",
	                "subType": 0
	                
	            }
	        ]
	    },{
	        "type": 3,
	        "options": [
	            {
	                "text": "无定义",
	                "subType": 0
	                
	            }
	        ]
	    },{
	        "type": 4,
	        "options": [
	            {
	                "text": "无定义",
	                "subType": 0
	                
	            }
	        ]
	    },{
	        "type": 5,
	        "options": [
	            {
	                "text": "无定义",
	                "subType": 0
	                
	            }
	        ]
	    },{
	        "type": 6,
	        "options": [
	        	{
	                "text": "850hpa",
	                "subType": 2,
	            },
	            {
	                "text": "925hpa",
	                "subType": 1,
	            },{
	                "text": "700hpa",
	                "subType": 3,
	            },{
	                "text": "500hpa",
	                "subType": 4,
	            },{
	                "text": "2m",
	                "subType": 5,
	            },{
	                "text": "surface",
	                "subType": 6,
	            }
	        ]
	    },{
	        "type": 7,
	        "options": [
	        	{
	                "text": "850hpa",
	                "subType": 1,
	            },
	            {
	                "text": "2m",
	                "subType": 2,
	            }
	        ]
	    },{
	        "type": 8,
	        "options": [
	        	{
	                "text": "850hpa",
	                "subType": 1,
	            },
	            {
	                "text": "2m",
	                "subType": 2,
	            }
	        ]
	    },{
	        "type": 9,
	        "options": [
	        	{
	                "text": "模式预报",
	                "subType": 1,
	            },
	            {
	                "text": "滑动订正",
	                "subType": 2,
	            },{
	                "text": "卡尔曼滤波",
	                "subType": 3,
	            }
	        ]
	    },{
	        "type": 10,
	        "options": [
	        	{
	                "text": "模式预报",
	                "subType": 1,
	            },
	            {
	                "text": "滑动订正",
	                "subType": 2,
	            },{
	                "text": "卡尔曼滤波",
	                "subType": 3,
	            }
	        ]
	    },{
	        "type": 11,
	        "options": [
	        	{
	                "text": "850hpa",
	                "subType": 2,
	            },
	            {
	                "text": "925hpa",
	                "subType": 1,
	            },{
	                "text": "700hpa",
	                "subType": 3,
	            },{
	                "text": "500hpa",
	                "subType": 4,
	            },{
	                "text": "2m",
	                "subType": 5,
	            }
	        ]
	    },{
	        "type": 12,
	        "options": [
	        	{
	                "text": "850hpa",
	                "subType": 2,
	            },
	            {
	                "text": "925hpa",
	                "subType": 1,
	            },{
	                "text": "700hpa",
	                "subType": 3,
	            }
	        ]
	    },{
	        "type": 13,
	        "options": [
	            {
	                "text": "无定义",
	                "subType": 0
	            }
	        ]
	    },{
	        "type": 14,
	        "options": [
	            {
	                "text": "无定义",
	                "subType": 0
	                
	            }
	        ]
	    },{
	        "type": 15,
	        "options": [
	        	{
	                "text": "850hpa",
	                "subType": 1,
	            },
	            {
	                "text": "h850-h500",
	                "subType": 2,
	            },{
	                "text": "h700-h500",
	                "subType": 3,
	            }
	        ]
	    },{
	        "type": 16,
	        "options": [
	        	{
	                "text": "500高度+850风&相对湿度",
	                "subType": 1,
	            },
	            {
	                "text": "500高度+700风&相对湿度",
	                "subType": 2,
	            },{
	                "text": "500高度+925风&相对湿度",
	                "subType": 3,
	            },{
	                "text": "500高度+200风&相对湿度",
	                "subType": 4,
	            }
	        ]
	    },{
	        "type": 17,
	        "options": [
	        	{
	                "text": "6小时降水",
	                "subType": 1,
	           },{
	                "text": "12小时降水",
	                "subType": 2,
	            },{
	                "text": "24小时降水",
	                "subType": 3,
	            }
	        ]
	    },{
	        "type": 18,
	        "options": [
	        	{
	                "text": "长沙",
	                "subType": 57687,
	            }, {
	                "text": "常德",
	                "subType": 57662,
	            }, {
	                "text": "张家界",
	                "subType": 57558,
	            }, {
	                "text": "益阳",
	                "subType": 57674,
	            }, {
	                "text": "怀化",
	                "subType": 57749,
	            }, {
	                "text": "娄底",
	                "subType": 57763,
	            }, {
	                "text": "邵阳",
	                "subType": 57766,
	            }, {
	                "text": "湘潭",
	                "subType": 57773,
	            }, {
	                "text": "衡阳",
	                "subType": 57872,
	            }, {
	                "text": "郴州",
	                "subType": 57972,
	            }, {
	                "text": "株洲",
	                "subType": 57780,
	            }, {
	                "text": "岳阳",
	                "subType": 57584,
	            }, {
	                "text": "永州",
	                "subType": 57866,
	            }, {
	                "text": "湘西州",
	                "subType": 57649,
	            }
	        ]
	    },{
	        "type": 999,
	        "options": [
	        	{
	                "text": "K-Index",
	                "type": 13,
	                "subType": 0,
	          	}, {
	                "text": "CAPE",
	                "type": 14,
	                "subType": 0,
	           }
	        ]
	    }
	];
	
});
