importScripts('../testMap/decimal.min.js')
	
this.onmessage = function(e) {
//	console.time('init')
	var test = new MapVisualization(e.data || {})
    this.postMessage(test)
//	console.timeEnd('init')
}

var MapVisualization = function(options) {
	var space = options.space || 0.5
	this._ = {
		Width: options.Width,
		Height: options.Height,
		wrapHeight: options.wrapHeight
	}
    this.lattices = []
	this.data = options.data || []
	this.space = space
	this.map_lat_start = 24.5
	this.map_lon_start = 108.65
    this.map_lat_end = 30.25
    this.map_lon_end = 114.4
    this.latDiff = Decimal.sub(this.map_lat_end, this.map_lat_start).toNumber()
    this.lonDiff = Decimal.sub(this.map_lon_end, this.map_lon_start).toNumber()
    this.longitudeRatio = Decimal.div(this.lonDiff, this._.Width).toNumber()
    this.latitudeRatio = Decimal.div(this.latDiff, this._.Height).toNumber()
    
	// 将数据格点化
	for (var latStart = this.map_lat_start; latStart <= this.map_lat_end; latStart = Decimal.add(latStart, space).toNumber()) {
        var rows = []
    	for (var lonStart = this.map_lon_start; lonStart <= this.map_lon_end; lonStart = Decimal.add(lonStart, space).toNumber()) {
            var cols = []
            this.data.forEach(function(item) {
                if (Number(item.lat) >= latStart && Number(item.lat) < Decimal.add(latStart, space).toNumber() && Number(item.lon) >= lonStart && Number(item.lon) < Decimal.add(lonStart, space).toNumber()) {
                    cols.push(item)
                }
            })
            rows.push(cols)
        }
        this.lattices.push(rows)
    }
}

//// 将数据格点化
//MapVisualization.prototype
//
//// x: left偏移量, y: top偏移量, s: 缩放比率
//MapVisualization.prototype.query = function(x, y, s) {
//	// 结果集
//	var result = []
//	
//	// 计算当前可视化区域的起始经纬度
//	var maxLon = Decimal.add(x, this._.Width).div(s).mul(this.longitudeRatio).add(this.map_lon_start)
//	var minLon = maxLon.sub(Decimal.div(this._.Width, s).mul(this.longitudeRatio))
//	var margin = Decimal.sub(this._.wrapHeight, this._.Height).div(2).toNumber()
//	var diff = Decimal.sub(margin, y).toNumber()
//	if (y < margin) {
//		diff = 0 - diff
//	}
//	var maxLat = Decimal.div(margin, s).mul(this.latitudeRatio).add(this.map_lat_end).sub(Decimal.div(y, s).mul(this.latitudeRatio))
//	var minLat = maxLat.sub(Decimal.div(this._.wrapHeight, s).mul(this.latitudeRatio))
//	
//	// 计算并统计初起始经纬度对应的格点数据
//	var len = this.lattices.length
//  var startLatIndex = Math.floor(minLat.sub(this.map_lat_start) / this.space)
//  startLatIndex = startLatIndex < 0 ? 0 : startLatIndex
//  var endLatIndex = Math.floor(maxLat.sub(this.map_lat_start) / this.space)
//  endLatIndex = endLatIndex >= len ? len - 1 : endLatIndex
//  var startLonIndex = Math.floor(minLon.sub(this.map_lon_start) / this.space)
//  var endLonIndex = Math.floor(maxLon.sub(this.map_lon_start) / this.space)
//	for (var q = startLatIndex; q <= endLatIndex + 1; q++) {
//		for (var w = startLonIndex; w <= endLonIndex + 1; w++) {
//			if (!this.lattices[q]) continue
//			if (!this.lattices[q][w]) continue
//			result = result.concat(this.lattices[q][w])
//		}
//	}
//	
//	return {
//  	data: result,
//  	startLat: minLat,
//  	endLat: maxLat,
//  	startLon: minLon,
//  	endLon: maxLon
//  }
//}

//
//function testMap(){
//  var win = $(window)
//
//  // 屏幕初始宽高
//  var Width = $("#rainMap").width()//win.width()
//  var Height = $("#rainMap").height()//win.height()
//
//  var space = 1
//  var map_lat_start = 24.5,
//      map_lon_start = 108.6,
//      map_lat_end = 30.3,
//      map_lon_end = 114.4,
//      latDiff = Decimal.sub(map_lat_end, map_lat_start).toNumber(),
//      lonDiff = Decimal.sub(map_lon_end, map_lon_start).toNumber()
//
//  var map_width_start = 0,
//      map_height_start = 0,
//      map_width_end = Width,
//      map_height_end = Height
//
//  var lattices = [],
//      longitudeRatio = Decimal.div(lonDiff, Width).toNumber(),
//      latitudeRatio = Decimal.div(latDiff, Height).toNumber()
//
//  window.init = function () {
//  	var count = 0
//      for (var latStart = map_lat_start; latStart <= map_lat_end; latStart = Decimal.add(latStart, space).toNumber()) {
//          var rows = []
//      	for (var lonStart = map_lon_start; lonStart <= map_lon_end; lonStart = Decimal.add(lonStart, space).toNumber()) {
//              var cols = []
//              window.data.forEach(function(item) {
//                  if (Number(item.lat) >= latStart && Number(item.lat) < Decimal.add(latStart, space).toNumber() && Number(item.lon) >= lonStart && Number(item.lon) < Decimal.add(lonStart, space).toNumber()) {
//                      cols.push(item)
//                  }
//              })
//              rows.push(cols)
//          	count += cols.length
//          }
//          lattices.push(rows)
//      }
//
//      console.log(count, lattices)
//      console.log(window.data.length)
//  }
//
//  console.time('init')
//  init()
//  console.timeEnd('init')
//
//  window.query = function(x, y, s) {
//      var result = []
//
////      var x1 = Math.floor(Decimal.div(x, s).mul(latitudeRatio).toNumber() / space)
////      var x2 = Math.floor(Decimal.div(Width, s).add(x).mul(latitudeRatio).toNumber() / space)
////      var y1 = Math.floor(Decimal.div(y, s).mul(longitudeRatio).toNumber() / space)
////      var y2 = Math.floor(Decimal.div(Height, s).add(y).mul(longitudeRatio).toNumber() / space)
////
////		var len = lattices.length
////		for (var t = len - y1 - 1; t >= len - 1 - (y2 - y1); t--) {
////			for (var k = x1; k < x2 - x1 + 1; k++) {
////				if (!lattices[t]) continue
////				if (!lattices[t][k]) continue
////				result = result.concat(lattices[t][k])
////			}
////		}
////		
//		var maxLon = Decimal.add(x, Width).div(s).mul(longitudeRatio).add(map_lon_start)
//		var minLon = maxLon.sub(Decimal.div(Width, s).mul(longitudeRatio))
////		console.log('minLon: ' + minLon)
////		console.log('maxLon: ' + maxLon)
//		
//		var wrapHeight = Number(document.getElementById("fullCan").style.height.replace('px', ''))
//		var margin = Decimal.sub(wrapHeight, Height).div(2).toNumber()
//		var diff = Decimal.sub(margin, y).toNumber()
//		if (y < margin) {
//			diff = 0 - diff
//		}
////		console.log('diff: ' + margin + ', y: ' + y)
//		
//		var maxLat = Decimal.div(margin, s).mul(latitudeRatio).add(map_lat_end).sub(Decimal.div(y, s).mul(latitudeRatio))
//		var minLat = maxLat.sub(Decimal.div(wrapHeight, s).mul(latitudeRatio))
//		// console.log('diff: ' + diff)
////		console.log('minLat: ' + minLat)
////		console.log('maxLat: ' + maxLat)
//
//
//		var len = lattices.length
//      var startLatIndex = Math.floor(minLat.sub(map_lat_start) / space)
//      startLatIndex = startLatIndex < 0 ? 0 : startLatIndex
//      var endLatIndex = Math.floor(maxLat.sub(map_lat_start) / space)
//      endLatIndex = endLatIndex >= len ? len - 1 : endLatIndex
//      var startLonIndex = Math.floor(minLon.sub(map_lon_start) / space)
//      var endLonIndex = Math.floor(maxLon.sub(map_lon_start) / space)
//		for (var q = startLatIndex; q <= endLatIndex + 1; q++) {
//			for (var w = startLonIndex; w <= endLonIndex + 1; w++) {
//				if (!lattices[q]) continue
//				if (!lattices[q][w]) continue
//				result = result.concat(lattices[q][w])
//			}
//		}
////		for (var t = len - y1 - 1; t >= len - 1 - (y2 - y1); t--) {
////			for (var k = x1; k < x2 - x1 + 1; k++) {
//////				if (!lattices[t]) continue
//////				if (!lattices[t][k]) continue
////				result = result.concat(lattices[t][k])
////			}
////		}
//		
////		console.log(startLatIndex + ',' + endLatIndex + ':' + startLonIndex + ',' + endLonIndex)
////		console.log(result.length)
//      return {
//      	data: result,
//      	startLat: minLat,
//      	endLat: maxLat,
//      	startLon: minLon,
//      	endLon: maxLon
//      }
//  }
//
//  console.log('init', Width, Height)
//  
//  win.on('resize', function () {
//      Width = win.width()
//      Height = win.height()
//      init(space)
//      console.log('resize', Width, Height)
//  })
//}