window.CONSTANT = {}
localStorage.workerTier=2
var asyncMapVisualization = function(data, key) {
	var worker;
	if (localStorage.workerTier == 1) {
		worker = new Worker('../js/serve/testMap/test.js')
	} else {
		worker = new Worker('../../js/serve/testMap/test.js')
	}
	
	worker.postMessage({
		data: data,
		Width: $("#rainMap").width(), 
		Height: $("#rainMap").height(), 
		wrapHeight: $("#fullCan").height()
	})
	worker.onmessage = function(e) {
		console.log('接收中')
		console.log(e)
		window.CONSTANT[key] = e.data
		window.CONSTANT[key].query = queryMapVisualization
		// 释放资源
		worker.terminate()
	}
}

// x: left偏移量, y: top偏移量, s: 缩放比率
function queryMapVisualization(x, y, s) {
	// 结果集
	var result = []
	
	// 计算当前可视化区域的起始经纬度
	var maxLon = Decimal.add(x, this._.Width).div(s).mul(this.longitudeRatio).add(this.map_lon_start)
	var minLon = maxLon.sub(Decimal.div(this._.Width, s).mul(this.longitudeRatio))
	var margin = Decimal.sub(this._.wrapHeight, this._.Height).div(2).toNumber()
	var diff = Decimal.sub(margin, y).toNumber()
	if (y < margin) {
		diff = 0 - diff
	}
	var maxLat = Decimal.div(margin, s).mul(this.latitudeRatio).add(this.map_lat_end).sub(Decimal.div(y, s).mul(this.latitudeRatio))
	var minLat = maxLat.sub(Decimal.div(this._.wrapHeight, s).mul(this.latitudeRatio))
	
	// 计算并统计初起始经纬度对应的格点数据
	var len = this.lattices.length
    var startLatIndex = Math.floor(minLat.sub(this.map_lat_start) / this.space)
    startLatIndex = startLatIndex < 0 ? 0 : startLatIndex
    var endLatIndex = Math.floor(maxLat.sub(this.map_lat_start) / this.space)
    endLatIndex = endLatIndex >= len ? len - 1 : endLatIndex
    var startLonIndex = Math.floor(minLon.sub(this.map_lon_start) / this.space)
    var endLonIndex = Math.floor(maxLon.sub(this.map_lon_start) / this.space)
	for (var q = startLatIndex; q <= endLatIndex + 1; q++) {
		for (var w = startLonIndex; w <= endLonIndex + 1; w++) {
			if (!this.lattices[q]) continue
			if (!this.lattices[q][w]) continue
			result = result.concat(this.lattices[q][w])
		}
	}
	
	return {
    	data: result,
    	startLat: minLat,
    	endLat: maxLat,
    	startLon: minLon,
    	endLon: maxLon
    }
}
