$(function () {
	var height = $(window).height(), 
		width = $(window).width(),
		containerHeight = height - Number($('header').css('height').replace("px", ''))
	$(".mui-content").height(containerHeight)

	mui.init({
		swipeBack: false, //启用右滑关闭功能
		gestureConfig: {
			tap: true, //默认为true
			doubletap: true, //默认为false
			longtap: true, //默认为false
			swipe: true, //默认为true
			drag: true, //默认为true
			hold: false,//默认为false，不监听
			release: false//默认为false，不监听
		},
		beforeback: function () {
			if (mui.os.plus) {
				if ($('body').hasClass('horizontal')) {
					plus.screen.lockOrientation('portrait-primary')
					setTimeout(function() {
						plus.screen.unlockOrientation()
					}, 2000)
					return false
				}

				plus.screen.lockOrientation('portrait-primary')
			}

			return true
		}
	})

	// 监听屏幕旋转事件
	window.addEventListener("orientationchange", function() {
		switch (window.orientation) {
			case 90:
			case -90:
				plus.navigator.setFullscreen(true)
				$('body').addClass('horizontal')
				$('.time-btn').removeClass('hide')
				$('.horizontal-display-item').css('display', 'none')
				$('.mui-content,.swiper-container').height(width)
				$('.mui-title').text('数据更新时间：' + $('.show-realtime').text())
				Screen.horizontal()
				break
			default:
				plus.navigator.setFullscreen(false)
				$('body').removeClass('horizontal')
				$('.time-btn').addClass('hide')
				$('.horizontal-display-item').css('display', 'flex')
				$('.mui-content').height(containerHeight)
				$('.swiper-container').height('')
				$('.mui-title').text($('title').text())
				Screen.vertical()
				break
		}

		swiper.update(true)
	}, false)

	$(document).click(function(e) {
		if ($('body').hasClass('horizontal') && $('.horizontal-display-item').find($(e.target)).length === 0) {
			if ($('.mui-bar').css('display') === 'flex') {
				plus.navigator.setFullscreen(true)
			} else {
				plus.navigator.setFullscreen(false)
			}
			$('.horizontal-display-item').stop().slideToggle(100).toggleClass('opacity').css('display', 'flex')
		}
	})

	// 渲染轮播图
	var swiper, data
	function renderSwiper(htmls) {
		swiper && swiper.destroy()
		$('.typhoon-img-container .swiper-wrapper').html(htmls.join(''))
		swiper = new Swiper('.typhoon-img-container', {
			effect: 'fade',
			passiveListeners: false,
			initialSlide: htmls.length - 1,
			preloadImages: false,
			lazy: {
				loadPrevNext: true
			},
			watchSlidesVisibility: true,
			zoom: {
				toggle: false
			},
			autoplay: {
				delay: 1500,
				stopOnLastSlide: true
			},
			on: {
				init: function () {
					$("#typhoonControl").attr('max', htmls.length - 1);
					$("#typhoonControl").val(htmls.length - 1)
					$("#showTyphoonTime").text($(htmls[htmls.length - 1]).data('time'));
					$("#playImg").attr("data-val", 0)
					$("#playImg").attr("src", "../images/monitoringOfLive/radar-play.png")
				},
				slideChange: function () {
					$("#typhoonControl").val(this.activeIndex)
					$("#showTyphoonTime").text($(htmls[this.activeIndex]).data('time'));
				},
				autoplayStop: function () {
					$("#playImg").attr("data-val", 0)
					$("#playImg").attr("src", "../images/monitoringOfLive/radar-play.png")
				}
			}
		})
		swiper.autoplay.stop()
	}

	// 切换台风类型
	function changeType(type) {
		var htmls = []
			;[].concat(data[type]).forEach(function (item) {
				var items = item.split(',')
				htmls.push('<div class="swiper-slide" data-time="' + items[0] + '"><div class="swiper-zoom-container"><img data-src="' + items[1] + '" class="swiper-lazy" onerror="notFoundImage(this)"></div><div class="swiper-lazy-preloader"></div></div>')
			})
		renderSwiper(htmls)
	}

	// 请求台风数据
	http.post('/typhoon/findTyphoonMsg', {}, function (res) {
		data = res.body
		var options = [], activeType, prefix = '台风路径预报图 - '
		for (var key in data) {
			if (!data[key] || data[key].length === 0) {
				continue
			}

			if (!activeType) {
				activeType = key
			}
			options.push('<option value="' + key + '">' + prefix + key + '</option>')
		}
		$('#typeSel').html(options.join(''))
		$('#typeSelTxt').html(prefix + activeType)
		changeType(activeType)

		mui.plusReady(function () {
			// 解除方向锁定
			plus.screen.unlockOrientation()
		})
	})

	// 各个容器高度适配
	var screenHeight = $(window).height()
	var calcHeight = screenHeight - 44 - localStorage.statusbarHeight
	$(".typhoonImages").height(calcHeight - $('.show-info-box').height())

	// 播放
	$("#playControlBtn").on("click", function () {
		var playImg = $('#playImg')
		var maxOrder = $("#typhoonControl").attr("max")
		var activeOrder = $("#typhoonControl").val()
		if (activeOrder == maxOrder) {
			$("#typhoonControl").val(0);
			swiper && swiper.slideTo(0, 0)
		}
		if (playImg.attr("data-val") == 0) {
			playImg.attr("data-val", 1);
			playImg.attr("src", "../images/monitoringOfLive/radar-unplay.png");
			swiper && swiper.autoplay.start()
		} else {
			playImg.attr("data-val", 0);
			playImg.attr("src", "../images/monitoringOfLive/radar-play.png");
			swiper && swiper.autoplay.stop()
		}
	})

	$("#typhoonControl").change(function () {
		var order = Number($(this).val())
		swiper && swiper.slideTo(order, 0)
	})

	$("#typeSel").on("change", function () {
		var active = $(this).find("option:checked")
		var aciveOptTxt = active.text()
		$("#typeSelTxt").text(aciveOptTxt)
		changeType($(this).val())
	})

	//swiper 横屏时翻页事件
	$("#prevImgBtn").on("click",function(e){
		swiper.slidePrev(0)
		e.stopPropagation()
	})
	$("#nextImgBtn").on("click",function(e){
		swiper.slideNext(0)
		e.stopPropagation()
	})
})