mui.plusReady(function() {
	var title = $('title').text()
	
	plus.runtime.getProperty(plus.runtime.appid, function(info) {
		if (title != '系统设置') {
			checkUpdate(info)
		} else {
			$("#activeVersion").text(info.version)
			$("#checkUpdateBtn").click(function() {
				checkUpdate(info)
			})
		}
	})

	// 检查更新
	function checkUpdate(info) {
		if (info.appid === 'HBuilder') {
			return
		}

		var env = info.appid === 'com.yiring.hntq' ? 'prod' : 'test'
		http.get('/setting/getVersion.do?env=' + env, function(res) {
			console.log(JSON.stringify(res))
			var body = res.body || {}
			var cuurentVersions = info.version.split('.')
			var newVersions = body.version ? body.version.split('.') : []

			for (var i = 0; i < newVersions.length; i++) {
				if (Number(cuurentVersions[i]) < Number(newVersions[i])) {
					var append = '版本：' + body.version + '        ' + '大小：' + body.fileSize
					plus.nativeUI.alert(append + '\n\n' + body.explanation, function() {
						if (body.type === 'override') {
							if (mui.os.android) {
								downloadPatch(body.androidDownloadUrl)
							} else {
								// 打开 itunes/url 下载地址
								plus.runtime.openURL(body.iosDownloadUrl)
							}
						} else {
							downloadPatch(body.downloadurl)
						}
					}, '新版本', '立即下载')
					return
				}
			}

			if (title === '系统设置') {
				plus.nativeUI.alert("当前已是最新版本！")
			}
		})
	}

	// 下载补丁包
	function downloadPatch(url) {
		mui.showLoading('<div class="loadingWrap"><span class="percentNum">0</span><span class="loadingTitle">%下载中...</span></div>','div')
		function changeLoadingTitle (loadingMsg,percentNum){
			document.querySelectorAll('.loadingTitle')[0].innerHTML = loadingMsg;
			document.querySelectorAll('.percentNum')[0].innerHTML = percentNum;
		}
		function hideLoading(){
			var mask = document.getElementsByClassName("mui-show-loading-mask")
			var toast = document.getElementsByClassName("mui-show-loading")
			mask[0].classList.add("mui-show-loading-mask-hidden")
			toast[0].classList.remove("loading-visible")
		}
		var percentNum = 0;
		window.updatePatching = true
		var downloader = plus.downloader.createDownload(url, {
			filename: "_doc/update/"
		}, function(d, status) {
			if (status == 200) {
				setTimeout(function(){
					installPatch(d.filename)
				}, 500); 
			} else {
				plus.nativeUI.alert("下载更新包失败...")
			}
		})
				
		document.addEventListener("netchange", function() {
			var net = plus.networkinfo.getCurrentType()
			switch (net) {
		　　　　case plus.networkinfo.CONNECTION_ETHERNET:
		　　　　case plus.networkinfo.CONNECTION_WIFI:
		　　　　case plus.networkinfo.CONNECTION_CELL2G:
		　　　　case plus.networkinfo.CONNECTION_CELL3G:
		　　　　case plus.networkinfo.CONNECTION_CELL4G:
					downloader.resume()
		　　　　　　 break
		　　　　default:
					downloader.pause()
		　　　　　　 break
		　　}
		}, false)
		downloader.addEventListener("statechanged", function(task, status) {
			switch(task.state) {
				case 1:
					changeLoadingTitle("连接中...",'')
				break;
				case 2:
					changeLoadingTitle("已连接到服务器",'')
				break;
				case 3:
					var currentNum = parseInt(parseInt(task.downloadedSize) / parseInt(task.totalSize) * 100);
					if(percentNum !== currentNum) { 
						 // 让百分比不重复
						percentNum = currentNum;
						changeLoadingTitle("%下载中...",percentNum)
					}
				break;
				case 4:
					hideLoading()
					plus.nativeUI.showWaiting("安装中...")
					window.updatePatching = false
				break;
			}
		})
		downloader.start()

		// 安装补丁包
		function installPatch(path) {
			window.updatePatching = true
			plus.runtime.install(path, {}, function() {
				window.updatePatching = false
				plus.nativeUI.alert("应用更新完成！", function() {
					plus.nativeUI.closeWaiting()
					plus.runtime.restart()
				})
			}, function(e) {
				plus.nativeUI.closeWaiting()
				window.updatePatching = false
				plus.nativeUI.alert("安装失败[" + e.code + "]：" + e.message)
			})
		}
	}
	
	
})
