;$(function () {
	var swiper = new Swiper('.weatherForecast', {
		allowTouchMove: false,
		pagination: {
			el: '.pagination-ul',
			clickable: true,
			renderBullet: function (index, className) {
				var title = '';
				switch (index) {
					case 1:
						title = '三小时预报'
						break;
					case 2:
						title = '逐日预报'
						break
					default:
						title = '小时预报'
				}
				return '<li class="' + className + '" data-item="' + index + '" >' + title + '</li>'
			}
		}
	});

	var hour1StartTime, hour3StartTime, dayStartTime;
	// 城市天气实况
	function _weatherForeCastCitySuccess() {
		var resCityData = (JSON.parse(localStorage.cityData)).body;
		var cityName;
		if (localStorage.firstLocalFlag == 0) {
			cityName = localStorage.firstLocalCityName;

			refreshWeatherEarly(cityName, localStorage.locationCity)
		} else {
			if (resCityData.cityName == '') {
				cityName = localStorage.cityName;
			} else {
				cityName = resCityData.cityName;
			}

			refreshWeatherEarly(cityName, cityName)
		}

		$(".weather-forecast-title").text(cityName);
		$(".weather-forecast-location").html('实况更新时间：' + resCityData.datetime.substring(5, 10) + ' ' + resCityData.datetime.substring(11, 16));

		var qualityLevel = resCityData.qualityLevel;
		var qualityLevelName, leafIconSrc, windLevelName, CIMISScode;
		if (resCityData.aqi > 0) {
			// $('.air-quality').css({visibility: 'visible'})
			$(".air-quality-txt").text("AQI " + (resCityData.aqi || 0));
		} else {
			// $('.air-quality').css({visibility: 'hidden'})
		}
		switch (parseInt(qualityLevel)) {
			case 1:
				qualityLevelName = "优";
				leafIconSrc = "../images/leaf/1.png";
				break;

			case 2:
				qualityLevelName = "良";
				leafIconSrc = "../images/leaf/2.png";
				break;

			case 3:
				qualityLevelName = "轻";
				leafIconSrc = "../images/leaf/3.png";
				break;

			case 4:
				qualityLevelName = "中";
				leafIconSrc = "../images/leaf/4.png";
				break;

			case 5:
				qualityLevelName = "重";
				leafIconSrc = "../images/leaf/5.png";
				break;

			case 6:
				qualityLevelName = "严重";
				leafIconSrc = "../images/leaf/6.png";
				break;

			default:
				qualityLevelName = "未知";
				leafIconSrc = "../images/leaf/green.png";
				break;
		}
		$("#weather-stationCode").val(resCityData.stationCode);
		$(".air-quality-txt").text(resCityData.aqi + ' ' + checkAqiLevel(resCityData.aqi));
		$(".air-quality-icon").attr({
			"src": leafIconSrc,
			"alt": qualityLevelName
		});
		$(".real-time-tem-txt").text(resCityData.tem);
		var weatherIconUrl = '../images/weather-little-icon/weather_' + resCityData.CIMISScode + '_720_2.png';
		//晚上换成晚上图标
		if (resCityData.CIMISScode === '1002' || resCityData.CIMISScode === '1008' || resCityData.CIMISScode === '1011') {
			var t = getHour() + ":" + getMin();
			if ((CompareDate(t, '19:59') && CompareDate(t, '07:59')) || (!CompareDate(t, '19:59') && !CompareDate(t, '07:59'))) {
				weatherIconUrl = '../images/weather-little-icon/weather_' + resCityData.CIMISScode + '_720_2' + '_night' + '.png';
			}
		}

		// 设置天气实况背景图，目前仅有以下天气代码对应的背景图，如果新增，需要更新该数组
		var codes = [1001, 1002, 1003, 1004, 1005, 1006, 1007, 1008, 1009, 1016, 1017, 1017, 1018, 1019, 1020, 1021, 1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1035, 1037]
		if (codes.indexOf(Number(resCityData.CIMISScode)) != -1) {
			var weatherBgUrl = "../images/weather-live-bg/" + resCityData.CIMISScode + ".png";
			$("#main").css("background-image", "url(" + weatherBgUrl + ")");
		}

		var windStr = resCityData.indexWindSpeedName
		$(".weather-summarize-icon").attr({
			"src": weatherIconUrl,
		});
		$(".weather-summarize-txt").text(resCityData.cimissContent);
		$('.weather-humidity-txt').text(resCityData.rhu);
		$('.weather-pressure-txt').text(resCityData.prs_sea);
		$(".weather-wind-name").text(windStr.substr(0, windStr.length - 1) + resCityData.windDirection + '风');
	}

	/**
	 * 更新预警信号
	 */
	function refreshWeatherEarly(district, city) {
		var weatherEarlys = JSON.parse(localStorage.weatherEarlys)
		var currentLocalEarlys = uniq(weatherEarlys
			.filter(function (item) {
				item.times = dayjs(item.submitTime).valueOf()

				return item.relevantArea.filter(function (area) {
					return area.indexOf(district) === 0 || district.indexOf(area) === 0 || area.indexOf(city) === 0 || city.indexOf(area) === 0
				}).length > 0
			})
			.sort(function (a, b) {
				return b.times - a.times
			})
			.map(function (item) {
				return item.earlyTypePY + '-' + item.earlyLevel
			}))

		var htmls = []
		for (var i = 0, len = currentLocalEarlys.length > 5 ? 5 : currentLocalEarlys.length; i < len; i++) {
			htmls.push('<img src="../images/earlyWarningIcon/' + currentLocalEarlys[i] + '.svg">')
		}
		$('.earlys').html(htmls.join(''))
	}

	function uniq(array) {
		var temp = []
		for (var i = 0; i < array.length; i++) {
			if (temp.indexOf(array[i]) === -1) {
				temp.push(array[i])
			}
		}
		return temp
	}

	/* //1小时预报
	function forecast1Hour(info) {
		var url = "/cityWeather/forecacstOneHour.do";
		var stationCode = info;
		var params = {
			stationCode: stationCode
		};
		ajaxPost(url, params, _forecast1HourSuccess, info);
	} */

	//1小时预报
	function forecast1Hour(info, chartDom, hasMask) {
		var url = "/cityWeather/forecacstOneHour.do";
		var stationCode = info;
		var params = {
			stationCode: stationCode
		};
		http.post(url, params, function (data, dom) {
			_forecast3HourSuccess(data, chartDom)
		}, true, hasMask)

		/* $.ajax({
			type:"get",
			url:url,
			data:params,
			cache:false,
			dataType:"jsonp",
			timeout:12000,
			success:function(data){
				if(data.reqState==1||data.reqState==4){
					_forecast3HourSuccess(data,chartDom)
				}
				hour1StartTime = data.body.data.startTime;
				console.log(data)
				renderStartTime(hour1StartTime)
			}
		}) */
	}

	//3小时预报
	function forecast3Hour(info, chartDom, hasMask) {
		var url = "/cityWeather/forecastThreeHour.do";
		var stationCode = info;
		var params = {
			stationCode: stationCode
		};
		http.post(url, params, function (data, dom) {
			_forecast3HourSuccess(data, chartDom)
		}, true, hasMask)

		/* $.ajax({
			type:"get",
			url:url,
			data:params,
			cache:false,
			dataType:"jsonp",
			timeout:12000,
			success:function(data){
				if(data.reqState==1||data.reqState==4){
					_forecast3HourSuccess(data,chartDom)
				}
				hour3StartTime = data.body.data.startTime;
			}
		}) */
	}

	function _forecast3HourSuccess(data, chartDom) {
		var activeSwiperItem = $('.swiper-pagination-bullet-active').data('item')
		
		if (chartDom === "#weather-forecast-1hour") {
			hour1StartTime = data.body.startTime;
			if (activeSwiperItem == 0) {
				renderStartTime(hour1StartTime)
			}
		} else if (chartDom === "#weather-forecast-3hour") {
			hour3StartTime = data.body.startTime;
			if (activeSwiperItem == 1) {
				renderStartTime(hour3StartTime)
			}
		}
		if (data.body.data.recordNum == 0) {
			return false;
		}
		var resData = data.body.data;
		var resDataLength = resData.length;
		var weatherPhenomenaArr = [],
			windDirectionArr = [],
			windSpeedArr = [],
			temArr = [],
			rainArr = [].resDataItem = [],
			windInfoItemArr = [],
			weatherInfoArr = [],
			xAixsArr = [],
			weatherTime;
		var startTime = data.body.startTime;
		// hourStartTime=startTime;
		// $('.weather-source').text('预报起报时间：' + startTime.substr(5, 10) + ' ' + startTime.substr(11, 5));
		for (var i = 0; i < resDataLength; i++) {
			var weatherInfo = {};
			resDataItem = resData[i].split(',');
			weatherInfo.weatherPhenomena = resDataItem[1];
			weatherInfo.windDirection = resDataItem[2];
			weatherInfo.windSpeed = resDataItem[3];
			weatherInfo.tem = resDataItem[4];
			weatherInfo.rain = resDataItem[5];
			weatherInfo.weatherTime = addHour(startTime, resDataItem[0] * 60 * 60 * 1000);
			weatherInfoArr.push(weatherInfo);
			temArr.push(parseInt(resDataItem[4]));
			rainArr.push(parseFloat(resDataItem[5]).toFixed(1) == 0 ? 0 : parseFloat(resDataItem[5]).toFixed(1));
		}
		for (var i = 0; i < temArr.length; i++) {
			xAixsArr.push('');
		}
		$(chartDom).highcharts({
			chart: {
				type: 'spline',
				backgroundColor: 'rgba(0,0,0,0)', //背景色透明
				margin: [(bottomPartHeight - bottomPartHeadHeight)*0.39, 5, (bottomPartHeight - bottomPartHeadHeight)*0.28, 20],
			},
			credits: {
				enabled: false
			},
			title: {
				text: ''
			},
			xAxis: {
				visible: false,
				categories: xAixsArr
			},
			yAxis: {
				visible: false
			},
			plotOptions: {
				line: {
					dataLabels: {
						enabled: true, // 开启数据标签
						color: 'rgb(132,132,132)',
						//                  allowOverlap: false, //处理标签重叠,
						padding: 5
					},
					enableMouseTracking: true // 关闭鼠标跟踪，对应的提示框、点击事件会失效
				}
			},
			legend: {
				enabled: false
			},
			exporting: {
				enabled: false
			},
			series: [{
				type: 'spline',
				name: '气温',
				data: temArr,
				dataLabels: {
					enabled: true,
					format: '{y} °'
				}
			}]
		}, function (chart) { // on complete
			pointXArr = [], windAngleArr = [];
			$.each(chart.series[0].data, function (i, point) {
				x = point.plotX + chart.plotLeft; //x轴位置
				pointXArr.push(x);
			});
			var bottomPartHeight = $(".weather-forecast-chart").height();
			var bottomPartHeadHeight = $(".pagination").outerHeight();
			var weatherChartDayHeihet = bottomPartHeight - bottomPartHeadHeight - 20;
			var weatherPhenIconSrc, windPowerIconSrc, weatherCode, hourWeatherPhenomena;
			var recentDay = '';
			for (var i = 0; i < weatherInfoArr.length; i++) {
				//三小时预报,日期显示 跨日处理 recentDay,nowDay
				var nowDay = weatherInfoArr[i].weatherTime.substr(8, 2);
				if (recentDay == '' || recentDay == nowDay) {
					drawWeatherTime = weatherInfoArr[i].weatherTime.substr(11, 5)
				} else {
					drawWeatherTime = weatherInfoArr[i].weatherTime.substr(5, 5)
				}
				recentDay = nowDay;

				var judgeHour = (weatherInfoArr[i].weatherTime).substr(11, 5);
				//TODO
				hourWeatherPhenomena = Number(weatherInfoArr[i].weatherPhenomena)
				weatherPhenIconSrc = '../images/new-weather-forecast-icon/day' + hourWeatherPhenomena + '.png';

				//晚上换成晚上图标
				if (hourWeatherPhenomena === 0 || hourWeatherPhenomena === 1 || hourWeatherPhenomena === 4) {
					if ((CompareDate(judgeHour, '19:59') && CompareDate(judgeHour, '07:59')) || (!CompareDate(judgeHour, '19:59') && !CompareDate(judgeHour, '07:59'))) {
						weatherPhenIconSrc = '../images/new-weather-forecast-icon/night' + hourWeatherPhenomena + '.png';
					}
				}
				windAngleArr.push(weatherInfoArr[i].windDirection)

				//三小时横排1  顶部时间 
				chart.renderer.text(drawWeatherTime, pointXArr[i] - 18, (bottomPartHeight - bottomPartHeadHeight) * 0.07)
					.css({
						color: '#cfdbff',
						fontSize: '0.4032rem',
					})
					.add();
				//天气现象转对应文字
				var prText = getPhenomenaCodeByInfo(hourWeatherPhenomena)
				//三小时横排2 顶部天气文字
				chart.renderer.text(prText.phenomenonatext, pointXArr[i] - 14, (bottomPartHeight - bottomPartHeadHeight) * 0.16)
					.css({
						color: '#ffffff',
						fontSize: '0.4032rem'
					})
					.add();
				//三小时横排3  天气图标 
				chart.renderer.image(weatherPhenIconSrc, pointXArr[i] - 15, (bottomPartHeight - bottomPartHeadHeight) * 0.18, 30, 30).add();
				//三小时横排4 降雨量文字
				var rainText = rainArr[i] + 'mm'
				chart.renderer.text(rainText, pointXArr[i] - 14, (bottomPartHeight - bottomPartHeadHeight) * 0.35)
					.css({
						color: '#ffffff',
						fontSize: '0.3332rem',
					})
					.add();
				//三小时横排5 风向
				var windDirectionText = queryWindDirection(weatherInfoArr[i].windDirection)
				chart.renderer.text(windDirectionText, pointXArr[i] - 14, (bottomPartHeight - bottomPartHeadHeight) * 0.81)
					.css({
						color: '#cfdbff',
						fontSize: '0.4032rem',
					})
					.add();
				//三小时横排6 风力
				var windSpeedText = getWindData(weatherInfoArr[i].windSpeed)[1] + '级'
				chart.renderer.text(windSpeedText, pointXArr[i] - 14, (bottomPartHeight - bottomPartHeadHeight) * 0.9)
					.css({
						color: '#ffffff',
						fontSize: '0.4032rem',
					})
					.add();
			}
		});
	}

	//逐日预报
	function forecastDay(info, hasMask) {
		// var url = "/cityWeather/forecastFourteenDay.do";
		var url = "/cityWeather/forecastFourteenDay.do";
		var stationCode = info;
		var params = {
			stationCode: stationCode
		};
		// ajaxPost(url, params, _forecastDaySuccess, info);
		http.post(url, params, function (data, info) {
			_forecastDaySuccess(data, info)
		}, true, hasMask)
	}
	function adapter(arr) {
		var _oldArr;
		_oldArr = arr.map(function (val, idx) {
			return (val.mornWeather || '') + ',' + (val.nightWeather || '') + ',' + (val.maxTem || '') + ',' + (val.minTem || '')
		})
		return _oldArr;
	}

	function _forecastDaySuccess(data, info) {
		if (data.body.data.recordNum == 0) {
			return false;
		}

		var resData = adapter(data.body.data);
		var bottomPartHeight = $(".weather-forecast-chart").height();
		var bottomPartHeadHeight = $(".pagination").outerHeight();
		var weatherChartDayHeihet = bottomPartHeight - bottomPartHeadHeight - 40;
		var resDataItem, weatherDayArr = [],
			weatherNightArr = [],
			highTemArr = [],
			lowTemArr = [],
			weatherDayItemArr = [];
		var resStartime = data.body.startTime;
		dayStartTime = resStartime;

		var activeSwiperItem = $('.swiper-pagination-bullet-active').data('item')
		if (activeSwiperItem == 2) {
			renderStartTime(dayStartTime)
		}

		// $('.weather-source').text('预报起报时间：' + resStartime.substr(5, 5) + ' ' + resStartime.substr(11, 5));
		var isDaylightStart = resStartime.endsWith('20:00:00');
		if (isDaylightStart) {
			weatherDayItemArr.push('');
			highTemArr.push('');
		}
		var allArr = [], singleRes = [], xAixsArr = [];
		for (var i = 0; i < resData.length; i++) {
			singleRes = resData[i].split(',');
			allArr.push(singleRes[0] + ',' + singleRes[2]);
			allArr.push(singleRes[1] + ',' + singleRes[3]);
		}
		/* resData.foreach(function(val,ind){
			allArr.push(val.mornWeather)
			allArr.push(val.mornWeather)
			allArr.push(val.mornWeather)
			allArr.push(val.mornWeather)
		}) */
		for (var i = 0; i < allArr.length; i++) {
			singleRes = allArr[i].split(',');
			weatherDayItemArr.push(singleRes[0]);
			if ((isDaylightStart && i % 2 == 0) || (!isDaylightStart && i % 2 == 0))
				highTemArr.push(parseInt(singleRes[1]));
			else
				lowTemArr.push(parseInt(singleRes[1]));
		}

		for (var i = 0; i < lowTemArr.length; i++) {
			xAixsArr.push('');
		}

		$('#weather-forecast-day').highcharts({
			chart: {
				type: 'line',
				backgroundColor: 'rgba(0,0,0,0)', //背景色透明
				margin: [(bottomPartHeight - bottomPartHeadHeight)*0.32, 5 , (bottomPartHeight - bottomPartHeadHeight)*0.33, 0]
				// margin: [(bottomPartHeight - bottomPartHeadHeight)*0.31 - 20, 20, (bottomPartHeight - bottomPartHeadHeight)*0.32, 0],
				// marginBottom: 40
				// [(0.4032 * 2 * 16) + 40.6, 20, (0.4032 * 2 * 16) + 80, 0]  ---lastSet
			},
			credits: {
				enabled: false
			},
			title: {
				text: ''
			},
			xAxis: {
				visible: false,
				categories: xAixsArr
			},
			yAxis: {
				visible: false
			},
			plotOptions: {
				series: {
					type: 'spline',
					dataLabels: {
						enabled: true,
						format: '{y} °'
					}
				}
			},
			legend: {
				enabled: false
			},
			exporting: {
				enabled: false
			},
			series: [{
				name: "日最高温",
				data: data.body.data.map(function (v) { return parseInt(v.maxTem) }),
				color: '#eb6247',
				dataLabels: {
					verticalAlign: 'bottom'
				}
			}, {
				name: "日最低温",
				data: data.body.data.map(function (v) { return parseInt(v.minTem) }),
				color: '#72a2f1',
				dataLabels: {
					verticalAlign: 'top'
				}
			}]
		}, function (chart) { // on complete
			var xPlotArr = [],
				weatherCodeNight, weatherCodeDaytime, weatherCodeDaytimeSrc, weatherCodeNightSrc, weatherTime, weatherTimeWeek;
			$.each(chart.series[0].data, function (i, point) {
				x = point.plotX + chart.plotLeft; //x轴位置
				xPlotArr.push(x);
			});

			data.body.data.forEach(function (item, i) {

				// 逐日横排1 日期
				chart.renderer.text(item.forecastDay.substr(4, 2) + '/' + item.forecastDay.substr(6, 2), xPlotArr[i] - 16, (bottomPartHeight - bottomPartHeadHeight) * 0.07)
					.css({
						color: '#cfdbff',
						fontSize: '0.4032rem',
					})
					.add();

				var morn = getPhenomenaCodeByInfo(item.mornWeather) || {}
				var night = getPhenomenaCodeByInfo(item.nightWeather) || {}
				// 逐日横排2 白天天气现象
				chart.renderer.text(morn.phenomenonatext, xPlotArr[i] - 10, (bottomPartHeight - bottomPartHeadHeight) * 0.16)
					.css({
						color: '#ffffff',
						fontSize: '0.4032rem'
					})
					.add();

				//天气现象转图标路径
				var dayCode = parseInt(item.mornWeather);
				var nightCode = parseInt(item.nightWeather);
				var isNightImg = nightCode == 0 || nightCode == 1 || nightCode == 4;
				weatherCodeDaytimeSrc = ('../images/new-weather-forecast-icon/day' + dayCode + '.png');
				weatherCodeNightSrc = ('../images/new-weather-forecast-icon/' + (isNightImg ? 'night' : 'day') + nightCode + '.png');
				//逐日横排3 白天天气图标
				chart.renderer.image(weatherCodeDaytimeSrc, xPlotArr[i] - 15, (bottomPartHeight - bottomPartHeadHeight) * 0.18, 30, 30)
					.add();
				//逐日横排4 夜晚天气图标
				chart.renderer.image(weatherCodeNightSrc, xPlotArr[i] - 15, (bottomPartHeight - bottomPartHeadHeight) * 0.7, 30, 30)
					.add();

				//逐日横排5 夜晚天气现象
				chart.renderer.text(night.phenomenonatext, xPlotArr[i] - 10, (bottomPartHeight - bottomPartHeadHeight) * 0.86)
					.css({
						color: '#ffffff',
						fontSize: '0.4032rem'
					})
					.add();

				var weeks = ['周天', '周一', '周二', '周三', '周四', '周五', '周六']
				//逐日横排6 星期
				chart.renderer.text(weeks[dayjs(item.forecastDay).format('d')], xPlotArr[i] - 10, (bottomPartHeight - bottomPartHeadHeight) * 0.95)
					.css({
						color: '#cfdbff',
						fontSize: '0.4032rem'
					})
					.add();
			})

			return

			for (var i = 0; i < weatherDayItemArr.length; i += 2) {
				var dayPrText, nightPrText;
				//天气现象转对应文字
				if (getPhenomenaCodeByInfo(weatherDayItemArr[i + 1]) !== null) {
					nightPrText = getPhenomenaCodeByInfo(weatherDayItemArr[i + 1]).phenomenonatext
				}

				var phenomena = getPhenomenaCodeByInfo(weatherDayItemArr[i])
				dayPrText = (phenomena && phenomena.phenomenonatext) || ''

				//天气现象转图标路径
				var dayCode = parseInt(weatherDayItemArr[i]);
				var nightCode = parseInt(weatherDayItemArr[i + 1]);
				var isNightImg = nightCode == 0 || nightCode == 1 || nightCode == 4;
				weatherCodeDaytimeSrc = ('../images/new-weather-forecast-icon/day' + dayCode + '.png');
				weatherCodeNightSrc = ('../images/new-weather-forecast-icon/' + (isNightImg ? 'night' : 'day') + nightCode + '.png');
				weatherTimeDay = addHour(resStartime, i * 12 * 60 * 60 * 1000);
				weatherTimeWeek = getWeek(resStartime, i * 12 * 60 * 60 * 1000);

				//逐日横排1 日期
				chart.renderer.text(weatherTimeDay.substr(5, 5).split('-').join('/'), xPlotArr[i / 2] - 16, (bottomPartHeight - bottomPartHeadHeight) * 0.07)
					.css({
						color: '#cfdbff',
						fontSize: '0.4032rem',
					})
					.add();
				//逐日横排2 白天天气现象
				chart.renderer.text(dayPrText, xPlotArr[i / 2] - 10, (bottomPartHeight - bottomPartHeadHeight) * 0.16)
					.css({
						color: '#ffffff',
						fontSize: '0.4032rem'
					})
					.add();

				//逐日横排3 白天天气图标
				chart.renderer.image(weatherCodeDaytimeSrc, xPlotArr[i / 2] - 15, (bottomPartHeight - bottomPartHeadHeight) * 0.18, 30, 30)
					.add();
				//逐日横排4 夜晚天气图标
				chart.renderer.image(weatherCodeNightSrc, xPlotArr[i / 2] - 15, (bottomPartHeight - bottomPartHeadHeight) * 0.7, 30, 30)
					.add();
				//逐日横排5 夜晚天气现象
				chart.renderer.text(dayPrText, xPlotArr[i / 2] - 10, (bottomPartHeight - bottomPartHeadHeight) * 0.86)
					.css({
						color: '#ffffff',
						fontSize: '0.4032rem'
					})
					.add();
				//逐日横排6 星期
				chart.renderer.text(weatherTimeWeek, xPlotArr[i / 2] - 10, (bottomPartHeight - bottomPartHeadHeight) * 0.95)
					.css({
						color: '#cfdbff',
						fontSize: '0.4032rem'
					})
					.add();
			}
		});
	}

	//	init
	var indexStationCode = (JSON.parse(localStorage.cityData)).body.stationCode;
	_weatherForeCastCitySuccess();

	if (!mui.os.plus) {
		//1小时预报
		forecast1Hour(indexStationCode, '#weather-forecast-1hour');
		//3小时预报
		forecast3Hour(indexStationCode, '#weather-forecast-3hour');
		//逐日预报
		forecastDay(indexStationCode);
	}

	// 刷新全部数据
	window.addEventListener('refresh', function (e) {//执行刷新
		var indexStationCode = (JSON.parse(localStorage.cityData)).body.stationCode;
		_weatherForeCastCitySuccess();
		forecast1Hour(indexStationCode, '#weather-forecast-1hour');
		forecast3Hour(indexStationCode, '#weather-forecast-3hour');
		forecastDay(indexStationCode);
	})

	// 刷新实况数据
	window.addEventListener('refreshLive', function (e) {
		_weatherForeCastCitySuccess()
	})

	// 刷新预警信号数据
	window.addEventListener('refreshWeatherEarly', function (e) {
		_weatherForeCastCitySuccess()
	})

	//底部容器赋值高 避免留白
	var screenHeight = $(window).height();
	var screenWeight = $(window).width();
	var headerHeight = $(".weather-forecast-bar-nav").height();
	var topPartHeight = $(".weather-forecast-top-part").outerHeight();
	var isAndroid = navigator.userAgent.indexOf('Android') > -1 || navigator.userAgent.indexOf('Adr') > -1;
	/* if(isAndroid){
		$(".weather-forecast-chart").height(window.screen.availHeight-topPartHeight-headerHeight-(localStorage.statusbarHeight || 20))
	}else{
		$(".weather-forecast-chart").height(window.screen.availHeight-topPartHeight-headerHeight)
	} */
	if (isAndroid) {
		$(".weather-forecast-chart").height('9.158rem')
	} else {
		$(".weather-forecast-chart").height('9.158rem')
	}


	var bottomHeight = screenHeight - topPartHeight - headerHeight;
	var bottomPartHeight = $(".weather-forecast-chart").height();
	var bottomPartHeadHeight = $(".pagination").outerHeight();
	//	console.log("window.screen.availHeight:"+window.screen.availHeight)
	//	console.log("topPartHeight:"+topPartHeight)
	//	console.log("headerHeight:"+headerHeight)
	//	console.log("bottomPartHeight:"+bottomPartHeight)
	$(".weather-forecast-bottom").outerHeight(bottomPartHeight - bottomPartHeadHeight);
	//.height(bottomPartHeight-bottomPartHeadHeight)
	$("#weather-forecast-day").height('calc(9.158rem - 40px)').width(2 * screenWeight);
	$("#weather-forecast-3hour").height('calc(9.158rem - 40px)').width(4 * screenWeight);
	$("#weather-forecast-1hour").height('calc(9.158rem - 40px)').width(15.12 * screenWeight);
	var test = $("#weather-forecast-3hour").height()
	var weatherChartDayHeihet = bottomPartHeight - bottomPartHeadHeight;

	$("#cityManage").click(function () {
		mui.openWindow({
			url: '../web/cityBuilde.html'
		});
	});

	$(".swiper-container").on("tap", ".swiper-pagination-bullet", function () {
		var activeItem = $(this).attr("data-item");
		switch (activeItem) {
			case '0':
				renderStartTime(hour1StartTime)
				break
			case '1':
				renderStartTime(hour3StartTime)
				break
			case '2':
				renderStartTime(dayStartTime)
				break
		}
	});

	//刷新预报起报时间	
	function renderStartTime(timeData) {
		if(timeData){
			$('.weather-source').text('预报起报时间：' + timeData.substring(5, 10) + ' ' + timeData.substring(11, 16));
		}
	}

	//动态获取tipsContent高度  并定位
	var _h = $(".tipsContent").height()
	$(".tipsContent").css('top', -_h)

	// 标识该页面成功加载完成
	localStorage.preloaded = '1'
});