/**
 * 色标文件
 */

var Colors = {
    getColor: function(type, value) {
        var mark = Colors[type]

        for (var i = 0, len = mark.values.length; i < len; i++) {
            if (value < mark.values[i]) {
                return mark.colors[i - 1]
            }
        }

        return '#ffffff'
    },
    // 24小时实况降水
    RAINSCENE_24H: {
        values: [0, 0.1, 10, 25, 50, 100, 250, 9999],
        colors: ["#ffffff", "#A3F48B", "#35AB00", "#61B9F9", "#0403FF", "#FA00FA", "#810042"]
    },
    // 12小时实况降水
    RAINSCENE_12H: {
        values: [0, 0.1, 10, 25, 50, 100, 250, 9999],
        colors: ["#ffffff", "#A3F48B", "#35AB00", "#61B9F9", "#0403FF", "#FA00FA", "#810042"]
    },
    // 6小时实况降水
    RAINSCENE_6H: {
        values: [0, 0.1, 3, 10, 20, 50, 70, 9999],
        colors: ["#ffffff", "#A3F48B", "#35AB00", "#61B9F9", "#0403FF", "#FA00FA", "#810042"]
    },
    // 3小时实况降水
    RAINSCENE_3H: {
        values: [0, 0.1, 3, 10, 20, 50, 70, 9999],
        colors: ["#ffffff", "#A3F48B", "#35AB00", "#61B9F9", "#0403FF", "#FA00FA", "#810042"]
    },
    // 1小时实况降水
    RAINSCENE_1H: {
        values: [0, 0.1, 1.6, 7, 15, 40, 50, 9999],
        colors: ["#ffffff", "#A3F48B", "#35AB00", "#61B9F9", "#0403FF", "#FA00FA", "#810042"]
    },
    // 1小时实况降水
    RAINSCENE_1H: {
        values: [0, 0.1, 1.6, 7, 15, 40, 50, 9999],
        colors: ["#ffffff", "#A3F48B", "#35AB00", "#61B9F9", "#0403FF", "#FA00FA", "#810042"]
    },
    // 实况逐小时气温
    TEMSCENE_1H: {
        values: [-9999, -30, -28, -26, -24, -22, -20, -18, -16, -14, -12, -10, -8, -6, -4, -2, 0, 2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 22, 24, 26, 28, 30, 33, 35, 9999],
        colors: ["#0001fd", "#0014ff", "#0043fc", "#0166fe", "#0086ff", "#01a6ff", "#00c9fc", "#00eaff", "#00fffc", "#00ffd7", "#01ffb2", "#00ff92", "#01fd72", "#02fe4f", "#00ff2f", "#01ff0a", "#12ff03", "#32ff01", "#55ff00", "#77ff02", "#97fe00", "#b4ff00", "#dbfe01", "#fcff00", "#fee600", "#ffc300", "#ffa200", "#ff7f00", "#ff6103", "#ff4002", "#ff2d02", "#ff2300", "#ff1400", "#fe0002"]
    },
    // 实况24小时变温
    TEMSCENE_24H: {
        values: [-9999, -18, -16, -14, -12, -10, -8, -6, -4, -2, -1, 1, 2, 4, 6, 8, 10, 9999],
        colors: ["#0001fd", "#0014ff", "#0043fc", "#0166fe", "#0086ff", "#01a6ff", "#00c9fc", "#00eaff", "#00fffc", "#00ffd7", "#01ffb2", "#00ff92", "#01fd72", "#02fe4f", "#00ff2f", "#01ff0a", "#12ff03", "#32ff01", "#55ff00", "#77ff02", "#97fe00", "#b4ff00", "#dbfe01", "#fcff00", "#fee600", "#ffc300", "#ffa200", "#ff7f00", "#ff6103", "#ff4002", "#ff2d02", "#ff2300", "#ff1400", "#fe0002"]
    },
    // 实况24小时最大最小气温
    TEMSCENE_MINORMAX: {
        values: [-9999, -48, -44, -40, -36, -32, -28, -24, -20, -16, -12, -8, -4, 0, 4, 8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 9999],
        colors: ["#020c38", "#310c80", "#452194", "#5540b6", "#010082", "#0303ff", "#4148ca", "#4e96e1", "#85ade1", "#5c898f", "#75e1e6", "#b9f5c3", "#c9fbdd", "#fbfcd5", "#fffab8", "#fbe37b", "#ffff02", "#fca848", "#fa7305", "#fdb7b4", "#c38b88", "#ff90fe", "#970487", "#fe0203", "#750025", "#26011e"]
    }
}

window.Colors = Colors