function initRemLayout(designWidth, maxWidth) {
	window.clearEventListener && window.clearEventListener()

	var doc = document,
		win = window;
	var docEl = doc.documentElement;
	var tid;
	var rootItem, rootStyle;

	function refreshRem() {
		var width = docEl.getBoundingClientRect().width;
		if (!maxWidth) {
			maxWidth = 540;
		};
		if (width > maxWidth) {
			width = maxWidth;
		}
		//与淘宝做法不同，直接采用简单的rem换算方法1rem=100px
		var rem = width * 100 / designWidth;
		//兼容UC开始
		rootStyle = "html{font-size:" + rem + 'px !important}';
		rootItem = document.getElementById('rootsize') || document.createElement("style");
		if (!document.getElementById('rootsize')) {
			document.getElementsByTagName("head")[0].appendChild(rootItem);
			rootItem.id = 'rootsize';
		}
		if (rootItem.styleSheet) {
			rootItem.styleSheet.disabled || (rootItem.styleSheet.cssText = rootStyle)
		} else {
			try {
				rootItem.innerHTML = rootStyle
			} catch (f) {
				rootItem.innerText = rootStyle
			}
		}
		//兼容UC结束
		docEl.style.fontSize = rem + "px";
	};
	refreshRem();

	var resize = function () {
		clearTimeout(tid); //防止执行两次
		tid = setTimeout(refreshRem, 0);
	}
	win.addEventListener("resize", resize, false);

	var pageshow = function (e) {
		if (e.persisted) { // 浏览器后退的时候重新计算
			clearTimeout(tid);
			tid = setTimeout(refreshRem, 0);
		}
	}
	win.addEventListener("pageshow", pageshow, false);

	if (doc.readyState === "complete") {
		doc.body.style.fontSize = "16px";
	} else {
		doc.addEventListener("DOMContentLoaded", function (e) {
			doc.body.style.fontSize = "16px";
		}, false);
	}

	window.clearEventListener = function() {
		clearTimeout(tid)
		window.removeEventListener('resize', resize)
		window.removeEventListener('pageshow', pageshow)
	}
}

var designWidth = 1080, maxWidth = 1921;
window.Screen = {
	horizontal: function(cb) {
		setTimeout(function() {
			initRemLayout(maxWidth, designWidth)
			cb && cb()
		}, 100)
	},
	vertical: function() {
		setTimeout(function(cb) {
			initRemLayout(designWidth, maxWidth)
			cb && cb()
		}, 100)
	}
}

initRemLayout(designWidth, maxWidth)
