var phenomenaCodeData = {
	"0": {
		"phenomenonaCode": "0",
		"phenomenonatext": "晴"
	},
	"1": {
		"phenomenonaCode": "1",
		"phenomenonatext": "多云"
	},
	"2": {
		"phenomenonaCode": "2",
		"phenomenonatext": "阴"
	},
	"3": {
		"phenomenonaCode": "3",
		"phenomenonatext": "阵雨"
	},
	"4": {
		"phenomenonaCode": "4",
		"phenomenonatext": "雷阵雨"
	},
	"5": {
		"phenomenonaCode": "5",
		"phenomenonatext": "冰雹"
	},
	"6": {
		"phenomenonaCode": "6",
		"phenomenonatext": "雨夹雪"
	},
	"7": {
		"phenomenonaCode": "7",
		"phenomenonatext": "小雨"
	},
	"8": {
		"phenomenonaCode": "8",
		"phenomenonatext": "中雨"
	},
	"9": {
		"phenomenonaCode": "9",
		"phenomenonatext": "大雨"
	},
	"10": {
		"phenomenonaCode": "10",
		"phenomenonatext": "暴雨"
	},
	"11": {
		"phenomenonaCode": "11",
		"phenomenonatext": "大暴雨"
	},
	"12": {
		"phenomenonaCode": "12",
		"phenomenonatext": "特大暴雨"
	},
	"13": {
		"phenomenonaCode": "13",
		"phenomenonatext": "阵雪"
	},
	"14": {
		"phenomenonaCode": "14",
		"phenomenonatext": "小雪"
	},
	"15": {
		"phenomenonaCode": "15",
		"phenomenonatext": "中雪"
	},
	"16": {
		"phenomenonaCode": "16",
		"phenomenonatext": "大雪"
	},
	"17": {
		"phenomenonaCode": "17",
		"phenomenonatext": "暴雪"
	},
	"18": {
		"phenomenonaCode": "18",
		"phenomenonatext": "雾"
	},
	"19": {
		"phenomenonaCode": "19",
		"phenomenonatext": "冻雨"
	},
	"20": {
		"phenomenonaCode": "20",
		"phenomenonatext": "沙尘暴"
	},
	"21": {
		"phenomenonaCode": "21",
		"phenomenonatext": "小到中雨"
	},
	"22": {
		"phenomenonaCode": "22",
		"phenomenonatext": "中到大雨"
	},
	"23": {
		"phenomenonaCode": "23",
		"phenomenonatext": "大到暴雨"
	},
	"24": {
		"phenomenonaCode": "24",
		"phenomenonatext": "暴雨到暴雨"
	},
	"25": {
		"phenomenonaCode": "25",
		"phenomenonatext": "大暴雨到特大暴雨"
	},
	"26": {
		"phenomenonaCode": "26",
		"phenomenonatext": "小到中雪"
	},
	"27": {
		"phenomenonaCode": "27",
		"phenomenonatext": "中到大雪"
	},
	"28": {
		"phenomenonaCode": "28",
		"phenomenonatext": "大到暴雪"
	},
	"29": {
		"phenomenonaCode": "29",
		"phenomenonatext": "浮尘"
	},
	"30": {
		"phenomenonaCode": "30",
		"phenomenonatext": "扬沙"
	},
	"31": {
		"phenomenonaCode": "31",
		"phenomenonatext": "强沙尘暴"
	},
	"32": {
		"phenomenonaCode": "32",
		"phenomenonatext": "浓雾"
	},
	"49": {
		"phenomenonaCode": "49",
		"phenomenonatext": "强浓雾"
	},
	"53": {
		"phenomenonaCode": "53",
		"phenomenonatext": "霾"
	},
	"54": {
		"phenomenonaCode": "54",
		"phenomenonatext": "中度霾"
	},
	"55": {
		"phenomenonaCode": "55",
		"phenomenonatext": "重度霾"
	},
	"56": {
		"phenomenonaCode": "56",
		"phenomenonatext": "严重霾"
	},
	"57": {
		"phenomenonaCode": "57",
		"phenomenonatext": "大雾"
	},
	"58": {
		"phenomenonaCode": "58",
		"phenomenonatext": "特强浓雾"
	},
	"301": {
		"phenomenonaCode": "301",
		"phenomenonatext": "降雨"
	},
	"302": {
		"phenomenonaCode": "302",
		"phenomenonatext": "降雪"
	}
}
function getPhenomenaCodeByInfo(info) {
	return phenomenaCodeData[info] || null
}

/**
 * 根据风速查询风力等级
 * @param {number} speed 风速  
 */
function queryWindSpeed(speed) {
	var breaks = [32.6, 28.4, 24.4, 20.7, 17.1, 13.8, 10.7, 7.9, 5.4, 3.3, 1.5, 0.3, 0]
	var texts = ['12级', '11级', '10级', '9级', '8级', '7级', '6级', '5级', '4级', '3级', '2级', '1级', '微风']
	
	for (var i = 0, len = breaks.length; i < len; i++) {
		if (speed > breaks[i]) {
			return texts[i]
		}
	}

	return '无风'
}

/**
 * 获取风向描述
 * @param {*} wind 风向数值
 */
function queryWindDirection(wind) {
	if ((wind > 0 && wind < 22.5) || (wind >= 337.5 && wind < 360)) {
		return "正北"
	} else if(wind >= 22.5 && wind < 67.5) {
		return "东北"
	} else if(wind >= 67.5 && wind < 112.5) {
		return "正东"
	} else if(wind >= 112.5 && wind < 157.5) {
		return "东南"
	} else if(wind >= 157.5 && wind < 202.5) {
		return "正南"
	} else if(wind >= 205.5 && wind < 247.5) {
		return "西南"
	} else if(wind >= 247.5 && wind < 292.5) {
		return "正西"
	} else if(wind >= 292.5 && wind < 337.5) {
		return "西北"
	} else {
		return "无风"
	}
}
