var reqAnimationFrame = (function () {
//  return window[Hammer.prefixed(window, 'requestAnimationFrame')] || function (callback) {
//      window.setTimeout(callback, 16)
//  }
	return function(callback) {
		callback()
	}
})()

$.fn.zoom = function(params) {
    var CONFIG = $.extend({
        isReduce: false,
        width: 0,
        height: 0,
        maxScale: 100,
        pinchend: null,
        panend: null,
        moved: null,
        onUpdate: null,
        syncDoms: []
    }, params || {})

    return this.each(function() {
        var self = $(this),
            el = self[0],
            width = self.parent().width(),
            height = self.parent().height(),
            MAX_X = 0,
            MAX_Y = 0,
            START_X = 0,
            START_Y = 0,
            transform = {
                translate: { 
                    x: START_X,
                    y: START_Y
                },
                scale: 1,
                angle: 0,
                rx: 0,
                ry: 0,
                rz: 0,
                width: self.width(),
                height: self.height(),
                panendX: 0,
                panendY: 0
            },
            initScale = 1,
            ticking = false,
            mc = new Hammer.Manager(el)
        self.show()
        mc.add(new Hammer.Pan({ threshold: 0, pointers: 0 }))
        mc.add(new Hammer.Rotate({ threshold: 0 })).recognizeWith(mc.get('pan'))
        mc.add(new Hammer.Pinch({ threshold: 0 })).recognizeWith([mc.get('pan'), mc.get('rotate')])
//      mc.on("panstart", function(ev) {
//      	onPan(ev)
//      	CONFIG.touchStartCallback && CONFIG.touchStartCallback()
//      })
//      mc.on("pinchstart", function(ev) {
//      	onPinch(ev);
//      	// CONFIG.touchStartCallback && CONFIG.touchStartCallback()
//      })
        mc.on("panstart panmove", onPan)
        mc.on("pinchstart pinchmove", onPinch)
        mc.on("hammer.input", function(ev) {
            if (ev.isFinal) {
                START_X = transform.translate.x
                START_Y = transform.translate.y
                CONFIG.moved && CONFIG.moved(START_X + transform.panendX, START_Y + transform.panendY, transform.scale)
            }
        })
        
        if (CONFIG.pinchend) {
        	mc.on("pinchend", function() {
        		CONFIG.pinchend(transform.width * transform.scale, transform.height * transform.scale, transform.scale, transform.translate)
        	})
        }
        if (CONFIG.panend) {
        	mc.on("panend", function() {
        		CONFIG.panend(transform)
        	})
        }

        function requestElementUpdate(x, y, s) {
            if (!ticking) {
                ticking = true
                reqAnimationFrame(function() {
                	updateElementTransform(x, y, s)
                })
            }
        }

        function updateElementTransform(x, y, s) {
            var value = [
                'translate3d(' + transform.translate.x + 'px, ' + transform.translate.y + 'px, 0)',
                'scale(' + transform.scale + ', ' + transform.scale + ')'
                // 'rotate3d('+ transform.rx +','+ transform.ry +','+ transform.rz +','+  transform.angle + 'deg)'
            ]
    
            value = value.join(" ")
            el.style.webkitTransform = value
            el.style.mozTransform = value
            el.style.transform = value
            
            if (x || y || s) {
            	CONFIG.onUpdate && CONFIG.onUpdate(x, y, s)
            }
            
            CONFIG.syncDoms.forEach(function(el) {
            	$(el).css({
            		webkitTransform: value,
            		mozTransform: value,
            		transform: value
            	})
            })
            
            ticking = false
        }

        function onPan(ev) {//TODO 返回移动后的偏移量
            var x = START_X + ev.deltaX,
                y = START_Y + ev.deltaY,
                xx = (width * transform.scale - width) / 2,
                yy = (height * transform.scale - height) / 2,
                oldX = transform.translate.x,
                oldY = transform.translate.y

            if (width * transform.scale >　MAX_X + width) {
                transform.translate.x = x > xx ? xx : (x < MAX_X - xx ? MAX_X - xx : x)
                transform.panendX = MAX_X - xx
            } else {
                transform.translate.x = x < xx ? xx : (x > MAX_X - xx ? MAX_X - xx : x)
            }
    
            if (height * transform.scale > MAX_Y + height) {
                transform.translate.y = y > yy ? yy : (y < MAX_Y - yy ? MAX_Y - yy : y)
                transform.panendY = MAX_Y - yy
            } else {
                transform.translate.y = y < yy ? yy : (y > MAX_Y - yy ? MAX_Y - yy : y)
            }

            requestElementUpdate(oldX - transform.translate.x, oldY - transform.translate.y, 0)
        }

        function onPinch(ev) {
            if (ev.type == 'pinchstart') {
                initScale = transform.scale || 1
            }
            
            var oldScale = transform.scale
    
            transform.scale = initScale * ev.scale
            if (!CONFIG.isReduce) {
                transform.scale = transform.scale < 1 ? 1 : transform.scale
            }
            
            if (transform.scale > CONFIG.maxScale) {
            	transform.scale = CONFIG.maxScale
            }
            
            requestElementUpdate(0, 0, oldScale - transform.scale)
        }
        
        requestElementUpdate()
    })
}