$(function(){
  // 初始化容器宽高
  var headerHeightCss = $('header').css('height')
  $(".mui-content").height($(window).height() - headerHeightCss.replace('px', ''))

  mui.init({
    swipeBack: false, //启用右滑关闭功能
      gestureConfig:{
       tap: true, //默认为true
       doubletap: true, //默认为false
       longtap: true, //默认为false
       swipe: true, //默认为true
       drag: false, //默认为true
       hold:false,//默认为false，不监听
       release:false//默认为false，不监听
    }
  });

  //响应获取地图初始化比例
  function getMapboxScale(){
    var _screenWidth = window.innerWidth;
    var _widthArr = [320,375,414]
    var _scaleArr = [5.3,5.5,5.7]
    
    function find(array,val){
      if(val < Math.min.apply(null,array)){
          return 0;
      };
      if(val >  Math.max.apply(null,array)){
          return array.length-1;
      };
      var idx = 0,
          i   = 0,
          j   = array.length;
      for(;i<j;i++){
          if(array[i] >= val){
              idx = i;
              break;
          };
      };
      return idx;
    };
    return _scaleArr[find(_widthArr,_screenWidth)]
  }
  var cityLibObj = {
    CS:{
      name:'长沙',
      geoCode:57687,
      latlon:[28.2197,112.9197]
    },
    ZZ:{
      name:'株洲',
      geoCode:57780,
      latlon:[26.87,113.5]
    },
    XT:{
      name:'湘潭',
      geoCode:57773,
      latlon:[27.7,112.62]
    },
    YUEY:{
      name:'岳阳',
      geoCode:57584,
      latlon:[29.2,113.0797]
    },
    HY:{
      name:'衡阳',
      geoCode:57872,
      latlon:[26.9,112.5]
    },
    CZ:{
      name:'郴州',
      geoCode:57972,
      latlon:[25.8,113.0167]
    },
    YZ:{
      name:'永州',
      geoCode:57866,
      latlon:[26,111.62]
    },
    SY:{
      name:'邵阳',
      geoCode:57766,
      latlon:[27.18,111]
    },
    LD:{
      name:'娄底',
      geoCode:57763,
      latlon:[27.68,111.6]
    },
    CD:{
      name:'常德',
      geoCode:57662,
      latlon:[29.12,111.68]
    },
    ZJJ:{
      name:'张家界',
      geoCode:57558,
      latlon:[29.33,110.4]
    },
    HH:{
      name:'怀化',
      geoCode:57749,
      latlon:[27.57,110]
    },
    XXZ:{
      name:'湘西州',
      geoCode:57649,
      latlon:[28.53,109.62]
    },
    YIY:{
      name:'益阳',
      geoCode:57674,
      latlon:[28.57,112.18]
    }
  }
  var areaObj={ALL:'全省',CS:'长沙',ZZ:'株洲',XT:'湘潭',YUEY:'岳阳',HY:'衡阳',CZ:'郴州',YZ:'永州',SY:'邵阳',LD:'娄底',CD:'常德',ZJJ:'张家界',HH:'怀化',XXZ:'湘西州',YIY:'益阳'}
  var typeObj={1:'暴雨',2:'暴雪',3:'寒潮',4:'低温雨雪冰冻',5:'高温',6:'干旱',7:'强对流',8:'大雾',9:'霾',10:'重污染天气'}
  var emLevelObj={1:'Ⅰ',2:'Ⅱ',3:'Ⅲ',4:'Ⅳ'}
  var imgNameObj={1:{imgName:'by'},2:{imgName:'bx'},3:{imgName:'hc'},4:{imgName:'bd'},5:{imgName:'gw'},6:{imgName:'gh'},7:{imgName:'qdl'},8:{imgName:'dw'},9:{imgName:'m'},10:{imgName:'zwr'}}
  var badgeData = {}
  var emergencyStateOption = {
    length:24,
    time:'',
    cacheTime: '',//初次请求存储的最新时间
  }
  Object.defineProperty(badgeData, "hideArr", {
    value: ["!in", "iconHideClass"],
    enumerable: false,
    writable : true
  });
  Object.defineProperty(badgeData, "init", {
    value: function(key){
      for(key in this){
        this[key] = [];
      }
      return this;
    },
    enumerable: false
  });
  for(i=1;i<=10;i++){
    for(j=1;j<=4;j++){
      var curKey = String(i)+String(j);
      badgeData[curKey] = new Array();
    }
  }
  var map = GIS.init({ spot: true })
  var markers=[]
  map.on('load', function() {
    GIS.utils.addBlankGeoJSONSource('emIcon')
    map.addLayer({
      "id": "emIcon",
      "type": "symbol",
      "source": "emIcon",
      "layout": {
        "icon-image": {
          "property": "iconClass",
          "stops":[[1,"emerg.by"],[2,"emerg.bx"],[3,"emerg.hc"],[4,"emerg.bd"]
          ,[5,"emerg.gw"],[6,"emerg.gh"],[7,"emerg.qdl"],[8,"emerg.dw"]
          ,[9,"emerg.m"],[10,"emerg.zwr"]
          ]
        },
        "icon-rotate": 0,
        "icon-size": 0.35,
        "icon-allow-overlap":true
      }
    })
    
    getEmergencyState(true)
    $('#queryText').text(emergencyStateOption.length)
    $('#queryTextCon').text(emergencyStateOption.length)
  })

  //请求应急数据 hour:查询范围(最近多少小时内生效)
  function getEmergencyState(notButton){
    if(notButton){
      emergencyStateOption.endTime = emergencyStateOption.cacheTime = nowTime
    }
    var url="/findUsefulEmergency.go";
    var nowTime = dayjs(new Date()).format('YYYY-MM-DD HH:mm:ss')
    var _time = emergencyStateOption.endTime || nowTime
    $("#realTime").text(_time.substring(0,_time.length-3))
    var params = {
      time: _time,
      // length: emergencyStateOption.length || 24
    }
    // ajaxPost(url,params,getEStateSuccess,'');
    ajax(url,'',getEStateSuccess,'post');
  }
  function getEStateSuccess(data){
    var res = data.body;
    markers = []
    // var layerTmpArr = [],badgeCount = {};
    if(res && res.length!==0){
      res.map(function(val){
        return emDataFormat(val)
      })
      //每次不同的请求 清空badgeData
      badgeData.init();
      var newMarkers = []
      for(i=0;i<markers.length;i++){
        if(markers[i].length!==1){
          newMarkers = newMarkers.concat(markers[i])
        }else{
          newMarkers.push(markers[i])
        }
      }
      map.getSource('emIcon').setData({
        "type": "FeatureCollection",
        "features": newMarkers
      })
      res.forEach(function(val,idx){
        var locArr =  val.locations.split(',');
        var curKey =  String(val.type)+ String(val.emLevel);
        locArr.forEach(function(loc,locIdx){
          if(loc!=='ALL'){
            var tmpObj = $.extend({},val,cityLibObj[loc],imgNameObj[val['type']])
            badgeData[curKey].push(tmpObj)
          }else{
            for(item in cityLibObj){
              var tmpObj = $.extend({},val,cityLibObj[item],imgNameObj[val['type']])
              badgeData[curKey].push(tmpObj)
            }
          }
        })
      })
      var str = '';
      //外层遍历  拼接iconDom str
      for(item in badgeData){
        if(badgeData[item].length!==0){
          str += '<li data-val="'+ item +'">'+
          '<img src="../images/emergencyState/'+ badgeData[item][0].imgName +'.svg" alt=""><span class="level">'+emLevelObj[badgeData[item][0]['emLevel']]+'级</span>'+
          '<span class="mui-badge mui-badge-danger">'+badgeData[item].length +'</span></li>'
        }
      }
      $('.mapBottom-icon').html(str)
    }else{
      var newMarkers = []
      map.getSource('emIcon').setData({
        "type": "FeatureCollection",
        "features": newMarkers
      })
      // $('.mapBottom-icon').html('当前选择时间内无应急响应')
      $('.mapBottom-icon').html('当前无应急响应信号')
    }

   
    //应急响应数据格式化
    function emDataFormat(data){
      console.log(data)
      var _cityArr = data.locations.split(",")
      // if(_cityArr.indexOf("ALL")!==-1){
      // }
      function _temp(city){
        return {
          "type": "Feature",
          "geometry": {
            "type": "Point",
            "coordinates": [Number(cityLibObj[city].latlon[1]), Number(cityLibObj[city].latlon[0])]
          },
          "properties": {
            // "title": cityLibObj[city].name+"<br/>"+"应急状态："+typeObj[data.type]+emLevelObj[data.emLevel]+"级"+"<br/>"+"开始时间："+data.startTime.substr(0,16)+"<br/>"+"结束时间："+data.endTime.substr(0,16),
            "title": cityLibObj[city].name+"<br/>"+"应急状态："+typeObj[data.type]+emLevelObj[data.emLevel]+"级"+"<br/>"+"开始时间："+data.startTime.substr(0,16)+"<br/>"+"结束时间："+data.endTime.substr(0,16),
            "iconClass": Number(data.type),
            "iconHideClass": Number(data.type+data.emLevel),
          }
        }
      }
      //['ALL','CS']
      markers.push.apply(
        markers,(
          _cityArr.map(function(val){
            var _temRes = []
            if(val.indexOf("ALL")==-1){
              return _temp(val)
            }else{
              for(var key in cityLibObj) {
                _temRes.push(_temp(key))
              }
              return _temRes;
            }
          })
        )
      )
    }
  }


  map.on('click','emIcon',function(e){
    var feature = e.features[0]
    var popup = new mapboxgl.Popup()
      .setLngLat(feature.geometry.coordinates)
      .setHTML(feature.properties.title)
      .addTo(map);
    window.popup = popup;
  })

  map.on('zoomstart', function (e) {
    window.popup && (window.popup.remove(), window.popup = undefined)
  })

  //点击图标切换
  $('.mapBottom-icon').on('tap','li',function(){
    window.popup && (window.popup.remove(), window.popup = undefined)
    $(this).toggleClass('invalid')
    var curLayer = $(this).data().val;
    var _index = badgeData.hideArr.indexOf(curLayer)
    if(_index==-1){
      badgeData.hideArr.push(curLayer)
    }else{
      badgeData.hideArr.splice(_index,1)
    }
    map.setFilter("emIcon",badgeData.hideArr)
  })

  // $("#rain-datehour-ul").on("click", ".rain-datehour-option", function () {
  //   var curQueryHour = $(this).attr("data-val")
  //   emergencyStateOption.length = Number(curQueryHour)
  //   getEmergencyState()
  // })
  //点击弹出时间选择器
  // var dtPicker = new mui.DtPicker({type:'hour' ,"beginDate":new Date("2018-01-01 00:00:00"),"endDate":new Date()}); //年月日时
  // $(".updateTime").click(function(){
  //   var _curDate = $('#realTime').text()
  //   dtPicker.setSelectedValue(_curDate)
  //   dtPicker.show(function(items){
  //     var datetime=items.text+':00:00';
  //     emergencyStateOption.endTime = datetime;
  //     getEmergencyState()
  //     $('#queryText').text(emergencyStateOption.length)
  //   });
  // });

  // $("#prevTimeBtn").on("click", function () {
  //   emergencyStateOption.endTime = dayjs(emergencyStateOption.endTime).subtract(emergencyStateOption.length, 'hour').format('YYYY-MM-DD HH:mm:ss')
  //   getEmergencyState()
  // });
  // $("#nextTimeBtn").on("click", function () {
  //   var _endTime = dayjs(emergencyStateOption.endTime).add(emergencyStateOption.length, 'hour')
  //   var _firstTime = dayjs(emergencyStateOption.cacheTime)
  //   if(_endTime>_firstTime){
  //     mui.alert("已是最新数据！")
  //     getEmergencyState(true)
  //   }else{
  //     emergencyStateOption.endTime = _endTime.format('YYYY-MM-DD HH:mm:ss')
  //     getEmergencyState()
  //   }
  // });

  	// 色标图切换
  $("#warnningContent").on("tap","#rain-legend-box",function(){
    $(".legend").toggle()
	});
});
