/*!
 * ======================================================
 * FeedBack Template For MUI (http://dev.dcloud.net.cn/mui)
 * =======================================================
 * @version:1.0.0
 * @author:cuihongbao@dcloud.io
 */
(function () {
	var index = 1;
	var size = null;
	var imageIndexIdNum = 0;
	var starIndex = 0;
	var feedback = {
		question: document.getElementById('question'),
		//		contact: document.getElementById('contact'), 
		imageList: document.getElementById('image-list'),
		submitBtn: document.getElementById('submit')
	};
	var url = HOST + '/suggestion/insertOneSuggest';
	feedback.phone = localStorage.username
	feedback.files = [];
	feedback.uploader = null;
	feedback.deviceInfo = null;
	mui.plusReady(function () {
		var NET_TYPES = {}
		NET_TYPES[plus.networkinfo.CONNECTION_UNKNOW] = "Unknown";
		NET_TYPES[plus.networkinfo.CONNECTION_NONE] = "None";
		NET_TYPES[plus.networkinfo.CONNECTION_ETHERNET] = "Ethernet";
		NET_TYPES[plus.networkinfo.CONNECTION_WIFI] = "WiFi";
		NET_TYPES[plus.networkinfo.CONNECTION_CELL2G] = "Cellular 2G";
		NET_TYPES[plus.networkinfo.CONNECTION_CELL3G] = "Cellular 3G";
		NET_TYPES[plus.networkinfo.CONNECTION_CELL4G] = "Cellular 4G";

		plus.runtime.getProperty(plus.runtime.appid, function(info) {
			//设备信息，无需修改
			feedback.deviceInfo = {
				deviceId: plus.device.uuid,
				appid: plus.runtime.appid,
				appVersion: info.version,
				imei: plus.device.imei, //设备标识
				images: feedback.files, //图片文件
				os: mui.os.android ? 'Android' : 'iOS', //平台类型，i表示iOS平台，a表示Android平台。
				osVersion: mui.os.version,
				deviceModel: plus.device.model, //设备型号
				plusVersion: plus.runtime.innerVersion, //基座版本号
				net: NET_TYPES[plus.networkinfo.getCurrentType()] || plus.networkinfo.getCurrentType()
			}
		})
	});
	/**
	 *提交成功之后，恢复表单项 
	 */
	feedback.clearForm = function () {
		feedback.question.value = '';
		//		feedback.contact.value = '';
		feedback.imageList.innerHTML = '';
		feedback.newPlaceholder();
		feedback.files = [];
		index = 0;
		size = 0;
		imageIndexIdNum = 0;
		starIndex = 0;
		//清除所有星标
		mui('.icons i').each(function (index, element) {
			if (element.classList.contains('mui-icon-star-filled')) {
				element.classList.add('mui-icon-star')
				element.classList.remove('mui-icon-star-filled')
			}
		})
	};
	feedback.getFileInputArray = function () {
		return [].slice.call(feedback.imageList.querySelectorAll('.file'));
	};
	feedback.addFile = function (path) {
		feedback.files.push({ name: "images" + index, path: path });
		index++;
	};
	/**
	 * 初始化图片域占位
	 */
	feedback.newPlaceholder = function () {
		var fileInputArray = feedback.getFileInputArray();
		if (fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		};
		imageIndexIdNum++;
		var placeholder = document.createElement('div');
		placeholder.setAttribute('class', 'image-item space');
		//删除图片
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		//小X的点击事件
		closeButton.addEventListener('tap', function (event) {
			setTimeout(function () {
				feedback.imageList.removeChild(placeholder);
			}, 0);
			return false;
		}, false);

		//
		var fileInput = document.createElement('div');
		fileInput.setAttribute('class', 'file');
		fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
		fileInput.addEventListener('tap', function (event) {
			var self = this;
			var index = (this.id).substr(-1);

			plus.gallery.pick(function (e) {
				//				console.log("event:"+e);
				var name = e.substr(e.lastIndexOf('/') + 1);
				console.log("name:" + name);

				plus.zip.compressImage({
					src: e,
					dst: '_doc/_' + name,
					overwrite: true,
					quality: 50
				}, function (zip) {
					size += zip.size
					console.log("filesize:" + zip.size + ",totalsize:" + size);
					if (size > (10 * 1024 * 1024)) {
						return mui.toast('文件超大,请重新选择~');
					}
					if (!self.parentNode.classList.contains('space')) { //已有图片
						feedback.files.splice(index - 1, 1, { name: "images" + index, path: e });
					} else { //加号
						placeholder.classList.remove('space');
						feedback.addFile(zip.target);
						feedback.newPlaceholder();
					}
					placeholder.style.backgroundImage = 'url(' + zip.target + ')';
				}, function (zipe) {
					mui.toast('压缩失败！')
				});
			}, function (e) {
				if (e.code === 12) {
					mui.toast("取消选择")
				} else {
					mui.toast(e.message)
				}
			}, {});
		}, false);
		placeholder.appendChild(closeButton);
		placeholder.appendChild(fileInput);
		feedback.imageList.appendChild(placeholder);
	};
	feedback.newPlaceholder();
	feedback.submitBtn.addEventListener('tap', function (event) {
		if (feedback.question.value == '') {
			return mui.toast('请输入您的宝贵意见 ^_^');
		}
		if (feedback.question.value.length > 500) {
			return mui.toast('信息超长,请重新填写~')
		}
		//判断网络连接
		if (plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE) {
			return mui.toast("连接网络失败，请稍后再试");
		}
		feedback.send(mui.extend({}, feedback.deviceInfo, {
			user: feedback.phone,
			content: feedback.question.value,
			//			contact: feedback.contact.value,
			images: feedback.files,
			score: '' + starIndex,
			'Authorization': 'Bearer ' + localStorage.Token
		}))
	}, false)
	feedback.send = function (content) {
		feedback.uploader = plus.uploader.createUpload(url, {
			method: 'POST'
		}, function (upload, status) {
			plus.nativeUI.closeWaiting()
			var result = JSON.parse(upload.responseText)
			console.log("upload cb:" + upload.responseText);
			console.log("upload status:" + status + ', typeof: ' + (typeof status));
			if (status === 200 && result.status === 200) {
				mui.toast("感谢您的反馈!");
				feedback.clearForm();
				mui.back();
			} else {
				mui.toast("反馈信息上传失败!");
			}
		});
		//添加上传数据
		mui.each(content, function (index, element) {
			if (index !== 'images') {
				//				console.log("addData:"+index+","+element);
				feedback.uploader.addData(index, element)
			}
		});
		//添加上传文件
		mui.each(feedback.files, function (index, element) {
			var f = feedback.files[index];
			//			console.log("addFile:"+JSON.stringify(f));
			feedback.uploader.addFile(f.path, {
				key: f.name
			});
		});

		//开始上传任务
		plus.nativeUI.showWaiting('正在上传反馈信息...')
		feedback.uploader.start()
	};

	//应用评分
	mui('.icons').on('tap', 'i', function () {
		var index = parseInt(this.getAttribute("data-index"));
		var parent = this.parentNode;
		var children = parent.children;
		if (this.classList.contains("mui-icon-star")) {
			for (var i = 0; i < index; i++) {
				children[i].classList.remove('mui-icon-star');
				children[i].classList.add('mui-icon-star-filled');
			}
		} else {
			for (var i = index; i < 5; i++) {
				children[i].classList.add('mui-icon-star')
				children[i].classList.remove('mui-icon-star-filled')
			}
		}
		starIndex = index;
	});
	//选择快捷输入
	mui('.mui-popover').on('tap', 'li', function (e) {
		document.getElementById("question").value = document.getElementById("question").value + this.children[0].innerHTML;
		mui('.mui-popover').popover('toggle')
	})
})();