$(function () {
  // 初始化容器宽高
  var headerHeightCss = $('header').css('height')
  $(".mui-content").height($(window).height() - headerHeightCss.replace('px', ''))
  
	mui.init({
		swipeBack: false, //启用右滑关闭功能
		gestureConfig: {
			tap: true, //默认为true
			doubletap: true, //默认为false
			longtap: true, //默认为false
			swipe: true, //默认为true
			drag: false, //默认为true
			hold: false, //默认为false，不监听
			release: false //默认为false，不监听
		}
	})
  //响应获取地图初始化比例
  function getMapboxScale(){
    var _screenWidth = window.innerWidth;
    var _widthArr = [320,375,414]
    var _scaleArr = [5.3,5.5,5.7]
    
    function find(array,val){
      if(val < Math.min.apply(null,array)){
          return 0;
      };
      if(val >  Math.max.apply(null,array)){
          return array.length-1;
      };
      var idx = 0,
          i   = 0,
          j   = array.length;
      for(;i<j;i++){
          if(array[i] >= val){
              idx = i;
              break;
          };
      };
      return idx;
    };
    return _scaleArr[find(_widthArr,_screenWidth)]
  }
  var markers=[]
  var warningOption = {
    curStation:1,
    interval:72,
    endTime:'',
    // startTime: '',
    cacheTime: '',//初次请求存储的最新时间
  }
  var typeObj={'雷电':'1', '暴雪':'2', '雷雨大风':'3', '寒潮':'4', '霾':'5', '干旱':'6', '大风':'7', '高温':'8', '冰雹':'9',
  '暴雨':'10', '大雾':'11', '道路结冰':'12', '低温雨雪冰冻':'13'}
  var emLevelObj={1:'红色',2:'橙色',3:'黄色',4:'蓝色'}
  var provinceBadgeData = newBadge()
  var countryBadgeData = newBadge()
  function newBadge(){
    var o = {}
    Object.defineProperty(o, "hideArr", {
      value: ["!in", "iconHideClass"],
      enumerable: false, 
      writable : true
    });
    Object.defineProperty(o, "init", {
      value: function(key){
        for(key in this){
          this[key] = {warningArr:[],occurNum:0,validWarningArr:[],areaSet:[]};
        }
        return this;
      },
      enumerable: false
    });
    for(i=1;i<=13;i++){
      for(j=1;j<=4;j++){
        var curKey = String(i)+String(j);
        o[curKey] = {warningArr:[],occurNum:0,validWarningArr:[],areaSet:[]};
      }
    }
    return o
  }
	var map = GIS.init()
	map.on('load', function() {
		// GIS.utils.addBlankImageSource('spotImage')
    GIS.utils.addBlankGeoJSONSource('warning')
		// map.addLayer({
		// 	id: 'spotImage',
		// 	source: 'spotImage',
		// 	type: "raster"
    // }, 'city-boundary')
    var typeObj={'雷电':'1', '暴雪':'2', '雷雨大风':'3', '寒潮':'4', '霾':'5', '干旱':'6', '大风':'7', '高温':'8', '冰雹':'9',
    '暴雨':'10', '大雾':'11', '道路结冰':'12', '低温雨雪冰冻':'13'}
    map.addLayer({
      "id": "severeWeatherWarning",
      "type": "symbol",
      "source": "warning",
      // "filter": ["==", "attrName", "electricStrength"],
      "layout": {
        "icon-image": {
          "property": "iconHideClass",
          "stops":[[11,"sWeatherWarning.ld1"],[12,"sWeatherWarning.ld2"],[13,"sWeatherWarning.ld3"],[14,"sWeatherWarning.ld4"],
                  [21,"sWeatherWarning.bx1"],[22,"sWeatherWarning.bx2"],[23,"sWeatherWarning.bx3"],[24,"sWeatherWarning.bx4"],
                  [31,"sWeatherWarning.lf1"],[32,"sWeatherWarning.lf2"],[33,"sWeatherWarning.lf3"],[34,"sWeatherWarning.lf4"],
                  [41,"sWeatherWarning.hc1"],[42,"sWeatherWarning.hc2"],[43,"sWeatherWarning.hc3"],[44,"sWeatherWarning.hc4"],
                  [51,"sWeatherWarning.m1"],[52,"sWeatherWarning.m2"],[53,"sWeatherWarning.m3"],[54,"sWeatherWarning.m4"],
                  [61,"sWeatherWarning.gh1"],[62,"sWeatherWarning.gh2"],[63,"sWeatherWarning.gh3"],[64,"sWeatherWarning.gh4"],
                  [71,"sWeatherWarning.df1"],[72,"sWeatherWarning.df2"],[73,"sWeatherWarning.df3"],[74,"sWeatherWarning.df4"],
                  [81,"sWeatherWarning.gw1"],[82,"sWeatherWarning.gw2"],[83,"sWeatherWarning.gw3"],[84,"sWeatherWarning.gw4"],
                  [91,"sWeatherWarning.bb1"],[92,"sWeatherWarning.bb2"],[93,"sWeatherWarning.bb3"],[94,"sWeatherWarning.bb4"],
                  [101,"sWeatherWarning.by1"],[102,"sWeatherWarning.by2"],[103,"sWeatherWarning.by3"],[104,"sWeatherWarning.by4"],
                  [111,"sWeatherWarning.dw1"],[112,"sWeatherWarning.dw2"],[113,"sWeatherWarning.dw3"],[114,"sWeatherWarning.dw4"],
                  [121,"sWeatherWarning.jb1"],[122,"sWeatherWarning.jb2"],[123,"sWeatherWarning.jb3"],[124,"sWeatherWarning.jb4"],
                  [131,"sWeatherWarning.dwbd1"],[132,"sWeatherWarning.dwbd2"],[133,"sWeatherWarning.dwbd3"],[134,"sWeatherWarning.dwbd4"]]
        },
        "icon-rotate": 0,
        "icon-size": 0.2,
        "icon-allow-overlap":true
      }
    })
    severeWeatherEarly(true)
  })
  
  //请求数据
  function severeWeatherEarly(notButton){
    var url="/home/severeWeatherEarly.do";
    var _nowTime = dayjs().format('YYYY-MM-DD HH:mm:ss')
    if(notButton){
      warningOption.cacheTime = _nowTime
      warningOption.endTime = _nowTime
    }
    var params = {
      interval:warningOption.interval,
      datetime:warningOption.endTime||_nowTime
    }
    //更新时间
    $('#realTime').html(params.datetime.substr(0,16));
    ajax(url, "" , _severeWeatherEarlySuccess , "get")
  }

  function _severeWeatherEarlySuccess(data){
    window.popup && (window.popup.remove(), window.popup = undefined)
    markers = [];
    //无预警提示
    if(data.body.recordNum == 0) {
      var _str = '';
      warningOption.curStation == 1 ? _str = '<p>目前生效中的省级预警信号0条</p>':_str = '<p>目前生效中的市县(区)级预警信号0条</p>'
      $('.mapBottom-content').html(_str)
      return false;
    }
    data.body.data.forEach(function(val,idx){
        warningDataFormat(val)
    })
    //应急响应数据格式化
    function warningDataFormat(data){
      var _startTimeD = dayjs(data.submitTime)
      var _validPeriod = data.validPeriod
      var _endTimeD = _startTimeD.add(_validPeriod,"hour")
      var _startTime = _startTimeD.format('YYYY-MM-DD HH:mm')
      var _endTime = _endTimeD.format('YYYY-MM-DD HH:mm')
      var _cityArr = data.relevantArea
      var _nowTime = dayjs()
      function _temp(city){
        var _cityData = getLatLngInfosByCityName(city)
        return {
          "type": "Feature",
          "geometry": {
            "type": "Point",
            "coordinates": [Number(_cityData.lon), Number(_cityData.lat)]
          },
          "properties": {
            "title": city+"  "+data.earlyType+emLevelObj[data.earlyLevel]+"预警"+"<br/>"+data.sendContent+"<br/>"+"开始时间："+_startTime+"<br/>"+"结束时间："+_endTime,
            "iconClass": Number(data.unitType),
            "iconHideClass": Number(typeObj[data.earlyType]+data.earlyLevel),
            "unitType": data.unitType,
            "submitTime": data.submitTime
          }
        }
      }
      //剔除失效预警数据
      if(_nowTime<_endTimeD){
        markers.push.apply(
          markers,(
            _cityArr.map(function(val){
                return _temp(val);
            })
          )
        )
        //有效期内数据 存入validWarningArr 
        var locArr =  data.relevantArea
        var curKey =  String(typeObj[data.earlyType])+ String(data.earlyLevel);
        if(Number(data.unitType)===1){
          locArr.forEach(function(v,i){
            _eachCity(v,data,provinceBadgeData[curKey].validWarningArr)
          })
        }else{
          locArr.forEach(function(v,i){
            _eachCity(v,data,countryBadgeData[curKey].validWarningArr)
          })
        }
      }else{
        // console.log("此预警已失效：",data)
      }
    }

    map.getSource('warning').setData({
      "type": "FeatureCollection",
      "features": sortFilter(markers)
    })
    syncOption()
    
    //存入warningArr方法  v:地区数组遍历中每一个地区  data：单个源数据  o：需要存入的数组
    function _eachCity(v,data,o){
      var tmpObj = $.extend({},data,{relevantArea:v})
      o.push(tmpObj)
    }

    // warningArr;occurNum
    data.body.data.forEach(function(val,idx){
      
      var locArr =  val.relevantArea
      var curKey =  String(typeObj[val.earlyType])+ String(val.earlyLevel);
      if(Number(val.unitType)===1){
        provinceBadgeData[curKey].occurNum++;
        locArr.forEach(function(v,i){
          _eachCity(v,val,provinceBadgeData[curKey].warningArr)
        })
      }else{
        countryBadgeData[curKey].occurNum++;
        locArr.forEach(function(v,i){
          _eachCity(v,val,countryBadgeData[curKey].warningArr)
        })
      }
    })

    if(warningOption.curStation===1){
      renderDom(provinceBadgeData)
    }else{
      renderDom(countryBadgeData)
    }
  }

  // 过滤掉重复的预警信号,同一经纬度仅显示最新的数据
  function sortFilter(markers) {
    var alls = []

    var types = {}
    markers.forEach(function(item) {
      if (!types[item.properties.iconHideClass]) {
        types[item.properties.iconHideClass] = []
      }

      types[item.properties.iconHideClass].push(item)
    })

    for (var type in types) {
      var coordinates = {}

      types[type].forEach(function(item) {
        var key = item.geometry.coordinates.join(',')
        if (!coordinates[key]) {
          coordinates[key] = []
        }
  
        coordinates[key].push(item)
      })

      for (var key in coordinates) {
        var sorts = coordinates[key].sort(function(a, b) {
          return dayjs(b.submitTime) - dayjs(a.submitTime)
        })

        alls.push(sorts[0])
      }
    }

    return alls
  }

  function renderDom(badgeData){
    //外层遍历  拼接iconDom str
    var iconStr = '',  _gradeStr = '', contentStr = '';
    var validNum = 0 ;
    // var textStr = '';
    for(item in badgeData){
      // if(badgeData[item].warningArr.length!==0){
      //   textStr += '<p>最近'+warningOption.interval+'小时内发布'+badgeData[item].warningArr[0].earlyType+emLevelObj[badgeData[item].warningArr[0].earlyLevel]+'预警'+badgeData[item].occurNum+'次</p>'
      // }
      if(badgeData[item].validWarningArr.length!==0){
        iconStr += '<li data-val="'+ item +'">'+
        '<img src="../images/earlyWarningIcon/'+ badgeData[item].validWarningArr[0].earlyTypePY +'-'+ badgeData[item].validWarningArr[0].earlyLevel+'.svg" alt=""><span class="level"></span>'+
        // '<span class="mui-badge mui-badge-danger">'+badgeData[item].validWarningArr.length +'</span></li>';
        '</li>';
        validNum += badgeData[item].validWarningArr.length;
      }
    }
    // if(iconStr===''&&textStr===''){
    //   $('.mapBottom-icon').html('<p>当前时段无预警或预警信号</p>')
    //   $('.mapBottom-content').html('<p>当前时段无预警或预警信号统计</p>')
    // }else if(iconStr===''){
    //   $('.mapBottom-icon').html('<p>当前时段无生效中预警或预警信号</p>')
    //   $('.mapBottom-content').html(textStr)
    // }else {
    //   $('.mapBottom-icon').html(iconStr)
    //   $('.mapBottom-content').html(textStr)
    // }
    // '<p>目前生效中的市县(区)级预警信号0条</p>'
    // _html($('.mapBottom-icon'),iconStr)

    _gradeStr = warningOption.curStation == 1 ? '省级':'市县(区)级';
    if(iconStr === ''){
      iconStr = '<p>当前无'+_gradeStr+'预警信号</p>'
    }
    // contentStr = '<p>目前生效中的'+_gradeStr+'预警信号'+validNum+'条</p>'
    contentStr = '<p>目前生效中的'+_gradeStr+'预警信号</p>'
    $('.mapBottom-icon').html(iconStr)
    $('.mapBottom-content').html(contentStr)
    // _html($('.mapBottom-content'),textStr)
    // function _html(jq,str){
    //   if(str===''){
    //     jq.html('<p>当前无预警或预警信号</p>')
    //   }else{
    //     jq.html(str)
    //   }
    // }
    // $('#queryText').html(warningOption.interval+"小时")
    // $('#queryTitleText').text('最近'+warningOption.interval+'小时预警')
    
  }
  //地图同步
  function syncOption(init){
    console.log(warningOption.curStation)
		if(init){
      provinceBadgeData.hideArr = countryBadgeData.hideArr = ["!in", "iconHideClass"]
      if(warningOption.curStation == 1){
        GIS.map.setFilter("severeWeatherWarning",["<=", 'unitType', warningOption.curStation])
      }else{
        GIS.map.setFilter("severeWeatherWarning",["all",["<=", 'unitType', warningOption.curStation],[">=", 'unitType', 2]])
      }
			console.log("筛选条件已清除")
			return;
		}
		var _curStation = warningOption.curStation;
    
    var filter = ["all", ["<=", "unitType" , _curStation]]
    if (GIS.map) {
      var badgeData ;
      if(_curStation===1){
        badgeData = provinceBadgeData;
        filter.push(badgeData.hideArr)
      }else{
        badgeData = countryBadgeData;
        filter.push(badgeData.hideArr)
        filter.push([">=", 'unitType', 2])
      }
      GIS.map.setFilter("severeWeatherWarning", filter)
    }
	}

  map.on('click','severeWeatherWarning',function(e){
    var feature = e.features[0]
    var popup = new mapboxgl.Popup({className: 'popupClass'})
      .setLngLat(feature.geometry.coordinates)
      .setHTML(feature.properties.title)
      .addTo(map);
    window.popup = popup;
  })

  //切换 省区县预警
  $("#provinceToggle").on("click",".datehour-option",function(e){
    var activeType=parseInt($(this).attr("data-val"));
    $(this).addClass("datehour-option-active").siblings().removeClass("datehour-option-active");
    if(activeType===1){
      warningOption.curStation = 1;
      renderDom(provinceBadgeData)
    }else{
      warningOption.curStation = 3;
      renderDom(countryBadgeData)
    }
    syncOption(true)

    window.popup && (window.popup.remove(), window.popup = undefined)
  });
  
  // //切换左侧选择菜单
  // function toggleLeftMenu(){
  //   $('#hourQuery').toggleClass('hide')
  //   $('#detailIcon').toggleClass('rotateUD')
  //   if(changeTimeCounter.getFlag()){
  //     $('#queryIcon')[0].setAttribute('class','icon rotateUD')
  //     // $('.mapBottom-content').css('height','2.1rem')
  //   }else{
  //     $('#queryIcon')[0].setAttribute('class','icon')
  //     // $('.mapBottom-content').css('height','0')
  //   }
  //   changeTimeCounter.changeFlag();	
  // }

  // //开关
  // function Counter(){
  //   var flag = true;
  //   function toggle(){
  //     flag = !flag;
  //   }
  //   return {
  //     changeFlag:function(){
  //       toggle();
  //     },
  //     getFlag:function(){
  //       return flag;
  //     }
  //   }
  // }
  // var changeTimeCounter = new Counter;
  // var detailCounter = new Counter;

  // //选择时间按钮
  // $('.mapBottom-title').on('tap','#queryButtom',function(){
  //   //对齐定位
  //   var topShift = $('#hourQuery').outerHeight();
  //   $('#hourQuery').css('top',-topShift)
  //   toggleLeftMenu()

  // })


  // //详情按钮
  // $('.mapBottom-title').on('tap','#detail',function(){
  //   //对齐定位
  //   $('.mapBottom-content').toggleClass('hide')
  //   $('#detailIcon').toggleClass('rotateUD')
  //   if(detailCounter.getFlag()){
  //     $('#detailIcon')[0].setAttribute('class','icon rotateUD')
  //   }else{
  //     $('#detailIcon')[0].setAttribute('class','icon')
  //   }
  //   detailCounter.changeFlag();
  // })

  // //按下效果
  // $('#hourQuery').on('touchstart','li',function(){
  //   $(this).addClass("hover")
  // })
  // $('#hourQuery').on('touchend','li',function(){
  //   $(this).removeClass("hover")
  // })
  // $('#hourQuery').on('tap','li',function(){
  //   var curQueryHour = $(this).children('span').attr("data-val")
  //   warningOption.interval = Number(curQueryHour)
  //   // getEmergencyState(curQueryHour)
  //   $('#queryText').text(curQueryHour+'小时')
  //   $('#queryTitleText').text('最近'+curQueryHour+'小时预警')
  //   $(this).addClass('active').siblings().removeClass('active')
  //   provinceBadgeData.init()
  //   countryBadgeData.init()
  //   toggleLeftMenu()
  //   severeWeatherEarly()
  //   syncOption(init)
  // })

  // $("#rain-datehour-ul").on("click", ".rain-datehour-option", function () {
  //   var curQueryHour = $(this).attr("data-val")
  //   warningOption.interval = Number(curQueryHour)
  //   $('#queryText').text(curQueryHour+'小时')
  //   $('#queryTitleText').text('最近'+curQueryHour+'小时预警')
  //   provinceBadgeData.init()
  //   countryBadgeData.init()
  //   severeWeatherEarly()
  //   syncOption(true)
  // })

  //点击图标切换
  $('.mapBottom-icon').on('tap','li',function(){
    window.popup && (window.popup.remove(), window.popup = undefined)
    $(this).toggleClass('invalid').children('.mui-badge').toggleClass('mui-badge-danger')
    var curLayer = $(this).data().val;
    var badgeData ;
    if(warningOption.curStation===1){
      badgeData = provinceBadgeData;
    }else{
      badgeData = countryBadgeData;
    }
    var _index = badgeData.hideArr.indexOf(curLayer)
    if(_index==-1){
      badgeData.hideArr.push(curLayer)
    }else{
      badgeData.hideArr.splice(_index,1)
    }
    syncOption()
  })

  // //点击弹出时间选择器
  // var dtPicker = new mui.DtPicker({type:'hour'}); //年月日时
  // $(".updateTime").click(function(){
  //   dtPicker.show(function(items){
  //     var datetime=items.text+':00:00';
  //     warningOption.endTime = datetime
  //     provinceBadgeData.init()
  //     countryBadgeData.init()
  //     syncOption(true)
  //     severeWeatherEarly()
  //   });
  // });

  // $("#prevTimeBtn").on("click", function () {
  //   warningOption.endTime = dayjs(warningOption.endTime).subtract(warningOption.interval, 'hour').format('YYYY-MM-DD HH:mm:ss')
  //   provinceBadgeData.init()
  //   countryBadgeData.init()
  //   syncOption(true)
  //   severeWeatherEarly()
  // });
  // $("#nextTimeBtn").on("click", function () {
  //   var _endTime = dayjs(warningOption.endTime).add(warningOption.interval, 'hour')
  //   var _firstTime = dayjs(warningOption.cacheTime)
  //   if(_endTime>_firstTime){
  //     mui.alert("已是最新数据！")
  //   }else{
  //     warningOption.endTime = _endTime.format('YYYY-MM-DD HH:mm:ss')
  //     provinceBadgeData.init()
  //     countryBadgeData.init()
  //     syncOption(true)
  //     severeWeatherEarly()
  //   }
  // });
})